package com.ibm.etools.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.util.List;
import com.ibm.etools.emf.ref.RefBaseObject;




import com.ibm.etools.java.*;
import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.beaninfo.meta.*;
import java.lang.Boolean;
/**
 * @lastgen interface BeanDecorator extends FeatureDecorator {}
 */


public interface BeanDecorator extends FeatureDecorator {
















































































































































































	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Set merge super properties proxy. This can't be answered from the BeanDescriptor proxy,
	 * so it must be explicitly set from the beaninfo class adapter.
	 */
	public void setMergeSuperPropertiesProxy(Boolean bool);
	
	/**
 	 * Set merge super behaviors proxy. This can't be answered from the BeanDescriptor proxy,
	 * so it must be explicitly set from the beaninfo class adapter.
	 * @param value The new value of the MergeSuperBehaviors attribute
	 */
	public void setMergeSuperBehaviorsProxy(Boolean value);
	
	/**
 	 * Set merge super events proxy. This can't be answered from the BeanDescriptor proxy,
	 * so it must be explicitly set from the beaninfo class adapter.
	 * @param value The new value of the MergeSuperBehaviors attribute
	 */
	public void setMergeSuperEventsProxy(Boolean value);	
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	BeaninfoPackage ePackageBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassBeanDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The meta-Object for the BeanDecorator
	 * @deprecated Please replace with eClassBeanDecorator()
	 */
	MetaBeanDecorator metaBeanDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperProperties attribute
	 * Should the properties of super types be merged when asking for eAllAttributes//eAllReferences.
	 */
	boolean isMergeSuperProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperProperties attribute
	 * Should the properties of super types be merged when asking for eAllAttributes//eAllReferences.
	 */
	Boolean getMergeSuperProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperProperties attribute
	 */
	void setMergeSuperProperties(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperProperties attribute
	 */
	void setMergeSuperProperties(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the MergeSuperProperties attribute
	 */
	void unsetMergeSuperProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the MergeSuperProperties attribute has been set
	 */
	boolean isSetMergeSuperProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperBehaviors attribute
	 * Should the behaviors of super types be merged when asking for eAllBehaviors.
	 */
	boolean isMergeSuperBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperBehaviors attribute
	 * Should the behaviors of super types be merged when asking for eAllBehaviors.
	 */
	Boolean getMergeSuperBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperBehaviors attribute
	 */
	void setMergeSuperBehaviors(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperBehaviors attribute
	 */
	void setMergeSuperBehaviors(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the MergeSuperBehaviors attribute
	 */
	void unsetMergeSuperBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the MergeSuperBehaviors attribute has been set
	 */
	boolean isSetMergeSuperBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperEvents attribute
	 * Should the events of super types be merged when asking for eAllEvents.
	 */
	boolean isMergeSuperEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeSuperEvents attribute
	 * Should the events of super types be merged when asking for eAllEvents.
	 */
	Boolean getMergeSuperEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperEvents attribute
	 */
	void setMergeSuperEvents(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeSuperEvents attribute
	 */
	void setMergeSuperEvents(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the MergeSuperEvents attribute
	 */
	void unsetMergeSuperEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the MergeSuperEvents attribute has been set
	 */
	boolean isSetMergeSuperEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectProperties attribute
	 * Should the properties from the introspection be added to the class. This allows properties to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	boolean isIntrospectProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectProperties attribute
	 * Should the properties from the introspection be added to the class. This allows properties to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	Boolean getIntrospectProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectProperties attribute
	 */
	void setIntrospectProperties(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectProperties attribute
	 */
	void setIntrospectProperties(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IntrospectProperties attribute
	 */
	void unsetIntrospectProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IntrospectProperties attribute has been set
	 */
	boolean isSetIntrospectProperties();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectBehaviors attribute
	 * Should the behaviors from the introspection be added to the class. This allows behaviors to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	boolean isIntrospectBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectBehaviors attribute
	 * Should the behaviors from the introspection be added to the class. This allows behaviors to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	Boolean getIntrospectBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectBehaviors attribute
	 */
	void setIntrospectBehaviors(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectBehaviors attribute
	 */
	void setIntrospectBehaviors(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IntrospectBehaviors attribute
	 */
	void unsetIntrospectBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IntrospectBehaviors attribute has been set
	 */
	boolean isSetIntrospectBehaviors();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectEvents attribute
	 * Should the events from the introspection be added to the class. This allows events to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	boolean isIntrospectEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IntrospectEvents attribute
	 * Should the events from the introspection be added to the class. This allows events to not be introspected and to use only what is defined explicitly in the JavaClass xmi file.
	 */
	Boolean getIntrospectEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectEvents attribute
	 */
	void setIntrospectEvents(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IntrospectEvents attribute
	 */
	void setIntrospectEvents(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IntrospectEvents attribute
	 */
	void unsetIntrospectEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IntrospectEvents attribute has been set
	 */
	boolean isSetIntrospectEvents();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The CustomizerClass reference
	 */
	JavaClass getCustomizerClass();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param l The new value of the CustomizerClass reference
	 */
	void setCustomizerClass(JavaClass l);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the CustomizerClass attribute
	 */
	void unsetCustomizerClass();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the CustomizerClass attribute has been set
	 */
	boolean isSetCustomizerClass();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DoBeaninfo attribute
	 * This means do we go and get the beaninfo from the remote vm. If false, then it will not try to get the beaninfo. This doesn't prevent introspection through reflection. That is controled by the separate introspect... attributes.
	 */
	Boolean getDoBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the DoBeaninfo attribute
	 */
	void unsetDoBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the DoBeaninfo attribute has been set
	 */
	boolean isSetDoBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DoBeaninfo attribute
	 * This means do we go and get the beaninfo from the remote vm. If false, then it will not try to get the beaninfo. This doesn't prevent introspection through reflection. That is controled by the separate introspect... attributes.
	 */
	boolean isDoBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DoBeaninfo attribute
	 */
	void setDoBeaninfo(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DoBeaninfo attribute
	 */
	void setDoBeaninfo(boolean value);
}
