package com.ibm.etools.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.util.List;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.proxy.IBeanProxy;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.beaninfo.meta.*;
import com.ibm.etools.emf.ref.EList;
import java.lang.Boolean;
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * @lastgen interface FeatureDecorator extends EDecorator {}
 */


public interface FeatureDecorator extends EDecorator {














































































































































































	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Enumeration of what was implicitly created.
	 */
	public static final int
		NOT_IMPLICIT = 0,
		IMPLICIT_DECORATOR = 1,
		IMPLICIT_DECORATOR_AND_FEATURE = 3;
		// Can't have explicit decorator but implicit feature.


	/**
	 * Was this decorator implicitly created by introspection?
	 * The default should be false.
	 * This is here for linkage with the introspection process
	 * and is not really a MOF property. The introspection needs
	 * to know which features it created and which were explicitly
	 * created by other means. Implicitly created ones may be 
	 * deleted at any time when the introspection determines it
	 * needs to.
	 */
	public int isImplicitlyCreated();
	public void setImplicitlyCreated(int implicit);
	
	/**
	 * Answer whether this has introspection results merged into it.
	 * This is important because if it doesn't have a proxy,
	 * then this is an explicit decorator. Explicit decorators
	 * will show up in the eAllAttribute/eAllBehaviors/eAllEvents
	 * when beaninfo says don't do merge. This is because the
	 * introspection only knows about beaninfo features and so
	 * it can only specify that beaninfo features are not to
	 * be inherited.
	 */
	public boolean isIntrospected();
	 
	/**
	 * Set the descriptor proxy to gather implicit information
	 * not explicitly set on the decorator. Each decorator
	 * knows what to retrieve out of the proxy. If the proxy
	 * is null, then it there is no beaninfo to info from. When
	 * this method is called, any cached values are cleared out.
	 */
	public void setDescriptorProxy(IBeanProxy descriptor);
	
	/**
	 * Set the decorator to use for querying reflected properties.
	 * On reflection we need to return the results, but we don't
	 * want to explicitly set anything that could override the
	 * explicit settings by the user. So we pass in a decorator
	 * that has the reflected settings. It act's like the descriptor proxy
	 * above for when it comes from beaninfo's. Each decorator knows what
	 * to retrieve from implicit decorator.
	 */
	public void setDecoratorProxy(FeatureDecorator decorator);
	
	/**
	 * An internal method used by the ExportManager to create a copy
	 * of this decorator with all of the introspected settings turned
	 * into hard-coded settings on the new decorator.
	 */
	public FeatureDecorator createIntrospectedCopy();
	
	/**
	 * An internal method used by BeaninfoClassAdapter to tell it
	 * to re-proxy any reference to JavaMethods. This is because the
	 * class has changed and the java model has removed all methods
	 * and recreated them. But any actual references we made hold
	 * will be invalid because they will be pointing to the old
	 * actual instances. We need to turn them back into an emf proxy
	 * so that the next time they are accessed they will be retrieved
	 * and return the new ones.
	 */
	public void refreshJavaReferences();
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	BeaninfoPackage ePackageBeaninfo();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassFeatureDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The meta-Object for the FeatureDecorator
	 * @deprecated Please replace with eClassFeatureDecorator()
	 */
	MetaFeatureDecorator metaFeatureDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DisplayName attribute
	 */
	String getDisplayName();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DisplayName attribute
	 */
	void setDisplayName(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the DisplayName attribute
	 */
	void unsetDisplayName();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the DisplayName attribute has been set
	 */
	boolean isSetDisplayName();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the ShortDescription attribute
	 */
	String getShortDescription();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the ShortDescription attribute
	 */
	void setShortDescription(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the ShortDescription attribute
	 */
	void unsetShortDescription();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the ShortDescription attribute has been set
	 */
	boolean isSetShortDescription();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Category attribute
	 */
	String getCategory();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Category attribute
	 */
	void setCategory(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the Category attribute
	 */
	void unsetCategory();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the Category attribute has been set
	 */
	boolean isSetCategory();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsExpert attribute
	 */
	boolean isExpert();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsExpert attribute
	 */
	Boolean getIsExpert();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsExpert attribute
	 */
	void setIsExpert(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsExpert attribute
	 */
	void setIsExpert(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsExpert attribute
	 */
	void unsetIsExpert();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsExpert attribute has been set
	 */
	boolean isSetIsExpert();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsHidden attribute
	 */
	boolean isHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsHidden attribute
	 */
	Boolean getIsHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsHidden attribute
	 */
	void setIsHidden(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsHidden attribute
	 */
	void setIsHidden(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsHidden attribute
	 */
	void unsetIsHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsHidden attribute has been set
	 */
	boolean isSetIsHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsPreferred attribute
	 */
	boolean isPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsPreferred attribute
	 */
	Boolean getIsPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsPreferred attribute
	 */
	void setIsPreferred(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsPreferred attribute
	 */
	void setIsPreferred(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsPreferred attribute
	 */
	void unsetIsPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsPreferred attribute has been set
	 */
	boolean isSetIsPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeIntrospection attribute
	 * Should the introspection results be merged into this decorator. If this is set to false, then the introspection results are ignored for this particular decorator. This is an internal feature simply to allow desired override capabilities.
	 */
	boolean isMergeIntrospection();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the MergeIntrospection attribute
	 * Should the introspection results be merged into this decorator. If this is set to false, then the introspection results are ignored for this particular decorator. This is an internal feature simply to allow desired override capabilities.
	 */
	Boolean getMergeIntrospection();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeIntrospection attribute
	 */
	void setMergeIntrospection(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the MergeIntrospection attribute
	 */
	void setMergeIntrospection(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the MergeIntrospection attribute
	 */
	void unsetMergeIntrospection();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the MergeIntrospection attribute has been set
	 */
	boolean isSetMergeIntrospection();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The list of Attributes references
	 */
	EList getAttributes();
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	String getName();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the AttributesExplicit attribute
	 * The attributes are explicitly set and not retrieved from the beaninfo.
	 */
	boolean isAttributesExplicit();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the AttributesExplicit attribute
	 * The attributes are explicitly set and not retrieved from the beaninfo.
	 */
	Boolean getAttributesExplicit();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the AttributesExplicit attribute
	 */
	void setAttributesExplicit(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the AttributesExplicit attribute
	 */
	void setAttributesExplicit(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the AttributesExplicit attribute
	 */
	void unsetAttributesExplicit();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the AttributesExplicit attribute has been set
	 */
	boolean isSetAttributesExplicit();
}
