package com.ibm.etools.beaninfo.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.beaninfo.*;


import java.util.List;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import com.ibm.etools.emf.ref.InstantiatorCollection;
import com.ibm.etools.emf.ref.RefBaseObject;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.PackageNotRegisteredException;
import com.ibm.etools.emf.ref.InstantiatorDescriptor;
import com.ibm.etools.emf.ref.RefObject;
import java.lang.Class;
import java.lang.Object;
/**
 * @lastgen class BeaninfoFactoryImpl extends EFactoryImpl implements BeaninfoFactory, EFactory, InstantiatorCollection {}
 */


public class BeaninfoFactoryImpl extends EFactoryImpl implements BeaninfoFactory, EFactory, InstantiatorCollection{
























































































	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private InstantiatorCollection instantiatorCollection;
	public BeaninfoFactoryImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 @param className The name of the class in the package
	 @return The static final int constant that maps to that class
	 */
	public int lookupClassConstant(String className) {


		InstantiatorDescriptor i = lookup(className);
		if (i!=null) return i.getId();
		else return  BeaninfoPackage.CLASS_UNKNOWN;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private InstantiatorCollection getInstantiatorCollection() {
		if (instantiatorCollection==null)
			instantiatorCollection = new BeaninfoInstanceCollectionImpl();
		return instantiatorCollection;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public InstantiatorDescriptor lookup(int id) {
		return getInstantiatorCollection().lookup(id);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public InstantiatorDescriptor lookup(Object instance) {
		return getInstantiatorCollection().lookup(instance);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public InstantiatorDescriptor lookup(String name) {
		return getInstantiatorCollection().lookup(name);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public int getSize() {
		return getInstantiatorCollection().getSize();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void addDescriptor(InstantiatorDescriptor c) {
		getInstantiatorCollection().addDescriptor(c);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject getInstance(Class c) {
		return getInstantiatorCollection().getInstance(c);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object create(String ObjectName) {
		switch (getBeaninfoPackage().getEMetaObjectId(ObjectName)) {
			case BeaninfoPackage.FEATURE_DECORATOR: return createFeatureDecorator();
			case BeaninfoPackage.PARAMETER_DECORATOR: return createParameterDecorator();
			case BeaninfoPackage.METHOD_DECORATOR: return createMethodDecorator();
			case BeaninfoPackage.EVENT_SET_DECORATOR: return createEventSetDecorator();
			case BeaninfoPackage.METHOD_PROXY: return createMethodProxy();
			case BeaninfoPackage.BEAN_EVENT: return createBeanEvent();
			case BeaninfoPackage.PROPERTY_DECORATOR: return createPropertyDecorator();
			case BeaninfoPackage.INDEXED_PROPERTY_DECORATOR: return createIndexedPropertyDecorator();
			case BeaninfoPackage.BEAN_DECORATOR: return createBeanDecorator();
			case BeaninfoPackage.FEATURE_ATTRIBUTE_VALUE: return createFeatureAttributeValue();
		}
		return super.create(ObjectName);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public FeatureDecorator createFeatureDecorator() {
		FeatureDecorator o = new FeatureDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EventSetDecorator createEventSetDecorator() {
		EventSetDecorator o = new EventSetDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MethodProxy createMethodProxy() {
		MethodProxy o = new MethodProxyImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PropertyDecorator createPropertyDecorator() {
		PropertyDecorator o = new PropertyDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public IndexedPropertyDecorator createIndexedPropertyDecorator() {
		IndexedPropertyDecorator o = new IndexedPropertyDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeanDecorator createBeanDecorator() {
		BeanDecorator o = new BeanDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MethodDecorator createMethodDecorator() {
		MethodDecorator o = new MethodDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ParameterDecorator createParameterDecorator() {
		ParameterDecorator o = new ParameterDecoratorImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public FeatureAttributeValue createFeatureAttributeValue() {
		FeatureAttributeValue o = new FeatureAttributeValueImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public JavaObject createJavaObject() {
		JavaObject o = new JavaObjectImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeaninfoPackage getBeaninfoPackage() {
		return (BeaninfoPackage)refPackage();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static BeaninfoFactory getActiveFactory() {
		BeaninfoPackage pkg = getPackage();
		if (pkg!=null) return pkg.getBeaninfoFactory();
		else return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static BeaninfoPackage getPackage() {
		BeaninfoPackage pkg;
		pkg = (BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI);
		return pkg;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeanEvent createBeanEvent() {
		BeanEvent o = new BeanEventImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
}
