package com.ibm.etools.beaninfo.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.beaninfo.*;
import com.ibm.etools.beaninfo.FeatureDecorator;
import com.ibm.etools.beaninfo.adapters.BeaninfoProxyConstants;
import com.ibm.etools.beaninfo.meta.MetaFeatureDecorator;
import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.EDecoratorImpl;
import com.ibm.etools.emf.ecore.utilities.copy.EtoolsCopySession;
import com.ibm.etools.emf.ecore.utilities.copy.EtoolsCopyUtility;
import com.ibm.etools.emf.notify.Notification;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.emf.ref.impl.EListImpl;
import com.ibm.etools.proxy.*;
import com.ibm.etools.beaninfo.meta.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.EList;
import com.ibm.etools.emf.ref.Extent;
import com.ibm.etools.emf.resource.Resource;


import java.util.List;
import java.lang.Boolean;
import java.lang.Object;
import java.lang.ClassCastException;
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * Equivalent to FeatureDescriptor in java.
 */
/**
 * @lastgen class FeatureDecoratorImpl extends EDecoratorImpl implements FeatureDecorator, EDecorator {}
 */


public class FeatureDecoratorImpl extends EDecoratorImpl implements FeatureDecorator, EDecorator{






























































































	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected IBeanProxy fFeatureProxy;
	protected FeatureDecorator fFeatureDecoratorProxy;
	private int fIsImplicit = NOT_IMPLICIT;
	private String fProxyDisplayName = null;
	private EList attributes = null;
	protected Boolean isDesignTimeProxy = null;
	protected boolean setIsDesignTimeProxy;
	 
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String displayName = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String shortDescription = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String category = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isExpert = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isHidden = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isPreferred = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean mergeIntrospection = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setDisplayName = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setShortDescription = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setCategory = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsExpert = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsHidden = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsPreferred = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setMergeIntrospection = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean attributesExplicit = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setAttributesExplicit = false;
	protected FeatureDecoratorImpl() {
		super();
	}
	protected boolean retrievedAttributes;
	
	protected boolean validProxy(IBeanProxy proxy) {
		return proxy != null ?
			proxy.getProxyFactoryRegistry().isValid() :
			false;
	}
			
	public EList getAttributes() {
		if (!isAttributesExplicit()) {
			if (validProxy(fFeatureProxy) && !retrievedAttributes) {
				retrievedAttributes = true;
				List attribs = this.getAttributesGen();				
				
				IMethodProxy getValue = BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getValueProxy();
				BeaninfoFactory bFact = ePackageBeaninfo().getBeaninfoFactory();
				
				try {				
					EnumerationBeanProxyWrapper attrNames = new EnumerationBeanProxyWrapper(BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getAttributeNamesProxy().invoke(fFeatureProxy));
					while (attrNames.hasMoreElements()) {
						try {
							IStringBeanProxy attrName = (IStringBeanProxy) attrNames.nextElement();
							IBeanProxy attrValue = getValue.invoke(fFeatureProxy, attrName);
							if ("ivjDesignTimeProperty".equals(attrName.stringValue())) { //$NON-NLS-1$
								// This is special, we pull it out.
								// This actually only has meaning for Properties, so we only set it here, it is not referenced till there.
								if (attrValue instanceof IBooleanBeanProxy) {
									IBooleanBeanProxy v = (IBooleanBeanProxy) attrValue;
									isDesignTimeProxy = v.getBooleanValue();
								}
								setIsDesignTimeProxy = true;
							} else {
								// Create the entry, which is FeatureAttribute with the key
								// being the attribute name and the value being the (as a proxy) being the value.
								FeatureAttributeValue fv = bFact.createFeatureAttributeValue();
								fv.setName(attrName.stringValue());
								fv.setValueProxy(attrValue);
								attribs.add(fv);
							}
						} catch (ThrowableProxy e) {
						}
					}
				} catch (ThrowableProxy e) {
				}						
			}
		}
		return this.getAttributesGen();
	}
	
	/**
	 * Was this decorator and/or feature implicitly created by introspection?
	 * The default should be NOT_IMPLICIT.
	 * This is here for linkage with the introspection process
	 * and is not really a MOF property. The introspection needs
	 * to know which features it created and which were explicitly
	 * created by other means. Implicitly created ones may be 
	 * deleted at any time when the introspection determines it
	 * needs to.
	 */
	public int isImplicitlyCreated() {
		return fIsImplicit;
	}
	
	public void setImplicitlyCreated(int implicit) {
		fIsImplicit = implicit;
	}
	
	
	public boolean isIntrospected() {
		return fFeatureProxy != null;
	}
	
	public void setDescriptorProxy(IBeanProxy descriptor) {
		fFeatureProxy = descriptor;
		fProxyDisplayName = null;
		if (retrievedAttributes) {
			attributes.clear();
			retrievedAttributes = false;
		}
		isDesignTimeProxy = null;
		if (validProxy(fFeatureProxy)) {
			// Cache display name because this is used over and over.
			if (!isSetDisplayName())
				try {
					fProxyDisplayName = ((IStringBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getDisplayNameProxy().invoke(fFeatureProxy)).stringValue();
				} catch (NullPointerException e) {
				} catch (ThrowableProxy e) {
				}
				
		}
				
	}
	
	public void setDecoratorProxy(FeatureDecorator decorator) {
		fFeatureDecoratorProxy = decorator;
	}
	
	public String getName() {
		ENamedElement ne = (ENamedElement)getEDecorates();
		if (ne != null)
			return ne.getName();	// The name from the owner of the feature has to be the name of feature.
		else
			return "?";	// Don't know what it is. //$NON-NLS-1$
	}
	
	public String getDisplayName() {
		if (!isSetDisplayName())
			if (fProxyDisplayName != null) 
				return fProxyDisplayName;
			else
				return getName();	// Use the name as the display name.
		return this.getDisplayNameGen();
	}
	public String getShortDescription() {
		if (validProxy(fFeatureProxy) && !isSetShortDescription()) {
			try {
				IStringBeanProxy str = (IStringBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getShortDescriptionProxy().invoke(fFeatureProxy);
				if (str != null)
					return str.stringValue();
			} catch (ThrowableProxy e) {
			};
			
			return getDisplayName();	// It not set, then use display name.
		}
					
		return this.getShortDescriptionGen();
	}
	public Boolean getIsExpert() {
		if (validProxy(fFeatureProxy) && !isSetIsExpert())
			try {
				return ((IBooleanBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getIsExpertProxy().invoke(fFeatureProxy)).getBooleanValue();
			} catch (ThrowableProxy e) {
			};
					
		return this.getIsExpertGen();
	}
	public Boolean getIsHidden() {
		if (validProxy(fFeatureProxy) && !isSetIsHidden())
			try {
				return ((IBooleanBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getIsHiddenProxy().invoke(fFeatureProxy)).getBooleanValue();
			} catch (ThrowableProxy e) {
			};
					
		return this.getIsHiddenGen();
	}
	public Boolean getIsPreferred() {
		if (validProxy(fFeatureProxy) && !isSetIsPreferred())
			try {
				return ((IBooleanBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getIsPreferredProxy().invoke(fFeatureProxy)).getBooleanValue();
			} catch (ThrowableProxy e) {
			};
					
		return this.getIsPreferredGen();
	}
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature = null;
		try {
			eFeature = (EStructuralFeature) feature;
			switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
				case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES :
					return this.attributes;
					// So we don't query over the proxy line for basic value.
			}
		} catch (ClassCastException e) {
		}


		return this.refBasicValueGen(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassFeatureDecorator());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeaninfoPackage ePackageBeaninfo() {
		return (BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassFeatureDecorator() {
		return ((BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI)).getFeatureDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MetaFeatureDecorator metaFeatureDecorator() {
		return ePackageBeaninfo().metaFeatureDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setDisplayName(String value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_DisplayName(),this.displayName,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetDisplayName() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_DisplayName()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetDisplayName() {
		return setDisplayName;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setShortDescription(String value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_ShortDescription(),this.shortDescription,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetShortDescription() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_ShortDescription()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetShortDescription() {
		return setShortDescription;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getCategory() {
		if (this.setCategory) return this.category;
		else return (String)ePackageBeaninfo().getFeatureDecorator_Category().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setCategory(String value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_Category(),this.category,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetCategory() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_Category()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetCategory() {
		return setCategory;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isExpert() {
		Boolean result = getIsExpert();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsExpert(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_IsExpert(),this.isExpert,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsExpert(boolean value) {
		setIsExpert(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsExpert() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_IsExpert()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsExpert() {
		return setIsExpert;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isHidden() {
		Boolean result = getIsHidden();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsHidden(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_IsHidden(),this.isHidden,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsHidden(boolean value) {
		setIsHidden(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsHidden() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_IsHidden()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsHidden() {
		return setIsHidden;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isPreferred() {
		Boolean result = getIsPreferred();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsPreferred(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_IsPreferred(),this.isPreferred,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsPreferred(boolean value) {
		setIsPreferred(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsPreferred() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_IsPreferred()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsPreferred() {
		return setIsPreferred;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Should the introspection results be merged into this decorator. If this is set to false, then the introspection results are ignored for this particular decorator. This is an internal feature simply to allow desired override capabilities.
	 */
	public Boolean getMergeIntrospection() {
		if (this.setMergeIntrospection) return this.mergeIntrospection;
		else return (Boolean)ePackageBeaninfo().getFeatureDecorator_MergeIntrospection().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Should the introspection results be merged into this decorator. If this is set to false, then the introspection results are ignored for this particular decorator. This is an internal feature simply to allow desired override capabilities.
	 */
	public boolean isMergeIntrospection() {
		Boolean result = getMergeIntrospection();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setMergeIntrospection(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_MergeIntrospection(),this.mergeIntrospection,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setMergeIntrospection(boolean value) {
		setMergeIntrospection(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetMergeIntrospection() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_MergeIntrospection()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetMergeIntrospection() {
		return setMergeIntrospection;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: return getDisplayName();
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: return getShortDescription();
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: return getCategory();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: return getIsExpert();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: return getIsHidden();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: return getIsPreferred();
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: return getMergeIntrospection();
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: return getAttributesExplicit();
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES: return getAttributes();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: return isSetDisplayName();
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: return isSetShortDescription();
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: return isSetCategory();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: return isSetIsExpert();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: return isSetIsHidden();
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: return isSetIsPreferred();
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: return isSetMergeIntrospection();
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: return isSetAttributesExplicit();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: {
				setDisplayName((String)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: {
				setShortDescription((String)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: {
				setCategory((String)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: {
				setIsExpert((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: {
				setIsHidden((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: {
				setIsPreferred((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: {
				setMergeIntrospection((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: {
				setAttributesExplicit((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: {
				Object oldValue = this.displayName;
				this.displayName = (String)newValue;
				this.setDisplayName = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_DisplayName(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: {
				Object oldValue = this.shortDescription;
				this.shortDescription = (String)newValue;
				this.setShortDescription = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_ShortDescription(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: {
				Object oldValue = this.category;
				this.category = (String)newValue;
				this.setCategory = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_Category(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: {
				Object oldValue = this.isExpert;
				this.isExpert = (Boolean)newValue;
				this.setIsExpert = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_IsExpert(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: {
				Object oldValue = this.isHidden;
				this.isHidden = (Boolean)newValue;
				this.setIsHidden = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_IsHidden(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: {
				Object oldValue = this.isPreferred;
				this.isPreferred = (Boolean)newValue;
				this.setIsPreferred = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_IsPreferred(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: {
				Object oldValue = this.mergeIntrospection;
				this.mergeIntrospection = (Boolean)newValue;
				this.setMergeIntrospection = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_MergeIntrospection(),oldValue,newValue);
			}
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: {
				Object oldValue = this.attributesExplicit;
				this.attributesExplicit = (Boolean)newValue;
				this.setAttributesExplicit = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getFeatureDecorator_AttributesExplicit(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: {
				unsetDisplayName();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: {
				unsetShortDescription();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: {
				unsetCategory();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: {
				unsetIsExpert();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: {
				unsetIsHidden();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: {
				unsetIsPreferred();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: {
				unsetMergeIntrospection();
				return;
			}
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: {
				unsetAttributesExplicit();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME: {
				Object oldValue = this.displayName;
				this.displayName = null;
				this.setDisplayName = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_DisplayName(),oldValue,getDisplayName());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION: {
				Object oldValue = this.shortDescription;
				this.shortDescription = null;
				this.setShortDescription = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_ShortDescription(),oldValue,getShortDescription());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY: {
				Object oldValue = this.category;
				this.category = null;
				this.setCategory = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_Category(),oldValue,getCategory());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT: {
				Object oldValue = this.isExpert;
				this.isExpert = null;
				this.setIsExpert = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_IsExpert(),oldValue,getIsExpert());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN: {
				Object oldValue = this.isHidden;
				this.isHidden = null;
				this.setIsHidden = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_IsHidden(),oldValue,getIsHidden());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED: {
				Object oldValue = this.isPreferred;
				this.isPreferred = null;
				this.setIsPreferred = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_IsPreferred(),oldValue,getIsPreferred());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION: {
				Object oldValue = this.mergeIntrospection;
				this.mergeIntrospection = null;
				this.setMergeIntrospection = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_MergeIntrospection(),oldValue,getMergeIntrospection());
			}
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT: {
				Object oldValue = this.attributesExplicit;
				this.attributesExplicit = null;
				this.setAttributesExplicit = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getFeatureDecorator_AttributesExplicit(),oldValue,getAttributesExplicit());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetDisplayName()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="displayName: "+this.displayName; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetShortDescription()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="shortDescription: "+this.shortDescription; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetCategory()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="category: "+this.category; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsExpert()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isExpert: "+this.isExpert; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsHidden()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isHidden: "+this.isHidden; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsPreferred()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isPreferred: "+this.isPreferred; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetMergeIntrospection()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="mergeIntrospection: "+this.mergeIntrospection; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetAttributesExplicit()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="attributesExplicit: "+this.attributesExplicit; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected String getDisplayNameGen() {
		if (this.setDisplayName) return this.displayName;
		else return (String)ePackageBeaninfo().getFeatureDecorator_DisplayName().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected String getShortDescriptionGen() {
		if (this.setShortDescription) return this.shortDescription;
		else return (String)ePackageBeaninfo().getFeatureDecorator_ShortDescription().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Boolean getIsExpertGen() {
		if (this.setIsExpert) return this.isExpert;
		else return (Boolean)ePackageBeaninfo().getFeatureDecorator_IsExpert().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Boolean getIsHiddenGen() {
		if (this.setIsHidden) return this.isHidden;
		else return (Boolean)ePackageBeaninfo().getFeatureDecorator_IsHidden().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Boolean getIsPreferredGen() {
		if (this.setIsPreferred) return this.isPreferred;
		else return (Boolean)ePackageBeaninfo().getFeatureDecorator_IsPreferred().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected EList getAttributesGen() {
		if (this.attributes==null) {
			this.attributes=newCollection(refDelegateOwner(),ePackageBeaninfo().getFeatureDecorator_Attributes());
		}
		return this.attributes;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected String getNameGen() {
		return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Object refBasicValueGen(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassFeatureDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.FEATURE_DECORATOR__DISPLAY_NAME:
				return this.setDisplayName? this.displayName : null;
			case BeaninfoPackage.FEATURE_DECORATOR__SHORT_DESCRIPTION:
				return this.setShortDescription? this.shortDescription : null;
			case BeaninfoPackage.FEATURE_DECORATOR__CATEGORY:
				return this.setCategory? this.category : null;
			case BeaninfoPackage.FEATURE_DECORATOR__IS_EXPERT:
				return this.setIsExpert? this.isExpert : null;
			case BeaninfoPackage.FEATURE_DECORATOR__IS_HIDDEN:
				return this.setIsHidden? this.isHidden : null;
			case BeaninfoPackage.FEATURE_DECORATOR__IS_PREFERRED:
				return this.setIsPreferred? this.isPreferred : null;
			case BeaninfoPackage.FEATURE_DECORATOR__MERGE_INTROSPECTION:
				return this.setMergeIntrospection? this.mergeIntrospection : null;
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES_EXPLICIT:
				return this.setAttributesExplicit? this.attributesExplicit : null;
			case BeaninfoPackage.FEATURE_DECORATOR__ATTRIBUTES:
				return this.attributes;

		}
		return super.refBasicValue(feature);
	}
	/*
	 * @see FeatureDecorator#createIntrospectedCopy()
	 */
	public final FeatureDecorator createIntrospectedCopy() {
		// Bug in copy, has problems with the eDecorates, so we will undo it and then put it back.
		// We will use basicUnset and set so that it will only temporarily be unset, but it won't
		// cause the decorates object to be notified of the change.
		EModelElement decorates = getEDecorates();
		// Get an clone of it so that any currently actual sets will be copied for us.
		refBasicUnsetValue(ePackageEcore().getEDecorator_EDecorates());
		EtoolsCopyUtility copyUtil = new EtoolsCopyUtility();
		copyUtil.setPreserveIds(true);
		FeatureDecorator newGuy = (FeatureDecorator) copyUtil.copy(this);
		refBasicSetValue(ePackageEcore().getEDecorator_EDecorates(), decorates);
		
		applyIntrospectionToCopy(newGuy);
		return newGuy;
	}
	
	/*
	 * Set the introspected values onto this guy. All subclasses need to 
	 * override and apply their settings. They must also call super.
	 */
	protected void applyIntrospectionToCopy(FeatureDecorator decorator) {
		// Display name special because it appears set on beaninfo side even if not set,
		// so if it appears to be set and is the same as the name, then don't set it.
		if (!isSetDisplayName() && fProxyDisplayName != null && !getName().equals(fProxyDisplayName))
			decorator.setDisplayName(getDisplayName());
		// Short description is special because it appears set on beaninfo side even if not set,
		// so if it appears to be set and is the same as the display name, then don't set it.			
		if (!isSetShortDescription() && !getDisplayName().equals(getShortDescription()))
			decorator.setShortDescription(getShortDescription());
		if (fFeatureProxy != null && !isSetIsExpert())
			decorator.setIsExpert(getIsExpert());
		if (fFeatureProxy != null && !isSetIsHidden())
			decorator.setIsHidden(getIsHidden());
		if (fFeatureProxy != null && !isSetIsPreferred())
			decorator.setIsPreferred(getIsPreferred());
		if (fFeatureProxy != null && !isAttributesExplicit())
			decorator.setAttributesExplicit(true);	// Attributes are now explicit, they should of already been copied over.
	}


	/*
	 * @see FeatureDecorator#refreshMethodReferences()
	 */
	public void refreshJavaReferences() {
		// Feature decorators don't have any method references.
	}
	
	/**
	 * Create a proxy from the given InternalProxy, if not a proxy, else return as is.
	 */
	public static Object makeProxy(InternalProxy proxy) {
		if (proxy != null && !proxy.refIsProxy())
			return proxy.refCreateProxy();
		else
			return proxy;
	}


	/**
	 * @generated This field/method will be replaced during code generation 
	 * The attributes are explicitly set and not retrieved from the beaninfo.
	 */
	public Boolean getAttributesExplicit() {
		if (this.setAttributesExplicit) return this.attributesExplicit;
		else return (Boolean)ePackageBeaninfo().getFeatureDecorator_AttributesExplicit().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * The attributes are explicitly set and not retrieved from the beaninfo.
	 */
	public boolean isAttributesExplicit() {
		Boolean result = getAttributesExplicit();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setAttributesExplicit(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getFeatureDecorator_AttributesExplicit(),this.attributesExplicit,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setAttributesExplicit(boolean value) {
		setAttributesExplicit(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetAttributesExplicit() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getFeatureDecorator_AttributesExplicit()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetAttributesExplicit() {
		return setAttributesExplicit;
	}
}
