package com.ibm.etools.beaninfo.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.beaninfo.*;
import com.ibm.etools.beaninfo.FeatureDecorator;


import java.util.*;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.EList;
import com.ibm.etools.proxy.*;
import com.ibm.etools.beaninfo.adapters.BeaninfoProxyConstants;
import com.ibm.etools.java.Method;
import com.ibm.etools.java.JavaParameter;
import com.ibm.etools.beaninfo.adapters.*;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.beaninfo.meta.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
import java.lang.Boolean;
import java.lang.Object;
import java.lang.ClassCastException;
/**
 * @lastgen class MethodDecoratorImpl extends FeatureDecoratorImpl implements MethodDecorator, FeatureDecorator {}
 */


public class MethodDecoratorImpl extends FeatureDecoratorImpl implements MethodDecorator, FeatureDecorator{






































































	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected boolean fRetrievedParms = false;
	protected boolean fRetrievedParmsSuccessful = false;
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean parmsExplicit = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EList parameterDescriptors = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setParmsExplicit = false;
	protected MethodDecoratorImpl() {
		super();
	}
	public EList getParameterDescriptors() {
		if (!isParmsExplicit()) {
			if (validProxy(fFeatureProxy) && !fRetrievedParms) {
				fRetrievedParms = true;
				EList parmsList = this.getParameterDescriptorsGen();
									
				try {
					IArrayBeanProxy parms = (IArrayBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getParameterDescriptorsProxy().invoke(fFeatureProxy);
					if (parms != null) {
						List plist = getMethodParameters();
						int plistLength = plist != null ? plist.size() : 0;
						int parmsLength = Math.min(parms.getLength(), plistLength);
						// Don't want to add more than there really is. This just means that the beaninfo is out of sync with the code.
						for (int i=0; i<parmsLength; i++) {
							IBeanProxy parm = parms.get(i);
							ParameterDecorator pd = ((BeaninfoFactory) metaMethodDecorator().refPackage().getFactory()).createParameterDecorator();
							pd.setImplicitlyCreated(IMPLICIT_DECORATOR);
							pd.setDescriptorProxy(parm);
							parmsList.add(pd);
							// Get the real parm and set as the decorates.
							pd.setParameter((JavaParameter) plist.get(i));
						}
						fRetrievedParmsSuccessful = true;
						return parmsList;
					}		
				} catch (ThrowableProxy e) {
				};
			}
			
			if (fRetrievedParmsSuccessful)
				return this.getParameterDescriptorsGen();	// Built once from proxy, use it always.
			else
				return createDefaultParmsList();	// Not explicit and not sucessful retrieval, use default.
		}
		return this.getParameterDescriptorsGen();
	}
	/**
	 * This is called if parms list not explicitly set and there is no feature proxy or
	 * there is a feature proxy and the proxy has nothing defined.
	 * We will generate a list based upon the parameters from the method itself.
	 * We won't cache it because it may change and we aren't listening for changes.
	 * It shouldn't be used that often to cause a performance problem.
	 */
	protected EList createDefaultParmsList() {
		EList parmsList = this.getParameterDescriptorsGen();
		parmsList.clear();
		
		List p = getMethodParameters();
		if (p == null)
			return parmsList;	// Couldn't get the list for some reason, so leave as is.
		int psize = p.size();
		for (int i=0; i<psize; i++) {
			ParameterDecorator pd = ePackageBeaninfo().getBeaninfoFactory().createParameterDecorator();
			JavaParameter jp = (JavaParameter) p.get(i);
			pd.setName(jp.getName());
			pd.setParameter(jp);
			parmsList.add(pd);
		}
		return parmsList;
	}
	
	/*
	 * Initialize the ParameterDecorators to point to the JavaParameter they are describing.
	 * This is called from ParameterDecorator when it finds that its JavaParameter has not been set.
	 * This means that it was explicitly added and we need to setup the parms.
	 */
	protected void initializeParameters() {
		if (this.parameterDescriptors == null)
			return;
		List mp = getMethodParameters();
		if (mp == null || mp.isEmpty())
			return;	// Nothing that can be described.
		int psize = Math.min(this.parameterDescriptors.size(), mp.size());
		for (int i=0; i < psize; i++)
			((ParameterDecorator) this.parameterDescriptors.get(i)).setParameter((JavaParameter) mp.get(i));
	}


	protected List getMethodParameters() {
		// Get the method
		Method m = null;
		Object d = getEDecorates();
		if (d instanceof Method)
			m = (Method) d;
		else 
			if (d instanceof MethodProxy)
				m = ((MethodProxy) d).getMethod();
			else
				return null;	// Not decorating correct object.
		if (m == null)
			return null;	// Couldn't find the method.
		List p = m.getParametersWithoutReturn();
		return p;
	}
			
			
	
	public void setDescriptorProxy(IBeanProxy descriptorProxy) {
		if (fRetrievedParms) {
			this.getParameterDescriptorsGen().clear();
			fRetrievedParms = fRetrievedParmsSuccessful = false;
		}
		super.setDescriptorProxy(descriptorProxy);
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassMethodDecorator());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeaninfoPackage ePackageBeaninfo() {
		return (BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassMethodDecorator() {
		return ((BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI)).getMethodDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MetaMethodDecorator metaMethodDecorator() {
		return ePackageBeaninfo().metaMethodDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If the parameterDescriptors feature is explicitly set, ie. not through the method descriptor proxy, then this flag must be set true. If it is true, then the parameterDescriptors will not be brought over from the descriptor proxy, nor will default ones be created if there aren't any specified.
	 */
	public Boolean getParmsExplicit() {
		if (this.setParmsExplicit) return this.parmsExplicit;
		else return (Boolean)ePackageBeaninfo().getMethodDecorator_ParmsExplicit().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If the parameterDescriptors feature is explicitly set, ie. not through the method descriptor proxy, then this flag must be set true. If it is true, then the parameterDescriptors will not be brought over from the descriptor proxy, nor will default ones be created if there aren't any specified.
	 */
	public boolean isParmsExplicit() {
		Boolean result = getParmsExplicit();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setParmsExplicit(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getMethodDecorator_ParmsExplicit(),this.parmsExplicit,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setParmsExplicit(boolean value) {
		setParmsExplicit(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetParmsExplicit() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getMethodDecorator_ParmsExplicit()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetParmsExplicit() {
		return setParmsExplicit;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: return getParmsExplicit();
			case BeaninfoPackage.METHOD_DECORATOR__PARAMETER_DESCRIPTORS: return getParameterDescriptors();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT:
				return this.setParmsExplicit? this.parmsExplicit : null;
			case BeaninfoPackage.METHOD_DECORATOR__PARAMETER_DESCRIPTORS:
				return this.parameterDescriptors;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: return isSetParmsExplicit();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: {
				setParmsExplicit((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: {
				Object oldValue = this.parmsExplicit;
				this.parmsExplicit = (Boolean)newValue;
				this.setParmsExplicit = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getMethodDecorator_ParmsExplicit(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: {
				unsetParmsExplicit();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassMethodDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.METHOD_DECORATOR__PARMS_EXPLICIT: {
				Object oldValue = this.parmsExplicit;
				this.parmsExplicit = null;
				this.setParmsExplicit = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getMethodDecorator_ParmsExplicit(),oldValue,getParmsExplicit());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetParmsExplicit()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="parmsExplicit: "+this.parmsExplicit; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected EList getParameterDescriptorsGen() {
		if (this.parameterDescriptors==null) {
			this.parameterDescriptors=newCollection(refDelegateOwner(),ePackageBeaninfo().getMethodDecorator_ParameterDescriptors());
		}
		return this.parameterDescriptors;
	}
	/*
	 * @see FeatureDecoratorImpl#applyIntrospectionToCopy(FeatureDecorator)
	 */
	protected void applyIntrospectionToCopy(FeatureDecorator decorator) {
		super.applyIntrospectionToCopy(decorator);
		MethodDecorator md = (MethodDecorator) decorator;
		getParameterDescriptors();	// Force the creation if not already created.
		if (fRetrievedParmsSuccessful) {
			// We've retrieved parms from introspection. Copy them over.
			List newList = md.getParameterDescriptors();
			newList.clear();	// Clear in case something was copied over, we're going to replace them.
			Iterator itr = getParameterDescriptors().iterator();
			while (itr.hasNext()) {
				ParameterDecorator pd = (ParameterDecorator) itr.next();
				newList.add(pd.createIntrospectedCopy());
			}
			md.setParmsExplicit(true);	// Parms are now explicit.
		} else {
			// Kludge so that a copy of the md does not try to fill in the parameters again.
			// This won't get serialized out so it will be fine upon loading in the diff.
			// This happens because we created the parm list by default (i.e. went against
			// the method proxy to figure it out). But in that case we want to always default,
			// so we want to make sure that no clone will reconstruct the parms, which is what
			// setting these flags here does.
			((MethodDecoratorImpl) md).fRetrievedParmsSuccessful = true;
			((MethodDecoratorImpl) md).fRetrievedParms = true;
		}
	}


	/*
	 * @see FeatureDecorator#refreshMethodReferences()
	 */
	public void refreshJavaReferences() {
		super.refreshJavaReferences();
		if (this.parameterDescriptors != null) {
			Iterator itr = this.parameterDescriptors.iterator();
			while(itr.hasNext())
				((ParameterDecorator) itr.next()).refreshJavaReferences();
		}
	}


}
