package com.ibm.etools.beaninfo.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.beaninfo.*;
import com.ibm.etools.beaninfo.FeatureDecorator;


import java.util.List;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import com.ibm.etools.java.JavaParameter;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.proxy.*;
import com.ibm.etools.beaninfo.adapters.BeaninfoProxyConstants;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.beaninfo.meta.*;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
import com.ibm.etools.java.*;
import com.ibm.etools.emf.ref.InternalProxy;
import java.lang.Object;
import java.lang.ClassCastException;
/**
 * @lastgen class ParameterDecoratorImpl extends FeatureDecoratorImpl implements ParameterDecorator, FeatureDecorator {}
 */


public class ParameterDecoratorImpl extends FeatureDecoratorImpl implements ParameterDecorator, FeatureDecorator{








































































	protected ParameterDecoratorImpl() {
		super();
	}
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected String fProxyName;
	protected boolean triedOnce;	// Set when tried to get the java parameter and couldn't.
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String name = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setName = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected JavaParameter parameter = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setParameter = false;
	public void setDescriptorProxy(IBeanProxy descriptor) {
		super.setDescriptorProxy(descriptor);
		
		fProxyName = null;
		if (descriptor != null) {
			// Cache name and because these are used over and over.
			if (!isSetName())
				try {
					fProxyName = ((IStringBeanProxy) BeaninfoProxyConstants.getConstants(descriptor.getProxyFactoryRegistry()).getNameProxy().invoke(descriptor)).stringValue();
				} catch (NullPointerException e) {
				} catch (ThrowableProxy e) {
				}				
		}
	}
	
	public String getName() {
		if (!isSetName())
			if (fProxyName != null) 
				return fProxyName;
			else
				return "?";	// It must be set or come from proxy. //$NON-NLS-1$
		return this.getNameGen();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassParameterDecorator());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeaninfoPackage ePackageBeaninfo() {
		return (BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassParameterDecorator() {
		return ((BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI)).getParameterDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MetaParameterDecorator metaParameterDecorator() {
		return ePackageBeaninfo().metaParameterDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setName(String value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getParameterDecorator_Name(),this.name,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetName() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getParameterDecorator_Name()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetName() {
		return setName;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: return getName();
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: return getParameter();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME:
				return this.setName? this.name : null;
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER:
				if (!this.setParameter||this.parameter==null) return null;
				if (((InternalProxy)this.parameter).refIsDeleted()) {this.parameter=null; this.setParameter=false;}
				return this.parameter;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: return isSetName();
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: return isSetParameter();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: {
				setName((String)newValue);
				return;
			}
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: {
				setParameter((JavaParameter)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: {
				Object oldValue = this.name;
				this.name = (String)newValue;
				this.setName = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getParameterDecorator_Name(),oldValue,newValue);
			}
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: {
				Object oldValue = this.parameter;
				this.parameter = (JavaParameter)newValue;
				this.setParameter = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getParameterDecorator_Parameter(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: {
				unsetName();
				return;
			}
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: {
				unsetParameter();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassParameterDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PARAMETER_DECORATOR__NAME: {
				Object oldValue = this.name;
				this.name = null;
				this.setName = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getParameterDecorator_Name(),oldValue,getName());
			}
			case BeaninfoPackage.PARAMETER_DECORATOR__PARAMETER: {
				Object oldValue = this.parameter;
				this.parameter = null;
				this.setParameter = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getParameterDecorator_Parameter(),oldValue,null);
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetName()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="name: "+this.name; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * The name is explicit here because unlike the other feature decorators, the name does not come from the object being decorated.
	 */
	protected String getNameGen() {
		if (this.setName) return this.name;
		else return (String)ePackageBeaninfo().getParameterDecorator_Name().refGetDefaultValue();
	}
	/*
	 * @see FeatureDecoratorImpl#applyIntrospectionToCopy(FeatureDecorator)
	 */
	protected void applyIntrospectionToCopy(FeatureDecorator decorator) {
		super.applyIntrospectionToCopy(decorator);
		
		ParameterDecorator pd = (ParameterDecorator) decorator;
		if (!isSetName() && fProxyName != null)
			pd.setName(getName());
	}


	/*
	 * @see FeatureDecorator#refreshJavaReferences()
	 */
	public void refreshJavaReferences() {
		super.refreshJavaReferences();
		
		if (isSetParameter()) 
			this.parameter = (JavaParameter) makeProxy((InternalProxy) this.parameter);
	}

	/**
	 * The JavaParameter that this ParameterDecorator is decorating. Can't use eDecorates in this.
	 */
	public JavaParameter getParameter() {
		if (!isSetParameter() && !triedOnce) {
			// Need to try to fill in the parameter setting.
			triedOnce = true;
			RefBaseObject container = refContainer();	// See if we are in a MethodDecorator.
			if (container instanceof MethodDecoratorImpl)
				((MethodDecoratorImpl) container).initializeParameters();
		}
		
		return getParameterGen();
	}
	
	/**
	 * @generated This field/method will be replaced during code generation 
	 * The JavaParameter that this ParameterDecorator is decorating. Can't use eDecorates in this.
	 */
	protected JavaParameter getParameterGen() {
		try {
			if (this.parameter == null) return null;
			this.parameter = (JavaParameter) ((InternalProxy)this.parameter).resolve(this, ePackageBeaninfo().getParameterDecorator_Parameter());
			if (this.parameter==null) this.setParameter = false;
			return this.parameter;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setParameter(JavaParameter l) {
		refSetValueForSimpleSF(ePackageBeaninfo().getParameterDecorator_Parameter(),this.parameter,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetParameter() {
		refUnsetValueForSimpleSF(ePackageBeaninfo().getParameterDecorator_Parameter());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetParameter() {
		return setParameter;
	}
}
