package com.ibm.etools.beaninfo.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.beaninfo.*;
import com.ibm.etools.beaninfo.FeatureDecorator;


import java.util.List;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.beaninfo.adapters.*;
import com.ibm.etools.proxy.*;
import com.ibm.etools.java.*;
import com.ibm.etools.emf.ecore.EClassifier;
import com.ibm.etools.emf.ecore.EStructuralFeature;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.beaninfo.meta.*;
import com.ibm.etools.emf.ref.EList;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
import com.ibm.etools.emf.ref.Extent;
import com.ibm.etools.emf.resource.Resource;
/**
 * @lastgen class PropertyDecoratorImpl extends FeatureDecoratorImpl implements PropertyDecorator, FeatureDecorator {}
 */


public class PropertyDecoratorImpl extends FeatureDecoratorImpl implements PropertyDecorator, FeatureDecorator{

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	// getting read/write methods are expensive, and they are called very often in parsing, so we will cache them
	private Method cachedReadMethod, cachedWriteMethod;
	boolean retrievedReadMethod, retrievedWriteMethod;
		
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isBound = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isConstrained = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isDesignTime = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isAlwaysIncompatible = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EList filterFlags = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected JavaClass propertyEditorClass = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Method readMethod = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Method writeMethod = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsBound = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsConstrained = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsDesignTime = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsAlwaysIncompatible = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setPropertyEditorClass = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setReadMethod = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setWriteMethod = false;
	protected PropertyDecoratorImpl() {
		super();
	}
	public Boolean getIsBound() {
		if (!isSetIsBound()) {
			if (validProxy(fFeatureProxy)) {
				try {
					return ((IBooleanBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getIsBoundProxy().invoke(fFeatureProxy)).getBooleanValue();
				} catch (ThrowableProxy e) {
				}
			} else
				if (fFeatureDecoratorProxy != null)
					return ((PropertyDecorator) fFeatureDecoratorProxy).getIsBound();
		}
					
		return this.getIsBoundGen();
	}
	public Boolean getIsConstrained() {
		if (!isSetIsConstrained()) {
			if (validProxy(fFeatureProxy)) {
				try {
					return ((IBooleanBeanProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getIsConstrainedProxy().invoke(fFeatureProxy)).getBooleanValue();
				} catch (ThrowableProxy e) {
				}
			} else
				if (fFeatureDecoratorProxy != null)
					return ((PropertyDecorator) fFeatureDecoratorProxy).getIsConstrained();
		}
									
		return this.getIsConstrainedGen();
	}
	public Boolean getIsDesignTime() {
		if (validProxy(fFeatureProxy) && !this.isSetIsDesignTimeGen()) {
			getAttributes();	// This will cause the isDesignTime flag to be set if found.
			return isDesignTimeProxy;	// Return the value
		}
		
		return this.getIsDesignTimeGen();
	}
	public boolean isSetIsDesignTime() {
		if (validProxy(fFeatureProxy) && !this.isSetIsDesignTimeGen()) {
			getAttributes();	// This will cause the isDesignTime flag to be set if found.
			return setIsDesignTimeProxy;	// Return whether set or not.
		}
		
		return this.isSetIsDesignTimeGen();
	}
	public JavaClass getPropertyEditorClass() {
		if (validProxy(fFeatureProxy) && !this.isSetPropertyEditorClass())
			try {
				return (JavaClass) Utilities.getJavaClass((IBeanTypeProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getPropertyEditorClassProxy().invoke(fFeatureProxy),  getEDecorates().refResource().getResourceSet());
			} catch (ThrowableProxy e) {
			};
					
		return this.getPropertyEditorClassGen();
	}
	
	public Method getReadMethod() {
		if (!isSetReadMethod()) {
			if (validProxy(fFeatureProxy)) {
				if (!retrievedReadMethod) {
					try {
						cachedReadMethod = Utilities.getMethod((IMethodProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getReadMethodProxy().invoke(fFeatureProxy),  getEDecorates().refResource().getResourceSet());
						retrievedReadMethod = true;
					} catch (ThrowableProxy e) {
					}
				}
				return cachedReadMethod;
			} else
				if (fFeatureDecoratorProxy != null)
					return ((PropertyDecorator) fFeatureDecoratorProxy).getReadMethod();
		}
									
		return this.getReadMethodGen();
	}
	public Method getWriteMethod() {
		if (!isSetWriteMethod()) {
			if (validProxy(fFeatureProxy)) {
				if (!retrievedWriteMethod) {
					try {
						cachedWriteMethod = Utilities.getMethod((IMethodProxy) BeaninfoProxyConstants.getConstants(fFeatureProxy.getProxyFactoryRegistry()).getWriteMethodProxy().invoke(fFeatureProxy),  getEDecorates().refResource().getResourceSet());
						retrievedWriteMethod = true;
					} catch (ThrowableProxy e) {
					}
				}
				return cachedWriteMethod;
			} else
				if (fFeatureDecoratorProxy != null)
					return	((PropertyDecorator) fFeatureDecoratorProxy).getWriteMethod();
		}
									
		return this.getWriteMethodGen();
	}
	public EClassifier getPropertyType() {
		EStructuralFeature feature = (EStructuralFeature) getEDecorates();
		return (feature != null) ? feature.getETypeClassifier() : null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassPropertyDecorator());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public BeaninfoPackage ePackageBeaninfo() {
		return (BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassPropertyDecorator() {
		return ((BeaninfoPackage)RefRegister.getPackage(BeaninfoPackage.packageURI)).getPropertyDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public MetaPropertyDecorator metaPropertyDecorator() {
		return ePackageBeaninfo().metaPropertyDecorator();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isBound() {
		Boolean result = getIsBound();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsBound(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_IsBound(),this.isBound,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsBound(boolean value) {
		setIsBound(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsBound() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getPropertyDecorator_IsBound()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsBound() {
		return setIsBound;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isConstrained() {
		Boolean result = getIsConstrained();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsConstrained(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_IsConstrained(),this.isConstrained,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsConstrained(boolean value) {
		setIsConstrained(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsConstrained() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getPropertyDecorator_IsConstrained()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsConstrained() {
		return setIsConstrained;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If not set, then normal default processing.
	 * 
	 * If set true, then this property is a design time property. This means it will show up in the property sheet, but it won't be able to be connected to at runtime. It may not even be a true bean property but instead the builder will know how to handle it.
	 * 
	 * If set false, then this property will not show up on the property sheet, but will be able to be connected to for runtime.
	 */
	public boolean isDesignTime() {
		Boolean result = getIsDesignTime();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsDesignTime(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_IsDesignTime(),this.isDesignTime,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsDesignTime(boolean value) {
		setIsDesignTime(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsDesignTime() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getPropertyDecorator_IsDesignTime()));
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If set true, then when multiple objects are selected, this property is always incompatible with each other. So in this case the property will not show up on the property sheet if more than one object has been selected.
	 */
	public Boolean getIsAlwaysIncompatible() {
		if (this.setIsAlwaysIncompatible) return this.isAlwaysIncompatible;
		else return (Boolean)ePackageBeaninfo().getPropertyDecorator_IsAlwaysIncompatible().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If set true, then when multiple objects are selected, this property is always incompatible with each other. So in this case the property will not show up on the property sheet if more than one object has been selected.
	 */
	public boolean isAlwaysIncompatible() {
		Boolean result = getIsAlwaysIncompatible();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsAlwaysIncompatible(Boolean value) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_IsAlwaysIncompatible(),this.isAlwaysIncompatible,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsAlwaysIncompatible(boolean value) {
		setIsAlwaysIncompatible(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsAlwaysIncompatible() {
		notify(refBasicUnsetValue(ePackageBeaninfo().getPropertyDecorator_IsAlwaysIncompatible()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsAlwaysIncompatible() {
		return setIsAlwaysIncompatible;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public EList getFilterFlags() {
		if (this.filterFlags==null) {
			this.filterFlags=newCollection(this,ePackageBeaninfo().getPropertyDecorator_FilterFlags());
		}
		return this.filterFlags;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setPropertyEditorClass(JavaClass l) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_PropertyEditorClass(),this.propertyEditorClass,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetPropertyEditorClass() {
		refUnsetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_PropertyEditorClass());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetPropertyEditorClass() {
		return setPropertyEditorClass;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setReadMethod(Method l) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_ReadMethod(),this.readMethod,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetReadMethod() {
		refUnsetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_ReadMethod());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetReadMethod() {
		return setReadMethod;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setWriteMethod(Method l) {
		refSetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_WriteMethod(),this.writeMethod,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetWriteMethod() {
		refUnsetValueForSimpleSF(ePackageBeaninfo().getPropertyDecorator_WriteMethod());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetWriteMethod() {
		return setWriteMethod;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: return getIsBound();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: return getIsConstrained();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: return getIsDesignTime();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: return getIsAlwaysIncompatible();
			case BeaninfoPackage.PROPERTY_DECORATOR__FILTER_FLAGS: return getFilterFlags();
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: return getPropertyEditorClass();
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: return getReadMethod();
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: return getWriteMethod();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND:
				return this.setIsBound? this.isBound : null;
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED:
				return this.setIsConstrained? this.isConstrained : null;
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME:
				return this.setIsDesignTime? this.isDesignTime : null;
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE:
				return this.setIsAlwaysIncompatible? this.isAlwaysIncompatible : null;
			case BeaninfoPackage.PROPERTY_DECORATOR__FILTER_FLAGS:
				return this.filterFlags;
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS:
				if (!this.setPropertyEditorClass||this.propertyEditorClass==null) return null;
				if (((InternalProxy)this.propertyEditorClass).refIsDeleted()) {this.propertyEditorClass=null; this.setPropertyEditorClass=false;}
				return this.propertyEditorClass;
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD:
				if (!this.setReadMethod||this.readMethod==null) return null;
				if (((InternalProxy)this.readMethod).refIsDeleted()) {this.readMethod=null; this.setReadMethod=false;}
				return this.readMethod;
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD:
				if (!this.setWriteMethod||this.writeMethod==null) return null;
				if (((InternalProxy)this.writeMethod).refIsDeleted()) {this.writeMethod=null; this.setWriteMethod=false;}
				return this.writeMethod;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: return isSetIsBound();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: return isSetIsConstrained();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: return isSetIsDesignTime();
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: return isSetIsAlwaysIncompatible();
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: return isSetPropertyEditorClass();
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: return isSetReadMethod();
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: return isSetWriteMethod();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: {
				setIsBound((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: {
				setIsConstrained((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: {
				setIsDesignTime((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: {
				setIsAlwaysIncompatible((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: {
				setPropertyEditorClass((JavaClass)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: {
				setReadMethod((Method)newValue);
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: {
				setWriteMethod((Method)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: {
				Object oldValue = this.isBound;
				this.isBound = (Boolean)newValue;
				this.setIsBound = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_IsBound(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: {
				Object oldValue = this.isConstrained;
				this.isConstrained = (Boolean)newValue;
				this.setIsConstrained = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_IsConstrained(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: {
				Object oldValue = this.isDesignTime;
				this.isDesignTime = (Boolean)newValue;
				this.setIsDesignTime = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_IsDesignTime(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: {
				Object oldValue = this.isAlwaysIncompatible;
				this.isAlwaysIncompatible = (Boolean)newValue;
				this.setIsAlwaysIncompatible = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_IsAlwaysIncompatible(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: {
				Object oldValue = this.propertyEditorClass;
				this.propertyEditorClass = (JavaClass)newValue;
				this.setPropertyEditorClass = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_PropertyEditorClass(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: {
				Object oldValue = this.readMethod;
				this.readMethod = (Method)newValue;
				this.setReadMethod = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_ReadMethod(),oldValue,newValue);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: {
				Object oldValue = this.writeMethod;
				this.writeMethod = (Method)newValue;
				this.setWriteMethod = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageBeaninfo().getPropertyDecorator_WriteMethod(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: {
				unsetIsBound();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: {
				unsetIsConstrained();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: {
				unsetIsDesignTime();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: {
				unsetIsAlwaysIncompatible();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: {
				unsetPropertyEditorClass();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: {
				unsetReadMethod();
				return;
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: {
				unsetWriteMethod();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassPropertyDecorator().getEFeatureId(eFeature)) {
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_BOUND: {
				Object oldValue = this.isBound;
				this.isBound = null;
				this.setIsBound = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_IsBound(),oldValue,getIsBound());
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_CONSTRAINED: {
				Object oldValue = this.isConstrained;
				this.isConstrained = null;
				this.setIsConstrained = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_IsConstrained(),oldValue,getIsConstrained());
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_DESIGN_TIME: {
				Object oldValue = this.isDesignTime;
				this.isDesignTime = null;
				this.setIsDesignTime = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_IsDesignTime(),oldValue,getIsDesignTime());
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__IS_ALWAYS_INCOMPATIBLE: {
				Object oldValue = this.isAlwaysIncompatible;
				this.isAlwaysIncompatible = null;
				this.setIsAlwaysIncompatible = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_IsAlwaysIncompatible(),oldValue,getIsAlwaysIncompatible());
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__PROPERTY_EDITOR_CLASS: {
				Object oldValue = this.propertyEditorClass;
				this.propertyEditorClass = null;
				this.setPropertyEditorClass = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_PropertyEditorClass(),oldValue,null);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__READ_METHOD: {
				Object oldValue = this.readMethod;
				this.readMethod = null;
				this.setReadMethod = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_ReadMethod(),oldValue,null);
			}
			case BeaninfoPackage.PROPERTY_DECORATOR__WRITE_METHOD: {
				Object oldValue = this.writeMethod;
				this.writeMethod = null;
				this.setWriteMethod = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageBeaninfo().getPropertyDecorator_WriteMethod(),oldValue,null);
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetIsBound()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isBound: "+this.isBound; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsConstrained()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isConstrained: "+this.isConstrained; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsDesignTime()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isDesignTime: "+this.isDesignTime; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsAlwaysIncompatible()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isAlwaysIncompatible: "+this.isAlwaysIncompatible; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(!getFilterFlags().isEmpty()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="filterFlags: "+this.filterFlags; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Boolean getIsBoundGen() {
		if (this.setIsBound) return this.isBound;
		else return (Boolean)ePackageBeaninfo().getPropertyDecorator_IsBound().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Boolean getIsConstrainedGen() {
		if (this.setIsConstrained) return this.isConstrained;
		else return (Boolean)ePackageBeaninfo().getPropertyDecorator_IsConstrained().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * If not set, then normal default processing.
	 * 
	 * If set true, then this property is a design time property. This means it will show up in the property sheet, but it won't be able to be connected to at runtime. It may not even be a true bean property but instead the builder will know how to handle it.
	 * 
	 * If set false, then this property will not show up on the property sheet, but will be able to be connected to for runtime.
	 */
	protected Boolean getIsDesignTimeGen() {
		if (this.setIsDesignTime) return this.isDesignTime;
		else return (Boolean)ePackageBeaninfo().getPropertyDecorator_IsDesignTime().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean isSetIsDesignTimeGen() {
		return setIsDesignTime;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected JavaClass getPropertyEditorClassGen() {
		try {
			if (this.propertyEditorClass == null) return null;
			this.propertyEditorClass = (JavaClass) ((InternalProxy)this.propertyEditorClass).resolve(this, ePackageBeaninfo().getPropertyDecorator_PropertyEditorClass());
			if (this.propertyEditorClass==null) this.setPropertyEditorClass = false;
			return this.propertyEditorClass;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Method getReadMethodGen() {
		try {
			if (this.readMethod == null) return null;
			this.readMethod = (Method) ((InternalProxy)this.readMethod).resolve(this, ePackageBeaninfo().getPropertyDecorator_ReadMethod());
			if (this.readMethod==null) this.setReadMethod = false;
			return this.readMethod;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected Method getWriteMethodGen() {
		try {
			if (this.writeMethod == null) return null;
			this.writeMethod = (Method) ((InternalProxy)this.writeMethod).resolve(this, ePackageBeaninfo().getPropertyDecorator_WriteMethod());
			if (this.writeMethod==null) this.setWriteMethod = false;
			return this.writeMethod;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	protected EClassifier getPropertyTypeGen() {
		return null;
	}
	/*
	 * @see FeatureDecoratorImpl#applyIntrospectionToCopy(FeatureDecorator)
	 */
	protected void applyIntrospectionToCopy(FeatureDecorator decorator) {
		super.applyIntrospectionToCopy(decorator);
		
		PropertyDecorator pd = (PropertyDecorator) decorator;
		if (!isSetIsBound() && (fFeatureProxy != null || fFeatureDecoratorProxy != null))
			pd.setIsBound(getIsBound());
		if (!isSetIsConstrained() && (fFeatureProxy != null || fFeatureDecoratorProxy != null))
			pd.setIsConstrained(getIsConstrained());
		if (!isSetIsDesignTime() && setIsDesignTimeProxy)
			pd.setIsDesignTime(getIsDesignTime());
		if (fFeatureProxy != null && !this.isSetPropertyEditorClass())
			pd.setPropertyEditorClass(getPropertyEditorClass());
		if (!isSetReadMethod() && (fFeatureProxy != null || fFeatureDecoratorProxy != null))
			pd.setReadMethod(getReadMethod());
		if (!isSetWriteMethod() && (fFeatureProxy != null || fFeatureDecoratorProxy != null))
			pd.setWriteMethod(getWriteMethod());
	}


	/*
	 * @see FeatureDecorator#refreshJavaReferences()
	 */
	public void refreshJavaReferences() {
		super.refreshJavaReferences();
		
		if (isSetReadMethod())
			this.readMethod = (Method) makeProxy((InternalProxy) this.readMethod);
		if (isSetWriteMethod())
			this.writeMethod = (Method) makeProxy((InternalProxy) this.writeMethod);
		if (fFeatureDecoratorProxy != null)
			fFeatureDecoratorProxy.refreshJavaReferences();
			
	}
	
	/**
	 * @see com.ibm.etools.beaninfo.FeatureDecorator#setDescriptorProxy(IBeanProxy)
	 */
	public void setDescriptorProxy(IBeanProxy descriptor) {
		super.setDescriptorProxy(descriptor);
		clearCache();
		
	}
	
	private void clearCache() {
		if (retrievedReadMethod) {
			retrievedReadMethod = false;
			cachedReadMethod = null;
		}
		if (retrievedWriteMethod) {
			retrievedWriteMethod = false;
			cachedWriteMethod = null;
		}
	}

}
