package com.ibm.etools.beaninfo.testing.infos;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
import java.beans.*;
import com.ibm.etools.beaninfo.testing.*;
public class Test2ClassBBeanInfo extends IvjBeanInfo {
	
/**
 * Gets the bean class.
 * @return java.lang.Class
 */
public static Class getBeanClass() {
	return Test2ClassB.class;
}

public BeanInfo[] getAdditionalBeanInfo() {
	try {
		return new BeanInfo[] {
			Introspector.getBeanInfo(getBeanClass().getSuperclass())
		};
	} catch (IntrospectionException e) {
		return null;
	}
}
    
public BeanDescriptor getBeanDescriptor() {
	java.beans.BeanDescriptor aDescriptor = null;
	try {
		/* Create and return the WindowBeanInfobean descriptor. */
		aDescriptor = new java.beans.BeanDescriptor(getBeanClass(), getBeanClass());	// Just for yucks, made customizer the same class.
		aDescriptor.setDisplayName("A name for this class.");
	} catch (Throwable exception) {
	};
	return aDescriptor;
}
/**
 * Return the event set descriptors for this bean.
 * @return java.beans.EventSetDescriptor[]
 */
public java.beans.EventSetDescriptor[] getEventSetDescriptors() {
	try {
		EventSetDescriptor aDescriptorList[] = {
			createEventSetDescriptor(getBeanClass(), 
				"overrideName", 
				new Object[0],
				new MethodDescriptor[] {
					super.createMethodDescriptor(com.ibm.etools.beaninfo.testing.ITest1ClassEventListener.class, "event1", 
						new Object[] { DISPLAYNAME, "Event 1"},
						new ParameterDescriptor[0],
						new Class[] {java.util.EventObject.class}),					
				},
				com.ibm.etools.beaninfo.testing.ITest1ClassEventListener.class,
				"addTest2ClassBEventListener",
				"removeTest2ClassBEventListener")
		};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
	/**
	 * @return an icon of the specified kind for JButton
	 */
	public java.awt.Image getIcon(int kind) {
   return super.getIcon(kind);
	}
/**
 * Return the method descriptors for this bean.
 * @return java.beans.MethodDescriptor[]
 */
public java.beans.MethodDescriptor[] getMethodDescriptors() {
	try {
		MethodDescriptor aDescriptorList[] = {		
			super.createMethodDescriptor(getBeanClass(),"isSetA", //$NON-NLS-1$
				new Object[] {
	   			DISPLAYNAME, "is SetA",//$NON-NLS-1$
			   	EXPERT, Boolean.TRUE,
	      		// SHORTDESCRIPTION, "Create the window peer",
	    		}, 
	    		new ParameterDescriptor[] {},
	      	new Class[] {}		    		
		  	),
			super.createMethodDescriptor(getBeanClass(),"setSetA", //$NON-NLS-1$
				new Object[] {
	   			DISPLAYNAME, "set SetA",//$NON-NLS-1$
			   	EXPERT, Boolean.TRUE,
	      		// SHORTDESCRIPTION, "Create the window peer",
	    		}, 
	    		new ParameterDescriptor[] {createParameterDescriptor("aBooleanSetting", new Object[0])},
	      	new Class[] {Boolean.TYPE}		    		
		  	)		  	

		};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
/**
 * Return the property descriptors for this bean.
 * @return java.beans.PropertyDescriptor[]
 */
public java.beans.PropertyDescriptor[] getPropertyDescriptors() {
	try {
		PropertyDescriptor aDescriptorList[] = {
			// focusOwner
			super.createPropertyDescriptor(getBeanClass(),"setA", new Object[] {//$NON-NLS-1$
			      	EXPERT, Boolean.TRUE
	    			}
		    	),
		    	new IndexedPropertyDescriptor("foo", getBeanClass())
		};
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}	

}