package com.ibm.etools.beaninfo.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.beans.*;
/**
 * IndexedPropertyDescriptor equality tester
 */
public class IndexedPropertyDescriptorEquality extends PropertyDescriptorEquality {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	static {
		try {
			MAP_EQUALITY.put(IndexedPropertyDescriptor.class, (IndexedPropertyDescriptorEquality.class).getConstructor(new Class[] {IndexedPropertyDescriptor.class}));
		} catch (NoSuchMethodException e) {
		}
	}	
	
	public IndexedPropertyDescriptorEquality(IndexedPropertyDescriptor descr) {
		super(descr);
	}	
	/**
	 * Calculate the hashcode for the current feature, add this
	 * to the hashcode received from super.calculateHashCode
	 * and return the new value.
	 *
	 * NOTE: for subclasses, it is MANDITORY that the first line be:
	 *         int hashcode = super.calculateHashCode();
	 *       and the last line be:
	 *         return hashcode*31 + (your calculated hashcode for just this subclass);
	 */
	protected int calculateHashCode() {
		int hashcode = super.calculateHashCode();
		IndexedPropertyDescriptor pd = (IndexedPropertyDescriptor) fFeature;
		
		int hc = pd.getIndexedPropertyType().hashCode();

		if (pd.getIndexedReadMethod() != null)
			hc += pd.getIndexedReadMethod().hashCode();
		if (pd.getIndexedWriteMethod() != null)
			hc += pd.getIndexedWriteMethod().hashCode();		
						
		return hashcode*31 + hc;
	}

	/**
	 * equals: See if this is equal semantically.
	 *
	 * NOTE: Every subclass needs to implement this and
	 *       the first line should be:
	 *         if (!super.equals(obj))
	 *           return false;
	 */
	 
	public boolean equals(Object obj) {
		if (!super.equals(obj))
			return false;
 	
		IndexedPropertyDescriptor op = (IndexedPropertyDescriptor) ((FeatureDescriptorEquality) obj).fFeature;
		IndexedPropertyDescriptor fp = (IndexedPropertyDescriptor) fFeature;
 		
		if (op.getIndexedPropertyType() != fp.getIndexedPropertyType())
			return false;
		if (op.getIndexedReadMethod() != fp.getIndexedReadMethod())
			return false;
		if (op.getIndexedWriteMethod() != fp.getIndexedWriteMethod())
			return false;													
			
		return true;
	}


	

}