package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.gef.Request;
import com.ibm.etools.gef.EditPart;
/**
 * Request for Alignment on a a child of this component.
 * Typically this has been rerouted to this parent
 * by the Primary Drag Role Edit Policy,
 * since that policy typically handles move/size requests.
 *
 * Note: Processors of this request must return a
 * command. If no command is returned, this is interpreted
 * as alignment not permitted. So if no change in position
 * was performed, but alignment was permitted, then return
 * NoOpCommand.INSTANCE so that it is known the alignment
 * was allowed. In this manner if no one processes the
 * request then it is assumed it is not alignable (such as if the
 * child is on a Flow Layout, there align doesn't make sense).
 *
 */
public class AlignmentChildCommandRequest extends Request {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected AlignmentCommandRequest fAlignRequest;
	protected EditPart fEditPart;

public AlignmentChildCommandRequest(EditPart editpart, AlignmentCommandRequest alignRequest) {
	super(RequestConstantsCDE.REQ_ALIGNMENT_CHILD);
	fAlignRequest = alignRequest;
	fEditPart = editpart;
}
public EditPart getChildEditPart() {
	return fEditPart;
}
public AlignmentCommandRequest getAlignmentRequest() {
	return fAlignRequest;
}
}