package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.geometry.*;
import org.eclipse.swt.graphics.Color;

public class BevelBorder extends AbstractBorder{

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected int width = 1;
protected Color color1 = ColorConstants.black;
protected Color color2 = ColorConstants.darkGray;
protected Color color3 = ColorConstants.gray;
protected Color color4 = ColorConstants.lightGray;

public Insets getInsets(IFigure figure){
	return new Insets(width);
}
public boolean isOpaque(){
	return true;
}

public void paint(IFigure figure, Graphics graphics, Insets insets){
	tempRect.setBounds(getPaintRectangle(figure, insets));
	if (width%2 == 1){
		tempRect.width--;
		tempRect.height--;
	}
	tempRect.shrink(width/2,width/2);
	graphics.setLineWidth(width);
	graphics.setForegroundColor(color2);
	// Top and left outer
	graphics.drawLine(tempRect.x,tempRect.y,tempRect.x,tempRect.y+tempRect.height);
	graphics.drawLine(tempRect.x,tempRect.y,tempRect.x+tempRect.width,tempRect.y);
	// Bottom and right outer
	graphics.setForegroundColor(color4);
	graphics.drawLine(tempRect.x+1,tempRect.y+tempRect.width,tempRect.x+tempRect.width,tempRect.y+tempRect.width);
	graphics.drawLine(tempRect.x+tempRect.width,tempRect.y+tempRect.height,tempRect.x+tempRect.width,tempRect.y);
	// Top and left inner
	graphics.setForegroundColor(color1);
	graphics.drawLine(tempRect.x+1,tempRect.y+1,tempRect.x+tempRect.width-2,tempRect.y+1);
	graphics.drawLine(tempRect.x+1,tempRect.y+1,tempRect.x+1,tempRect.y+tempRect.height-2);
	// Botton and right inner
	graphics.setForegroundColor(color3);
	graphics.drawLine(tempRect.x+1,tempRect.y+tempRect.height-1,tempRect.x+tempRect.width-1,tempRect.y+tempRect.height-1);
	graphics.drawLine(tempRect.x+tempRect.width-1,tempRect.y+tempRect.height-1,tempRect.x+tempRect.width-1,tempRect.y+1);
}
}