package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.internal.plugins.PluginRegistry;

public class CDEMessages {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static final String BUNDLE_NAME = "com.ibm.etools.cde.messages"; //$NON-NLS-1$
	private static final String PLUGIN_BUNDLE_NAME ="plugin"; //$NON-NLS-1$	

	// Keys for messages within the resource bundle.
	static public final String
		OBJECT_NOINSTANTIATE = "Object.noinstantiate_EXC_", //$NON-NLS-1$
		CLASS_NOT_FOUND = "ClassNotFound_EXC_", //$NON-NLS-1$
		NOT_INSTANCE = "NotInstance_EXC_", //$NON-NLS-1$
		NAME_IN_COMPOSITION_NOTUNIQUE = "NameInComposition.notunique_WARN_"; //$NON-NLS-1$
	static public final String
		NOT_FILE_INPUT = "NOT_FILE_INPUT_ERROR_", //$NON-NLS-1$
		ERROR_TITLE = "ERROR_TITLE_UI_",	// Dialog Title for an Error //$NON-NLS-1$
		SAVING = "SAVING_UI_",	// Progress Monitor Saving task name. //$NON-NLS-1$
		SAVING_AS = "SAVING_AS_UI_",	// Progress Monitor Saving As task name. //$NON-NLS-1$
		SAVE_ERROR = "SAVE_FAIL_ERROR_",	// Save failed. //$NON-NLS-1$
		LOAD_ERROR = "FAIL_LOAD_ERROR_";	// Failure loading a file. //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE =
		ResourceBundle.getBundle(BUNDLE_NAME);
	private static final ResourceBundle PLUGIN_BUNDLE = CDEPlugin.getPlugin().getDescriptor().getResourceBundle();

	private CDEMessages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	public static String getPluginString(String key) {
		try {
			return PLUGIN_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}	
}