package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.*;
import com.ibm.etools.draw2d.geometry.Rectangle;
import com.ibm.etools.gef.Request;
/**
 * Request for Distribute on a specific component.
 * Typically this is rerouted to the parent as an
 * DistributeChildCommandRequest by the Primary Drag Role Edit Policy,
 * since that policy typically handles move/size requests.
 *
 * Note: Processors of this request must return a
 * command. If no command is returned, this is interpreted
 * as distribute not permitted. So if no change in position
 * was performed, but distribute was permitted, then return
 * NoOpCommand.INSTANCE so that it is known the distribute
 * was allowed. This may be done by the DistributeChildCommandRequest
 * processing instead. In this manner if no one processes the
 * request then it is assumed it is not distributable (such as if the
 * child is on a Flow Layout, there distribute doesn't make sense).
 *
 */
public class DistributeCommandRequest extends Request {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/*
	 * The distribute types.
	 */
	public final static int 
		HORIZONTAL = 0,
		VERTICAL = 1;
		
	protected Rectangle bounds;	// Bounds of the figure of this request
	
public DistributeCommandRequest() {
	super(RequestConstantsCDE.REQ_DISTRIBUTE);
}


/**
 * The bounds to distriubte too.
 */
public Rectangle getBounds() {
	return bounds;
}

public void setBounds(Rectangle rect) {
	bounds = rect;
}
}
