package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import org.eclipse.ui.IEditorPart;
import org.eclipse.jface.util.*;
import org.eclipse.jface.resource.ImageDescriptor;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.ui.actions.*;
import java.util.*;

public class GridPropertiesAction extends EditorPartAction implements IPropertyChangeListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String ACTION_ID = "cde.GRIDPROPERTIES"; //$NON-NLS-1$
	
public GridPropertiesAction(IEditorPart part, ShowGridAction showGridAction) {
	super(part);
	
	setText(CDEMessages.getString("GridPropertiesAction.label")); //$NON-NLS-1$
	setToolTipText(CDEMessages.getString("GridPropertiesAction.tooltip")); //$NON-NLS-1$
	setId(ACTION_ID);
	setImageDescriptor(ImageDescriptor.createFromFile(getClass(),CDEMessages.getString("GridPropertiesAction.image"))); //$NON-NLS-1$
	setEnabled(showGridAction.isChecked());
	showGridAction.addPropertyChangeListener(this);	// It is assumed that both show grid action and gridproperties action go away at the same time so no need to have a removeListener.
}

/*
 * Updates this action when the grid visibility changes
 */
public void propertyChange(PropertyChangeEvent event) {
	if (event.getProperty().equals(ShowGridAction.SHOW_GRID)) {
		setEnabled(((Boolean) event.getNewValue()).booleanValue());
	}
}

/*
 * Get the grid figure decoration, open the GridPropertiesDialog, and if 
 * changes are made, update the grid figure decoration on the edit part.
 */
public void run() {
	GridController gridController = GridController.getGridController(getEditorPart());
	
	GridPropertiesDialog dialog = new GridPropertiesDialog(
		getEditorPart().getSite().getWorkbenchWindow().getShell(), 
		gridController);
	dialog.open();
}
}