package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.gef.EditPart;
/**
 * Interface for the edit part factory.
 *
 * The editpart factory, if being used for the current viewer,
 * will be stored in the EditDomain under the viewer using the
 * key EDITPART_FACTORY_KEY defined here.
 *
 * An editpart factory does not need to be used, the customization
 * of CDE that the developer is creating determines if they wish
 * to use it or not.
 *
 * This not related to the IModelAdapterFactory because this is viewer
 * specific, not model specific.
 *
 * There is a static method on CDEUtilities to retrieve the editpart factory.
 */

public interface IEditPartFactory {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String EDITPART_FACTORY_KEY = "com.ibm.etools.ide.editpartfactorykey"; //$NON-NLS-1$
	
	/**
	 * Create the editpart for this model object.
	 */
	public EditPart createEditPart(Object modelObject);
		
}