package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



/**
 * Image Changed Notifier.
 * Creation date: (3/3/00 5:14:19 PM)
 * @author: Administrator
 */
public interface IImageNotifier {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Add the image listener.
	 * Creation date: (3/3/00 5:15:47 PM)
	 * @param listener IImageListener
	 */
	public void addImageListener(IImageListener listener);
	
	/**
	 * Answer if anyone is listening.
	 * Creation date: (3/15/00 5:57:45 PM)
	 * @return boolean
	 */
	public boolean hasImageListeners();
	
	/**
	 * Invalidate the image. The next time
	 * refreshImage is called, if still invalid,
	 * it will send out a new image.
	 * Creation date: (3/6/00 5:39:58 PM)
	 * @return com.ibm.swt.image.ImageData
	 */
	public void invalidateImage();
	
	/**
	 * Refresh the image, get a new one and
	 * send notification if image was validated
	 * with this request.
	 * Creation date: (3/6/00 5:39:58 PM)
	 * @return com.ibm.swt.image.ImageData
	 */
	public void refreshImage();
	
	/**
	 * Remove the image listener.
	 * Creation date: (3/3/00 5:15:47 PM)
	 * @param listener com.ibm.vce.java.awt.IImageListener
	 */
	public void removeImageListener(IImageListener listener);
}
