package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.draw2d.geometry.*;
/**
 * VisualComponent interface. A visual component is an interface
 * to visual components. It notifies if the image has changed,
 * and if the size and position have changed.
 */
public interface IVisualComponent extends IImageNotifier {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Return the bounds of the live object.
	 */
	public Rectangle getBounds();
	
	/**
	 * Return the position of the live object.
	 */
	public Point getLocation();
	
	/**
	 * Return the size of the live object.
	 */
	public Dimension getSize();
	
	/**
	 * Add the argument as a listener for when the component
	 * moves, resized or is shown
	 */
	public void addComponentListener(IVisualComponentListener aListener);
	
	/**
	 * Remove the argument as a listener
	 * for component changes.
	 */
	public void removeComponentListener(IVisualComponentListener aListener);
}
