package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.EventListener;
/**
 * Listener for visual component changes
 */
public interface IVisualComponentListener extends java.util.EventListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * The listened component was hidden
	 */
	public void componentHidden();
	
	/**
	 * The listened component moved, the point moved to is passed on.
	 */
	public void componentMoved(int x, int y);
	
	/**
	 * The listened component has changed in some way,
	 * but can't give a specific. So refresh.
	 * (an example is the underlying component
	 * that the visual component is
	 * monitoring has been replaced, so refresh the bounds).
	 */
	public void componentRefreshed();
	
	/**
	 * The listened component was resized. The new size is passed also.
	 */
	public void componentResized(int width, int height);
	
	/**
	 * The listened component was shown
	 */
	public void componentShown();
}
