package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.EventListener;
/**
 * This listener listens for changes to the zoom setting.
 * A listener must add itself to the listener list of the
 * ZoomController. See ZoomController to find out how to
 * find the ZoomController.
 */
public interface IZoomListener extends EventListener {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * The zoom has changed. The value is the percentage of the zoom.
	 * For example, 100 = normal size, 1000 = 10 times larger, 10 = 1/10 size
	 */
	public void zoomChanged(int newZoom, int oldZoom);
}