package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuCreator;
import org.eclipse.ui.actions.RetargetAction;

public class MenuCreatorRetargetAction extends RetargetAction {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	// Because the inherited handler is private we must re-declare it
	protected IAction localHandler;
	
	public MenuCreatorRetargetAction(String id, String text){
		super(id,text);
	}
	protected void setActionHandler(IAction newHandler) {
		localHandler = newHandler;
		super.setActionHandler(newHandler);
	}
	
	public int getStyle(){
		return AS_DROP_DOWN_MENU;
	}
	
	public IMenuCreator getMenuCreator() {
		if (localHandler != null) {
			return localHandler.getMenuCreator();
		} else {
			return super.getMenuCreator();
		}		
	}
	
	public void setMenuCreator(IMenuCreator aCreator){
		if (localHandler != null) {
			localHandler.setMenuCreator(aCreator);
		} else {
			super.setMenuCreator(aCreator);
		}
	}	
}
