/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



package com.ibm.etools.cde;

import java.util.Iterator;

import org.eclipse.jface.action.*;
import org.eclipse.jface.action.IMenuCreator;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

public class PaletteMenuCreator implements IMenuCreator {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected MenuManager fDropdownMenuManager;
	protected MenuManager fToolbarMenuManager;
	protected Menu fMenu;

public PaletteMenuCreator(MenuManager toolbarMenuManager, MenuManager dropdownMenuManager){
	// There is a bug in Eclipse where the same menu manager can't be shared between the toolbar
	// and the drop down menu
	// The drop down menu is invokved when the toolbar action is off the right hand edge and a >>
	// appears that the user can invoke the menu from
	// To overcome the Eclipse but we need two separate menu managers, otherwise once you use the drop down
	// and then go to the menu and back again it doesn't work
	fToolbarMenuManager = toolbarMenuManager;
	fDropdownMenuManager = dropdownMenuManager;
}
public void dispose(){
	fToolbarMenuManager.dispose();
	fDropdownMenuManager.dispose();
}

public Menu getMenu(Menu aMenu){
	// Get the categories from the menu manager
	Menu fMenu = new Menu(aMenu);
	// Our menu manager has contribution items that are the menu managers
	// for the palette categories
	IContributionItem[] items = fDropdownMenuManager.getItems();
	for(int i=0;i<items.length;i++){
		MenuManager menuManager = (MenuManager)items[i];
		// For each menu manager create a new menu
		menuManager.fill(fMenu,-1);
	}
	return fMenu;
}
public Menu getMenu(Control aControl){
	return fToolbarMenuManager.createContextMenu(aControl);
}
}
