package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import org.eclipse.ui.IEditorPart;
import org.eclipse.jface.resource.ImageDescriptor;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.ui.actions.*;
import java.util.*;
import java.net.*;

public class ShowDistributeBoxAction extends EditorPartAction {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String ACTION_ID = "cde.SHOWDISTRIBUTEBOX"; //$NON-NLS-1$
		
public ShowDistributeBoxAction(IEditorPart part) {
	super(part);	// Make sure this is not dynamic
	setText(CDEMessages.getString("ShowDistributeBoxAction.label")); //$NON-NLS-1$
	setToolTipText(CDEMessages.getString("ShowDistributeBoxAction.tooltip")); //$NON-NLS-1$
	setId(ACTION_ID);

	String graphicName = "distributebox_obj.gif"; //$NON-NLS-1$
	try { 
		URL colorURL = new URL("platform:/plugin/com.ibm.etools.cde/icons/full/clcl16/" + graphicName); //$NON-NLS-1$
		URL enabledURL = new URL("platform:/plugin/com.ibm.etools.cde/icons/full/elcl16/" + graphicName); //$NON-NLS-1$
		URL disabledURL = new URL("platform:/plugin/com.ibm.etools.cde/icons/full/dlcl16/" + graphicName); //$NON-NLS-1$
		setImageDescriptor(ImageDescriptor.createFromURL(enabledURL));
		setHoverImageDescriptor(ImageDescriptor.createFromURL(colorURL));
		setDisabledImageDescriptor(ImageDescriptor.createFromURL(disabledURL));
	} catch ( MalformedURLException exc ) {
		exc.printStackTrace();
	}			
	setChecked(false);	// It is assumed that the box is initially not visible.
}
/**
 * Creates and executes the alignment command on the selected objects.
 */
public void run() {
	DistributeController dc = DistributeController.getDistributeController(getEditorPart());
	dc.setBoxVisible(isChecked());
}
	/**
	 * Sets the editor.
	 */
	public void setEditorPart(IEditorPart part) {
		if ( getEditorPart() != null ) {
			unhookEditorPart();
		}
		super.setEditorPart(part);
		if(part != null){
			setEnabled(true);
			DistributeController dc = DistributeController.getDistributeController(getEditorPart());
			if(dc != null){
				setChecked(dc.isBoxVisible());	
			} else {
				setChecked(false);
			}
		} else {
			setEnabled(false);
		}
	}	 
}