package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.List;
import com.ibm.etools.common.command.Command;
import com.ibm.etools.common.command.UnexecutableCommand;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.requests.GroupRequest;
import com.ibm.etools.gef.editpolicies.AbstractEditPolicy;

/**
 * Default Tree Primary Drag EditPolicy. This is used on components
 * to send move requests up to the parent. It should be installed
 * on all tree components (and containers) except the contents
 * tree edit part. That part doesn't need it.
 */
public class TreePrimaryDragRoleEditPolicy
	extends AbstractEditPolicy
{

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public Command getCommand(Request req){
	if (REQ_MOVE.equals(req.getType()))
		return getMoveCommand(req);
	return null;	
}

protected Command getMoveCommand(Request req){
	EditPart parent = getHost().getParent();
	if(parent != null){
		req.setType(REQ_MOVE_CHILDREN);
		Command cmd = parent.getCommand(req);
		req.setType(REQ_MOVE);
		return cmd;
	} else {
		return UnexecutableCommand.INSTANCE;
	}
}

public EditPart getTargetEditPart(Request req){
	return null;
}

}


