package com.ibm.etools.cde;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.gef.ui.actions.EditorPartAction;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorPart;
/**
 * Action to request zoom prompt.
 */
public class ZoomAction extends EditorPartAction {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String ACTION_ID = "cdm.ZOOM"; //$NON-NLS-1$
	public static int ZOOM_DELTA = 20; // The amount to increase and decrase zoom by

public ZoomAction(IEditorPart part) {
	super(part);
	setText(CDEMessages.getString("ZoomAction.label")); //$NON-NLS-1$
	setToolTipText(CDEMessages.getString("ZoomAction.tooltip")); //$NON-NLS-1$
	setId(ACTION_ID);
	setImageDescriptor(ImageDescriptor.createFromFile(getClass(),CDEMessages.getString("ZoomAction.image"))); //$NON-NLS-1$
	setEnabled(true);
}

public void run() {

	ZoomController zoomController = ZoomController.getZoomController(getEditorPart());
	
	if (zoomController != null ) {
		ZoomHelperDialog dialog = new ZoomHelperDialog(
			getEditorPart().getSite().getWorkbenchWindow().getShell(), 
			zoomController.getZoomValue() );
			dialog.open();
			int zoomValue = dialog.getZoomValue();
			if (zoomValue != ZoomHelperDialog.NO_CHANGE)
				zoomController.setZoomValue(zoomValue);
	}
}

}