package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.*;
import com.ibm.etools.emf.ref.*;
/**
 * Abstract command for applying attributes.
 */
public abstract class AbstractApplyAttributeCommand extends AbstractAttributeCommand {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public AbstractApplyAttributeCommand(String name) {
		super(name);
	}	
	
	public AbstractApplyAttributeCommand() {
		super();
	}	
	
	public boolean canExecute() {
		List values = getAttributeSettingValues();
		
		// Super.canExecute() or Must have at least one setting and can't set multiple values on a single valued feature.
		if (!super.canExecute() || (values == null || values.isEmpty() || (!feature.refIsMany() && values.size() > 1))){
			return false;
		}
		
		RefMetaObject mo = (RefMetaObject) feature.refType();	
		Iterator itr = values.iterator();
		while(itr.hasNext()) {
			Object n = itr.next();
			if (n != null && !mo.isInstance(n))
				return false;
		}
		return true;
	}	

}