package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.*;

import com.ibm.etools.emf.ref.*;
import com.ibm.etools.common.command.AbstractCommand;

abstract public class AbstractAttributeCommand
	extends AbstractCommand
{
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected RefStructuralFeature feature;
	private List values;
	private RefObject target;
	
	public AbstractAttributeCommand(String name) {
		super(name);
	}
	
	public AbstractAttributeCommand() {
		super();
	}	
	
	public boolean canExecute() {
		return feature != null && target != null && !((InternalProxy) feature).refIsDeleted();
	}
	
	public boolean canUndo() {
		return feature != null && !((InternalProxy) feature).refIsDeleted();
	}
	
	public RefObject getTarget() {return target;}
	
	public void setTarget(RefObject aTarget){target = aTarget;}
	
	protected List getAttributeSettingValues(){
		return values;
	}
	
	public void redo() { execute(); }
	
	public void setAttribute(RefStructuralFeature attribute) {
		feature = attribute;
	}
	public void setAttributeSettingValue(Object newValue) {
		values = new ArrayList(1);
		values.add(newValue);
	}
	public void setAttributeSettingValue(List newValues){
		values = newValues;
	}
}

