package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.common.command.AbstractCommand;
import com.ibm.etools.cdm.*;
/**
 * This command cancel a keyed value to the keyed value holder.
 */

public class CancelKeyedValueCommand extends AbstractCommand {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected KeyedValueHolder target;
	protected String key;
	protected KeyedValue oldValue;
	
	public CancelKeyedValueCommand(String name) {
		super(name);
	}
	
	public CancelKeyedValueCommand() {
	}
	
	public void setTarget(KeyedValueHolder target) {
		this.target = target;
	}	
	
	public void setKey(String key) {
		this.key = key;
	}
	
	public boolean canExecute() {
		return target != null && key != null;
	}
	
	public boolean canUndo() {
		return true;
	}
	
	public void execute() {
		oldValue = target.unsetKeyedValue(key);
	}
	
	public void redo() {
		execute();
	}
	
	public void undo() {
		if (oldValue != null)
			target.setKeyedValue(key, oldValue);
		else
			target.unsetKeyedValue(key);
			
		oldValue = null;	// Don't hold onto old value
	}

}