package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.common.command.*;
import com.ibm.etools.emf.ref.RefRegister;
import java.util.*;
import com.ibm.etools.cde.commands.CommandBuilder;
import com.ibm.etools.cdm.model.*;
import com.ibm.etools.cdm.*;

/**
 * Delete the visual constraint. This will work whether there is a visual constraint or not.
 */
public class CancelVisualConstraintCommand extends CommandWrapper {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected KeyedValueHolder fTarget;
	
public CancelVisualConstraintCommand() {
}

public CancelVisualConstraintCommand(String desc) {
	super(desc);
}
public void setTarget(KeyedValueHolder target) {
	fTarget = target;
}
protected boolean prepare() {
	return fTarget != null;
}

public void execute() {
	CommandBuilder cbld = new CommandBuilder(getLabel());
	cbld.cancelAttributeSetting(fTarget, CDMModelConstants.VISUAL_CONSTRAINT_KEY);
	command = cbld.getCommand();
	command.execute();
}

}
