package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.*;

import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.*;

public class InstantiateAndApplyCommand
	extends ApplyAttributeSettingCommand
{
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected EClass fMofClass;
protected RefObject fNewInstance;

public InstantiateAndApplyCommand(String name) {
	super(name);
}

public InstantiateAndApplyCommand() {
	super();
}
				
protected List getAttributeSettingValues(){
	if (super.getAttributeSettingValues() == null){
		List values = new ArrayList(1);
		values.add(getNewInstance());
		setAttributeSettingValue(values);
	}
	return super.getAttributeSettingValues();
}

public RefObject getNewInstance() {
	if (fNewInstance == null) {
		fNewInstance = (RefObject) fMofClass.refPackage().getFactory().create(((RefBaseObject)fMofClass).refName()); // Required for VAJava ambigious references
	}
	return fNewInstance;
}

public void setMOFClass(EClass mofClass) {
	fMofClass = mofClass;
}
}
