package com.ibm.etools.cde.commands;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.common.command.AbstractCommand;
/**
 * This is a No Operation command. There are times when a command must
 * be returned and none being returned is considered an error. This can
 * be used in those situations where nothing is to be be done.
 *
 * Use the INSTANCE static field for all usages. There is no need for more
 * than one.
 */

public class NoOpCommand extends AbstractCommand {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final NoOpCommand INSTANCE = new NoOpCommand();
	
	private NoOpCommand() {
		super();
		setDescription(getLabel());
	}
	
	public boolean canExecute() {
		return true;
	}
	
	public void execute() {
	}
	
	public void redo() {
	}
	
	public boolean canUndo() {
		return true;
	}
	
	public void undo() {
	}

}