package com.ibm.etools.cde.decorators;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.EList;
import java.lang.Boolean;
/**
 * This is base information for properties. This will be on an EClassifier for how to edit a property of the type of the EClassifier.
 */
public interface BasePropertyDecorator extends EDecorator {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	DecoratorsPackage ePackageDecorators();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassBasePropertyDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the CellEditorValidatorClassnames attribute
	 */
	EList getCellEditorValidatorClassnames();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the LabelProviderClassname attribute
	 */
	String getLabelProviderClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the LabelProviderClassname attribute
	 */
	void setLabelProviderClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the LabelProviderClassname attribute
	 */
	void unsetLabelProviderClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the LabelProviderClassname attribute has been set
	 */
	boolean isSetLabelProviderClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the CellEditorClassname attribute
	 */
	String getCellEditorClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the CellEditorClassname attribute
	 */
	void setCellEditorClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the CellEditorClassname attribute
	 */
	void unsetCellEditorClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the CellEditorClassname attribute has been set
	 */
	boolean isSetCellEditorClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsNullInvalid attribute
	 * Are null settings invalid. If this is true, then they will be prevented. If this is false, then the cell editor and validator will be used to determine if null is valid or not.
	 * 
	 * The search order will be find it explicitly set on:
	 *   1) The BasePropertyDescriptor on the feature, then if not set,
	 *   2) The BasePropertyDescriptor on the class, then if not set,
	 *   3) use false as the value.
	 */
	boolean isNullInvalid();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsNullInvalid attribute
	 * Are null settings invalid. If this is true, then they will be prevented. If this is false, then the cell editor and validator will be used to determine if null is valid or not.
	 * 
	 * The search order will be find it explicitly set on:
	 *   1) The BasePropertyDescriptor on the feature, then if not set,
	 *   2) The BasePropertyDescriptor on the class, then if not set,
	 *   3) use false as the value.
	 */
	Boolean getIsNullInvalid();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsNullInvalid attribute
	 */
	void setIsNullInvalid(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsNullInvalid attribute
	 */
	void setIsNullInvalid(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsNullInvalid attribute
	 */
	void unsetIsNullInvalid();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsNullInvalid attribute has been set
	 */
	boolean isSetIsNullInvalid();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsEntryExpandable attribute
	 * If this returns true, then the entry will expand in the property sheet if 
	 * there are child entries. If this returns false then it won't expand. This is useful when the cell editor handles the complete customization
	 * and it is not desired to allow sub-property customization.
	 * 
	 * The search order will be find it explicitly set on:
	 *   1) The BasePropertyDescriptor on the feature, then if not set,
	 *   2) The BasePropertyDescriptor on the class, then if not set,
	 *   3) use true as the value.
	 */
	boolean isEntryExpandable();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsEntryExpandable attribute
	 * If this returns true, then the entry will expand in the property sheet if 
	 * there are child entries. If this returns false then it won't expand. This is useful when the cell editor handles the complete customization
	 * and it is not desired to allow sub-property customization.
	 * 
	 * The search order will be find it explicitly set on:
	 *   1) The BasePropertyDescriptor on the feature, then if not set,
	 *   2) The BasePropertyDescriptor on the class, then if not set,
	 *   3) use true as the value.
	 */
	Boolean getIsEntryExpandable();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsEntryExpandable attribute
	 */
	void setIsEntryExpandable(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsEntryExpandable attribute
	 */
	void setIsEntryExpandable(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsEntryExpandable attribute
	 */
	void unsetIsEntryExpandable();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsEntryExpandable attribute has been set
	 */
	boolean isSetIsEntryExpandable();
}
