package com.ibm.etools.cde.decorators;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.cdm.*;
import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
/**
 * The descriptor decorator for a class. Currently it adds nothing over FeatureDescriptorDecortor.
 */
public interface ClassDescriptorDecorator extends FeatureDescriptorDecorator, KeyedValueHolder {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	DecoratorsPackage ePackageDecorators();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassClassDescriptorDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the CustomizerClassname attribute
	 * Classname string of the Customizer class.
	 * 
	 * The format of the string is "classname:initdata" or "plugin//classname:initdata"
	 */
	String getCustomizerClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the CustomizerClassname attribute
	 */
	void setCustomizerClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the CustomizerClassname attribute
	 */
	void unsetCustomizerClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the CustomizerClassname attribute has been set
	 */
	boolean isSetCustomizerClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the TreeViewClassname attribute
	 * Classname of the TreeView EditPart.
	 * 
	 * The format of the string is "classname:initdata" or "plugin//classname:initdata"
	 */
	String getTreeViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the TreeViewClassname attribute
	 */
	void setTreeViewClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the TreeViewClassname attribute
	 */
	void unsetTreeViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the TreeViewClassname attribute has been set
	 */
	boolean isSetTreeViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the GraphViewClassname attribute
	 * Classname of the GraphView EditPart.
	 * 
	 * The format of the string is "classname:initdata" or "plugin//classname:initdata"
	 */
	String getGraphViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the GraphViewClassname attribute
	 */
	void setGraphViewClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the GraphViewClassname attribute
	 */
	void unsetGraphViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the GraphViewClassname attribute has been set
	 */
	boolean isSetGraphViewClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the ModelAdapterClassname attribute
	 * Classname of the Model Adapter. This is the class that either implements all of the interfaces required by the model adapter, or it should be an IAdaptable that will return such adapters. See IModelAdapterFactory.
	 * 
	 * The format of the string is "classname:initdata" or "plugin//classname:initdata"
	 */
	String getModelAdapterClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the ModelAdapterClassname attribute
	 */
	void setModelAdapterClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the ModelAdapterClassname attribute
	 */
	void unsetModelAdapterClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the ModelAdapterClassname attribute has been set
	 */
	boolean isSetModelAdapterClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DefaultPalette attribute
	 * The default palette to use for this class if not specified by other means. It is in the form a MOF reference, i.e. "filename#id of palette".
	 */
	String getDefaultPalette();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DefaultPalette attribute
	 */
	void setDefaultPalette(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the DefaultPalette attribute
	 */
	void unsetDefaultPalette();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the DefaultPalette attribute has been set
	 */
	boolean isSetDefaultPalette();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Graphic attribute
	 * The graphic to use for this class.
	 */
	Graphic getGraphic();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Graphic attribute
	 */
	void setGraphic(Graphic value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the Graphic attribute
	 */
	void unsetGraphic();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the Graphic attribute has been set
	 */
	boolean isSetGraphic();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the LabelProviderClassname attribute
	 * The classname for the label provider to be used for objects of the class that this decorator decorates. This label provider will be used in cases other than property sheet. In that case the labelProvider from the BasePropertyDecorator on this class will be used. (Though the default if there is no BasePropertyDecorator will be to use the string from this label provider, but not the image).
	 * 
	 * The format of the string is "classname:initdata" or "plugin//classname:initdata"
	 */
	String getLabelProviderClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the LabelProviderClassname attribute
	 */
	void setLabelProviderClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the LabelProviderClassname attribute
	 */
	void unsetLabelProviderClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the LabelProviderClassname attribute has been set
	 */
	boolean isSetLabelProviderClassname();
}
