package com.ibm.etools.cde.decorators;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.EList;
import java.lang.Boolean;
/**
 * This descriptor decorator for any kind of feature. It contains info that is generalized to features.
 */
public interface FeatureDescriptorDecorator extends EDecorator {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	DecoratorsPackage ePackageDecorators();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassFeatureDescriptorDecorator();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DisplayNameString attribute
	 */
	AbstractString getDisplayNameString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DisplayNameString attribute
	 */
	void setDisplayNameString(AbstractString value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the DisplayNameString attribute
	 */
	void unsetDisplayNameString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the DisplayNameString attribute has been set
	 */
	boolean isSetDisplayNameString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the DescriptionString attribute
	 */
	AbstractString getDescriptionString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the DescriptionString attribute
	 */
	void setDescriptionString(AbstractString value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the DescriptionString attribute
	 */
	void unsetDescriptionString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the DescriptionString attribute has been set
	 */
	boolean isSetDescriptionString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Hidden attribute
	 */
	boolean isHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Hidden attribute
	 */
	Boolean getHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Hidden attribute
	 */
	void setHidden(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Hidden attribute
	 */
	void setHidden(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the Hidden attribute
	 */
	void unsetHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the Hidden attribute has been set
	 */
	boolean isSetHidden();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the HelpContextIdsString attribute
	 */
	EList getHelpContextIdsString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Preferred attribute
	 */
	boolean isPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the Preferred attribute
	 */
	Boolean getPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Preferred attribute
	 */
	void setPreferred(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the Preferred attribute
	 */
	void setPreferred(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the Preferred attribute
	 */
	void unsetPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the Preferred attribute has been set
	 */
	boolean isSetPreferred();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The CategoryString reference
	 */
	AbstractString getCategoryString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param l The new value of the CategoryString reference
	 */
	void setCategoryString(AbstractString l);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the CategoryString attribute
	 */
	void unsetCategoryString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the CategoryString attribute has been set
	 */
	boolean isSetCategoryString();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The list of FilterFlagStrings references
	 */
	EList getFilterFlagStrings();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Answer whether this filter flag passed in is in this features filterFlags.
	 */
	boolean isFiltered(String flag);
}
