package com.ibm.etools.cde.decorators;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import java.lang.Boolean;
/**
 * This is the information required to establish a PropertyDescriptorAdapter or a PropertyDescriptor.
 * 
 * This will be decorating a RefStructuralFeature to indicate what  PropertyDescriptorAdapter or PropertyDescscriptor  to use for this feature.
 * 
 * It depends upon whether the type flag is Adapter is true. If the flag is true, then an adapter will be created once for the feature.
 * 
 * If the flag is false, then it will create a descriptor each time a source is asked for descriptors. It will assume to have either a constructor that takes a RefObject and a RefStructuralFeature or one that takes just a RefObject. The RefObject is the source of the feature. This is useful when the descriptor needs to know the source to be able to answer its questions correctly, such as the celleditor, which may vary depending upon the source.
 */
public interface PropertyDescriptorInformation extends EDecorator {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	DecoratorsPackage ePackageDecorators();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassPropertyDescriptorInformation();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsAdapter attribute
	 */
	boolean isAdapter();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the IsAdapter attribute
	 */
	Boolean getIsAdapter();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsAdapter attribute
	 */
	void setIsAdapter(Boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the IsAdapter attribute
	 */
	void setIsAdapter(boolean value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the IsAdapter attribute
	 */
	void unsetIsAdapter();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the IsAdapter attribute has been set
	 */
	boolean isSetIsAdapter();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the PropertyDescriptorClassname attribute
	 */
	String getPropertyDescriptorClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the PropertyDescriptorClassname attribute
	 */
	void setPropertyDescriptorClassname(String value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the PropertyDescriptorClassname attribute
	 */
	void unsetPropertyDescriptorClassname();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the PropertyDescriptorClassname attribute has been set
	 */
	boolean isSetPropertyDescriptorClassname();
}
