package com.ibm.etools.cde.decorators.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.decorators.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Boolean;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * This is the information required to establish a PropertyDescriptorAdapter or a PropertyDescriptor.
 * 
 * This will be decorating a RefStructuralFeature to indicate what  PropertyDescriptorAdapter or PropertyDescscriptor  to use for this feature.
 * 
 * It depends upon whether the type flag is Adapter is true. If the flag is true, then an adapter will be created once for the feature.
 * 
 * If the flag is false, then it will create a descriptor each time a source is asked for descriptors. It will assume to have either a constructor that takes a RefObject and a RefStructuralFeature or one that takes just a RefObject. The RefObject is the source of the feature. This is useful when the descriptor needs to know the source to be able to answer its questions correctly, such as the celleditor, which may vary depending upon the source.
 */
/**
 * This is the information required to establish a PropertyDescriptorAdapter or a PropertyDescriptor.
 * 
 * This will be decorating a RefStructuralFeature to indicate what  PropertyDescriptorAdapter or PropertyDescscriptor  to use for this feature.
 * 
 * It depends upon whether the type flag is Adapter is true. If the flag is true, then an adapter will be created once for the feature.
 * 
 * If the flag is false, then it will create a descriptor each time a source is asked for descriptors. It will assume to have either a constructor that takes a RefObject and a RefStructuralFeature or one that takes just a RefObject. The RefObject is the source of the feature. This is useful when the descriptor needs to know the source to be able to answer its questions correctly, such as the celleditor, which may vary depending upon the source.
 */
/**
 * @lastgen class PropertyDescriptorInformationImpl extends EDecoratorImpl implements PropertyDescriptorInformation, EDecorator {}
 */


public class PropertyDescriptorInformationImpl extends EDecoratorImpl implements PropertyDescriptorInformation, EDecorator {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isAdapter = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String propertyDescriptorClassname = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsAdapter = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setPropertyDescriptorClassname = false;
	protected PropertyDescriptorInformationImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassPropertyDescriptorInformation());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public DecoratorsPackage ePackageDecorators() {
		return (DecoratorsPackage)RefRegister.getPackage(DecoratorsPackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassPropertyDescriptorInformation() {
		return ((DecoratorsPackage)RefRegister.getPackage(DecoratorsPackage.packageURI)).getPropertyDescriptorInformation();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public Boolean getIsAdapter() {
		if (this.setIsAdapter) return this.isAdapter;
		else return (Boolean)ePackageDecorators().getPropertyDescriptorInformation_IsAdapter().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isAdapter() {
		Boolean result = getIsAdapter();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsAdapter(Boolean value) {
		refSetValueForSimpleSF(ePackageDecorators().getPropertyDescriptorInformation_IsAdapter(),this.isAdapter,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsAdapter(boolean value) {
		setIsAdapter(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsAdapter() {
		notify(refBasicUnsetValue(ePackageDecorators().getPropertyDescriptorInformation_IsAdapter()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsAdapter() {
		return setIsAdapter;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getPropertyDescriptorClassname() {
		if (this.setPropertyDescriptorClassname) return this.propertyDescriptorClassname;
		else return (String)ePackageDecorators().getPropertyDescriptorInformation_PropertyDescriptorClassname().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setPropertyDescriptorClassname(String value) {
		refSetValueForSimpleSF(ePackageDecorators().getPropertyDescriptorInformation_PropertyDescriptorClassname(),this.propertyDescriptorClassname,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetPropertyDescriptorClassname() {
		notify(refBasicUnsetValue(ePackageDecorators().getPropertyDescriptorInformation_PropertyDescriptorClassname()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetPropertyDescriptorClassname() {
		return setPropertyDescriptorClassname;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: return getIsAdapter();
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: return getPropertyDescriptorClassname();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER:
				return this.setIsAdapter? this.isAdapter : null;
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME:
				return this.setPropertyDescriptorClassname? this.propertyDescriptorClassname : null;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: return isSetIsAdapter();
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: return isSetPropertyDescriptorClassname();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: {
				setIsAdapter((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: {
				setPropertyDescriptorClassname((String)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: {
				Object oldValue = this.isAdapter;
				this.isAdapter = (Boolean)newValue;
				this.setIsAdapter = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageDecorators().getPropertyDescriptorInformation_IsAdapter(),oldValue,newValue);
			}
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: {
				Object oldValue = this.propertyDescriptorClassname;
				this.propertyDescriptorClassname = (String)newValue;
				this.setPropertyDescriptorClassname = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageDecorators().getPropertyDescriptorInformation_PropertyDescriptorClassname(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: {
				unsetIsAdapter();
				return;
			}
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: {
				unsetPropertyDescriptorClassname();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassPropertyDescriptorInformation().getEFeatureId(eFeature)) {
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__IS_ADAPTER: {
				Object oldValue = this.isAdapter;
				this.isAdapter = null;
				this.setIsAdapter = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageDecorators().getPropertyDescriptorInformation_IsAdapter(),oldValue,getIsAdapter());
			}
			case DecoratorsPackage.PROPERTY_DESCRIPTOR_INFORMATION__PROPERTY_DESCRIPTOR_CLASSNAME: {
				Object oldValue = this.propertyDescriptorClassname;
				this.propertyDescriptorClassname = null;
				this.setPropertyDescriptorClassname = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageDecorators().getPropertyDescriptorInformation_PropertyDescriptorClassname(),oldValue,getPropertyDescriptorClassname());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetIsAdapter()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isAdapter: "+this.isAdapter; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetPropertyDescriptorClassname()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="propertyDescriptorClassname: "+this.propertyDescriptorClassname; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
}
