package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.gef.EditPart;
import com.ibm.etools.emf.ecore.EClassifier;
import com.ibm.etools.emf.ref.RefObject;
import org.eclipse.core.runtime.IAdaptable;
/**
 * Default factory for creating GraphicalEditParts.
 * It gets the class string out of the decorator of the RefObject and
 * uses the graphviewClassname attribute.
 */
public class DefaultGraphicalEditPartFactory extends AbstractEditPartFactory {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected ClassDescriptorDecoratorPolicy policy;
	
	public DefaultGraphicalEditPartFactory(ClassDescriptorDecoratorPolicy policy) {
		this.policy = policy;
	}
	
	public EditPart createEditPart(Object modelObject) {
		String epClassString = policy.getGraphViewClassname((EClassifier) ((RefObject) modelObject).refMetaObject());
		return createEditPart(epClassString, modelObject);
	}
}