package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.AnnotationLinkagePolicy;
import com.ibm.etools.cdm.Annotation;
import com.ibm.etools.cdm.AnnotationGeneric;
/**
 * This is used as an annotation linkage helper when the model is an EMF
 * model. In those cases we don't need anything special. EMF handles it all
 * for us.
 */
public final class EMFAnnotationLinkagePolicy extends AnnotationLinkagePolicy {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public void dispose() {
		// Nothing needs to be done.
	}
	
	// This shouldn't even be called in this case.	
	protected void setModelOnAnnotationGeneric(Object model, AnnotationGeneric annotation) {
	}

	// This shouldn't even be called in this case.		
	protected Annotation getAnnotationFromGeneric(Object model) {
		return null;
	}
	
	// This shouldn't even be called in this case.		
	protected void initializeAnnotationGeneric(AnnotationGeneric annotation) {
	}

	// This shouldn't even be called in this case.			
	protected boolean isAnnotationValidGeneric(AnnotationGeneric annotation) {
		return true;
	}

}