package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

import java.util.*;

import org.eclipse.jface.action.*;
import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.ui.*;

import com.ibm.etools.gef.*;
import com.ibm.etools.gef.ui.actions.*;
import com.ibm.etools.gef.ui.actions.ActionRegistry;

public class EMFContextMenuProvider implements com.ibm.etools.gef.ui.parts.ContextMenuProvider{

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private EMFGraphicalEditorPart editorPart;
	private EditorPartAction fDeleteAction;

public EMFContextMenuProvider(EMFGraphicalEditorPart editor, EditorPartAction deleteAction){
	editorPart = editor;
	fDeleteAction = deleteAction;
}
public void buildContextMenu(IMenuManager menu, EditPartViewer viewer){

	EditDomain domain = viewer.getEditDomain();
	ActionRegistry registry = (ActionRegistry)editorPart.getAdapter(ActionRegistry.class);
	addMenuContributions(menu,registry);	
}
/**
 */
protected void addMenuContributions(IMenuManager menu,ActionRegistry registry){
	menu.add(fDeleteAction);
}

protected IEditorPart getEditorPart(){
	return editorPart;
}
}