package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.gef.requests.CreateRequest;
import com.ibm.etools.logging.util.Level;
import com.ibm.etools.emf.ref.RefObject;
import org.eclipse.core.runtime.*;
import com.ibm.etools.cde.CDEPlugin;
/**
 * Creation factory for EMF objects.
 */
public class EMFCreationFactory implements CreateRequest.Factory {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected RefObject fClass;

public EMFCreationFactory(RefObject aClass) {
	setObjectType(aClass);
}

public void setObjectType(RefObject aClass) {
	fClass = aClass;
}	

/**
 * getNewObject method comment. 
 */
public Object getNewObject() {
	if (fClass == null)
		return null;
	try {
		return fClass.refPackage().getFactory().create(fClass);
	} catch (Exception e) {
		Status st = new Status(IStatus.ERROR, CDEPlugin.getPlugin().getDescriptor().getUniqueIdentifier(), 0, "", e); //$NON-NLS-1$
		CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, st);
	}
	return null;
}

public Object getObjectType(){
	
	return fClass;
	
}

}


