package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.emf.resource.ResourceSet;

/**
 * @version 	1.0
 * @author
 */
public class EMFEditDomainHelper {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String
		RESOURCE_SET_KEY = "com.ibm.etools.jbcf.resourcesetkey"; //$NON-NLS-1$

	/**
	 * The resourceSet for the editor. This is the editor specific resourceSet.
	 */
	public static ResourceSet getResourceSet(EditDomain dom) {
		return (ResourceSet) dom.getData(EMFEditDomainHelper.RESOURCE_SET_KEY);
	}

	/**
	 * Set the resource set into the domain.
	 */
	public static void setResourceSet(ResourceSet rset, EditDomain dom) {
		dom.setData(EMFEditDomainHelper.RESOURCE_SET_KEY, rset);
	}

}
