package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.gef.requests.CreateRequest;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ecore.utilities.copy.EtoolsCopyUtility;
import org.eclipse.core.runtime.*;
import com.ibm.etools.cde.CDEPlugin;
/**
 * Creation factory for creating EMF objects from prototypes.
 */
public class EMFPrototypeFactory implements CreateRequest.Factory {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected RefObject fPrototype;

public EMFPrototypeFactory(RefObject aPrototype) {
	setPrototype(aPrototype);
}

public void setPrototype(RefObject aPrototype) {	
	fPrototype = aPrototype;
}	

/**
 * getNewObject method comment. 
 */
public Object getNewObject() {
	if (fPrototype == null)
		return null;
	return EtoolsCopyUtility.createCopy(fPrototype);
}

public Object getObjectType(){
	
	return fPrototype.refMetaObject();
	
}

}


