package com.ibm.etools.cde.emf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.ref.RefObject;
/**
 * This is a simple interface that workes with EMFListenerAdapter
 * to listen for notifications on an EMF object and then
 * to notify this listener that implements IEMFListener.
 * This is an very light-weight interface that only has
 * the notification method. This takes the general purpose
 * EMF adapter and makes it a simple notifier. It will only
 * notify one object, this listener. This listener pattern
 * would be used when just simple notification is all that
 * is required so that the listener doesn't need to implement
 * all of the other requirements of an adapter.
 */
public interface IEMFListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Notification of an event.
	 */
	public void notifyChanged(Notifier notifier, int eventType, RefObject sf, Object oldValue, Object newValue, int pos);
}