package com.ibm.etools.cde.palette;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
/**
 * This is the abstract base category. There are two standard implementations of it:
 * 
 * CategoryCmp: This is a category where the groups is a composite aggregation. (i.e. it is contained within the  CategoryCmp).
 * 
 * CategoryRef: This is a category where the group is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of category allows references to pieces of other palettes to form together a new category.
 */
public interface Category extends Container, RefObject {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	PalettePackage ePackagePalette();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassCategory();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the CategoryLabel attribute
	 */
	AbstractString getCategoryLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the CategoryLabel attribute
	 */
	void setCategoryLabel(AbstractString value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the CategoryLabel attribute
	 */
	void unsetCategoryLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the CategoryLabel attribute has been set
	 */
	boolean isSetCategoryLabel();
	
	/**
	 * Return the groups
	 */
	public List getGroups();	
}
