package com.ibm.etools.cde.palette;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
/**
 * This is the abstract base group. There are two standard implementations of it:
 * 
 * GroupCmp: This is a group where the entries are a composite aggregation. (i.e. it is contained within the  GroupCmp).
 * 
 * GroupRef: This is a group where the entries is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of group allows references to pieces of other palettes to form together a new group.
 */
public interface Group extends Container, RefObject {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	PalettePackage ePackagePalette();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassGroup();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the GroupLabel attribute
	 */
	AbstractString getGroupLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the GroupLabel attribute
	 */
	void setGroupLabel(AbstractString value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the GroupLabel attribute
	 */
	void unsetGroupLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the GroupLabel attribute has been set
	 */
	boolean isSetGroupLabel();
	
	/**
	 * Return the entries
	 */
	public List getEntries();
	
}
