package com.ibm.etools.cde.palette;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.gef.palette.PaletteRoot;
/**
 * This is the abstract base palette. There are two standard implementations of it:
 * 
 * PaletteCmp: This is a palette where the categories and control group are composite aggregations. (i.e. they are contained within the  PaletteCmp).
 * 
 * PaletteRef: This is a palette where the categories and control group are shared aggregations. (i.e. they are actually contained somewhere else and only referenced here). This type of palette allows references to pieces of other palettes to form together a new palette.
 */
public interface Palette extends Container, PaletteRoot, RefObject {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	PalettePackage ePackagePalette();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassPalette();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The value of the PaletteLabel attribute
	 */
	AbstractString getPaletteLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @param value The new value of the PaletteLabel attribute
	 */
	void setPaletteLabel(AbstractString value);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unsets the PaletteLabel attribute
	 */
	void unsetPaletteLabel();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return <b>true</b> if the PaletteLabel attribute has been set
	 */
	boolean isSetPaletteLabel();
	
	/**
	 * Return the Control Group.
	 */
	public Group getControlGroup();
	
	/**
	 * Return the categories
	 */	
	public List getCategories();		
}
