package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import org.eclipse.swt.graphics.Image;
import com.ibm.etools.gef.palette.PaletteContainer;
import java.util.List;


import com.ibm.etools.emf.ref.EList;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.Internals;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * This is the abstract base category. There are two standard implementations of it:
 * 
 * CategoryCmp: This is a category where the groups is a composite aggregation. (i.e. it is contained within the  CategoryCmp).
 * 
 * CategoryRef: This is a category where the group is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of category allows references to pieces of other palettes to form together a new category.
 */
/**
 * This is the abstract base category. There are two standard implementations of it:
 * 
 * CategoryCmp: This is a category where the groups is a composite aggregation. (i.e. it is contained within the  CategoryCmp).
 * 
 * CategoryRef: This is a category where the group is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of category allows references to pieces of other palettes to form together a new category.
 */
/**
 * @lastgen class CategoryImpl extends ContainerImpl implements Category, Container, RefObject {}
 */


public class CategoryImpl extends ContainerImpl implements Category, Container, RefObject {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected AbstractString categoryLabel = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setCategoryLabel = false;
	protected CategoryImpl() {
		super();
	}
	public List getChildren() {
		return getCategoryGroups();
	}
	
	/**
	 * Return the groups
	 */
	public List getGroups() {
		return getCategoryGroups();
	}
	
	public String getLabel() {
		return isSetCategoryLabel() ? getCategoryLabel().getStringValue() : ""; //$NON-NLS-1$
	}


	protected List getCategoryGroups() {
		throw new IllegalStateException("Must be implemented by subclass."); //$NON-NLS-1$
	}
	public Object getType(){
		return PaletteContainer.PALETTE_TYPE_CATEGORY;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassCategory());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassCategory() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getCategory();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public AbstractString getCategoryLabel() {
		try {
			if (this.setCategoryLabel) {
				if (this.categoryLabel==null) return null;
				this.categoryLabel = (AbstractString) ((InternalProxy)this.categoryLabel).resolve(this);
				if (this.categoryLabel==null) this.setCategoryLabel = false;
				return this.categoryLabel;
			}
			return (AbstractString)ePackagePalette().getCategory_CategoryLabel().refGetDefaultValue();
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setCategoryLabel(AbstractString value) {
		refSetValueForRefObjectSF(ePackagePalette().getCategory_CategoryLabel(),this.categoryLabel,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetCategoryLabel() {
		if (this.categoryLabel != null)
			notify(((Internals)this.categoryLabel).refSetContainer(null, null));
		else
			notify(refBasicUnsetValue(ePackagePalette().getCategory_CategoryLabel()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetCategoryLabel() {
		return setCategoryLabel;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: return getCategoryLabel();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL:
				if (!this.setCategoryLabel||this.categoryLabel==null) return null;
				if (((InternalProxy)this.categoryLabel).refIsDeleted()) {this.categoryLabel=null; this.setCategoryLabel=false;}
				return this.categoryLabel;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: return isSetCategoryLabel();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: {
				setCategoryLabel((AbstractString)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: {
				Object oldValue = this.categoryLabel;
				this.categoryLabel = (AbstractString)newValue;
				this.setCategoryLabel = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getCategory_CategoryLabel(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: {
				unsetCategoryLabel();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassCategory().getEFeatureId(eFeature)) {
			case PalettePackage.CATEGORY__CATEGORY_LABEL: {
				Object oldValue = this.categoryLabel;
				this.categoryLabel = null;
				this.setCategoryLabel = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getCategory_CategoryLabel(),oldValue,getCategoryLabel());
			}

		}
		return super.refBasicUnsetValue(feature);
	}
}
