package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.emf.CDECreationTool;
import com.ibm.etools.cde.palette.*;
import com.ibm.etools.emf.ecore.EClass;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.gef.Tool;
import com.ibm.etools.gef.requests.CreateRequest.Factory;
import com.ibm.etools.gef.tools.CreationTool;
import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
/**
 * @lastgen class CreationToolEntryImpl extends AbstractToolEntryImpl implements CreationToolEntry, AbstractToolEntry {}
 */


public class CreationToolEntryImpl extends AbstractToolEntryImpl implements CreationToolEntry, AbstractToolEntry {






	protected CreationToolEntryImpl() {
		super();
	}
	/**
	 * Return the creation factory that will be used by this entry.
	 * Overrides must return something.
	 */
	public Factory createFactory() {
		return null;
	}
 
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Factory factory;
	
	protected final Factory getFactory() {
		return factory != null ? factory : createFactory();
	}
	
	/**
	 * Set the factory that will be used by this entry in the creation tool. This allows wrappering the factory returned by createFactory() with another one (such as the AnnotationCreationFactory).
	 * 
	 */
	public final void setFactory(Factory factory) {
		this.factory = factory;
	}
 
 	/**
	 * Return the tool.
	 */
	public final Tool getTool() {
		return createTool();
	}
 
	/**
	 * Create a new tool to use for creation.
	 * All createTool() overrides to this
	 * method should create a new tool and should
	 * use getFactory to get the appropriate factory.
	 * This is because the factory may be set and
	 * wrapper the one that normally is returned.
	 */
	protected Tool createTool() {
		CreationTool tool = new CDECreationTool();
		tool.setFactory(getFactory());
		return tool;
	}
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassCreationToolEntry());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassCreationToolEntry() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getCreationToolEntry();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Return the creation factory that will be used by this entry.
	 */
	protected Factory createFactoryGen() {
		return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Set the factory that will be used by this entry in the creation tool. This allows wrappering the factory returned by createFactory() with another one (such as the AnnotationCreationFactory).
	 */
	protected void setFactoryGen(Factory factory) {

	}
}
