package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import org.eclipse.swt.graphics.Image;
import com.ibm.etools.cde.CDEPlugin;


import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.Internals;
import com.ibm.etools.emf.ref.impl.RefObjectImpl;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.gef.palette.PaletteEntry;
import java.lang.Boolean;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * @lastgen class EntryImpl extends RefObjectImpl implements Entry, RefObject, PaletteEntry {}
 */


public class EntryImpl extends RefObjectImpl implements Entry, RefObject, PaletteEntry {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Image fIcon16;
	protected boolean fHasInitializedSmallIcon;
	protected Image fIcon32;
	protected boolean fHasInitializedLargeIcon;
	
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String icon16Name = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String icon32Name = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected AbstractString entryLabel = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected AbstractString entryShortDescription = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Boolean isDefaultEntry = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIcon16Name = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIcon32Name = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setEntryLabel = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setEntryShortDescription = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setIsDefaultEntry = false;
	protected EntryImpl() {
		super();
	}
	public void finalize() throws Throwable {
		// Just to make sure, we will clean up the icons.
		if (fIcon16 != null)
				try {
				fIcon16.dispose();
			} catch (Throwable e) {
			}
		if (fIcon32 != null)
				try {
				fIcon32.dispose();
			} catch (Throwable e) {
			}
		super.finalize();
	}


	/**
	 * Answer the 16x16 IIcon for this entry.
	 * @return IImage
	 */
	public Image getSmallIcon() {
		if (fIcon16 == null && !fHasInitializedSmallIcon) {
			fIcon16 = CDEPlugin.getImageFromURLString(getIcon16Name());
			fHasInitializedSmallIcon = true;
		}
		return fIcon16;
	}
	
	/**
	 * Answer the 32x32 IIcon for this entry.
	 * @return IImage
	 */
	public Image getLargeIcon() {
		if (fIcon32 == null && !fHasInitializedLargeIcon) {
			fIcon32 = CDEPlugin.getImageFromURLString(getIcon32Name());
			fHasInitializedLargeIcon = true;
		}
		return fIcon32;
	}
	
	public String getLabel() {
		return isSetEntryLabel() ? getEntryLabel().getStringValue() : ""; //$NON-NLS-1$
	}
	
	public String getDescription() {
		return isSetEntryShortDescription()
			? getEntryShortDescription().getStringValue()
			: null;
		// no short description is valid
	}
	
	public void setIcon16Name(String value) {
		if (fIcon16 != null)
			fIcon16.dispose();
		fIcon16 = null;
		this.setIcon16NameGen(value);
	}
	public void setIcon32Name(String value) {
		if (fIcon32 != null)
			fIcon32.dispose();
		fIcon32 = null;
		this.setIcon32NameGen(value);
	}
	public void unsetIcon16Name() {
		if (fIcon16 != null)
			fIcon16.dispose();
		fIcon16 = null;
		this.unsetIcon16NameGen();
	}
	public void unsetIcon32Name() {
		if (fIcon32 != null)
			fIcon32.dispose();
		fIcon32 = null;
		this.unsetIcon32NameGen();
	}
	public boolean isDefault() {
		return isDefaultEntry();
	}
	public Object getType() {
		return null;
	}					/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassEntry());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassEntry() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getEntry();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getIcon16Name() {
		if (this.setIcon16Name) return this.icon16Name;
		else return (String)ePackagePalette().getEntry_Icon16Name().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIcon16Name() {
		return setIcon16Name;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getIcon32Name() {
		if (this.setIcon32Name) return this.icon32Name;
		else return (String)ePackagePalette().getEntry_Icon32Name().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIcon32Name() {
		return setIcon32Name;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public AbstractString getEntryLabel() {
		try {
			if (this.setEntryLabel) {
				if (this.entryLabel==null) return null;
				this.entryLabel = (AbstractString) ((InternalProxy)this.entryLabel).resolve(this);
				if (this.entryLabel==null) this.setEntryLabel = false;
				return this.entryLabel;
			}
			return (AbstractString)ePackagePalette().getEntry_EntryLabel().refGetDefaultValue();
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setEntryLabel(AbstractString value) {
		refSetValueForRefObjectSF(ePackagePalette().getEntry_EntryLabel(),this.entryLabel,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetEntryLabel() {
		if (this.entryLabel != null)
			notify(((Internals)this.entryLabel).refSetContainer(null, null));
		else
			notify(refBasicUnsetValue(ePackagePalette().getEntry_EntryLabel()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetEntryLabel() {
		return setEntryLabel;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public AbstractString getEntryShortDescription() {
		try {
			if (this.setEntryShortDescription) {
				if (this.entryShortDescription==null) return null;
				this.entryShortDescription = (AbstractString) ((InternalProxy)this.entryShortDescription).resolve(this);
				if (this.entryShortDescription==null) this.setEntryShortDescription = false;
				return this.entryShortDescription;
			}
			return (AbstractString)ePackagePalette().getEntry_EntryShortDescription().refGetDefaultValue();
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setEntryShortDescription(AbstractString value) {
		refSetValueForRefObjectSF(ePackagePalette().getEntry_EntryShortDescription(),this.entryShortDescription,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetEntryShortDescription() {
		if (this.entryShortDescription != null)
			notify(((Internals)this.entryShortDescription).refSetContainer(null, null));
		else
			notify(refBasicUnsetValue(ePackagePalette().getEntry_EntryShortDescription()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetEntryShortDescription() {
		return setEntryShortDescription;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public Boolean getIsDefaultEntry() {
		if (this.setIsDefaultEntry) return this.isDefaultEntry;
		else return (Boolean)ePackagePalette().getEntry_IsDefaultEntry().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public boolean isDefaultEntry() {
		Boolean result = getIsDefaultEntry();
		return result != null ? result.booleanValue() : false;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsDefaultEntry(Boolean value) {
		refSetValueForSimpleSF(ePackagePalette().getEntry_IsDefaultEntry(),this.isDefaultEntry,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setIsDefaultEntry(boolean value) {
		setIsDefaultEntry(new Boolean(value));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetIsDefaultEntry() {
		notify(refBasicUnsetValue(ePackagePalette().getEntry_IsDefaultEntry()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetIsDefaultEntry() {
		return setIsDefaultEntry;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: return getIcon16Name();
			case PalettePackage.ENTRY__ICON32_NAME: return getIcon32Name();
			case PalettePackage.ENTRY__ENTRY_LABEL: return getEntryLabel();
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: return getEntryShortDescription();
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: return getIsDefaultEntry();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME:
				return this.setIcon16Name? this.icon16Name : null;
			case PalettePackage.ENTRY__ICON32_NAME:
				return this.setIcon32Name? this.icon32Name : null;
			case PalettePackage.ENTRY__ENTRY_LABEL:
				if (!this.setEntryLabel||this.entryLabel==null) return null;
				if (((InternalProxy)this.entryLabel).refIsDeleted()) {this.entryLabel=null; this.setEntryLabel=false;}
				return this.entryLabel;
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION:
				if (!this.setEntryShortDescription||this.entryShortDescription==null) return null;
				if (((InternalProxy)this.entryShortDescription).refIsDeleted()) {this.entryShortDescription=null; this.setEntryShortDescription=false;}
				return this.entryShortDescription;
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY:
				return this.setIsDefaultEntry? this.isDefaultEntry : null;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: return isSetIcon16Name();
			case PalettePackage.ENTRY__ICON32_NAME: return isSetIcon32Name();
			case PalettePackage.ENTRY__ENTRY_LABEL: return isSetEntryLabel();
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: return isSetEntryShortDescription();
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: return isSetIsDefaultEntry();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: {
				setIcon16Name((String)newValue);
				return;
			}
			case PalettePackage.ENTRY__ICON32_NAME: {
				setIcon32Name((String)newValue);
				return;
			}
			case PalettePackage.ENTRY__ENTRY_LABEL: {
				setEntryLabel((AbstractString)newValue);
				return;
			}
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: {
				setEntryShortDescription((AbstractString)newValue);
				return;
			}
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: {
				setIsDefaultEntry((newValue instanceof String)?Boolean.valueOf((String)newValue):(Boolean)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: {
				Object oldValue = this.icon16Name;
				this.icon16Name = (String)newValue;
				this.setIcon16Name = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getEntry_Icon16Name(),oldValue,newValue);
			}
			case PalettePackage.ENTRY__ICON32_NAME: {
				Object oldValue = this.icon32Name;
				this.icon32Name = (String)newValue;
				this.setIcon32Name = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getEntry_Icon32Name(),oldValue,newValue);
			}
			case PalettePackage.ENTRY__ENTRY_LABEL: {
				Object oldValue = this.entryLabel;
				this.entryLabel = (AbstractString)newValue;
				this.setEntryLabel = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getEntry_EntryLabel(),oldValue,newValue);
			}
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: {
				Object oldValue = this.entryShortDescription;
				this.entryShortDescription = (AbstractString)newValue;
				this.setEntryShortDescription = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getEntry_EntryShortDescription(),oldValue,newValue);
			}
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: {
				Object oldValue = this.isDefaultEntry;
				this.isDefaultEntry = (Boolean)newValue;
				this.setIsDefaultEntry = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getEntry_IsDefaultEntry(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: {
				unsetIcon16Name();
				return;
			}
			case PalettePackage.ENTRY__ICON32_NAME: {
				unsetIcon32Name();
				return;
			}
			case PalettePackage.ENTRY__ENTRY_LABEL: {
				unsetEntryLabel();
				return;
			}
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: {
				unsetEntryShortDescription();
				return;
			}
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: {
				unsetIsDefaultEntry();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassEntry().getEFeatureId(eFeature)) {
			case PalettePackage.ENTRY__ICON16_NAME: {
				Object oldValue = this.icon16Name;
				this.icon16Name = null;
				this.setIcon16Name = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getEntry_Icon16Name(),oldValue,getIcon16Name());
			}
			case PalettePackage.ENTRY__ICON32_NAME: {
				Object oldValue = this.icon32Name;
				this.icon32Name = null;
				this.setIcon32Name = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getEntry_Icon32Name(),oldValue,getIcon32Name());
			}
			case PalettePackage.ENTRY__ENTRY_LABEL: {
				Object oldValue = this.entryLabel;
				this.entryLabel = null;
				this.setEntryLabel = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getEntry_EntryLabel(),oldValue,getEntryLabel());
			}
			case PalettePackage.ENTRY__ENTRY_SHORT_DESCRIPTION: {
				Object oldValue = this.entryShortDescription;
				this.entryShortDescription = null;
				this.setEntryShortDescription = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getEntry_EntryShortDescription(),oldValue,getEntryShortDescription());
			}
			case PalettePackage.ENTRY__IS_DEFAULT_ENTRY: {
				Object oldValue = this.isDefaultEntry;
				this.isDefaultEntry = null;
				this.setIsDefaultEntry = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getEntry_IsDefaultEntry(),oldValue,getIsDefaultEntry());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetIcon16Name()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="icon16Name: "+this.icon16Name; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIcon32Name()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="icon32Name: "+this.icon32Name; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		if(isSetIsDefaultEntry()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="isDefaultEntry: "+this.isDefaultEntry; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void setIcon16NameGen(String value) {
		refSetValueForSimpleSF(ePackagePalette().getEntry_Icon16Name(),this.icon16Name,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void unsetIcon16NameGen() {
		notify(refBasicUnsetValue(ePackagePalette().getEntry_Icon16Name()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void setIcon32NameGen(String value) {
		refSetValueForSimpleSF(ePackagePalette().getEntry_Icon32Name(),this.icon32Name,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void unsetIcon32NameGen() {
		notify(refBasicUnsetValue(ePackagePalette().getEntry_Icon32Name()));
	}
}
