package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import com.ibm.etools.gef.palette.*;
import org.eclipse.swt.graphics.Image;
import java.util.List;


import com.ibm.etools.emf.ref.EList;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.Internals;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * This is the abstract base group. There are two standard implementations of it:
 * 
 * GroupCmp: This is a group where the entries are a composite aggregation. (i.e. it is contained within the  GroupCmp).
 * 
 * GroupRef: This is a group where the entries is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of group allows references to pieces of other palettes to form together a new group.
 */
/**
 * This is the abstract base group. There are two standard implementations of it:
 * 
 * GroupCmp: This is a group where the entries are a composite aggregation. (i.e. it is contained within the  GroupCmp).
 * 
 * GroupRef: This is a group where the entries is a shared aggregation. (i.e. is is actually contained somewhere else and only referenced here). This type of group allows references to pieces of other palettes to form together a new group.
 */
/**
 * @lastgen class GroupImpl extends ContainerImpl implements Group, Container, RefObject {}
 */


public class GroupImpl extends ContainerImpl implements Group, Container, RefObject {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected AbstractString groupLabel = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setGroupLabel = false;
	protected GroupImpl() {
		super();
	}
	public String getLabel() {
		return isSetGroupLabel() ? getGroupLabel().getStringValue() : ""; //$NON-NLS-1$
	}
	
	public List getChildren() {
		return getGroupEntries();
	}
	
	/**
	 * Return the entries
	 */
	public List getEntries() {
		return getGroupEntries();
	}
	
	protected List getGroupEntries() {
		throw new IllegalStateException("Must be implemented by subclass."); //$NON-NLS-1$
	}
	
	public Object getType(){
		return PaletteContainer.PALETTE_TYPE_GROUP;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassGroup());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassGroup() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getGroup();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public AbstractString getGroupLabel() {
		try {
			if (this.setGroupLabel) {
				if (this.groupLabel==null) return null;
				this.groupLabel = (AbstractString) ((InternalProxy)this.groupLabel).resolve(this);
				if (this.groupLabel==null) this.setGroupLabel = false;
				return this.groupLabel;
			}
			return (AbstractString)ePackagePalette().getGroup_GroupLabel().refGetDefaultValue();
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setGroupLabel(AbstractString value) {
		refSetValueForRefObjectSF(ePackagePalette().getGroup_GroupLabel(),this.groupLabel,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetGroupLabel() {
		if (this.groupLabel != null)
			notify(((Internals)this.groupLabel).refSetContainer(null, null));
		else
			notify(refBasicUnsetValue(ePackagePalette().getGroup_GroupLabel()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetGroupLabel() {
		return setGroupLabel;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: return getGroupLabel();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL:
				if (!this.setGroupLabel||this.groupLabel==null) return null;
				if (((InternalProxy)this.groupLabel).refIsDeleted()) {this.groupLabel=null; this.setGroupLabel=false;}
				return this.groupLabel;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: return isSetGroupLabel();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: {
				setGroupLabel((AbstractString)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: {
				Object oldValue = this.groupLabel;
				this.groupLabel = (AbstractString)newValue;
				this.setGroupLabel = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getGroup_GroupLabel(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: {
				unsetGroupLabel();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassGroup().getEFeatureId(eFeature)) {
			case PalettePackage.GROUP__GROUP_LABEL: {
				Object oldValue = this.groupLabel;
				this.groupLabel = null;
				this.setGroupLabel = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getGroup_GroupLabel(),oldValue,getGroupLabel());
			}

		}
		return super.refBasicUnsetValue(feature);
	}
}
