package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.PackageNotRegisteredException;
import java.lang.Object;
/**
 * @lastgen class PaletteFactoryImpl extends EFactoryImpl implements PaletteFactory, EFactory {}
 */


public class PaletteFactoryImpl extends EFactoryImpl implements PaletteFactory, EFactory {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public PaletteFactoryImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object create(String ObjectName) {
		switch (getPalettePackage().getEMetaObjectId(ObjectName)) {
			case PalettePackage.ANNOTATED_CREATION_ENTRY: return createAnnotatedCreationEntry();
			case PalettePackage.TOOL_ENTRY: return createToolEntry();
			case PalettePackage.ENTRY: return createEntry();
			case PalettePackage.CATEGORY_REF: return createCategoryRef();
			case PalettePackage.GROUP_CMP: return createGroupCmp();
			case PalettePackage.GROUP_REF: return createGroupRef();
			case PalettePackage.PALETTE_REF: return createPaletteRef();
			case PalettePackage.CATEGORY_CMP: return createCategoryCmp();
			case PalettePackage.PALETTE_CMP: return createPaletteCmp();
			case PalettePackage.EMF_CREATION_TOOL_ENTRY: return createEMFCreationToolEntry();
			case PalettePackage.EMF_PROTOTYPE_TOOL_ENTRY: return createEMFPrototypeToolEntry();
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY: return createSelectionCreationToolEntry();
		}
		return super.create(ObjectName);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EMFPrototypeToolEntry createEMFPrototypeToolEntry() {
		EMFPrototypeToolEntry o = new EMFPrototypeToolEntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ToolEntry createToolEntry() {
		ToolEntry o = new ToolEntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Entry createEntry() {
		Entry o = new EntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public GroupCmp createGroupCmp() {
		GroupCmp o = new GroupCmpImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public GroupRef createGroupRef() {
		GroupRef o = new GroupRefImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PaletteRef createPaletteRef() {
		PaletteRef o = new PaletteRefImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CategoryRef createCategoryRef() {
		CategoryRef o = new CategoryRefImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CategoryCmp createCategoryCmp() {
		CategoryCmp o = new CategoryCmpImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PaletteCmp createPaletteCmp() {
		PaletteCmp o = new PaletteCmpImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public AnnotatedCreationEntry createAnnotatedCreationEntry() {
		AnnotatedCreationEntry o = new AnnotatedCreationEntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EMFCreationToolEntry createEMFCreationToolEntry() {
		EMFCreationToolEntry o = new EMFCreationToolEntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public SelectionCreationToolEntry createSelectionCreationToolEntry() {
		SelectionCreationToolEntry o = new SelectionCreationToolEntryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CreationFactory createCreationFactory() {
		CreationFactory o = new CreationFactoryImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage getPalettePackage() {
		return (PalettePackage)refPackage();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static PaletteFactory getActiveFactory() {
		PalettePackage pkg = getPackage();
		if (pkg!=null) return pkg.getPaletteFactory();
		else return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static PalettePackage getPackage() {
		PalettePackage pkg;
		pkg = (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
		return pkg;
	}
}
