package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.*;


import com.ibm.etools.emf.ref.EList;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * This is a palette where the categories and control group are shared aggregations. (i.e. they are actually contained somewhere else and only referenced here). This type of palette allows references to pieces of other palettes to form together a new palette.
 */
/**
 * This is a palette where the categories and control group are shared aggregations. (i.e. they are actually contained somewhere else and only referenced here). This type of palette allows references to pieces of other palettes to form together a new palette.
 */
/**
 * @lastgen class PaletteRefImpl extends PaletteImpl implements PaletteRef, Palette {}
 */


public class PaletteRefImpl extends PaletteImpl implements PaletteRef, Palette {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Group refControlGroup = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EList refCategories = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setRefControlGroup = false;
	protected PaletteRefImpl() {
		super();
	}
	protected Group getPaletteControlGroup() {
		return getRefControlGroup();
	}
	
	protected List getPaletteCategories() {
		List cats = getRefCategories();
		ArrayList catList = new ArrayList(cats.size());
		// Slight possibility that one of the categories can't be found (i.e. the href was invalid).
		// In that case, a null is returned. We need to strip these out because GEF can't handle this.
		Iterator itr = cats.iterator();
		while (itr.hasNext()) {
			Object n = itr.next();
			if (n != null)
				catList.add(n);
		}
		return catList;
	}	


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassPaletteRef());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassPaletteRef() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getPaletteRef();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public Group getRefControlGroup() {
		try {
			if (this.refControlGroup == null) return null;
			this.refControlGroup = (Group) ((InternalProxy)this.refControlGroup).resolve(this, ePackagePalette().getPaletteRef_RefControlGroup());
			if (this.refControlGroup==null) this.setRefControlGroup = false;
			return this.refControlGroup;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setRefControlGroup(Group l) {
		refSetValueForSimpleSF(ePackagePalette().getPaletteRef_RefControlGroup(),this.refControlGroup,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetRefControlGroup() {
		refUnsetValueForSimpleSF(ePackagePalette().getPaletteRef_RefControlGroup());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetRefControlGroup() {
		return setRefControlGroup;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public EList getRefCategories() {
		if (this.refCategories==null) {
			this.refCategories=newCollection(refDelegateOwner(),ePackagePalette().getPaletteRef_RefCategories());
		}
		return this.refCategories;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: return getRefControlGroup();
			case PalettePackage.PALETTE_REF__REF_CATEGORIES: return getRefCategories();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP:
				if (!this.setRefControlGroup||this.refControlGroup==null) return null;
				if (((InternalProxy)this.refControlGroup).refIsDeleted()) {this.refControlGroup=null; this.setRefControlGroup=false;}
				return this.refControlGroup;
			case PalettePackage.PALETTE_REF__REF_CATEGORIES:
				return this.refCategories;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: return isSetRefControlGroup();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: {
				setRefControlGroup((Group)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: {
				Object oldValue = this.refControlGroup;
				this.refControlGroup = (Group)newValue;
				this.setRefControlGroup = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getPaletteRef_RefControlGroup(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: {
				unsetRefControlGroup();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassPaletteRef().getEFeatureId(eFeature)) {
			case PalettePackage.PALETTE_REF__REF_CONTROL_GROUP: {
				Object oldValue = this.refControlGroup;
				this.refControlGroup = null;
				this.setRefControlGroup = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getPaletteRef_RefControlGroup(),oldValue,null);
			}

		}
		return super.refBasicUnsetValue(feature);
	}
}
