package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;
import com.ibm.etools.cde.*;
import org.eclipse.core.runtime.*;
import java.text.MessageFormat;
import com.ibm.etools.gef.requests.CreateRequest.Factory;
import com.ibm.etools.gef.tools.CreationTool;
import com.ibm.etools.logging.util.Level;
import com.ibm.etools.common.command.UnexecutableCommand;
//import com.ibm.etools.gef.*;
import com.ibm.etools.gef.Tool;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * A creation tool entry where the actual object created is determined by the selectionCreation class. This allows the actual object created to be determined at selection time rather than statically defined in the palette entry itself.
 */
/**
 * A creation tool entry where the actual object created is determined by the selectionCreation class. This allows the actual object created to be determined at selection time rather than statically defined in the palette entry itself.
 */
/**
 * @lastgen class SelectionCreationToolEntryImpl extends CreationToolEntryImpl implements SelectionCreationToolEntry, CreationToolEntry {}
 */


public class SelectionCreationToolEntryImpl extends CreationToolEntryImpl implements SelectionCreationToolEntry, CreationToolEntry {






	protected SelectionCreationToolEntryImpl() {
		super();
	}
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected List selectionHistory = new java.util.ArrayList(2);
		
	protected ISelector getSelector() {
		if ( !isSetSelectorClassName() || getSelectorClassName() == null)
			return null;
			
		// Now create the selector
		String selectorClassName = getSelectorClassName();
		try {	
			return (ISelector) CDEPlugin.createInstance(null, selectorClassName);
		} catch (InstantiationException e){
			String msg = MessageFormat.format(CDEMessages.getString(CDEMessages.OBJECT_NOINSTANTIATE), new Object[] {selectorClassName});		
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, msg, e));
		} catch (ClassCastException e){
			String msg = MessageFormat.format(CDEMessages.getString(CDEMessages.NOT_INSTANCE), new Object[] {selectorClassName, ISelector.class});		
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, msg, e));
		} catch (Exception e){
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, "", e));			 //$NON-NLS-1$
		}
		return null;
	}
	
	protected static class SelectionFactory implements Factory {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
		public Object newObject;
		public Object type;
		
		public Object getNewObject() {
			return newObject;
		}
		
		public Object getObjectType() {
			return type;
		}
	}


	// We need to keep last one created because that
	// is the one that gets wrappered, but we need
	// this one in the creation tool, not the wrapper.	
	protected SelectionFactory fSelFactory;
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String selectorClassName = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setSelectorClassName = false;
	public Factory createFactory() {
		fSelFactory = new SelectionFactory();
		return fSelFactory;
	}
	
	protected class SelectionCreationToolImpl extends SelectionCreationTool {
		
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
		SelectionFactory selFactory;
		
		public SelectionCreationToolImpl(SelectionFactory factory) {
			selFactory = factory;
		}
		
		public void activate(){
			super.activate();
			Object[] ret = null;
			ISelector sel = getSelector();
			if (sel != null)
				ret = sel.getNewObjectAndType(this);
			if (ret != null) {
				selFactory.newObject = ret[0];
				selFactory.type = ret[1];
			} else {
				getDomain().loadDefaultTool();
			}
		}
		
		public SelectionCreationToolEntry getSelectionToolEntry() {
			return SelectionCreationToolEntryImpl.this;
		}
		
		public void deactivate() {
			super.deactivate();
			selFactory.newObject = null;
			selFactory.type = null;
		}
	}
			
	protected Tool createTool() {
		CreationTool tool = new SelectionCreationToolImpl(fSelFactory);
		tool.setFactory(getFactory());
		return tool;
	}
	
	public List getSelectionHistory() {
		return selectionHistory;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassSelectionCreationToolEntry());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassSelectionCreationToolEntry() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getSelectionCreationToolEntry();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 * This is the classname of the selector class. It must implement the ISelector interface.
	 */
	public String getSelectorClassName() {
		if (this.setSelectorClassName) return this.selectorClassName;
		else return (String)ePackagePalette().getSelectionCreationToolEntry_SelectorClassName().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setSelectorClassName(String value) {
		refSetValueForSimpleSF(ePackagePalette().getSelectionCreationToolEntry_SelectorClassName(),this.selectorClassName,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetSelectorClassName() {
		notify(refBasicUnsetValue(ePackagePalette().getSelectionCreationToolEntry_SelectorClassName()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetSelectorClassName() {
		return setSelectorClassName;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: return getSelectorClassName();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME:
				return this.setSelectorClassName? this.selectorClassName : null;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: return isSetSelectorClassName();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: {
				setSelectorClassName((String)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: {
				Object oldValue = this.selectorClassName;
				this.selectorClassName = (String)newValue;
				this.setSelectorClassName = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getSelectionCreationToolEntry_SelectorClassName(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: {
				unsetSelectorClassName();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassSelectionCreationToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.SELECTION_CREATION_TOOL_ENTRY__SELECTOR_CLASS_NAME: {
				Object oldValue = this.selectorClassName;
				this.selectorClassName = null;
				this.setSelectorClassName = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getSelectionCreationToolEntry_SelectorClassName(),oldValue,getSelectorClassName());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetSelectorClassName()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="selectorClassName: "+this.selectorClassName; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
}
