package com.ibm.etools.cde.palette.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.palette.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;
import java.text.MessageFormat;
import org.eclipse.core.runtime.*;
import com.ibm.etools.gef.Tool;
import com.ibm.etools.logging.util.Level;
import com.ibm.etools.cde.*;
import com.ibm.etools.cde.CDEPlugin;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * @lastgen class ToolEntryImpl extends AbstractToolEntryImpl implements ToolEntry, AbstractToolEntry {}
 */


public class ToolEntryImpl extends AbstractToolEntryImpl implements ToolEntry, AbstractToolEntry {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Tool fTool;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String toolClassName = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setToolClassName = false;
	protected ToolEntryImpl() {
		super();
	}
	public Tool getTool() {
		if (fTool != null) 
			return fTool;
			
		if ( !isSetToolClassName() || getToolClassName() == null)
			return null;
			
		// Now create the tool
		String toolClassName = getToolClassName();
		try {	
			return (Tool) CDEPlugin.createInstance(null, toolClassName);
		} catch (InstantiationException e){
			String msg = MessageFormat.format(CDEMessages.getString(CDEMessages.OBJECT_NOINSTANTIATE), new Object[] {toolClassName});		
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, msg, e));
		} catch (ClassCastException e){
			String msg = MessageFormat.format(CDEMessages.getString(CDEMessages.NOT_INSTANCE), new Object[] {toolClassName, Tool.class});		
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, msg, e));
		} catch (Exception e){
			CDEPlugin.getPlugin().getMsgLogger().write(Level.WARNING, new Status(IStatus.WARNING, CDEPlugin.getPlugin().getPluginID(), 0, "", e));			 //$NON-NLS-1$
		}
		return null;
	}
	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassToolEntry());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public PalettePackage ePackagePalette() {
		return (PalettePackage)RefRegister.getPackage(PalettePackage.packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassToolEntry() {
		return ((PalettePackage)RefRegister.getPackage(PalettePackage.packageURI)).getToolEntry();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getToolClassName() {
		if (this.setToolClassName) return this.toolClassName;
		else return (String)ePackagePalette().getToolEntry_ToolClassName().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setToolClassName(String value) {
		refSetValueForSimpleSF(ePackagePalette().getToolEntry_ToolClassName(),this.toolClassName,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetToolClassName() {
		notify(refBasicUnsetValue(ePackagePalette().getToolEntry_ToolClassName()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetToolClassName() {
		return setToolClassName;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: return getToolClassName();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME:
				return this.setToolClassName? this.toolClassName : null;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: return isSetToolClassName();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: {
				setToolClassName((String)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: {
				Object oldValue = this.toolClassName;
				this.toolClassName = (String)newValue;
				this.setToolClassName = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackagePalette().getToolEntry_ToolClassName(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: {
				unsetToolClassName();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassToolEntry().getEFeatureId(eFeature)) {
			case PalettePackage.TOOL_ENTRY__TOOL_CLASS_NAME: {
				Object oldValue = this.toolClassName;
				this.toolClassName = null;
				this.setToolClassName = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackagePalette().getToolEntry_ToolClassName(),oldValue,getToolClassName());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetToolClassName()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="toolClassName: "+this.toolClassName; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
}
