package com.ibm.etools.cde.properties;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.util.*;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.emf.ecore.EcorePackage;
import com.ibm.etools.cde.CDEPlugin;
import com.ibm.etools.cde.decorators.*;
import com.ibm.etools.propertysheet.*;

public class PropertyEditorRegistry {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
static public void registerDefaultEditors() {
	EcorePackage pkg = (EcorePackage) RefRegister.getPackage(EcorePackage.packageURI);
	DecoratorsFactory dFact = ((DecoratorsPackage) RefRegister.getPackage(DecoratorsPackage.packageURI)).getDecoratorsFactory();
	
	String pid = CDEPlugin.getPlugin().getPluginID();
	String pspid = PSheetPlugin.getPlugin().getDescriptor().getUniqueIdentifier();

	BasePropertyDecorator bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":byte"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getEByte().getEDecorators().add(bpd);
	
	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":double"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getEDouble().getEDecorators().add(bpd);	
	
	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":float"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getEFloat().getEDecorators().add(bpd);	
	
	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":integer"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getEInt().getEDecorators().add(bpd);
	
	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":long"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getELong().getEDecorators().add(bpd);	

	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + NumberCellEditor.class.getName() + ":short"); //$NON-NLS-1$ //$NON-NLS-2$
	bpd.setLabelProviderClassname(pid + "/" + NumberLabelProvider.class.getName()); //$NON-NLS-1$
	pkg.getEShort().getEDecorators().add(bpd);	


	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + StringCellEditor.class.getName()); //$NON-NLS-1$
	// String doesn't need a label provider. If there isn't one, it just does toString(), which is good.
	pkg.getEString().getEDecorators().add(bpd);	
	
	bpd = dFact.createBasePropertyDecorator();
	bpd.setCellEditorClassname(pspid + "/" + BooleanCellEditor.class.getName()); //$NON-NLS-1$
	bpd.setLabelProviderClassname(pid + "/" + BooleanLabelProvider.class.getName());	 //$NON-NLS-1$
	pkg.getEBoolean().getEDecorators().add(bpd);	
}
}