package com.ibm.etools.cde.utility.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cde.utility.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;


import java.util.Arrays;
import com.ibm.etools.emf.ref.impl.EListImpl;


import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.PackageNotRegisteredException;
import java.lang.Object;
/**
 * @lastgen class UtilityFactoryImpl extends EFactoryImpl implements UtilityFactory, EFactory {}
 */


public class UtilityFactoryImpl extends EFactoryImpl implements UtilityFactory, EFactory {






	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public UtilityFactoryImpl() {
		super();
	}
	/**
	 * Some helper methods for creating the string objects.
	 */
	public ConstantString createConstantString(String aString) {
		ConstantString o = createConstantString();
		o.setString(aString);
		return o;
	}
	
	public ConstantString createConstantString(String aString, String id) {
		ConstantString o = createConstantString(aString);
		o.refSetID(id);
		return o;
	}
	
	public TranslatableString createTranslatableString(ResourceBundle bundle, String key) {
		TranslatableString o = createTranslatableString();
		o.setBundle(bundle);
		o.setKey(key);
		return o;
	}
	
	public TranslatableString createTranslatableString(ResourceBundle bundle, String key, String id)	{
		TranslatableString o = createTranslatableString(bundle, key);
		o.refSetID(id);
		return o;
	}
	
	public ResourceBundle createURLResourceBundle(String[] urls, String bundleName) {
		URLResourceBundle o = createURLResourceBundle();
		o.getBundleURLs().add(Arrays.asList(urls));
		o.setBundleName(bundleName);
		return o;
	}
	
	public ResourceBundle createURLResourceBundle(String[] urls, String bundleName, String id) {
		ResourceBundle o = createURLResourceBundle(urls, bundleName);
		o.refSetID(id);
		return o;
	}
	
	
	public ResourceBundle createURLResourceBundle(String url, String bundleName) {
		URLResourceBundle o = createURLResourceBundle();
		o.getBundleURLs().add(url);
		o.setBundleName(bundleName);		
		return o;
	}			
	
	public ResourceBundle createURLResourceBundle(String url, String bundleName, String id) {
		ResourceBundle o = createURLResourceBundle(url, bundleName);
		o.refSetID(id);
		return o;
	}
	
	public GIFFileGraphic createGIFFileGraphic(String resourceName) {
		GIFFileGraphic o = createGIFFileGraphic();
		o.setResourceName(resourceName);
		return o;
	}	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object create(String ObjectName) {
		switch (getUtilityPackage().getEMetaObjectId(ObjectName)) {
			case UtilityPackage.GIF_FILE_GRAPHIC: return createGIFFileGraphic();
			case UtilityPackage.CONSTANT_STRING: return createConstantString();
			case UtilityPackage.TRANSLATABLE_STRING: return createTranslatableString();
			case UtilityPackage.URL_RESOURCE_BUNDLE: return createURLResourceBundle();
		}
		return super.create(ObjectName);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public GIFFileGraphic createGIFFileGraphic() {
		GIFFileGraphic o = new GIFFileGraphicImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ConstantString createConstantString() {
		ConstantString o = new ConstantStringImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public TranslatableString createTranslatableString() {
		TranslatableString o = new TranslatableStringImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public URLResourceBundle createURLResourceBundle() {
		URLResourceBundle o = new URLResourceBundleImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public UtilityPackage getUtilityPackage() {
		return (UtilityPackage)refPackage();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static UtilityFactory getActiveFactory() {
		UtilityPackage pkg = getPackage();
		if (pkg!=null) return pkg.getUtilityFactory();
		else return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static UtilityPackage getPackage() {
		UtilityPackage pkg;
		pkg = (UtilityPackage)RefRegister.getPackage(UtilityPackage.packageURI);
		return pkg;
	}
}
