package com.ibm.etools.cdm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.emf.ref.RefBaseObject;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.EList;
/**
 * This class holds KeyedValues. It is used by mixing it in with multiple inheritance into where it is needed.
 * 
 * The operations allow treating the KeyedValues as properties. They should be used instead of the generic keyedValues relationship. It allows easier usage of the keyed values.
 * 
 * Note: KeyedValues should be treated as dataTypes, in other words, individual KeyedValues shouldn't be updated, they should be replaced instead. This is because typically users area listening for new keyed values, not subvalues within individual keyed values being changed. If the users understands this and still listens on individual KeyedValues, that is OK as long thier model handles unlistening when the keyedvalue is removed.
 */
public interface KeyedValueHolder extends RefObject {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	CDMPackage ePackageCDM();
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	EClass eClassKeyedValueHolder();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * @return The list of KeyedValues references
	 */
	EList getKeyedValues();
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Get the KeyedValue for a specific key.
	 */
	KeyedValue getKeyedValue(String key);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Set the KeyValue for the given key. Replace a KeyValue that is already there of that key. Return the previous setting, if any.
	 */
	KeyedValue setKeyedValue(String key, KeyedValue keyValue);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Is there a KeyedValue for given key?
	 */
	boolean isSetKeyedValue(String key);
	/**
	 * @generated This field/method will be replaced during code generation 
	 * Unset the KeyedValue for the given key, if any. Return the setting that was there, if any.
	 */
	KeyedValue unsetKeyedValue(String key);
}
