package com.ibm.etools.cdm.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cdm.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.PackageNotRegisteredException;
import java.lang.Object;
/**
 * @generated
 */
public class CDMFactoryImpl extends EFactoryImpl implements CDMFactory, EFactory {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public CDMFactoryImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object create(String ObjectName) {
		switch (getCDMPackage().getEMetaObjectId(ObjectName)) {
			case CDMPackage.DIAGRAM_DATA: return createDiagramData();
			case CDMPackage.DIAGRAM: return createDiagram();
			case CDMPackage.VISUAL_INFO: return createVisualInfo();
			case CDMPackage.ANNOTATION_EMF: return createAnnotationEMF();
			case CDMPackage.ANNOTATION_GENERIC: return createAnnotationGeneric();
			case CDMPackage.KEYED_STRING: return createKeyedString();
			case CDMPackage.KEYED_LOCATION: return createKeyedLocation();
			case CDMPackage.KEYED_POINTS: return createKeyedPoints();
			case CDMPackage.KEYED_SIZE: return createKeyedSize();
			case CDMPackage.KEYED_CONSTRAINT: return createKeyedConstraint();
			case CDMPackage.KEYED_GENERIC: return createKeyedGeneric();
			case CDMPackage.KEYED_INTEGER: return createKeyedInteger();
			case CDMPackage.DIAGRAM_FIGURE: return createDiagramFigure();
		}
		return super.create(ObjectName);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public DiagramData createDiagramData() {
		DiagramData o = new DiagramDataImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Diagram createDiagram() {
		Diagram o = new DiagramImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public VisualInfo createVisualInfo() {
		VisualInfo o = new VisualInfoImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public AnnotationEMF createAnnotationEMF() {
		AnnotationEMF o = new AnnotationEMFImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public AnnotationGeneric createAnnotationGeneric() {
		AnnotationGeneric o = new AnnotationGenericImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedString createKeyedString() {
		KeyedString o = new KeyedStringImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedLocation createKeyedLocation() {
		KeyedLocation o = new KeyedLocationImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedPoints createKeyedPoints() {
		KeyedPoints o = new KeyedPointsImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedSize createKeyedSize() {
		KeyedSize o = new KeyedSizeImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedConstraint createKeyedConstraint() {
		KeyedConstraint o = new KeyedConstraintImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedGeneric createKeyedGeneric() {
		KeyedGeneric o = new KeyedGenericImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public KeyedInteger createKeyedInteger() {
		KeyedInteger o = new KeyedIntegerImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public DiagramFigure createDiagramFigure() {
		DiagramFigure o = new DiagramFigureImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ViewPoint createViewPoint() {
		ViewPoint o = new ViewPointImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ViewDimension createViewDimension() {
		ViewDimension o = new ViewDimensionImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public ViewRectangle createViewRectangle() {
		ViewRectangle o = new ViewRectangleImpl();
		o.initInstance();
		adapt(o);
		return o;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CDMPackage getCDMPackage() {
		return (CDMPackage)refPackage();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static CDMFactory getActiveFactory() {
		CDMPackage pkg = getPackage();
		if (pkg!=null) return pkg.getCDMFactory();
		else return null;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static CDMPackage getPackage() {
		CDMPackage pkg;
		pkg = (CDMPackage)RefRegister.getPackage(CDMPackage.packageURI);
		return pkg;
	}
}
