package com.ibm.etools.cdm.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cdm.*;
import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.impl.*;

import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.Extent;
import com.ibm.etools.emf.ref.RefFactory;
import com.ibm.etools.emf.ref.PackageNotRegisteredException;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.impl.ExtentAutoKeyImpl;
import com.ibm.etools.cdm.model.Point;
import com.ibm.etools.cdm.model.Dimension;
import com.ibm.etools.cdm.model.Rectangle;
import com.ibm.etools.emf.resource.Resource;
import com.ibm.etools.emf.resource.ResourceFactoryRegister;
import java.util.List;


public class CDMPackageImpl extends EPackageImpl implements CDMPackage, EPackage {
		/**
		 * @generated This field/method will be replaced during code generation.
		 */



		/**
		 * @generated This field/method will be replaced during code generation.
		 */
	public CDMPackageImpl() {
		
				super(packageURI);
				initializePackage(null);
	}
		/**
		 * @generated This field/method will be replaced during code generation.
		 */
	public CDMPackageImpl(CDMFactory f) {
		
				super(packageURI);
				initializePackage(f);
	}
		/**
		 * @generated This field/method will be replaced during code generation.
		 */
	protected CDMPackageImpl(String uri) {
		
				super(uri);
	}
	protected void initializePackage(CDMFactory f)
	{
		initializePackageGen(f);
	
		EcorePackage epkg = (EcorePackage) RefRegister.getPackage(EcorePackage.packageURI);
		EcoreFactory ef = epkg.getEcoreFactory();
		EReference parentAnnotationAttr = ef.createEReference();
		parentAnnotationAttr.refSetID("RefObject."+PARENT_ANNOTATION_ATTRNAME); //$NON-NLS-1$
		parentAnnotationAttr.setName(PARENT_ANNOTATION_ATTRNAME);
		parentAnnotationAttr.refSetUUID ("com.ibm.etools.emf.ref/RefObject/"+PARENT_ANNOTATION_ATTRNAME); //$NON-NLS-1$
		parentAnnotationAttr.refSetIsTransient(true);
		parentAnnotationAttr.refSetIsVolatile(false);
		parentAnnotationAttr.refSetIsChangeable(true);
		parentAnnotationAttr.setIsNavigable(true);
		EMultiplicity eMult = ef.createEMultiplicity();
			eMult.refSetID("RefObject."+PARENT_ANNOTATION_ATTRNAME+".multiplicity"); //$NON-NLS-1$ //$NON-NLS-2$
		parentAnnotationAttr.setEMultiplicity(eMult);
		parentAnnotationAttr.refSetType(getAnnotationEMF());
		parentAnnotationAttr.refSetOtherEnd(getAnnotationEMF_Annotates());
		this.refResource().getExtent().add(parentAnnotationAttr);
		getAnnotationEMF_Annotates().refSetOtherEnd(parentAnnotationAttr);
	}	
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void initializePackageGen(CDMFactory f) {
		ePackage = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		eFactory = ePackage.getEcoreFactory();
		createAllClasses();

		setNsName("cdm"); //$NON-NLS-1$
		setNsURI(packageURI);
		refSetUUID("com.ibm.etools.cdm"); //$NON-NLS-1$
		refSetID(packageURI);
//		refSetMetaObject(ePackage.metaEPackage());
		refSetMetaObject(ePackage.getEMetaObject(EcorePackage.E_PACKAGE));
		if (f!=null) {
			setEFactoryInstance(f);
//			f.refSetMetaObject(ePackage.metaEFactory());
			f.refSetMetaObject(ePackage.getEMetaObject(EcorePackage.E_FACTORY));
		}

		// Initialize and register other packages in this model
		EcorePackageImpl.init();
		addAllInheritedFeatures();
		initializeAllFeatures();
		initializeAllClasses();
		initializeAllClassLinks();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private void createAllClasses() {

		// Classes
			addEMetaObject(getDiagramData(),"DiagramData",DIAGRAM_DATA); //$NON-NLS-1$
			addEMetaObject(getDiagram(),"Diagram",DIAGRAM); //$NON-NLS-1$
			addEMetaObject(getKeyedValueHolder(),"KeyedValueHolder",KEYED_VALUE_HOLDER); //$NON-NLS-1$
			addEMetaObject(getVisualInfo(),"VisualInfo",VISUAL_INFO); //$NON-NLS-1$
			addEMetaObject(getAnnotation(),"Annotation",ANNOTATION); //$NON-NLS-1$
			addEMetaObject(getAnnotationEMF(),"AnnotationEMF",ANNOTATION_EMF); //$NON-NLS-1$
			addEMetaObject(getAnnotationGeneric(),"AnnotationGeneric",ANNOTATION_GENERIC); //$NON-NLS-1$
			addEMetaObject(getKeyedValue(),"KeyedValue",KEYED_VALUE); //$NON-NLS-1$
			addEMetaObject(getKeyedString(),"KeyedString",KEYED_STRING); //$NON-NLS-1$
			addEMetaObject(getKeyedLocation(),"KeyedLocation",KEYED_LOCATION); //$NON-NLS-1$
			addEMetaObject(getKeyedPoints(),"KeyedPoints",KEYED_POINTS); //$NON-NLS-1$
			addEMetaObject(getKeyedSize(),"KeyedSize",KEYED_SIZE); //$NON-NLS-1$
			addEMetaObject(getKeyedConstraint(),"KeyedConstraint",KEYED_CONSTRAINT); //$NON-NLS-1$
			addEMetaObject(getKeyedGeneric(),"KeyedGeneric",KEYED_GENERIC); //$NON-NLS-1$
			addEMetaObject(getKeyedInteger(),"KeyedInteger",KEYED_INTEGER); //$NON-NLS-1$
			addEMetaObject(getDiagramFigure(),"DiagramFigure",DIAGRAM_FIGURE); //$NON-NLS-1$

		// Data types
			addEMetaObject(getViewPoint(),"ViewPoint",VIEW_POINT); //$NON-NLS-1$
			addEMetaObject(getViewDimension(),"ViewDimension",VIEW_DIMENSION); //$NON-NLS-1$
			addEMetaObject(getViewRectangle(),"ViewRectangle",VIEW_RECTANGLE); //$NON-NLS-1$
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private void addAllInheritedFeatures() {
		addInheritedFeaturesDiagramData();
		addInheritedFeaturesDiagram();
		addInheritedFeaturesKeyedValueHolder();
		addInheritedFeaturesVisualInfo();
		addInheritedFeaturesAnnotation();
		addInheritedFeaturesAnnotationEMF();
		addInheritedFeaturesAnnotationGeneric();
		addInheritedFeaturesKeyedValue();
		addInheritedFeaturesKeyedString();
		addInheritedFeaturesKeyedLocation();
		addInheritedFeaturesKeyedPoints();
		addInheritedFeaturesKeyedSize();
		addInheritedFeaturesKeyedConstraint();
		addInheritedFeaturesKeyedGeneric();
		addInheritedFeaturesKeyedInteger();
		addInheritedFeaturesDiagramFigure();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private void initializeAllFeatures() {
		initFeatureDiagramDataDiagrams();
		initFeatureDiagramDataAnnotations();
		initFeatureDiagramName();
		initFeatureDiagramDiagramData();
		initFeatureDiagramVisualInfos();
		initFeatureDiagramFigures();
		initFeatureKeyedValueHolderKeyedValues();
		initFeatureVisualInfoDiagram();
		initFeatureAnnotationVisualInfos();
		initFeatureAnnotationEMFAnnotates();
		initFeatureAnnotationGenericAnnotatesID();
		initFeatureKeyedValueKey();
		initFeatureKeyedValueHolder();
		initFeatureKeyedStringValue();
		initFeatureKeyedLocationValue();
		initFeatureKeyedPointsPoints();
		initFeatureKeyedSizeValue();
		initFeatureKeyedConstraintValue();
		initFeatureKeyedGenericValue();
		initFeatureKeyedIntegerValue();
		initFeatureDiagramFigureType();
		initFeatureDiagramFigureChildFigures();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void initializeAllClasses() {
		initClassDiagramData();
		initClassDiagram();
		initClassKeyedValueHolder();
		initClassVisualInfo();
		initClassAnnotation();
		initClassAnnotationEMF();
		initClassAnnotationGeneric();
		initClassKeyedValue();
		initClassKeyedString();
		initClassKeyedLocation();
		initClassKeyedPoints();
		initClassKeyedSize();
		initClassKeyedConstraint();
		initClassKeyedGeneric();
		initClassKeyedInteger();
		initClassDiagramFigure();
		initClassViewPoint();
		initClassViewDimension();
		initClassViewRectangle();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected void initializeAllClassLinks() {
		initLinksDiagramData();
		initLinksDiagram();
		initLinksKeyedValueHolder();
		initLinksVisualInfo();
		initLinksAnnotation();
		initLinksAnnotationEMF();
		initLinksAnnotationGeneric();
		initLinksKeyedValue();
		initLinksKeyedString();
		initLinksKeyedLocation();
		initLinksKeyedPoints();
		initLinksKeyedSize();
		initLinksKeyedConstraint();
		initLinksKeyedGeneric();
		initLinksKeyedInteger();
		initLinksDiagramFigure();
		initLinksViewPoint();
		initLinksViewDimension();
		initLinksViewRectangle();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Extent refExtent()
	{
		Extent ext = super.refExtent();
		if (ext ==null) {
			ext = new ExtentAutoKeyImpl ();
			Resource r = ResourceFactoryRegister.getFactory(packageURI).makeResource(packageURI,ext);
			ext.add(this);
		}
	return ext;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Resource refResource()
	{
		Resource res = super.refResource();
		if (res ==null) {
			Extent ext = refExtent();
			res=ext.getResource();
		}
	return res;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefFactory getFactory() {
		RefFactory existingFactory = getEFactoryInstance();
		if (existingFactory!=null) return existingFactory;
		CDMFactory f = new CDMFactoryImpl();
		setEFactoryInstance(f);
		return f;
	}

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EcorePackage ePackage = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EcoreFactory eFactory = null;

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classDiagramData = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classDiagram = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedValueHolder = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classVisualInfo = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classAnnotation = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classAnnotationEMF = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classAnnotationGeneric = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedValue = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedString = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedLocation = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedPoints = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedSize = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedConstraint = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedGeneric = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classKeyedInteger = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EClass classDiagramFigure = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private ViewPoint classViewPoint = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private ViewDimension classViewDimension = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private ViewRectangle classViewRectangle = null;


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private static boolean isPackageInitialized = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected static boolean isPackageInitialized() {
		return isPackageInitialized;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected static void markPackageInitialized() {
		isPackageInitialized=true;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public static void init() {
		if (isPackageInitialized()) return;
		CDMPackage p=null;
		markPackageInitialized();

		// Initialize and register this package
		try {
			p=(CDMPackage)RefRegister.getPackage(packageURI);
		} catch (PackageNotRegisteredException e) {
			p = new CDMPackageImpl();
			if(p.getEFactoryInstance()==null)
				p.setEFactoryInstance(new CDMFactoryImpl());
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getDiagramData() {
		if (classDiagramData==null) classDiagramData=createDiagramData();
		return classDiagramData;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagramData_Diagrams() {
		return (EReference)getDiagramData().getEFeature(DIAGRAM_DATA__DIAGRAMS,CDMPackage.DIAGRAM_DATA,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagramData_Annotations() {
		return (EReference)getDiagramData().getEFeature(DIAGRAM_DATA__ANNOTATIONS,CDMPackage.DIAGRAM_DATA,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getDiagram() {
		if (classDiagram==null) classDiagram=createDiagram();
		return classDiagram;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getDiagram_Name() {
		return (EAttribute)getDiagram().getEFeature(DIAGRAM__NAME,CDMPackage.DIAGRAM,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagram_DiagramData() {
		return (EReference)getDiagram().getEFeature(DIAGRAM__DIAGRAM_DATA,CDMPackage.DIAGRAM,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagram_VisualInfos() {
		return (EReference)getDiagram().getEFeature(DIAGRAM__VISUAL_INFOS,CDMPackage.DIAGRAM,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagram_Figures() {
		return (EReference)getDiagram().getEFeature(DIAGRAM__FIGURES,CDMPackage.DIAGRAM,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedValueHolder() {
		if (classKeyedValueHolder==null) classKeyedValueHolder=createKeyedValueHolder();
		return classKeyedValueHolder;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getKeyedValueHolder_KeyedValues() {
		return (EReference)getKeyedValueHolder().getEFeature(KEYED_VALUE_HOLDER__KEYED_VALUES,CDMPackage.KEYED_VALUE_HOLDER,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getVisualInfo() {
		if (classVisualInfo==null) classVisualInfo=createVisualInfo();
		return classVisualInfo;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getVisualInfo_Diagram() {
		return (EReference)getVisualInfo().getEFeature(VISUAL_INFO__DIAGRAM,CDMPackage.VISUAL_INFO,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getAnnotation() {
		if (classAnnotation==null) classAnnotation=createAnnotation();
		return classAnnotation;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getAnnotation_VisualInfos() {
		return (EReference)getAnnotation().getEFeature(ANNOTATION__VISUAL_INFOS,CDMPackage.ANNOTATION,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getAnnotationEMF() {
		if (classAnnotationEMF==null) classAnnotationEMF=createAnnotationEMF();
		return classAnnotationEMF;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getAnnotationEMF_Annotates() {
		return (EReference)getAnnotationEMF().getEFeature(ANNOTATION_EMF__ANNOTATES,CDMPackage.ANNOTATION_EMF,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getAnnotationGeneric() {
		if (classAnnotationGeneric==null) classAnnotationGeneric=createAnnotationGeneric();
		return classAnnotationGeneric;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getAnnotationGeneric_AnnotatesID() {
		return (EAttribute)getAnnotationGeneric().getEFeature(ANNOTATION_GENERIC__ANNOTATES_ID,CDMPackage.ANNOTATION_GENERIC,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedValue() {
		if (classKeyedValue==null) classKeyedValue=createKeyedValue();
		return classKeyedValue;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedValue_Key() {
		return (EAttribute)getKeyedValue().getEFeature(KEYED_VALUE__KEY,CDMPackage.KEYED_VALUE,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getKeyedValue_Holder() {
		return (EReference)getKeyedValue().getEFeature(KEYED_VALUE__HOLDER,CDMPackage.KEYED_VALUE,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedString() {
		if (classKeyedString==null) classKeyedString=createKeyedString();
		return classKeyedString;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedString_Value() {
		return (EAttribute)getKeyedString().getEFeature(KEYED_STRING__VALUE,CDMPackage.KEYED_STRING,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedLocation() {
		if (classKeyedLocation==null) classKeyedLocation=createKeyedLocation();
		return classKeyedLocation;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedLocation_Value() {
		return (EAttribute)getKeyedLocation().getEFeature(KEYED_LOCATION__VALUE,CDMPackage.KEYED_LOCATION,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedPoints() {
		if (classKeyedPoints==null) classKeyedPoints=createKeyedPoints();
		return classKeyedPoints;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedPoints_Points() {
		return (EAttribute)getKeyedPoints().getEFeature(KEYED_POINTS__POINTS,CDMPackage.KEYED_POINTS,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedSize() {
		if (classKeyedSize==null) classKeyedSize=createKeyedSize();
		return classKeyedSize;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedSize_Value() {
		return (EAttribute)getKeyedSize().getEFeature(KEYED_SIZE__VALUE,CDMPackage.KEYED_SIZE,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedConstraint() {
		if (classKeyedConstraint==null) classKeyedConstraint=createKeyedConstraint();
		return classKeyedConstraint;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedConstraint_Value() {
		return (EAttribute)getKeyedConstraint().getEFeature(KEYED_CONSTRAINT__VALUE,CDMPackage.KEYED_CONSTRAINT,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedGeneric() {
		if (classKeyedGeneric==null) classKeyedGeneric=createKeyedGeneric();
		return classKeyedGeneric;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedGeneric_Value() {
		return (EAttribute)getKeyedGeneric().getEFeature(KEYED_GENERIC__VALUE,CDMPackage.KEYED_GENERIC,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getKeyedInteger() {
		if (classKeyedInteger==null) classKeyedInteger=createKeyedInteger();
		return classKeyedInteger;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getKeyedInteger_Value() {
		return (EAttribute)getKeyedInteger().getEFeature(KEYED_INTEGER__VALUE,CDMPackage.KEYED_INTEGER,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass getDiagramFigure() {
		if (classDiagramFigure==null) classDiagramFigure=createDiagramFigure();
		return classDiagramFigure;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EAttribute getDiagramFigure_Type() {
		return (EAttribute)getDiagramFigure().getEFeature(DIAGRAM_FIGURE__TYPE,CDMPackage.DIAGRAM_FIGURE,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EReference getDiagramFigure_ChildFigures() {
		return (EReference)getDiagramFigure().getEFeature(DIAGRAM_FIGURE__CHILD_FIGURES,CDMPackage.DIAGRAM_FIGURE,packageURI);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public  ViewPoint getViewPoint() {
		if (classViewPoint==null) classViewPoint=createViewPoint();
		return classViewPoint;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public  ViewDimension getViewDimension() {
		if (classViewDimension==null) classViewDimension=createViewDimension();
		return classViewDimension;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public  ViewRectangle getViewRectangle() {
		if (classViewRectangle==null) classViewRectangle=createViewRectangle();
		return classViewRectangle;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CDMFactory getCDMFactory() {
		return (CDMFactory)getFactory();
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createDiagramData() {
		if (classDiagramData!=null) return classDiagramData;

		classDiagramData = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagramData).addEFeature(feature,"diagrams",DIAGRAM_DATA__DIAGRAMS);		// 0 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagramData).addEFeature(feature,"annotations",DIAGRAM_DATA__ANNOTATIONS);		// 1 //$NON-NLS-1$

		return classDiagramData;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesDiagramData() {

		EFeature feature;


		return classDiagramData;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassDiagramData() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classDiagramData, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), DiagramData.class, 
				"DiagramData", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classDiagramData;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedDiagramData = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksDiagramData() {
		if(isInitializedDiagramData) return classDiagramData;
		isInitializedDiagramData=true;

		this.getEMetaObjects().add(classDiagramData);

		List refs = classDiagramData.getEReferences();
		refs.add(getDiagramData_Diagrams());
		refs.add(getDiagramData_Annotations());
		return classDiagramData;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramDataDiagrams() {
		EReference sf = getDiagramData_Diagrams();
		initStructuralFeature(sf, (EClassifier)getDiagram(), 
				"diagrams", "DiagramData", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getDiagram_DiagramData(), 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramDataAnnotations() {
		EReference sf = getDiagramData_Annotations();
		initStructuralFeature(sf, (EClassifier)getAnnotation(), 
				"annotations", "DiagramData", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, null, 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createDiagram() {
		if (classDiagram!=null) return classDiagram;

		classDiagram = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classDiagram).addEFeature(feature,"name",DIAGRAM__NAME);		// 0 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagram).addEFeature(feature,"diagramData",DIAGRAM__DIAGRAM_DATA);		// 1 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagram).addEFeature(feature,"visualInfos",DIAGRAM__VISUAL_INFOS);		// 2 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagram).addEFeature(feature,"figures",DIAGRAM__FIGURES);		// 3 //$NON-NLS-1$

		return classDiagram;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesDiagram() {

		EFeature feature;

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classDiagram).addEFeature(feature,"keyedValues",DIAGRAM__KEYED_VALUES);		// 4 //$NON-NLS-1$


		return classDiagram;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassDiagram() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classDiagram, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), Diagram.class, 
				"Diagram", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classDiagram;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedDiagram = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksDiagram() {
		if(isInitializedDiagram) return classDiagram;
		isInitializedDiagram=true;
		initLinksKeyedValueHolder();
		classDiagram.getESuper().add(getEMetaObject(KEYED_VALUE_HOLDER));

		this.getEMetaObjects().add(classDiagram);

		List attribs = classDiagram.getEAttributes();
		attribs.add(getDiagram_Name());
		List refs = classDiagram.getEReferences();
		refs.add(getDiagram_DiagramData());
		refs.add(getDiagram_VisualInfos());
		refs.add(getDiagram_Figures());
		return classDiagram;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureDiagramName() {
		EAttribute sf = getDiagram_Name();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_STRING), 
				"name", "Diagram", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramDiagramData() {
		EReference sf = getDiagram_DiagramData();
		initStructuralFeature(sf, (EClassifier)getDiagramData(), 
				"diagramData", "Diagram", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getDiagramData_Diagrams(), 
				IS_NAVIGABLE, !IS_COMPOSITE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramVisualInfos() {
		EReference sf = getDiagram_VisualInfos();
		initStructuralFeature(sf, (EClassifier)getVisualInfo(), 
				"visualInfos", "Diagram", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getVisualInfo_Diagram(), 
				IS_NAVIGABLE, !IS_COMPOSITE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramFigures() {
		EReference sf = getDiagram_Figures();
		initStructuralFeature(sf, (EClassifier)getDiagramFigure(), 
				"figures", "Diagram", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, null, 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedValueHolder() {
		if (classKeyedValueHolder!=null) return classKeyedValueHolder;

		classKeyedValueHolder = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classKeyedValueHolder).addEFeature(feature,"keyedValues",KEYED_VALUE_HOLDER__KEYED_VALUES);		// 0 //$NON-NLS-1$

		return classKeyedValueHolder;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedValueHolder() {

		EFeature feature;


		return classKeyedValueHolder;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedValueHolder() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedValueHolder, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedValueHolder.class, 
				"KeyedValueHolder", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedValueHolder;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedValueHolder = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedValueHolder() {
		if(isInitializedKeyedValueHolder) return classKeyedValueHolder;
		isInitializedKeyedValueHolder=true;

		this.getEMetaObjects().add(classKeyedValueHolder);

		List refs = classKeyedValueHolder.getEReferences();
		refs.add(getKeyedValueHolder_KeyedValues());
		return classKeyedValueHolder;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureKeyedValueHolderKeyedValues() {
		EReference sf = getKeyedValueHolder_KeyedValues();
		initStructuralFeature(sf, (EClassifier)getKeyedValue(), 
				"keyedValues", "KeyedValueHolder", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getKeyedValue_Holder(), 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createVisualInfo() {
		if (classVisualInfo!=null) return classVisualInfo;

		classVisualInfo = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classVisualInfo).addEFeature(feature,"diagram",VISUAL_INFO__DIAGRAM);		// 0 //$NON-NLS-1$

		return classVisualInfo;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesVisualInfo() {

		EFeature feature;

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classVisualInfo).addEFeature(feature,"keyedValues",VISUAL_INFO__KEYED_VALUES);		// 1 //$NON-NLS-1$


		return classVisualInfo;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassVisualInfo() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classVisualInfo, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), VisualInfo.class, 
				"VisualInfo", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classVisualInfo;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedVisualInfo = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksVisualInfo() {
		if(isInitializedVisualInfo) return classVisualInfo;
		isInitializedVisualInfo=true;
		initLinksKeyedValueHolder();
		classVisualInfo.getESuper().add(getEMetaObject(KEYED_VALUE_HOLDER));

		this.getEMetaObjects().add(classVisualInfo);

		List refs = classVisualInfo.getEReferences();
		refs.add(getVisualInfo_Diagram());
		return classVisualInfo;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureVisualInfoDiagram() {
		EReference sf = getVisualInfo_Diagram();
		initStructuralFeature(sf, (EClassifier)getDiagram(), 
				"diagram", "VisualInfo", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getDiagram_VisualInfos(), 
				IS_NAVIGABLE, !IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createAnnotation() {
		if (classAnnotation!=null) return classAnnotation;

		classAnnotation = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classAnnotation).addEFeature(feature,"visualInfos",ANNOTATION__VISUAL_INFOS);		// 0 //$NON-NLS-1$

		return classAnnotation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesAnnotation() {

		EFeature feature;

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classAnnotation).addEFeature(feature,"keyedValues",ANNOTATION__KEYED_VALUES);		// 1 //$NON-NLS-1$


		return classAnnotation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassAnnotation() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classAnnotation, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), Annotation.class, 
				"Annotation", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classAnnotation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedAnnotation = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksAnnotation() {
		if(isInitializedAnnotation) return classAnnotation;
		isInitializedAnnotation=true;
		initLinksKeyedValueHolder();
		classAnnotation.getESuper().add(getEMetaObject(KEYED_VALUE_HOLDER));

		this.getEMetaObjects().add(classAnnotation);

		List refs = classAnnotation.getEReferences();
		refs.add(getAnnotation_VisualInfos());
		return classAnnotation;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureAnnotationVisualInfos() {
		EReference sf = getAnnotation_VisualInfos();
		initStructuralFeature(sf, (EClassifier)getVisualInfo(), 
				"visualInfos", "Annotation", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, null, 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createAnnotationEMF() {
		if (classAnnotationEMF!=null) return classAnnotationEMF;

		classAnnotationEMF = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classAnnotationEMF).addEFeature(feature,"annotates",ANNOTATION_EMF__ANNOTATES);		// 0 //$NON-NLS-1$

		return classAnnotationEMF;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesAnnotationEMF() {

		EFeature feature;

		feature= getAnnotation_VisualInfos();
		((InternalEClassifier)classAnnotationEMF).addEFeature(feature,"visualInfos",ANNOTATION_EMF__VISUAL_INFOS);		// 1 //$NON-NLS-1$

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classAnnotationEMF).addEFeature(feature,"keyedValues",ANNOTATION_EMF__KEYED_VALUES);		// 2 //$NON-NLS-1$


		return classAnnotationEMF;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassAnnotationEMF() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classAnnotationEMF, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), AnnotationEMF.class, 
				"AnnotationEMF", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classAnnotationEMF;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedAnnotationEMF = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksAnnotationEMF() {
		if(isInitializedAnnotationEMF) return classAnnotationEMF;
		isInitializedAnnotationEMF=true;
		initLinksAnnotation();
		classAnnotationEMF.getESuper().add(getEMetaObject(ANNOTATION));

		this.getEMetaObjects().add(classAnnotationEMF);

		List refs = classAnnotationEMF.getEReferences();
		refs.add(getAnnotationEMF_Annotates());
		return classAnnotationEMF;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureAnnotationEMFAnnotates() {
		EReference sf = getAnnotationEMF_Annotates();
		EcorePackage pkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initStructuralFeature(sf, (EClassifier)pkg.getERefObject(), 
				"annotates", "AnnotationEMF", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, null, 
				IS_NAVIGABLE, !IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createAnnotationGeneric() {
		if (classAnnotationGeneric!=null) return classAnnotationGeneric;

		classAnnotationGeneric = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classAnnotationGeneric).addEFeature(feature,"annotatesID",ANNOTATION_GENERIC__ANNOTATES_ID);		// 0 //$NON-NLS-1$

		return classAnnotationGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesAnnotationGeneric() {

		EFeature feature;

		feature= getAnnotation_VisualInfos();
		((InternalEClassifier)classAnnotationGeneric).addEFeature(feature,"visualInfos",ANNOTATION_GENERIC__VISUAL_INFOS);		// 1 //$NON-NLS-1$

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classAnnotationGeneric).addEFeature(feature,"keyedValues",ANNOTATION_GENERIC__KEYED_VALUES);		// 2 //$NON-NLS-1$


		return classAnnotationGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassAnnotationGeneric() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classAnnotationGeneric, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), AnnotationGeneric.class, 
				"AnnotationGeneric", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classAnnotationGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedAnnotationGeneric = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksAnnotationGeneric() {
		if(isInitializedAnnotationGeneric) return classAnnotationGeneric;
		isInitializedAnnotationGeneric=true;
		initLinksAnnotation();
		classAnnotationGeneric.getESuper().add(getEMetaObject(ANNOTATION));

		this.getEMetaObjects().add(classAnnotationGeneric);

		List attribs = classAnnotationGeneric.getEAttributes();
		attribs.add(getAnnotationGeneric_AnnotatesID());
		return classAnnotationGeneric;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureAnnotationGenericAnnotatesID() {
		EAttribute sf = getAnnotationGeneric_AnnotatesID();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_STRING), 
				"annotatesID", "AnnotationGeneric", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedValue() {
		if (classKeyedValue!=null) return classKeyedValue;

		classKeyedValue = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedValue).addEFeature(feature,"key",KEYED_VALUE__KEY);		// 0 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classKeyedValue).addEFeature(feature,"holder",KEYED_VALUE__HOLDER);		// 1 //$NON-NLS-1$

		return classKeyedValue;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedValue() {

		EFeature feature;


		return classKeyedValue;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedValue() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedValue, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedValue.class, 
				"KeyedValue", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedValue;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedValue = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedValue() {
		if(isInitializedKeyedValue) return classKeyedValue;
		isInitializedKeyedValue=true;

		this.getEMetaObjects().add(classKeyedValue);

		List attribs = classKeyedValue.getEAttributes();
		attribs.add(getKeyedValue_Key());
		List refs = classKeyedValue.getEReferences();
		refs.add(getKeyedValue_Holder());
		return classKeyedValue;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedValueKey() {
		EAttribute sf = getKeyedValue_Key();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_STRING), 
				"key", "KeyedValue", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureKeyedValueHolder() {
		EReference sf = getKeyedValue_Holder();
		initStructuralFeature(sf, (EClassifier)getKeyedValueHolder(), 
				"holder", "KeyedValue", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, getKeyedValueHolder_KeyedValues(), 
				IS_NAVIGABLE, !IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedString() {
		if (classKeyedString!=null) return classKeyedString;

		classKeyedString = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedString).addEFeature(feature,"value",KEYED_STRING__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedString;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedString() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedString).addEFeature(feature,"key",KEYED_STRING__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedString).addEFeature(feature,"holder",KEYED_STRING__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedString;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedString() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedString, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedString.class, 
				"KeyedString", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedString;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedString = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedString() {
		if(isInitializedKeyedString) return classKeyedString;
		isInitializedKeyedString=true;
		initLinksKeyedValue();
		classKeyedString.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedString);

		List attribs = classKeyedString.getEAttributes();
		attribs.add(getKeyedString_Value());
		return classKeyedString;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedStringValue() {
		EAttribute sf = getKeyedString_Value();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_STRING), 
				"value", "KeyedString", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedLocation() {
		if (classKeyedLocation!=null) return classKeyedLocation;

		classKeyedLocation = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedLocation).addEFeature(feature,"value",KEYED_LOCATION__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedLocation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedLocation() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedLocation).addEFeature(feature,"key",KEYED_LOCATION__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedLocation).addEFeature(feature,"holder",KEYED_LOCATION__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedLocation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedLocation() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedLocation, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedLocation.class, 
				"KeyedLocation", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedLocation;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedLocation = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedLocation() {
		if(isInitializedKeyedLocation) return classKeyedLocation;
		isInitializedKeyedLocation=true;
		initLinksKeyedValue();
		classKeyedLocation.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedLocation);

		List attribs = classKeyedLocation.getEAttributes();
		attribs.add(getKeyedLocation_Value());
		return classKeyedLocation;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedLocationValue() {
		EAttribute sf = getKeyedLocation_Value();
		initStructuralFeature(sf, (EClassifier)getViewPoint(), 
				"value", "KeyedLocation", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedPoints() {
		if (classKeyedPoints!=null) return classKeyedPoints;

		classKeyedPoints = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedPoints).addEFeature(feature,"points",KEYED_POINTS__POINTS);		// 0 //$NON-NLS-1$

		return classKeyedPoints;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedPoints() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedPoints).addEFeature(feature,"key",KEYED_POINTS__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedPoints).addEFeature(feature,"holder",KEYED_POINTS__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedPoints;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedPoints() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedPoints, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedPoints.class, 
				"KeyedPoints", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedPoints;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedPoints = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedPoints() {
		if(isInitializedKeyedPoints) return classKeyedPoints;
		isInitializedKeyedPoints=true;
		initLinksKeyedValue();
		classKeyedPoints.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedPoints);

		List attribs = classKeyedPoints.getEAttributes();
		attribs.add(getKeyedPoints_Points());
		return classKeyedPoints;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedPointsPoints() {
		EAttribute sf = getKeyedPoints_Points();
		initStructuralFeature(sf, (EClassifier)getViewPoint(), 
				"points", "KeyedPoints", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedSize() {
		if (classKeyedSize!=null) return classKeyedSize;

		classKeyedSize = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedSize).addEFeature(feature,"value",KEYED_SIZE__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedSize;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedSize() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedSize).addEFeature(feature,"key",KEYED_SIZE__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedSize).addEFeature(feature,"holder",KEYED_SIZE__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedSize;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedSize() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedSize, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedSize.class, 
				"KeyedSize", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedSize;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedSize = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedSize() {
		if(isInitializedKeyedSize) return classKeyedSize;
		isInitializedKeyedSize=true;
		initLinksKeyedValue();
		classKeyedSize.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedSize);

		List attribs = classKeyedSize.getEAttributes();
		attribs.add(getKeyedSize_Value());
		return classKeyedSize;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedSizeValue() {
		EAttribute sf = getKeyedSize_Value();
		initStructuralFeature(sf, (EClassifier)getViewDimension(), 
				"value", "KeyedSize", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedConstraint() {
		if (classKeyedConstraint!=null) return classKeyedConstraint;

		classKeyedConstraint = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedConstraint).addEFeature(feature,"value",KEYED_CONSTRAINT__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedConstraint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedConstraint() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedConstraint).addEFeature(feature,"key",KEYED_CONSTRAINT__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedConstraint).addEFeature(feature,"holder",KEYED_CONSTRAINT__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedConstraint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedConstraint() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedConstraint, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedConstraint.class, 
				"KeyedConstraint", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedConstraint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedConstraint = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedConstraint() {
		if(isInitializedKeyedConstraint) return classKeyedConstraint;
		isInitializedKeyedConstraint=true;
		initLinksKeyedValue();
		classKeyedConstraint.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedConstraint);

		List attribs = classKeyedConstraint.getEAttributes();
		attribs.add(getKeyedConstraint_Value());
		return classKeyedConstraint;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedConstraintValue() {
		EAttribute sf = getKeyedConstraint_Value();
		initStructuralFeature(sf, (EClassifier)getViewRectangle(), 
				"value", "KeyedConstraint", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedGeneric() {
		if (classKeyedGeneric!=null) return classKeyedGeneric;

		classKeyedGeneric = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedGeneric).addEFeature(feature,"value",KEYED_GENERIC__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedGeneric() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedGeneric).addEFeature(feature,"key",KEYED_GENERIC__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedGeneric).addEFeature(feature,"holder",KEYED_GENERIC__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedGeneric() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedGeneric, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedGeneric.class, 
				"KeyedGeneric", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedGeneric;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedGeneric = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedGeneric() {
		if(isInitializedKeyedGeneric) return classKeyedGeneric;
		isInitializedKeyedGeneric=true;
		initLinksKeyedValue();
		classKeyedGeneric.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedGeneric);

		List attribs = classKeyedGeneric.getEAttributes();
		attribs.add(getKeyedGeneric_Value());
		return classKeyedGeneric;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedGenericValue() {
		EAttribute sf = getKeyedGeneric_Value();
		EcorePackage pkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initStructuralFeature(sf, (EClassifier)pkg.getERefObject(), 
				"value", "KeyedGeneric", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createKeyedInteger() {
		if (classKeyedInteger!=null) return classKeyedInteger;

		classKeyedInteger = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classKeyedInteger).addEFeature(feature,"value",KEYED_INTEGER__VALUE);		// 0 //$NON-NLS-1$

		return classKeyedInteger;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesKeyedInteger() {

		EFeature feature;

		feature= getKeyedValue_Key();
		((InternalEClassifier)classKeyedInteger).addEFeature(feature,"key",KEYED_INTEGER__KEY);		// 1 //$NON-NLS-1$
		feature= getKeyedValue_Holder();
		((InternalEClassifier)classKeyedInteger).addEFeature(feature,"holder",KEYED_INTEGER__HOLDER);		// 2 //$NON-NLS-1$


		return classKeyedInteger;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassKeyedInteger() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classKeyedInteger, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), KeyedInteger.class, 
				"KeyedInteger", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classKeyedInteger;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedKeyedInteger = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksKeyedInteger() {
		if(isInitializedKeyedInteger) return classKeyedInteger;
		isInitializedKeyedInteger=true;
		initLinksKeyedValue();
		classKeyedInteger.getESuper().add(getEMetaObject(KEYED_VALUE));

		this.getEMetaObjects().add(classKeyedInteger);

		List attribs = classKeyedInteger.getEAttributes();
		attribs.add(getKeyedInteger_Value());
		return classKeyedInteger;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureKeyedIntegerValue() {
		EAttribute sf = getKeyedInteger_Value();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_INT), 
				"value", "KeyedInteger", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass createDiagramFigure() {
		if (classDiagramFigure!=null) return classDiagramFigure;

		classDiagramFigure = (EClass) ePackage.eCreateInstance(ePackage.E_CLASS);
		EFeature feature;
		feature = (EAttribute) ePackage.eCreateInstance(ePackage.E_ATTRIBUTE);
		((InternalEClassifier)classDiagramFigure).addEFeature(feature,"type",DIAGRAM_FIGURE__TYPE);		// 0 //$NON-NLS-1$
		feature = (EReference) ePackage.eCreateInstance(ePackage.E_REFERENCE);
		((InternalEClassifier)classDiagramFigure).addEFeature(feature,"childFigures",DIAGRAM_FIGURE__CHILD_FIGURES);		// 1 //$NON-NLS-1$

		return classDiagramFigure;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass addInheritedFeaturesDiagramFigure() {

		EFeature feature;

		feature= getKeyedValueHolder_KeyedValues();
		((InternalEClassifier)classDiagramFigure).addEFeature(feature,"keyedValues",DIAGRAM_FIGURE__KEYED_VALUES);		// 2 //$NON-NLS-1$


		return classDiagramFigure;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initClassDiagramFigure() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classDiagramFigure, (EClass)metaPkg.getEMetaObject(EcorePackage.E_CLASS), DiagramFigure.class, 
				"DiagramFigure", "com.ibm.etools.cdm"); //$NON-NLS-2$//$NON-NLS-1$
		return classDiagramFigure;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private boolean isInitializedDiagramFigure = false;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected EClass initLinksDiagramFigure() {
		if(isInitializedDiagramFigure) return classDiagramFigure;
		isInitializedDiagramFigure=true;
		initLinksKeyedValueHolder();
		classDiagramFigure.getESuper().add(getEMetaObject(KEYED_VALUE_HOLDER));

		this.getEMetaObjects().add(classDiagramFigure);

		List attribs = classDiagramFigure.getEAttributes();
		attribs.add(getDiagramFigure_Type());
		List refs = classDiagramFigure.getEReferences();
		refs.add(getDiagramFigure_ChildFigures());
		return classDiagramFigure;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EAttribute initFeatureDiagramFigureType() {
		EAttribute sf = getDiagramFigure_Type();
		initStructuralFeature(sf, (EClassifier)ePackage.getEMetaObject(ePackage.E_STRING), 
				"type", "DiagramFigure", "com.ibm.etools.cdm",  //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				!IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		return sf;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	private EReference initFeatureDiagramFigureChildFigures() {
		EReference sf = getDiagramFigure_ChildFigures();
		initStructuralFeature(sf, (EClassifier)getDiagramFigure(), 
				"childFigures", "DiagramFigure", "com.ibm.etools.cdm", //$NON-NLS-2$//$NON-NLS-1$ //$NON-NLS-3$
				IS_MANY, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE);
		initReference(sf, null, 
				IS_NAVIGABLE, IS_COMPOSITE);
		return sf;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewPoint createViewPoint() {
		if (classViewPoint!=null) return classViewPoint;

		classViewPoint=new ViewPointImpl();
		return classViewPoint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewPoint initClassViewPoint() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classViewPoint, (EClass)metaPkg.getEMetaObject(EcorePackage.E_DATA_TYPE), Point.class, 
				"ViewPoint", "com.ibm.etools.cdm");  //$NON-NLS-2$//$NON-NLS-1$

		return classViewPoint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewPoint initLinksViewPoint() {

		this.getEMetaObjects().add(classViewPoint);

		return classViewPoint;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewDimension createViewDimension() {
		if (classViewDimension!=null) return classViewDimension;

		classViewDimension=new ViewDimensionImpl();
		return classViewDimension;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewDimension initClassViewDimension() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classViewDimension, (EClass)metaPkg.getEMetaObject(EcorePackage.E_DATA_TYPE), Dimension.class, 
				"ViewDimension", "com.ibm.etools.cdm");  //$NON-NLS-2$//$NON-NLS-1$

		return classViewDimension;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewDimension initLinksViewDimension() {

		this.getEMetaObjects().add(classViewDimension);

		return classViewDimension;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewRectangle createViewRectangle() {
		if (classViewRectangle!=null) return classViewRectangle;

		classViewRectangle=new ViewRectangleImpl();
		return classViewRectangle;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewRectangle initClassViewRectangle() {
		EcorePackage metaPkg = (EcorePackage)RefRegister.getPackage(EcorePackage.packageURI);
		initClass(classViewRectangle, (EClass)metaPkg.getEMetaObject(EcorePackage.E_DATA_TYPE), Rectangle.class, 
				"ViewRectangle", "com.ibm.etools.cdm");  //$NON-NLS-2$//$NON-NLS-1$

		return classViewRectangle;
	}

	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected ViewRectangle initLinksViewRectangle() {

		this.getEMetaObjects().add(classViewRectangle);

		return classViewRectangle;
	}


	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject eCreateInstance(int id) {
		switch (id) {
		case CDMPackage.DIAGRAM_DATA:
			return getCDMFactory().createDiagramData();
		case CDMPackage.DIAGRAM:
			return getCDMFactory().createDiagram();
		case CDMPackage.KEYED_VALUE_HOLDER:
			return (new KeyedValueHolderImpl()).initInstance();
		case CDMPackage.VISUAL_INFO:
			return getCDMFactory().createVisualInfo();
		case CDMPackage.ANNOTATION:
			return (new AnnotationImpl()).initInstance();
		case CDMPackage.ANNOTATION_EMF:
			return getCDMFactory().createAnnotationEMF();
		case CDMPackage.ANNOTATION_GENERIC:
			return getCDMFactory().createAnnotationGeneric();
		case CDMPackage.KEYED_VALUE:
			return (new KeyedValueImpl()).initInstance();
		case CDMPackage.KEYED_STRING:
			return getCDMFactory().createKeyedString();
		case CDMPackage.KEYED_LOCATION:
			return getCDMFactory().createKeyedLocation();
		case CDMPackage.KEYED_POINTS:
			return getCDMFactory().createKeyedPoints();
		case CDMPackage.KEYED_SIZE:
			return getCDMFactory().createKeyedSize();
		case CDMPackage.KEYED_CONSTRAINT:
			return getCDMFactory().createKeyedConstraint();
		case CDMPackage.KEYED_GENERIC:
			return getCDMFactory().createKeyedGeneric();
		case CDMPackage.KEYED_INTEGER:
			return getCDMFactory().createKeyedInteger();
		case CDMPackage.DIAGRAM_FIGURE:
			return getCDMFactory().createDiagramFigure();
		}
		return null;
	}
} //CDMPackageImpl


