package com.ibm.etools.cdm.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cdm.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.Internals;
import com.ibm.etools.emf.ref.impl.RefObjectImpl;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * A keyed value. This abstract class is used in key//value pairs to allow dynamic extensions.
 * 
 * It is important that the key used be unique because other extensions may add their own keys in.
 */
public class KeyedValueImpl extends RefObjectImpl implements KeyedValue, RefObject{


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected String key = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setKey = false;
	protected KeyedValueImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassKeyedValue());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CDMPackage ePackageCDM() {
		CDMPackage pkg = null;
		if (eClassKeyedValue() != null)
			pkg =  (CDMPackage)eClassKeyedValue().refContainer();
		if (pkg == null)
			return (CDMPackage)RefRegister.getPackage(CDMPackage.packageURI);
		return pkg;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassKeyedValue() {
		return ((CDMPackage)RefRegister.getPackage(CDMPackage.packageURI)).getKeyedValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public String getKey() {
		if (this.setKey) return this.key;
		else return (String)ePackageCDM().getKeyedValue_Key().refGetDefaultValue();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setKey(String value) {
		refSetValueForSimpleSF(ePackageCDM().getKeyedValue_Key(),this.key,value);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetKey() {
		notify(refBasicUnsetValue(ePackageCDM().getKeyedValue_Key()));
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetKey() {
		return setKey;
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public KeyedValueHolder getHolder() {
		try {
			RefBaseObject currentContainer = refDelegateOwner().refContainer();
			if (currentContainer==null) return null;
			RefObject currentContainerSF = refDelegateOwner().refContainerSF();
			RefObject containerSF = ePackageCDM().getKeyedValueHolder_KeyedValues();
			if (currentContainerSF != containerSF) return null;
			currentContainer = ((InternalProxy)currentContainer).resolve(this);
			((Internals)refDelegateOwner()).refBasicSetContainer(currentContainer);
			return (KeyedValueHolder) currentContainer;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setHolder(KeyedValueHolder newContainer) {
		refSetValueForContainMVReference(ePackageCDM().getKeyedValue_Holder(),newContainer);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetHolder() {
		refUnsetValueForContainReference(ePackageCDM().getKeyedValue_Holder());
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetHolder() {
		RefObject containerSF = ePackageCDM().getKeyedValueHolder_KeyedValues();
		return (refDelegateOwner().refContainer() != null && refDelegateOwner().refContainerSF()==containerSF);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: return getKey();
			case CDMPackage.KEYED_VALUE__HOLDER: return getHolder();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY:
				return this.setKey? this.key : null;
			case CDMPackage.KEYED_VALUE__HOLDER:
				RefBaseObject holderCurrCnr = refDelegateOwner().refContainer();
				if (holderCurrCnr==null) return null;
				RefObject holderCurrCnrSF = refDelegateOwner().refContainerSF();
				RefObject holderCnrSF = ePackageCDM().getKeyedValueHolder_KeyedValues();
				if (holderCurrCnrSF != holderCnrSF) return null;
				holderCurrCnr = ((InternalProxy)holderCurrCnr).resolveDelete();
				((Internals)refDelegateOwner()).refBasicSetContainer(holderCurrCnr);
				return (KeyedValueHolder) holderCurrCnr;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: return isSetKey();
			case CDMPackage.KEYED_VALUE__HOLDER: return isSetHolder();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: {
				setKey((String)newValue);
				return;
			}
			case CDMPackage.KEYED_VALUE__HOLDER: {
				setHolder((KeyedValueHolder)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: {
				Object oldValue = this.key;
				this.key = (String)newValue;
				this.setKey = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageCDM().getKeyedValue_Key(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: {
				unsetKey();
				return;
			}
			case CDMPackage.KEYED_VALUE__HOLDER: {
				unsetHolder();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassKeyedValue().getEFeatureId(eFeature)) {
			case CDMPackage.KEYED_VALUE__KEY: {
				Object oldValue = this.key;
				this.key = null;
				this.setKey = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageCDM().getKeyedValue_Key(),oldValue,getKey());
			}


		}
		return super.refBasicUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public String toString() {
		String out="(";  //$NON-NLS-1$
		boolean first=true;
		boolean emptyList=true;
		if(isSetKey()) {
			if(!emptyList) out+=", "; //$NON-NLS-1$
			out+="key: "+this.key; //$NON-NLS-1$
			first=false;
			emptyList=false;
		}
		out+=")"; //$NON-NLS-1$
		if (!first) return super.toString() + " " +out; //$NON-NLS-1$
		return super.toString();
	}
}
