package com.ibm.etools.cdm.impl;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.cdm.*;
import com.ibm.etools.emf.ref.RefBaseObject;
import com.ibm.etools.emf.ref.impl.RefBaseObjectImpl;
import java.util.List;




import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefRegister;
import com.ibm.etools.emf.ref.InternalProxy;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.emf.notify.impl.NotificationImpl;
import java.lang.Object;
import java.lang.ClassCastException;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Notification;
/**
 * The visual info for a component. The id is used to allow the info to be for a specific viewer, in case the component may be visible in more than one viewer, e.g. the graphViewer and a specialized viewer.
 */
public class VisualInfoImpl extends KeyedValueHolderImpl implements VisualInfo, KeyedValueHolder{


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected Diagram diagram = null;
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	protected boolean setDiagram = false;
	protected VisualInfoImpl() {
		super();
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public RefObject initInstance() {
		refSetMetaObject(eClassVisualInfo());
		initInstanceDelegates();
		return this;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public CDMPackage ePackageCDM() {
		CDMPackage pkg = null;
		if (eClassVisualInfo() != null)
			pkg =  (CDMPackage)eClassVisualInfo().refContainer();
		if (pkg == null)
			return (CDMPackage)RefRegister.getPackage(CDMPackage.packageURI);
		return pkg;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public EClass eClassVisualInfo() {
		return ((CDMPackage)RefRegister.getPackage(CDMPackage.packageURI)).getVisualInfo();
	}
	/**
	 * @generated This field/method will be replaced during code generation 
	 */
	public Diagram getDiagram() {
		try {
			if (this.diagram == null) return null;
			this.diagram = (Diagram) ((InternalProxy)this.diagram).resolve(this, ePackageCDM().getVisualInfo_Diagram());
			if (this.diagram==null) this.setDiagram = false;
			return this.diagram;
		} catch (Exception e) {
			return null;
		}
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void setDiagram(Diagram l) {
		refSetValueForMVReference(ePackageCDM().getVisualInfo_Diagram(),this.diagram,l);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void unsetDiagram() {
		refUnsetValueForMVReference(ePackageCDM().getVisualInfo_Diagram(),this.diagram);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean isSetDiagram() {
		return setDiagram;
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refValue(feature);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: return getDiagram();


		}
		return super.refValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Object refBasicValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicValue(feature);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM:
				if (!this.setDiagram||this.diagram==null) return null;
				if (((InternalProxy)this.diagram).refIsDeleted()) {this.diagram=null; this.setDiagram=false;}
				return this.diagram;


		}
		return super.refBasicValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public boolean refIsSet(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refIsSet(feature);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: return isSetDiagram();


		}
		return super.refIsSet(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refSetValue(feature, newValue);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: {
				setDiagram((Diagram)newValue);
				return;
			}


		}
		super.refSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicSetValue(RefStructuralFeature feature, Object newValue) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicSetValue(feature, newValue);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: {
				Object oldValue = this.diagram;
				this.diagram = (Diagram)newValue;
				this.setDiagram = true;
				return new NotificationImpl(refDelegateOwner(),Notifier.SET,ePackageCDM().getVisualInfo_Diagram(),oldValue,newValue);
			}


		}
		return super.refBasicSetValue(feature, newValue);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public void refUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			super.refUnsetValue(feature);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: {
				unsetDiagram();
				return;
			}


		}
		super.refUnsetValue(feature);
	}
	/**
	 * @generated This field/method will be replaced during code generation.
	 */
	public Notification refBasicUnsetValue(RefStructuralFeature feature) {
		EStructuralFeature eFeature=null;
		try {
			eFeature=(EStructuralFeature)feature;
		} catch (ClassCastException e) {
			return super.refBasicUnsetValue(feature);
		}
		switch (eClassVisualInfo().getEFeatureId(eFeature)) {
			case CDMPackage.VISUAL_INFO__DIAGRAM: {
				Object oldValue = this.diagram;
				this.diagram = null;
				this.setDiagram = false;
				return new NotificationImpl(refDelegateOwner(),Notifier.UNSET,ePackageCDM().getVisualInfo_Diagram(),oldValue,null);
			}


		}
		return super.refBasicUnsetValue(feature);
	}
}
