package com.ibm.etools.cdm.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



/**
 * ViewDimension for the OCM Model.
 */
public class Dimension {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public int width, height;
	
	public Dimension() {
	}
	
	public Dimension(int width, int height) {
		this.width = width;
		this.height = height;
	}
	
	public String toString() {
		StringBuffer s = new StringBuffer(20);
		s.append(width);
		s.append(',');
		s.append(height);
		return s.toString();
	}
	
	/**
	 * Returns whether this Dimension is equal to the Object
	 * input. Checks for class type, and the values in 
	 * the input.
	 *
	 * @param o  Object being tested for equality.
	 * @return  Result of the equality test.
	 */
	public boolean equals(Object o){
		if (o instanceof Dimension){
			Dimension p = (Dimension)o;
			return p.width == width && p.height == height;
		}
		return false;
	}
	
	public int hashcode() {
		return width ^ height;
	}		
}