package com.ibm.etools.cdm.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



/**
 * ViewRectangle for the OCM Model.
 */
public class Rectangle {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public int x, y, width, height;
	
	public Rectangle() {
	}
	
	public Rectangle(int x, int y, int width, int height) {
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	public Rectangle(Rectangle rect) {
		this(rect.x, rect.y, rect.width, rect.height);
	}
	
	public String toString() {
		StringBuffer s = new StringBuffer(20);
		s.append(x);
		s.append(',');
		s.append(y);
		s.append(',');
		s.append(width);
		s.append(',');
		s.append(height);
		return s.toString();
	}
	
	/**
	 * Returns whether this Rectangle is equal to the Object
	 * input. Checks for class type, and the values in 
	 * the input.
	 *
	 * @param o  Object being tested for equality.
	 * @return  Result of the equality test.
	 */
	public boolean equals(Object o){
		if (o instanceof Rectangle){
			Rectangle p = (Rectangle)o;
			return p.x == x && p.y == y && p.width == width && p.height == height;
		}
		return false;
	}
	
	public int hashcode() {
		return x ^ y ^ width ^ height;
	}	
	
	public Point getLocation() {
		return new Point(x,y);
	}
	
	public Dimension getSize() {
		return new Dimension(width,height);
	}
}