package com.ibm.etools.java.instantiation.base;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.notify.impl.AbstractAdapterFactoryImpl;
import com.ibm.etools.java.instantiation.IInstantiationAdapter;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.Adapter;
import com.ibm.etools.java.JavaClass;
import com.ibm.etools.java.JavaDataType;

/**
 * The default factory to instantiate a Java Model object.
 */
public class DefaultJavaInstantiationAdapterFactory extends AbstractAdapterFactoryImpl {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	static final JavaObjectAdapter sObjectAdapter = new JavaObjectAdapter();
	static final JavaDataTypeAdapter sDataTypeAdapter = new JavaDataTypeAdapter();	
	
	public DefaultJavaInstantiationAdapterFactory(boolean shouldRegister) {
		super(shouldRegister);
	}
	
	public void adaptAllNew(Notifier notifier) {
		adaptNew(notifier, IInstantiationAdapter.ADAPTER_KEY);	// We only handle one type.
	}
	
	public boolean isFactoryForType(Object type) {
		return IInstantiationAdapter.ADAPTER_KEY.equals(type);
	}
	
	public Adapter createAdapter(Notifier notifier, Object type) {
		if (notifier instanceof JavaClass)
			return sObjectAdapter;
		if (notifier instanceof JavaDataType)
			return sDataTypeAdapter;
		return null;
	}

}
