package com.ibm.etools.java.instantiation.base;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.java.JavaHelpers;
import com.ibm.etools.emf.notify.Notifier;
/**
 * A common interface for Java instances. It will be
 * shared by Java Objects and Java DataType instances.
 */
public interface IJavaInstance extends Notifier {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Return the type of this instance.
	 */
	public JavaHelpers getJavaType();
	
	/**
	 * Return the initialization string.
	 */
	public String getInitializationString();
	
	/**
	 * Return whether the initialization string
	 * is set or not.
	 */
	public boolean isSetInitializationString();
	/**
	 * Answer true if we are an instance of one of Java's primitive data types.
	 * e.g. boolean, char - true otherwise, e.g. java.lang.Boolean
	 */
	public boolean isPrimitive();
	
}
