package com.ibm.etools.java.instantiation.base;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefObject;
/**
 * Interface for java object instances.
 */
public interface IJavaObjectInstance extends IJavaInstance , RefObject {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Is this an implicit bean, i.e. It is queried from the object
	 * and then any settings are placed upon that object, a new
	 * instance is not created when an implicit bean is accessed.
	 */
	public boolean isImplicit();
	
	public boolean isSetImplicit();
	
	public void setImplicit(boolean implicit);
	
	/**
	 * Objects can have their inititialization strings changed.
	 */
	public void setInitializationString(String initString);

	/**
	 * Objects can change the name of the class used to instantiate it.
	 */
	public void setInstantiateUsing(String classname);
	
	/**
	 * Objects can change the serialized string used to represent them.
	 */
	 public void setSerializeData(String serializeData);

	/**
	 * Return the class name used to instantiate this class.
	 */
	public String getInstantiateUsing();
	
	/** 
	 * Returns the serialized Data used to instantiate this class.
	 */
	public String getSerializeData();
	/**
	 * Return whether the instantiate using classname
	 * is set or not.
	 */
	public boolean isSetInstantiateUsing();
	
	/**
	 * Returns whether the serialized Data is set or not.
	 */
	 public boolean isSetSerializeData();

}
