package com.ibm.etools.java.instantiation.base;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ecore.EClassifier;
import com.ibm.etools.emf.notify.Notification;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.notify.impl.AdapterImpl;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.java.JavaClass;
import com.ibm.etools.java.JavaDataType;
import com.ibm.etools.java.instantiation.IInstantiationAdapter;

/**
 * Adapter for instantiating java datatypes (i.e. primitives). It doesn't save any state so there
 * is no need to have more than one. It's an internal adapter that other users won't
 * need to have access to.
 */
public class JavaDataTypeAdapter extends AdapterImpl implements IInstantiationAdapter {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public void notifyChanged(Notification msg){
	}
	
	public Notifier getTarget() {
		return null;
	}
	
	public boolean isAdapterForType(Object type) {
		return IInstantiationAdapter.ADAPTER_KEY.equals(type);
	}
	
	public void setTarget(Notifier p1) {
	}
	
	public boolean adapterCreatesInstance() {
		return false;	// Shouldn't be called.
	}
	
	public RefObject eCreateInstance(JavaClass p1){
		return null;	// Shouldn't be called.
	}
	
	public boolean adapterCreatesDataType(){
		return true;
	}
	
	public Object createFromString(String string, JavaDataType type){
		return new JavaDataTypeInstance(string, type);
	}
	
	public boolean adapterConvertsToString(){
		return false;
	}
	
	public String convertToString(Object p1, JavaDataType p2){
		return null;	// Shouldn't be called.
	}
	
	public boolean isInstance(Object o, EClassifier type) {
		return o instanceof IJavaDataTypeInstance && ((IJavaDataTypeInstance) o).getJavaType() == type;
	}


}
