package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.common.command.*;
import com.ibm.etools.java.instantiation.base.*;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.proxy.*;

public class ApplyCustomizedValueCommand extends AbstractCommand {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected IJavaObjectInstance fBean;
	protected IJavaInstance newSetting;
	protected IBeanProxy oldBeanProxy;
	protected RefStructuralFeature fFeature;
	protected IJavaInstance oldSetting;
	protected boolean oldIsSet;


public void setTarget(IJavaObjectInstance aBean){fBean = aBean;}
public void setFeature(RefStructuralFeature aFeature){fFeature = aFeature;}
public void setOldBeanProxy(IBeanProxy aBeanProxy){oldBeanProxy = aBeanProxy;}
public void setValue(IJavaInstance aValue){newSetting = aValue;}


public void execute(){
	oldIsSet = fBean.refIsSet(fFeature);
	if (oldIsSet)
		oldSetting = (IJavaInstance)fBean.refValue(fFeature);
	else {
		// It wasn't previously set, but we've already changed the value before this command was executed, so the origSettings table is wrong
		// So we will now force in our old setting that was passed in.
		IBeanProxyHost beanProxyHost = BeanProxyUtilities.getBeanProxyHost(fBean);
		beanProxyHost.getOriginalSettingsTable().put(fFeature, oldBeanProxy);
	}
	fBean.refSetValue(fFeature,newSetting);
	
}
/**
 * On undo if there was a previous value apply it
 * if not we must revert the bean to its previous value that is the oldBeanProxy
 */
public void undo(){
	
	if (oldIsSet) {
		fBean.refSetValue(fFeature,oldSetting);
	} else {
		fBean.refUnsetValue(fFeature);
	}	
}
public void redo(){
	fBean.refSetValue(fFeature,newSetting);
}
public boolean canExecute(){
	return true;
}
}