package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.SWT;
import org.eclipse.jface.window.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.jface.viewers.*;

import com.ibm.etools.jbcf.common.*;
import com.ibm.etools.proxy.*;
import java.util.*;
/**
 * Dialog Editor for working with Bean Custom Dialogs.
 * This will invoke a property editor on a remote VM
 * and maintain a pseudo-modal conversation with it
 */
public class BeanDialogCellEditor extends DialogCellEditor implements BeanFeatureEditor.IWrappedCellEditor {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static ResourceBundle resvce = JBCFNls.RESBUNDLE; 
	protected PropertyEditorBeanProxyWrapper fEditorProxy;
	protected String fPropertyName;
	private Label fLabel;
	private Button fButton;

/**
 * BeanDialogCellEditor constructor comment.
 */
protected BeanDialogCellEditor(Composite aComposite , PropertyEditorBeanProxyWrapper anEditorProxy, String propertyName) {
	super(aComposite);
	fEditorProxy = anEditorProxy;
	fPropertyName = propertyName;
}


/**
 * openDialogBox method comment.
 */
protected Object openDialogBox(Control cellEditorWindow) {
	
	// Because the custom editor will be in another VM, we need to disable the
	// shell containing the cell editor so that we simulate showModel so that
	// no changes can be made while this is up.
	// The editor proxy has all the magic to do this for us
	// so that the current thread is suspended while the AWT window is open
	int returnCode = fEditorProxy.launchCustomEditor(cellEditorWindow.getShell());
	// The return code says whether or not OK was pressed on the property editor
	if ( returnCode == Common.DLG_OK || returnCode == Common.DLG_APPLY ) {
		return fEditorProxy.getValue();	
	} else {
		return null;
	}
}

/**
 * @see IWrappedCellEditor#newValue(String)
 */
public void newValue(String text) {
	setValue(text);
}

}
