package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.widgets.Composite;

public class BeanFeatureComboBoxCellEditor extends ComboBoxCellEditor implements BeanFeatureEditor.IWrappedCellEditor {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected String[] items;
	/**
	 * Constructor for BeanFeatureComboBoxCellEditor.
	 * @param parent
	 * @param items
	 */
	public BeanFeatureComboBoxCellEditor(Composite parent, String[] items) {
		super(parent, items);
		this.items = items;
	}

	/**
	 * @see IWrappedCellEditor#newValue(String)
	 */
	public void newValue(String text) {
		// Find where the text value occurs in the list of valid tags and use this as the value
		// This is because CellEditor's value is the Integer index of the value in the list
		for (int i = 0; i < items.length; i++) {
			if (items[i].equals(text)) {
				setValue(new Integer(i));
			}
		}
		
	}

}
