package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.graphics.Image;

import com.ibm.etools.draw2d.Figure;
import com.ibm.etools.draw2d.Graphics;
import com.ibm.etools.draw2d.geometry.Dimension;

public class ErrorFigure extends Figure {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	int fSev;
	Image fImage;
	
	public ErrorFigure(int severity){
		sevSeverity(severity);
		// Make our bounds be the size of the icon we will display
	}
	
	protected void paintFigure(Graphics graphics){
		
		super.paintFigure(graphics);
		if ( fImage != null){
			// Clear some background so the image can be seen			
			graphics.drawImage(fImage,getLocation().x,getLocation().y);
		}
	}
	
	public void sevSeverity(int severity){
		fSev = severity;
		switch(fSev){
			case IBeanProxyHost.ERROR_SEVERE:
				fImage = IBeanProxyHost.ErrorType.getSevereErrorImage();
				setSize(new Dimension(fImage.getBounds().width,fImage.getBounds().height));
			break;
			case IBeanProxyHost.ERROR_WARNING:
				fImage = IBeanProxyHost.ErrorType.getWarningErrorImage();
				setSize(new Dimension(fImage.getBounds().width,fImage.getBounds().height));
				break;
			default:
				setSize(0,0);
		}				
	}
}
