package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.draw2d.geometry.Insets;
/**
 * Constraint class that emulates the java.awt.GridBagConstraints classs
 * Any interface changes to Sun's GridBagConstraints class need to be made here as well.
 */
public class GridBagConstraint {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final int 
		// fill values
		NONE = 0,
		BOTH = 1,
		HORIZONTAL = 2,
		VERTICAL = 3,
		// anchor values
		CENTER = 10,
		NORTH = 11,
		NORTHEAST = 12,
		EAST = 13,
		SOUTHEAST = 14,
		SOUTH = 15,
		SOUTHWEST = 16,
		WEST = 17,
		NORTHWEST = 18;
		
	public int gridx, gridy, gridwidth, gridheight, anchor, fill, ipadx, ipady;
	public double weightx, weighty;
	public Insets insets;

public GridBagConstraint() {
    gridx = -1;
    gridy = -1;
    gridwidth = 1;
    gridheight = 1;

    weightx = 0;
    weighty = 0;
    anchor = CENTER;
    fill = NONE;

    insets = new Insets(0, 0, 0, 0);
    ipadx = 0;
    ipady = 0;
}
}