package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.viewers.LabelProvider;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
import com.ibm.etools.propertysheet.INeedData;
import com.ibm.etools.proxy.*;
/**
 * Label provider for the GridBagConstraints.anchor  field
 */
public class GridBagConstraintsAnchorLabelProvider extends LabelProvider implements INeedData {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static String[] ANCHOR_VALUES = new String[] {
		JBCFMessages.getString("CENTER"), JBCFMessages.getString("NORTH"), JBCFMessages.getString("NORTHEAST"), JBCFMessages.getString("EAST"),JBCFMessages.getString("SOUTHEAST"), //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		JBCFMessages.getString("SOUTH"),JBCFMessages.getString("SOUTHWEST"),JBCFMessages.getString("WEST"),JBCFMessages.getString("NORTHWEST") //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	};
	
	protected EditDomain editDomain;

public String getText(Object element){
	IIntegerBeanProxy anchorValueProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanProxy((IJavaInstance)element, JBCFEditDomainHelper.getResourceSet(editDomain));
	int anchorValue = anchorValueProxy.intValue();
	switch (anchorValue) {
		case GridBagConstraint.CENTER: 
			return JBCFMessages.getString("CENTER"); //$NON-NLS-1$
		case GridBagConstraint.NORTH: 
			return JBCFMessages.getString("NORTH"); //$NON-NLS-1$
		case GridBagConstraint.NORTHEAST: 
			return JBCFMessages.getString("NORTHEAST"); //$NON-NLS-1$
		case GridBagConstraint.EAST: 
			return JBCFMessages.getString("EAST"); //$NON-NLS-1$
		case GridBagConstraint.SOUTHEAST: 
			return JBCFMessages.getString("SOUTHEAST"); //$NON-NLS-1$
		case GridBagConstraint.SOUTH: 
			return JBCFMessages.getString("SOUTH"); //$NON-NLS-1$
		case GridBagConstraint.SOUTHWEST: 
			return JBCFMessages.getString("SOUTHWEST"); //$NON-NLS-1$
		case GridBagConstraint.WEST: 
			return JBCFMessages.getString("WEST"); //$NON-NLS-1$
		case GridBagConstraint.NORTHWEST: 
			return JBCFMessages.getString("NORTHWEST"); //$NON-NLS-1$
		default:
			return JBCFMessages.getString("CENTER"); //$NON-NLS-1$
	}
}
	/**
	 * @see INeedData#setData(Object)
	 */
	public void setData(Object data) {
		editDomain = (EditDomain) data;
	}

}