package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.viewers.LabelProvider;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
import com.ibm.etools.propertysheet.INeedData;
import com.ibm.etools.proxy.*;
/**
 * Label provider for the GridBagConstraints.fill  field
 */
public class GridBagConstraintsFillLabelProvider extends LabelProvider implements INeedData {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static String[] FILL_VALUES = new String[] {
		JBCFMessages.getString("NONE"),JBCFMessages.getString("HORIZONTAL"),JBCFMessages.getString("VERTICAL"),JBCFMessages.getString("BOTH") //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	};
	
	protected EditDomain editDomain;

public String getText(Object element){
	IIntegerBeanProxy fillValueProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanProxy((IJavaInstance)element, JBCFEditDomainHelper.getResourceSet(editDomain));
	int fillValue = fillValueProxy.intValue();
	switch (fillValue) {
		case GridBagConstraint.NONE: 
			return JBCFMessages.getString("NONE"); //$NON-NLS-1$
		case GridBagConstraint.HORIZONTAL: 
			return JBCFMessages.getString("HORIZONTAL"); //$NON-NLS-1$
		case GridBagConstraint.VERTICAL: 
			return JBCFMessages.getString("VERTICAL"); //$NON-NLS-1$
		case GridBagConstraint.BOTH: 
			return JBCFMessages.getString("BOTH"); //$NON-NLS-1$
		default:
			return JBCFMessages.getString("NONE"); //$NON-NLS-1$
	}
}
	/**
	 * @see INeedData#setData(Object)
	 */
	public void setData(Object data) {
		editDomain = (EditDomain) data;
	}

}