package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.viewers.LabelProvider;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
import com.ibm.etools.proxy.*;
	

public class InsetsJavaClassLabelProvider extends LabelProvider{
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static final String NULL_INSETS_STRING = "0,0,0,0";	 //$NON-NLS-1$
	
public String getText(Object element){	
	if (element instanceof IJavaInstance)
		return toString((IJavaInstance) element);
	else if (element == null)
		return NULL_INSETS_STRING;
	else
		return super.getText(element);
}

/**
 * Static helper that is used by the editor as well
 */
public static String toString(IJavaInstance anInsets){
	IBeanProxy beanProxy = BeanProxyUtilities.getBeanProxy(anInsets);
	if (beanProxy != null) {
		StringBuffer sb = new StringBuffer(50);
		IIntegerBeanProxy intProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanField("top", beanProxy); //$NON-NLS-1$
		sb.append(intProxy.intValue());
		sb.append(',');
		intProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanField("left", beanProxy); //$NON-NLS-1$
		sb.append(intProxy.intValue());
		sb.append(',');
		intProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanField("bottom", beanProxy); //$NON-NLS-1$
		sb.append(intProxy.intValue());
		sb.append(',');
		intProxy = (IIntegerBeanProxy)BeanProxyUtilities.getBeanField("right", beanProxy); //$NON-NLS-1$
		sb.append(intProxy.intValue());
		return sb.toString();
	} else
		return NULL_INSETS_STRING;
}
}