package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.Hashtable;

import com.ibm.etools.cde.CDEHack;
import com.ibm.etools.logging.util.*;
import com.ibm.etools.logging.util.MsgLogger;

/**
 * 
 * @version 	1.0
 * @author
 */
public class JBCFMsgLogger {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final String[] LOG_LEVELNAMES = Level.getLevelNames();
	public static final int LOG_NONE = Level.NONE;
    public static final int LOG_CONFIG = Level.CONFIG;
    public static final int LOG_INFO = Level.INFO;
    public static final int LOG_WARNING = Level.WARNING;
    public static final int LOG_SEVERE = Level.SEVERE;
    public static final int LOG_FINE = Level.FINE;
    public static final int LOG_FINER = Level.FINER;
    public static final int LOG_FINEST = Level.FINEST;	
    
    private static boolean  LOG_ECHO_CONSOLE = false ; 
    private static boolean  LOG_ECLIPSE_ON = true ; 

	private MsgLogger internalMsgLogger = null;
	private JBCFPlugin jbcfPlugin = null;
	
	public JBCFMsgLogger(JBCFPlugin jbcfPlugin){
		this.jbcfPlugin = jbcfPlugin;
        LOG_ECHO_CONSOLE = jbcfPlugin.LOG_ECHO_CONSOLE ;
	}
	
	protected MsgLogger getInternalMsgLogger(){
		if(internalMsgLogger==null)
			internalMsgLogger = (MsgLogger) MsgLogger.getFactory().getLogger(
												PluginHelperImpl.getMsgLoggerName(jbcfPlugin), 
												jbcfPlugin);
		return internalMsgLogger;
	}

	public void log(String message, int logLevel){
       if (LOG_ECLIPSE_ON)
		   primLogObject(message, logLevel);
		if(LOG_ECHO_CONSOLE)
			System.out.println(message);
	}

	public void log(Throwable e, int logLevel){
        if (LOG_ECLIPSE_ON)
		  primLogObject(e, logLevel);
		if(LOG_ECHO_CONSOLE)
			e.printStackTrace();
	}
	
	public void log(Object object, int logLevel){
        if (LOG_ECLIPSE_ON)
		  primLogObject(object, logLevel);
		if(LOG_ECHO_CONSOLE)
			System.out.println(object.toString());
	}
	
	protected void primLogObject(Object object, int logLevel){
		getInternalMsgLogger().write(logLevel, object);
	}
	
	public void setConsoleEcho(boolean flag) {
		LOG_ECHO_CONSOLE = flag ;
	}
    public void setEclipseLog(boolean flag) {
        LOG_ECLIPSE_ON = flag ;
    }

	public void setMsgLoggerConfig(Hashtable config){
		getInternalMsgLogger().setMsgLoggerConfig(config);
	}
}
