package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.java.instantiation.base.*;
import com.ibm.etools.emf.ecore.EAttribute;
import com.ibm.etools.emf.ref.RefObject;

public class ModifyAttributesCommand 
	extends com.ibm.etools.common.command.AbstractCommand {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected EAttribute feature = null;
protected RefObject target = null;
protected Object data = null;
protected Object oldData = null;
protected byte operation = 0;

public static byte FEATURE_MODIFY = 11;
public static byte FEATURE_REMOVE = 22;
public static byte FEATURE_ADD = 33;

public ModifyAttributesCommand(String label){
	super(label);
}

public ModifyAttributesCommand(String label, String description){
	super(label, description);
}

public boolean canExecute(){
	if((operation==FEATURE_MODIFY || operation==FEATURE_ADD) && target!=null && feature!=null && data!=null)
		return true;
	if(operation==FEATURE_REMOVE && target!=null && feature!=null)
		return true;
	return false;
}

public void execute(){
	if(operation==FEATURE_REMOVE){
		oldData = target.refValue(feature);
		target.refUnsetValue(feature);
	}
	if(operation==FEATURE_MODIFY){
		oldData = target.refValue(feature);
		target.refSetValue(feature, data);
	}
	if(operation==FEATURE_ADD){
		target.refSetValue(feature, data);
	}
}

public void undo(){
	if(operation==FEATURE_REMOVE)
		target.refSetValue(feature, oldData);
	if(operation==FEATURE_MODIFY)
		target.refSetValue(feature, oldData);
	if(operation==FEATURE_ADD)
		target.refUnsetValue(feature);
}

public void redo(){
	execute();
}

public void setOperation(byte operation){
	this.operation = operation;
}

public void setTarget(RefObject target){
	this.target = target;
}

public void setData(Object data){
	this.data = data;
}

public void setFeature(EAttribute feature){
	this.feature = feature;
}

}