package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.propertysheet.INeedData;
import com.ibm.etools.propertysheet.NumberLabelProvider;
import com.ibm.etools.proxy.INumberBeanProxy;
import com.ibm.etools.proxy.IBeanProxy;
import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
/**
 * This is a generic cell renderer that can format numbers correctly
 * It goes to the bean proxy to get the number value, however because it casts to the
 * the specifc type it doesn't actually trip to the target VM as the value of the number
 * is stored in the IDE's implementation of IBeanProxy
 */
public class NumberJavaLabelProvider extends NumberLabelProvider implements INeedData {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected EditDomain editDomain;
	
public String getText(Object element){
	
	if (element instanceof IJavaInstance) {
		IBeanProxy proxy = BeanProxyUtilities.getBeanProxy((IJavaInstance)element, JBCFEditDomainHelper.getResourceSet(editDomain));
		if (proxy == null)
			return "";	// It shouldn't be null. //$NON-NLS-1$
		else if (proxy instanceof INumberBeanProxy)
			return super.getText(((INumberBeanProxy) proxy).numberValue());
		else
			return proxy.toBeanString();
	} else
		return super.getText(element);
}
	/**
	 * @see INeedData#setData(Object)
	 */
	public void setData(Object data) {
		editDomain = (EditDomain) data;
	}

}