package com.ibm.etools.jbcf;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.jface.viewers.LabelProvider;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
import com.ibm.etools.proxy.awt.IPointBeanProxy;
import com.ibm.etools.proxy.IBeanProxy;
/**
 * Render a dimension in a usable form, e.g. 100,100
 */
public class PointJavaClassLabelProvider extends LabelProvider {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static final String NULL_POINT_STRING = "0,0";	 //$NON-NLS-1$
	
public String getText(Object element){	
	if (element instanceof IJavaInstance)
		return toString((IJavaInstance) element);
	else if (element == null)
		return NULL_POINT_STRING;
	else
		return super.getText(element);
}

/**
 * Static helper that is used by the editor as well
 */
public static String toString(IJavaInstance aDimension){
	IBeanProxy beanProxy = BeanProxyUtilities.getBeanProxy(aDimension);
	if (beanProxy instanceof IPointBeanProxy) {
		IPointBeanProxy pointProxy = (IPointBeanProxy) beanProxy;
		StringBuffer sb = new StringBuffer(50);
		sb.append(String.valueOf(pointProxy.getX()));
		sb.append(',');
		sb.append(String.valueOf(pointProxy.getY()));
		return sb.toString();
	} else
		return beanProxy != null ? beanProxy.toBeanString() : NULL_POINT_STRING;
}
}


