package com.ibm.etools.jbcf.choosebean;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.widgets.Display;
import org.eclipse.core.resources.*;
import org.eclipse.core.resources.IFile;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.ui.*;
import org.eclipse.ui.dialogs.*;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.jface.operation.IRunnableContext;
import org.eclipse.jface.operation.IRunnableWithProgress;
import java.lang.reflect.InvocationTargetException;
import org.eclipse.jdt.core.search.IJavaSearchScope;
import org.eclipse.jdt.core.search.SearchEngine;
import java.util.*;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.cde.palette.SelectionCreationToolEntry;
import com.ibm.etools.cde.palette.impl.SelectionCreationToolEntryImpl;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.tools.CreationTool;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFEditDomainHelper;

public class ChooseBeanSelector
	implements SelectionCreationToolEntry.ISelector {
 
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected SelectionCreationToolEntry creationToolEntry = null;
protected List selectionHistory = null;

public ChooseBeanSelector(){
	selectionHistory = new ArrayList();
}

protected String getPluginName(){
	return ResourcesPlugin.getPlugin().getDescriptor().getLabel();
}
public Object[] getNewObjectAndType(SelectionCreationToolEntry.SelectionCreationTool creationTool){
	creationToolEntry = creationTool.getSelectionToolEntry();
	List selHistory = creationToolEntry.getSelectionHistory();
	ChooseBeanDialog dialog = new ChooseBeanDialog(
							Display.getDefault().getActiveShell(), 
							((FileEditorInput)((DefaultEditDomain)creationTool.getDomain()).getEditorPart().getEditorInput()).getFile(),
							JBCFEditDomainHelper.getResourceSet((EditDomain)creationTool.getDomain()),
							selHistory);
	if(dialog.open()==dialog.OK){
		try{
			Object[] results = dialog.getResult();
			JBCFPlugin.log(ChooseBeanMessages.getString("ToolSelector.SelectionLogMessage")+results[0], JBCFMsgLogger.LOG_FINE); //$NON-NLS-1$
			com.ibm.etools.emf.ecore.EClassifier classifier= 
				(com.ibm.etools.emf.ecore.EClassifier)results[1];
			selHistory.add(0,classifier.refName());
			return results;
		}catch(Exception e){
			return null;
		}
	}else{
		return null;
	}
}

}