package com.ibm.etools.jbcf.codegen;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.text.MessageFormat;
import java.util.Hashtable;

import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import com.ibm.etools.jbcf.editorpart.IJVEStatus;

/**
 * @version 	1.0
 * @author
 */
public class DefaultTransientErrorHandler implements ITransientErrorListener {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
   IJVEStatus fMr = null ;
   Hashtable    fEvents = new Hashtable () ;

   public DefaultTransientErrorHandler(IJVEStatus mr) {
       this.fMr = mr ;
   }

	public void display(ITransientErrorEvent event) {
		JBCFPlugin.log("DefaultTransientError:", JBCFMsgLogger.LOG_FINE); //$NON-NLS-1$
		JBCFPlugin.log("\t\tMessage:"+event.getMessage(), JBCFMsgLogger.LOG_FINE); //$NON-NLS-1$
		JBCFPlugin.log("\t\tErrorType:"+event.getErrorType(), JBCFMsgLogger.LOG_FINE); //$NON-NLS-1$
		JBCFPlugin.log("\t\tRefObject:"+event.getRefObject(), JBCFMsgLogger.LOG_FINE); //$NON-NLS-1$
	}

	/*
	 * @see ITransientErrorListener#correctionOccured(TransientErrorEvent)
	 */
	public void correctionOccured(ITransientErrorEvent event) {
        if (fMr != null)
           fMr.showMsg(null,fMr.NORMAL_MSG) ;        
		display(event);
	}

	/*
	 * @see ITransientErrorListener#errorOccured(TransientErrorEvent)
	 */
	public void errorOccured(ITransientErrorEvent event) {
        if (fMr != null)
        fMr.showMsg(MessageFormat.format(CodegenMessages.getString("TransientErrorHandler.MsgRenderer.TransientError"), new Object[]{event.getMessage()}),fMr.ERROR_MSG) ; //$NON-NLS-1$
    //    fEvents.put(event.getElementHandle(), event)
		display(event);
	}

}
