package com.ibm.etools.jbcf.codegen;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.EventListener;

/**
 * Interface used for those interested in changes to the code gen status.
 * Implementers can change the views or images shown to the user based on the current status.
 * For example, the graph viewer can show an image or figure indicating there
 * is a reload in progress.
 * 
 * The status constants used come from ICodeGenStatus. Some examples are:
 * 		JVE_CODEGEN_STATUS_SYNCHING
 * 		JVE_CODEGEN_STATUS_OUTOFSYNC
 * 		JVE_CODEGEN_STATUS_RELOAD_IN_PROGRESS
 */
public interface IJVEStatusChangeListener extends EventListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Notify the listeners the status has changed. 
	 */
	public void statusChanged(int oldStatus,  int newStatus);

}
