package com.ibm.etools.jbcf.codegen;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import  com.ibm.etools.emf.resource.*;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import com.ibm.etools.jbcf.codegen.util.CodeGenException;
import  com.ibm.etools.cde.properties.PropertySourceAdapterFactory;
import  com.ibm.etools.cde.properties.PropertySourceAdapter;
import  com.ibm.etools.cde.properties.PropertyDescriptorAdapterFactory;
import  org.eclipse.core.resources.IProject ;
import  com.ibm.etools.beaninfo.adapters.BeaninfoNature ;
import  org.eclipse.core.runtime.*;


/**
 * @Deprecated
 */

public class JBCFModelBuilder extends AbstractModelBuilder { 


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
// plugin extension point details
public static  String  DECODERS_EXT_ID =  "com.ibm.etools.jbcf.mimedecoders" ; //$NON-NLS-1$
public static  String  DECODERS_DEFAULT = "mimeDefault" ; //$NON-NLS-1$
public static  String  DECODERS_TYPE =    "mimeType" ; //$NON-NLS-1$
public static  String  DECODERS_FILE =    "filext" ; //$NON-NLS-1$
public static  String  DECODERS_DECODER = "decoder" ; //$NON-NLS-1$
public static  String  DECODERS_CLASS =   "class" ; //$NON-NLS-1$






/**
 *   This builder provides configuration hooks 
 */
protected void initializeResourceSet() throws Exception {
      
      throw new Exception("Deprecated") ; //$NON-NLS-1$
      
//      Context context = fResourceSet.getContext();
//	context.addAdapterFactory(new PropertySourceAdapterFactory(PropertySourceAdapter.class));
//	context.addAdapterFactory(new PropertyDescriptorAdapterFactory());	
//      	
//	// Initialize the nature for the project that creates a remote VM and registers the 
//	// java:/ protocol in MOF
//	IProject aProject = fFile.getProject();
//	BeaninfoNature fNature = BeaninfoNature.getRuntime(aProject);		
//	fResourceSet.getContext().setParent(fNature.getContext());
}

/**
 *  Go through the mimedecoders extension point to figure out which decoder to use
 *  for the current file resource
 */
protected void resolveDecoder (String fileExt) throws Exception {
	
		// Try to find the configuration element from the extension point 
		// that matchs the VM we will be using.
		IExtensionPoint xp = Platform.getPluginRegistry().getExtensionPoint(DECODERS_EXT_ID);
		
		if (xp != null) {			
			IConfigurationElement  defaultDecoderCE=null , theDecoderCE = null ;
			IExtension[] extensions = xp.getExtensions();
			for (int i=0; theDecoderCE == null && i < extensions.length; i++) {
				IConfigurationElement[] ces = extensions[i].getConfigurationElements();
				for (int j=0; j < ces.length; j++) {
					IConfigurationElement ce = ces[j];
					if (ce.getName().equals(DECODERS_TYPE)) {
						String ext = ce.getAttributeAsIs(DECODERS_FILE);
						if (ext != null && ext.equals(fileExt)) {
						  IConfigurationElement[] ces2 = ce.getChildren(DECODERS_DECODER) ;
						  if (ces2!= null & ces2.length>0) 
						  	theDecoderCE = ces2[0] ;						  
						}
					} 
					else if (ce.getName().equals(DECODERS_DEFAULT)) {						
						defaultDecoderCE=ce ;
					}
					
				}
			}
			try {
			 if (theDecoderCE == null)  theDecoderCE = defaultDecoderCE ;
			 if (theDecoderCE != null)
		        fSourceDecoder = (IDiagramSourceDecoder) theDecoderCE.createExecutableExtension(DECODERS_CLASS) ;
			}
			catch (Exception e) {
				JBCFPlugin.log(e, JBCFMsgLogger.LOG_WARNING) ;
			}
		}				 	
	
}


/**
 * @return a string representation of the receiver
 */
public String toString() {
	return "JBCFModelBuilder("+fUri+", "+fRoot+")" ; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
}

public void dispose() {
	if (fSourceDecoder != null)
	   fSourceDecoder.dispose() ;
}


	/**
	 * @see com.ibm.etools.jbcf.codegen.IDiagramModelBuilder#pauseRoundTripping(boolean)
	 */
	public void pauseRoundTripping(boolean flag) throws CodeGenException {
	}

}