package com.ibm.etools.jbcf.codegen;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefObject;

/**
 * @version 	1.0
 * @author
 */
public class TransientErrorEvent implements ITransientErrorEvent{
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private String code = null;
	private String handle = null;
	private String type = null;
	private RefObject refObject = null;
	private int sourceStart = -1;
	private int sourceEnd = -1;
	private String message = null;
	
	public TransientErrorEvent(
				String type, 
				RefObject refObject, 
				int srcStart, 
				int srcEnd, 
				String message, 
				String handle, 
				String code){
		setErrorType(type);
		setRefObject(refObject);
		setSourceStart(srcStart);
		setSourceEnd(srcEnd);
		setMessage(message);
		setElementSource(code);
		setElementHandle(handle);
	}

	public TransientErrorEvent(
				String type, 
				RefObject refObject, 
				String message){
		this(type, refObject, -1, -1, message, null, null);
	}

	public String getErrorType(){
		return type;
	}
	
	public String getElementHandle(){
		return handle;
	}
	
	public String getElementSource(){
		return code;
	}
	
	public RefObject getRefObject(){
		return refObject;
	}
	
	public int getSourceStart(){
		return sourceStart;
	}
	
	public int getSourceEnd(){
		return sourceEnd;
	}
	
	public String getMessage(){
		return message;
	}
	
	public String getSource(){
		if(getElementSource()==null)
			return null;
		if(getSourceStart()>-1 && getSourceEnd()<getElementSource().length())
			return getElementSource().substring(getSourceStart(), getSourceEnd());
		return null;
	}
	
	public void setErrorType(String type){
		this.type = type;
	}
	
	public void setRefObject(RefObject refObject){
		this.refObject = refObject;
	}
	
	public void setSourceStart(int sourceStart){
		this.sourceStart= sourceStart;
	}
	
	public void setSourceEnd(int sourceEnd){
		this.sourceEnd = sourceEnd;
	}
	
	public void setMessage(String message){
		this.message = message;
	}
	
	public void setElementSource(String code){
		this.code = code;
	}
	
	public void setElementHandle(String handle){
		this.handle = handle;
	}
}
