package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefStructuralFeature ;
import com.ibm.etools.emf.ecore.* ;
import com.ibm.etools.emf.ecore.impl.EAttributeImpl;
import com.ibm.etools.java.instantiation.base.IJavaInstance ;
import org.eclipse.jdt.internal.compiler.ast.* ;
import org.eclipse.jface.viewers.ITreeContentProvider;

import com.ibm.etools.beaninfo.PropertyDecorator ;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import com.ibm.etools.jbcf.codegen.util.* ;
import com.ibm.etools.beaninfo.adapters.Utilities ;
import com.ibm.etools.cde.CDEHack;
import java.util.* ;
import com.ibm.etools.emf.jbcf.BeanFeatureDecorator ;


public abstract class AbstractFeatureMapper implements IJavaFeatureMapper {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
RefStructuralFeature    fSF = null ;
String                  fSFname = null ;
PropertyDecorator       fPD = null ;
IJavaInstance           fRefObj = null ;
String                  fMethodName = null ;
String                  fReadMethodName = null ;
boolean                fisMethod = true ;

/**
 *  Implementors will provide a specific logic.
 *  Note: that implementors are designed for a particular set of features.
 *        One has to load the propper mapper
 */
public abstract RefStructuralFeature getFeature(Statement expr) ;

public boolean isFieldFeature() {
    return !fisMethod ;
}


protected boolean isFieldAccess(RefStructuralFeature sf) {
   
    if (sf instanceof EAttributeImpl) {
	  EAttributeImpl a = (EAttributeImpl) sf ;
	  Iterator itr = a.getEDecorators().iterator() ; 
	  while (itr.hasNext()) {
	      Object obj = itr.next() ;
	      if (obj instanceof BeanFeatureDecorator) {
	          if (((BeanFeatureDecorator)obj).getBeanProxyMediatorName().equals("com.ibm.etools.jbcf/com.ibm.etools.jbcf.BeanFieldProxyFeatureMediator"))  //$NON-NLS-1$
	            return true ;
	      }
	  }
    }
    return false ;
}

public void setFeature(RefStructuralFeature sf){
	fSF = sf ;
	if (sf != null) {
	   try {
	     fSFname = ((EStructuralFeature)fSF).getName() ;
	     fPD = Utilities.getPropertyDecorator((EModelElement)sf);	
	   }
	   catch (Throwable e) {
	       JBCFPlugin.log("Utilities.getPropertyDecorator on:"+sf, JBCFMsgLogger.LOG_WARNING) ; //$NON-NLS-1$
	       JBCFPlugin.log(e, JBCFMsgLogger.LOG_WARNING);
	   }
	   if (fPD == null && isFieldAccess(sf)) {
	       fisMethod = false ;
	       fMethodName = sf.refName() ;
	   }
	}
}
public String getFeatureName(){
	return fSFname ;
}


public void setRefObject(IJavaInstance obj) {
	fRefObj = obj ;
}
public IJavaInstance getRefObject() {
	return fRefObj ;
}

public String getMethodName() {
	if (fMethodName == null) {
	  if (fPD != null && fPD.getWriteMethod()!= null) {
	  	fMethodName = fPD.getWriteMethod().getName() ;
	  }
	}     
	return fMethodName ;
}

public String getReadMethodName() {
	if (fReadMethodName == null) {
	  if (fPD != null && fPD.getReadMethod()!= null) {
	  	fReadMethodName = fPD.getReadMethod().getName() ;
	  }
	}     
	return fReadMethodName ;	
}

protected String getMethodName(Statement exp) {
	if (fMethodName == null) 
	  fMethodName = CodeGenUtil.getWriteMethod(exp) ;
	return fMethodName ;	  
}

public PropertyDecorator getDecorator() {
	return fPD ;
}

/**
 * The default, overide if needed
 */
public String getIndexMethodName() {
    return getMethodName() ;
}


/**
 * @see com.ibm.etools.jbcf.codegen.java.IJavaFeatureMapper#getPriorityIncrement(String)
 */
public int getPriorityIncrement(String methodType) {
	return 0;
}

}