package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jdt.core.ISourceRange;

/**
 * @version 	1.0
 * @author
 */
public class CodeGenSourceRange implements ICodeGenSourceRange {
    
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
    int fOffset,
        fLen,
        fLine ;
    
   public CodeGenSourceRange (ISourceRange sr) {
       if (sr != null) {
        fOffset = sr.getOffset() ;
        fLen = sr.getLength() ;
       }
       else {
        fOffset = fLen = -1 ;
       }
       fLine = -1 ;
   }
   
   public CodeGenSourceRange (int off, int len) {
       fOffset = off ;
       fLen = len ;
       fLine = -1 ;
   }
   public int getOffset () {
       return fOffset ;
   }
   
   public int getLineOffset() {
       return fLine ;
   }
   public void setLineOffset(int line) {
       fLine = line ;
   }
   public int getLength() {
       return fLen ;
   }
   
   public String toString() {
       return new String ("(off:"+fOffset+", line:"+fLine+", len:"+fLen+")") ; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
   }
   
   public void setOffset(int off) {
       fOffset = off ;
   }
   
   public void setLen(int len) {
       fLen = len ;
   }
   

}
