package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefStructuralFeature ;
import com.ibm.etools.java.instantiation.base.IJavaInstance ;
import org.eclipse.jdt.internal.compiler.ast.* ;
import com.ibm.etools.jbcf.codegen.util.* ;
import com.ibm.etools.emf.ecore.EClass ;
import com.ibm.etools.emf.ref.RefObject ;
import java.util.* ;
import com.ibm.etools.jbcf.codegen.model.* ;
import com.ibm.etools.jbcf.codegen.* ;
import com.ibm.etools.jbcf.* ;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance ;



public class ComponentDecoder extends ObjectDecoder {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
/**
 *  A JComponent (may be changing to Component) Decoder will also deal with constraints ...
 *  May need to augment it with other features in the future
 */
public ComponentDecoder (CodeExpressionRef expr, IBeanDeclModel model, IDiagramModelInstance cm, BeanPart part) {
	super (expr,model,cm,part) ;
}

public ComponentDecoder() {
	super () ;
}


protected String getMethod() {
      String method=null ;
	  
	  if (fFeatureMapper!= null)
	    if(fFeatureMapper.getDecorator()!= null) 
	       method = fFeatureMapper.getDecorator().getWriteMethod().getName() ;
	    	    
	  if (method == null)
	    method = CodeGenUtil.getWriteMethod(fExpr) ;	  
	    
	 return method ;
}

/**
 *  This is it for now
 */
protected boolean isConstraint() {	
	
	  String method=getMethod() ;
	  
	    
      if (method == null)
      	  return false;
      else
          return method.equals(IJavaFeatureMapper.CONSTRAINT_BOUND) ||
               method.equals(IJavaFeatureMapper.CONSTRAINT_SIZE)	;
	 
} 

protected boolean isLocation() {	
	
	  String method=getMethod() ;
	  
	    
      if (method == null)
      	  return false;
      else
          return method.equals(IJavaFeatureMapper.LOCATION_NAME) ;
	 
} 


/**
 *
 */
protected void initialFeatureMapper(){
               super.initialFeatureMapper() ;                       
}

/**
 *
 */
protected void initialFeatureMapper(RefStructuralFeature sf){  
       super.initialFeatureMapper(sf) ;
}
/**
 *
 */
protected void initialDecoderHelper() {

      if (isConstraint())	
	   fhelper = new ConstraintDecoderHelper(fbeanPart, fExpr,  fFeatureMapper,this) ;
	else if (isLocation())
	   fhelper = new PointDecoderHelper(fbeanPart, fExpr,  fFeatureMapper,this) ;
	else
	   super.initialDecoderHelper() ;
}

/**
 *  Get the first level descendents
 */
public Vector getChildren(IJavaObjectInstance component) {
	// Vanilla Components has no specific children
      return super.getChildren(component) ; 	
}



}