package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import com.ibm.etools.jbcf.codegen.model.*;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import com.ibm.etools.jbcf.codegen.*;
import com.ibm.etools.jbcf.codegen.util.*;
import org.eclipse.jdt.internal.compiler.ast.*;
import com.ibm.etools.emf.ref.RefObject ;
import com.ibm.etools.emf.ref.RefStructuralFeature;

import java.util.List;
import com.ibm.etools.java.instantiation.base.* ;
import java.util.* ;

public class ContainerAddDecoderHelper extends ExpressionDecoderHelper {	
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	BeanPart            fAddedPart = null ;
	RefObject           fCC = null ;
	IJavaObjectInstance fAddedConstraintInstance=null ;
	String              fAddedConstraint = null ;
	String              fnonResolvedAddedConstraint = null ;
	boolean            fisAddedConstraintSet = false ;
	String	        	fAddedIndex = null;	
	boolean 	        indexValueFound = false;

public ContainerAddDecoderHelper(BeanPart bean, Statement exp,  IJavaFeatureMapper fm, IExpressionDecoder owner){
	super (bean,exp,fm,owner) ;
}
/**
 * Overide the default action, as we are maintained as a list
 */
public void adaptToCompositionModel(IExpressionDecoder decoder) {
	com.ibm.etools.cde.CDEHack.fixMe("Need to clean this up") ; //$NON-NLS-1$
    // Make sure we do not have stale, need to be a bit smarter of how we do this.
    UnadaptToCompositionModel() ;
    
    BeanDecoderAdapter ba = (BeanDecoderAdapter) fbeanPart.getRefObject().getAdapter(ICodeGenAdapter.JVE_CODEGEN_BEAN_PART_ADAPTER) ;
		
	ExpressionDecoderAdapter adapter = new ExpressionDecoderAdapter(fAddedPart.getRefObject(),decoder) ;		   
	ba.addChildAdapter(fAddedPart,adapter) ;
	RefObject CC = getConstraintComponent(false) ;
	if (CC != null) {
	   CC.addAdapter(adapter) ;
	   IJavaObjectInstance c = CodeGenUtil.getCCconstraint(CC) ;
	   // Add a SourceRange adapter for the constraint
	   if (c != null &&              
	       // If we already have an Expression Adapter on it, do not add a Range Adapter e.g., GridBagConstraint
	       c.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_SOURCE_RANGE) == null) 	   	  
	   	 c.addAdapter(adapter.getShadowSourceRangeAdapter()) ;
	}
}

/**
 * Most helpers should consider overiding this one
 */
public void UnadaptToCompositionModel() {
	com.ibm.etools.cde.CDEHack.fixMe("Need to clean this up") ; //$NON-NLS-1$

    if (fbeanPart.getRefObject() == null) {
    	com.ibm.etools.jbcf.JBCFPlugin.log("UnadaptToCompositionModel: No RefObject",com.ibm.etools.jbcf.JBCFMsgLogger.LOG_WARNING) ;    	 //$NON-NLS-1$
    	return ;
    }
    
    BeanDecoderAdapter ba = (BeanDecoderAdapter)fbeanPart.getRefObject().getAdapter(ICodeGenAdapter.JVE_CODEGEN_BEAN_PART_ADAPTER) ;		
	ba.removeChildAdapter(fAddedPart) ;
	RefObject CC = getConstraintComponent(true) ;
	
	if (CC != null) {
	   ExpressionDecoderAdapter adapter = (ExpressionDecoderAdapter) CC.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_ADAPTER) ;
	   if (adapter != null) {
	     CC.removeAdapter(adapter) ;
	     IJavaObjectInstance c = CodeGenUtil.getCCconstraint(CC) ;
	     if (c != null) {
	     	ICodeGenAdapter a = (ICodeGenAdapter) c.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_SOURCE_RANGE) ;
	     	if (a != null && !(a instanceof ExpressionDecoderAdapter))
	          c.removeAdapter(a) ;
	     }
	   }
	}
}





/*
 * Decoder Specific Add 
 */
protected void add(BeanPart toAdd,BeanPart target) {
	add(null,toAdd, target, -1);
}

/**
 * Try to figure out where ti insert this object, with accordance to its position
 * in the code, in relation to other components.
 */
protected int findIndex (BeanPart toAdd,BeanPart target) {
    
     if (fOwner.getExprRef().getOffset()<0) return -1 ;
    
     java.util.List compList = (java.util.List) target.getRefObject().
                               refValue(fFmapper.getFeature(null));                               
     if (compList == null || compList.size() == 0) return -1 ;
     
     int thisOffset = fOwner.getExprRef().getOffset() ;
     int result = -1 ;
     for (int i = compList.size()-1; i >= 0; i--) {
        try {
          RefObject cc = (RefObject) compList.get(i) ;
          ICodeGenAdapter a = (ICodeGenAdapter) cc.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_ADAPTER) ;
          if (a!= null && a.getBDMSourceRange().getOffset()>thisOffset)
            result = i ;        
        }
        catch (CodeGenException e) {}
     }
     
     return result ;     
}

/*
 * Decoder Specific Add 
 * @return RefObject the ConstraintComponent object
 */
protected RefObject add(RefObject cc, BeanPart toAdd,BeanPart target, int index) {
      int i = index ;
      if (i<0)
         i = findIndex(toAdd,target) ;
	  toAdd.setContainer(target) ;
      target.addChild(toAdd) ;
      fAddedConstraintInstance = CodeGenUtil.getCCconstraint(cc) ;
      //  Make this relationship in the Composition Model
      return CodeGenUtil.addComponentToContainer(cc,toAdd.getRefObject(), target.getRefObject(), i, fbeanPart.getModel().getCompositionModel()) ;
}

/**
 * @return List of all the components aggregated by fbeanPart
 */
protected List getComponentList() {
	return CodeGenUtil.getChildrenComponents(fbeanPart.getRefObject()) ;	
}

/**
 * @return RefObject denoting the ConstratintComponent object associated this expression
 */
protected RefObject getConstraintComponent(boolean cache) {
	if (fCC != null && cache) return fCC ;
    List compList=getComponentList() ;
    // Look for out added part
    RefObject targetCC = null ;    
    if (compList != null && compList.size()>0) {
    	// This component has childrents, Process them first, so that we 
    	// can add them as we generate the current method
    	Iterator itr = compList.iterator() ;
    	while (itr.hasNext()) {
    		try {
    		  RefObject CC = (RefObject)itr.next() ;
    		  IJavaObjectInstance child = CodeGenUtil.getCCcomponent(CC) ;
    		  if (child.equals(fAddedPart.getRefObject())) {
    			targetCC = CC ;
    			break ;
    		  }     			
    		}
    		catch (Exception e) {}
    	}    	
    }
    if (targetCC != null)
       fCC = targetCC ;
    return targetCC ;
}

protected void clearPreviousIfNeeded() {

    List compList=CodeGenUtil.getChildrenComponents(fbeanPart.getRefObject()) ;
    // Look for out added part
    RefObject targetCC = getConstraintComponent(false) ;
    if (targetCC != null && compList != null && compList.size()>0) {
    	compList.remove(targetCC) ;
    }

	
}

protected BeanPart parseAddedPart(MessageSend exp) throws CodeGenException {
	com.ibm.etools.cde.CDEHack.fixMe("Need to deal with multiple arguments, and nesting") ; //$NON-NLS-1$
	
	if (exp == null) return null ;
	
	BeanPart bp = null ;
	
	Expression[] args = exp.arguments ;
	if (args.length < 1) throw new CodeGenException("No Arguments !!! " + exp) ; //$NON-NLS-1$
      
      // Parse the arguments to figure out which bean to add to this container
      if (args[0] instanceof MessageSend)  {
      	// Look to see of if this method returns a Bean
      	String selector = new String (((MessageSend)args[0]).selector) ;  
      	bp = fOwner.getBeanModel().getBeanReturned(selector) ;       	
      }
      else if (args[0] instanceof SingleNameReference){
            // Simple reference to a bean
            String beanName = new String (((SingleNameReference)args[0]).token);
            bp = fOwner.getBeanModel().getABean(beanName) ;
            if(bp==null)
            	bp = fOwner.getBeanModel().getABean(BeanDeclModel.constructUniqueName(fOwner.getExprRef().getMethod(),beanName));
            	//bp = fOwner.getBeanModel().getABean(fOwner.getExprRef().getMethod().getMethodHandle()+"^"+beanName);
      }
	return bp ;
}


/**
 *   Add new Componet to target Bean,
 */
protected boolean  addComponent () throws CodeGenException {
	
	BeanPart oldAddedPart = fAddedPart ;
	
	fAddedPart = parseAddedPart((MessageSend)fExpr) ;
		    
    if (oldAddedPart != null)
       if (fAddedPart != oldAddedPart) {
       	BeanPart parent = oldAddedPart.getContainer() ;
       	if (parent.equals(fbeanPart))  // May have moved to another container already
       	    oldAddedPart.setContainer(null) ;
       }
          
	if (fAddedPart == null) throw new CodeGenException("No Added Part") ; //$NON-NLS-1$
      clearPreviousIfNeeded() ;
      
      Expression[] args = ((MessageSend)fExpr).arguments ;      
      return understandAddArguments(args);
}


protected boolean understandAddArguments(Expression[] args) throws CodeGenException{
	boolean defaultConstraintFound = false;
      int defaultConstraintPosition = -1;
      int indexValuePosition = -1;
      fAddedConstraintInstance = null ;
      fisAddedConstraintSet = false ;
      if (fAddedPart!= null) {
		com.ibm.etools.cde.CDEHack.fixMe("Deal with all signitures of add()") ; //$NON-NLS-1$
	    if( args.length >= 2) {      		
          	// Process all arguments to determine which is constraint and which is index.
          	for(int arg=1;arg<args.length;arg++){ 
    			// Check to see if there is layout manager constraint
    			if (args[arg] instanceof MessageSend){
    				MessageSend msgSnd = (MessageSend) args[arg];
    				if(msgSnd.receiver instanceof MessageSend) {
    					// check for getFooBean().getName() - our default           
    					String method = new String (msgSnd.selector) ;
    					if (!(ContainerDecoder.DEFAULT_CONSTRAINT.indexOf(method)<0)){
    						defaultConstraintFound = false ;
    						continue;
    					}
    				}
    				if(msgSnd.receiver instanceof ThisReference){
    					// Things like getCurrentIndex() or getDefaultConstraint();
    				}
    			}else   //  This is a Temporary solution !!!! we need to better fit for param. number for semantics
    				if(args[arg] instanceof StringLiteral){
    					defaultConstraintFound = true;
    					defaultConstraintPosition = arg;
    					fAddedConstraint = fnonResolvedAddedConstraint = args[arg].toString() ;
    				}else if(args[arg] instanceof IntLiteral){
    						indexValueFound = true;
    						indexValuePosition = arg;
    				}
    				else if (args[arg] instanceof SingleNameReference) {
    					  // A Variable - like a bean name
    					  String beanName = new String(((SingleNameReference)args[arg]).token);
    				      
    				      BeanPart cbp = fbeanPart.getModel().getABean(BeanDeclModel.constructUniqueName(fOwner.getExprRef().getMethod(),beanName));
    				      if(cbp==null)
    				      	cbp = fbeanPart.getModel().getABean(beanName) ;
    				      if (cbp != null) {
    				         cbp.setContainer(fbeanPart) ;
    				         fbeanPart.addChild(cbp) ;
    				         fAddedConstraintInstance = (IJavaObjectInstance) cbp.getRefObject() ; 
    				         fisAddedConstraintSet = fAddedConstraint != null ;
    				      }				         
    				}else if(args[arg] instanceof QualifiedNameReference){
    					// Something dot separated - like a fqn class name, or a static variable.
    					// Since chances are that it is a static variable like Button.NoRTH it 
    					// should become the defaultConstraint if one is not found already.
    					if(!defaultConstraintFound){
    						defaultConstraintFound = true;
    						defaultConstraintPosition = arg;
    						fnonResolvedAddedConstraint = args[arg].toString() ;
    						fAddedConstraint = fbeanPart.getModel().resolve(fnonResolvedAddedConstraint) ;
    					}
    				} else if (args[arg] instanceof NullLiteral){
    					com.ibm.etools.cde.CDEHack.fixMe("Arg index should be consulted") ; //$NON-NLS-1$
    					defaultConstraintFound = true;
    				    defaultConstraintPosition = arg;
    					fAddedConstraint = fnonResolvedAddedConstraint = null ;
    					
    				}
          	}
	    }
       try {
           int index = -1;
			if(indexValueFound)
				index = Integer.parseInt(((IntLiteral)args[indexValuePosition]).toStringExpression());
			RefObject CC = CodeGenUtil.getNewCC(fbeanPart.getModel().getCompositionModel()) ;
			if (defaultConstraintFound) { 				
				fisAddedConstraintSet = true ;
				// Add the constraint to the added part
                CodeGenUtil.addConstraintString(CC,
	           	       	                        fAddedConstraint,
	           	       	                        CodeGenUtil.getConstraintFeature(CC),
	           	            	                fOwner.getCompositionModel()) ;
			}
			else if (fAddedConstraintInstance != null) {
			    CodeGenUtil.addConstraintInstance(CC,
			                                      fAddedConstraintInstance,
			                                      CodeGenUtil.getConstraintFeature(CC)) ;    
                
            }
			if(indexValueFound){
				fAddedIndex = ((IntLiteral)args[indexValuePosition]).toStringExpression();
			}
			// Now add it to the model
			add(CC,fAddedPart, fbeanPart, index);
       }catch (Exception e) {
           throw new CodeGenException(e) ;
       }
		return true ;
      }		
	return false ;
}

public String primRefreshFromComposition(String expSig) throws CodeGenException {
        		
      // Isolate the constraint argument using the last used constraint
      String[] args = getSourceCodeArgs() ;
          
	int start = expSig.indexOf(args[0]) ;	
	com.ibm.etools.cde.CDEHack.fixMe("Need to deal with identical ") ; //$NON-NLS-1$
	int end = start<0 ? -1 : 
	          expSig.lastIndexOf(args[args.length-1])+ args[args.length-1].length();
	if (start<0 || end<0) {
		JBCFPlugin.log ("SimpleAttr.DecoderHelper.primRefreshFromComposition(): Error", JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
		return expSig ;
	}
	// Get the latest constraint	
	RefObject CC = getConstraintComponent(false) ;
	ICodeGenAdapter constraintAdapter = null ;
	if (fAddedConstraintInstance != null) {
	   constraintAdapter = (ICodeGenAdapter) fAddedConstraintInstance.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_SOURCE_RANGE) ;	   
	}
	// It is possible that we are moving from No constraint to a new one, so create a source range adapter.
	if (constraintAdapter == null) {
	   	ExpressionDecoderAdapter a = (ExpressionDecoderAdapter) CC.getAdapter(ICodeGenAdapter.JVE_CODEGEN_EXPRESSION_ADAPTER) ;	   	
	   	constraintAdapter = a.getShadowSourceRangeAdapter() ;
	}
	if (CC != null) {
		RefStructuralFeature sf = (RefStructuralFeature) CC.refMetaObject().metaObject("constraint") ; //$NON-NLS-1$
	    fAddedConstraintInstance = (IJavaObjectInstance)CC.refValue(sf) ;
	    if (constraintAdapter != null && fAddedConstraintInstance!=null) 
	       fAddedConstraintInstance.addAdapter(constraintAdapter) ;
	    fisAddedConstraintSet = CC.refIsSet(sf) ;	   	      
	}
	updateAddedArguments();
	args = getSourceCodeArgs() ;
	// Regenerate the arguments, only
	StringBuffer sb = new StringBuffer() ;
	for (int i=0; i<args.length; i++) {
	   if (i>0) sb.append(", ") ; //$NON-NLS-1$
	   sb.append(args[i]) ;
	}
	// Replace the arguments part	
	StringBuffer newExp = new StringBuffer(expSig) ;
	newExp.replace(start,end,sb.toString()) ;
	fExprSig = newExp.toString() ;
	return fExprSig ;
}

/**
 *  Look for our added part, 
 */
public boolean primIsDeleted() {
	
    RefObject CC = getConstraintComponent(false) ;
    if (CC == null) return true ;
    else return false ;	
}



/**
 *   Overidable test: Is this expression fits this decoder
 */
protected boolean isMySigniture()
{
   return  fFmapper.getFeature(fExpr).equals(CodeGenUtil.getComponentFeature(fbeanPart.getRefObject()));	
}

/**
 *   Go for it
 */
public boolean decode() throws CodeGenException {

   if (fFmapper.getFeature(fExpr) == null ||
	   fExpr == null) throw new CodeGenException ("null Feature:"+fExpr) ; //$NON-NLS-1$

   if (isMySigniture())	   
      return addComponent() ;
   else
      return false ;	   
}

public void delete() {
	UnadaptToCompositionModel() ;
	
	com.ibm.etools.emf.ref.RefStructuralFeature sf = fFmapper.getFeature(fExpr) ;
	IJavaObjectInstance parent = (IJavaObjectInstance)fbeanPart.getRefObject() ;
    // refresh CC
    getConstraintComponent(false) ;
	
	com.ibm.etools.cde.CDEHack.fixMe("Consider setting a new constraint to child") ; //$NON-NLS-1$
	List parentsChildren = CodeGenUtil.getChildrenComponents(parent);
    if (fCC != null)
	   parentsChildren.remove(fCC) ;
    fAddedPart.setContainer(null) ;
}



public Object getPriorityOfExpression(){
	Integer pri = (Integer)super.getPriorityOfExpression();
	int indexOfChildInParent = 0;
	if(fAddedPart!=null){
//		List ccs = CodeGenUtil.getChildrenComponents(fAddedPart.getContainer().getRefObject());
        // It is possible that the fAddedPart was taken to another container (with a later on
        // parsed add() for another container.. so this expression is somewhat stale.  But the
        // expression itself is releated to the BeanPart, not to the Added Part's container
		List ccs = CodeGenUtil.getChildrenComponents(fbeanPart.getRefObject());
		if (ccs != null) {
		  for(int i=0;i<ccs.size();i++){
			RefObject cc = (RefObject)ccs.get(i);
			if("ConstraintComponent".equals(cc.refMetaObject().refName())) //$NON-NLS-1$
				cc = CodeGenUtil.getCCcomponent(cc);
			if (cc == null) {
				JBCFPlugin.log("ContainerAddDecoderHelper.getPriorityOfExpression(): null Component in a CC :"+this+com.ibm.etools.jbcf.JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
				continue ;
			}
			if(cc.equals(fAddedPart.getRefObject())){
				indexOfChildInParent = i;
				break;
			}
		 }
		}
	}
	indexOfChildInParent++;
	return new Integer(IJavaFeatureMapper.PRIORITY_ADD_CHANGE + pri.intValue() + (IJavaFeatureMapper.INTER_LAYOUT_ADD_PRIORITIES_GAP-indexOfChildInParent));}

/**
 *  Detemine the source code argument for the add() method
 */
private String[] getSourceCodeArgs()  {
   
	String AddedArg ;
	if (fAddedPart.getInitMethod().equals(fbeanPart.getInitMethod()))   // Added part is defined in the same method as the container
		 AddedArg = fAddedPart.getSimpleName() ;
    else
       if (fAddedPart.getReturnedMethod() != null)	
	       AddedArg= fAddedPart.getReturnedMethod().getMethodName()+
	                     ExpressionTemplate.LPAREN+ExpressionTemplate.RPAREN ;  
	   else // In the case a bean has an init method, instance var., but no return method.
	       AddedArg = fAddedPart.getSimpleName() ;
	                   
	List finalArgs = new ArrayList();
	finalArgs.add(AddedArg);
	if(fAddedConstraint!=null){
		// Supplied constraint;
		finalArgs.add(fnonResolvedAddedConstraint);
	}else{
		// Generate a getName() by default
		if (!fisAddedConstraintSet) {
			if (ContainerDecoder.DEFAULT_CONSTRAINT != null) {
				String defArg = AddedArg +					
						ContainerDecoder.DEFAULT_CONSTRAINT;
				finalArgs.add(defArg);
			}
		}
		else // Generate a true null constraint
			finalArgs.add("null") ; //$NON-NLS-1$
	}
	if(fAddedIndex!=null){
		finalArgs.add(fAddedIndex);
	}
	String[] args = new String[finalArgs.size()];
	for(int i=0;i<finalArgs.size();i++)
		args[i] = (String)finalArgs.get(i);
	return args;
}
/**
 *  Overide the abstract method, to deal No Decorations.
 */
protected ExpressionTemplate getExpressionTemplate() throws CodeGenException {
		
	
	com.ibm.etools.cde.CDEHack.fixMe("Need to deal with layout constraints") ; //$NON-NLS-1$
	
	String[] args = getSourceCodeArgs() ; // Arguments for the add() method
	
	String sel = fbeanPart.getSimpleName() ;
	String mtd = fFmapper.getMethodName() ;
	ExpressionTemplate exp = new ExpressionTemplate (sel,mtd, args,	                                                
	                                                 null,
	                                                 0 ) ;
	exp.setLineSeperator(fbeanPart.getModel().getLineSeperator()) ;	
	return exp ;   	
}

protected void updateAddedArguments() {
	
	fAddedConstraint = null ;
	if (fAddedConstraintInstance != null){
		// get the contstraints value
		BeanPart cbp = fbeanPart.getModel().getABean(fAddedConstraintInstance) ;
		if (cbp == null) // Vanilla constraint
		   fnonResolvedAddedConstraint = fAddedConstraint = fAddedConstraintInstance.getInitializationString() ;                                   
		else
		   fnonResolvedAddedConstraint= fAddedConstraint = cbp.getSimpleName() ;
	}
	fAddedIndex = null;
	// If you dont want this variable indexValuefound, then there should be
	// some way of telling whether an index is necessary (like finding out the
	// the type of the layout).
	if(indexValueFound){  
		// Add an index position, as it was found.
		List parentsChildren = CodeGenUtil.getChildrenComponents(fbeanPart.getRefObject());
		int indexOfAddedPart = parentsChildren.indexOf(fAddedPart.getRefObject());
		fAddedIndex = Integer.toString(indexOfAddedPart);
	}
}

public String generate(Object[] args) throws CodeGenException {

 	
	if (fFmapper.getFeature(null) == null) 
	    throw new CodeGenException ("null Feature") ; //$NON-NLS-1$
	if (args == null || args[0] == null)
	    throw new CodeGenException ("ContainerAddDecoderHelper.generate() : no Target") ; //$NON-NLS-1$
	    
	RefObject CC = (RefObject) args[0] ;
    IJavaObjectInstance comp = CodeGenUtil.getCCcomponent(CC) ;      
    fAddedPart = fbeanPart.getModel().getABean(comp) ;
    if (fAddedPart!=null) {        
      fbeanPart.addChild(fAddedPart) ;
      fAddedPart.setContainer(fbeanPart) ;
    }
    
    RefStructuralFeature sf = (RefStructuralFeature) CC.refMetaObject().metaObject("constraint") ; //$NON-NLS-1$
	fAddedConstraintInstance = (IJavaObjectInstance)CC.refValue(sf) ;
	fisAddedConstraintSet = CC.refIsSet(sf) ;	
      
    updateAddedArguments() ;
	    		
	ExpressionTemplate exp = getExpressionTemplate() ;
    fExprSig = exp.toString() ;	                                                 
    return fExprSig ;	     	
}

 
public boolean isImplicit(Object args[]) {
	IJavaObjectInstance obj ;
	if (args == null) {
	  obj = (IJavaObjectInstance) fAddedPart.getRefObject() ;	  
	}
	else {
	  RefObject CC = (RefObject) args[0] ;
	  obj = CodeGenUtil.getCCcomponent(CC) ;
	}
	if (obj == null) return false ;// Added Part was deleted, process delete
	else	return obj.isImplicit() ;
}


public Object[] getArgsHandles(Statement expr) {
    Object[] result = null ;    
    try {
      if (fAddedPart == null && expr != null) {
        // Brand new expression
        BeanPart bp = parseAddedPart((MessageSend)expr) ;
        if (bp != null) 
          result = new Object[] { bp.getType()+"["+bp.getSimpleName()+"]" } ; //$NON-NLS-1$ //$NON-NLS-2$
       }
       else if (fAddedPart != null) {
           return new Object[] { fAddedPart.getType()+"["+fAddedPart.getSimpleName()+"]" } ; //$NON-NLS-1$ //$NON-NLS-2$
       }
    }    
    catch (CodeGenException e) {}
    return result ;
}
 

/**
 * Overide to include the constraint SF.
 */
public boolean isRelevantFeature(RefStructuralFeature sf) {
	if (super.isRelevantFeature(sf)) return true ;	
	if (sf != null && fCC != null) {
	    RefStructuralFeature hSF = (RefStructuralFeature) fCC.refMetaObject().metaObject("constraint") ; //$NON-NLS-1$
		if (sf.equals(hSF) ||
		    (hSF.refID() != null && hSF.refID().equals(sf.refID()))) return true ;
	}
	return false ;
}

}


