package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.java.instantiation.base.IJavaInstance ;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFPlugin;
import com.ibm.etools.java.JavaHelpers ;
import com.ibm.etools.java.impl.JavaClassImpl ;
import com.ibm.etools.emf.ref.RefObject ;
import com.ibm.etools.emf.resource.ResourceSet;
import com.ibm.etools.emf.ecore.EClassifier ;
import java.util.* ;

import org.eclipse.core.runtime.*;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.Platform;

public class ExpressionDecoderFactory {
	
	
		
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	

public final static String ExpressionsExtID 		= "com.ibm.etools.jbcf.codegen.internal_statement_decoders" ; //$NON-NLS-1$

	
private static HashMap			fReflected2DecoderMap=null ;  
private static ArrayList			decodedObjectReflectedClasses=null ;
private static ResourceSet		currentRS = null ;  // do not use directly, as it can be reSettet to null mid stream.
private static HashMap			fObj2DecoderMapCache = null ;

//  decodedObjectNames works with decodedObjectDecoders
private static final ArrayList	decodedObjectNames = new ArrayList() ;
// To be extended mappings will be held here.
// It is possible that for a given project a bean is not
// available, in this case it would be removed from the decoding list
// and added back here.
private static final HashMap      tobeADDEDlist = new HashMap() ;
static
{
// The order is important, and is the first thing that will be 
// looked at. ** Subclasses must come before Superclasses **

	decodedObjectNames.add("javax.swing.text.JTextComponent"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JTable"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JDesktopPane"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JSplitPane"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JScrollPane"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JMenu"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JMenuBar"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JPopupMenu"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JToolBar"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JTabbedPane"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JRootPane"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JInternalFrame"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JFrame"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JPanel"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JComponent"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JApplet"); //$NON-NLS-1$
	decodedObjectNames.add("javax.swing.JDialog"); //$NON-NLS-1$
	decodedObjectNames.add("java.awt.Container"); //$NON-NLS-1$
	decodedObjectNames.add("java.awt.Component"); //$NON-NLS-1$
}
// These are the decoder that are associated with the above components	
private static final ArrayList  decodedObjectDecoders =  new ArrayList() ;
static
{
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JTextComponentDecoder.class); 	// JTextComponent //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JTableDecoder.class);         	// JTable //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.ContainerDecoder.class);      	// JDesktopPane //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JSplitPaneDecoder.class);     	// JSplitPane //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JScrollPaneDecoder.class);    	// JScrollPane //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JMenuDecoder.class);          	// JMenu //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JMenuBarDecoder.class);       	// JMenuBar //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JMenuDecoder.class);          	// JPopupMenu //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JMenuDecoder.class);			// JToolBar //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JTabbedPaneDecoder.class);    	// JTabbedPane //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JFrameDecoder.class);        	// JRootPane //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JFrameDecoder.class);         	// JInternalFrame //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JFrameDecoder.class);         	// JFrame	     //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.ContainerDecoder.class);      	// JPanel //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.ContainerDecoder.class);      	// JComponent //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JFrameDecoder.class); 		  	// JApplet //$NON-NLS-1$		
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.JFrameDecoder.class); 		  	// JDialog //$NON-NLS-1$		
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.ContainerDecoder.class);      	// Container //$NON-NLS-1$
	decodedObjectDecoders.add(com.ibm.etools.jbcf.codegen.java.ComponentDecoder.class);   		// Component //$NON-NLS-1$
	
	getExtendedList() ;
}

// This is a default Attribute Decoder
private static final Class defaultDecoder = 
        com.ibm.etools.jbcf.codegen.java.ObjectDecoder.class ; //$NON-NLS-1$
        
        

private static void addDecoder(String objName, Object decoder, IExtension xp, boolean force) {
	if (objName==null || decoder==null) return ;
	
	
	String pname = null ;
	try {
	   pname = xp.getDeclaringPluginDescriptor().getPlugin().getDescriptor().getUniqueIdentifier() ;
	}
	catch (CoreException e) {} ;
	
	if (!(decoder instanceof IExpressionDecoder)) {
			com.ibm.etools.jbcf.JBCFPlugin.log("** Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " is not using a decoder for class : "+objName, //$NON-NLS-1$
							                   JBCFMsgLogger.LOG_INFO);
		return ;					                   		
	}
	
	
	Class clazz = decoder.getClass() ;
	for (int i=0; i<decodedObjectNames.size(); i++)
	   if (decodedObjectNames.get(i).equals(objName)) {
	   	 if (force) {
	   		com.ibm.etools.jbcf.JBCFPlugin.log("** Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " overided JVE default decoder for: "+objName, //$NON-NLS-1$
							                   JBCFMsgLogger.LOG_WARNING);
			break ;
	   	 }
	   	 else {
	   	 	com.ibm.etools.jbcf.JBCFPlugin.log("Discarted Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " overid for a JVE default decoder for: "+objName, //$NON-NLS-1$
							                   JBCFMsgLogger.LOG_WARNING);
	   	 	return ;
	   	 }
			
	   }
	   // At this point we need to figure out where, in the list to put this entry,
	   // We can only do so when we can reflect (with a JavaModel) to check injstanceof
	tobeADDEDlist.put(objName,clazz) ;	   
	com.ibm.etools.jbcf.JBCFPlugin.log("** Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " added a JVE decoder for: "+objName, //$NON-NLS-1$
							                   JBCFMsgLogger.LOG_INFO);
			
}

/**
 * There are a few issues with overiding, what if multiple plgins wants to add/overide 
 * the same decoder type, who wins ? At this point the last one wins
 */
private static void getExtendedList() {

		// Try to find the configuration element from the extension point 
		IExtensionPoint xp = Platform.getPluginRegistry().getExtensionPoint(ExpressionsExtID);
		
		if (xp != null) {						
			IExtension[] extensions = xp.getExtensions(); 
		  if (extensions.length>0) {
			for (int i=0;i < extensions.length; i++) {
				IConfigurationElement[] ces = extensions[i].getConfigurationElements();
				for (int j=0; j < ces.length; j++) {
					IConfigurationElement ce = ces[j];
					// <decoderType type="expression">
					if (ce.getName().equals("decoderType") &&   //$NON-NLS-1$
					    (ce.getAttribute("type") != null && ce.getAttribute("type").equals("expression"))) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					    	IConfigurationElement c[] = ce.getChildren() ;
							for (int k = 0; k < c.length; k++) {
								IConfigurationElement expConf = c[k];
								try {
									// <add classDecoded="xxx.yyy.Foo"  decoderClass="zzz.FooDecoder"/>
									if (expConf.getName().equals("add")) { //$NON-NLS-1$
										boolean force = false ;
										String fs = expConf.getAttribute("force") ; //$NON-NLS-1$
										if (fs != null)
										   if (fs.equalsIgnoreCase("true")) //$NON-NLS-1$
										      force = true ;
										addDecoder(expConf.getAttribute("classDecoded"), expConf.createExecutableExtension("decoderClass"),extensions[i],force); //$NON-NLS-1$ //$NON-NLS-2$
									}
								}
								catch (Throwable t) {
									com.ibm.etools.jbcf.JBCFPlugin.log(
										"Error loading extended decoder class" + expConf.getAttribute("classDecoded") + ". (" + t.getMessage() + ")", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
										JBCFMsgLogger.LOG_WARNING);
								}
							}
					}
				}
			}
		  }
		}					
}

/**
 *  Hack for now, we need to set up a factory per
 *  domain instance
 */ 	
private static void initialList(RefObject obj) {	
	
	RefObject o ;
	com.ibm.etools.cde.CDEHack.fixMe("Need more here")	; //$NON-NLS-1$
	if (obj.refResource() == null)
	  o = obj.refMetaObject() ;
	else
	  o = obj ;
	  
	ResourceSet rs = o.refResource().getResourceSet() ;
	
	// Is our cached elements are from the same RS ??
	if (currentRS != null && rs.equals(currentRS)) return ;
	
	currentRS = rs ;
	com.ibm.etools.jbcf.JBCFPlugin.log("ExpressionDecoderFactory.initialList()",com.ibm.etools.jbcf.JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
	fReflected2DecoderMap = new HashMap(30) ;	
    fObj2DecoderMapCache = new HashMap(200) ;
	decodedObjectReflectedClasses = new ArrayList () ;
	// Look for decoder extensions
	
	// A decoder extension may not be able to be resolve for a given project rs.
	
	HashMap removedList = new HashMap() ;			    			
	for (int i=0 ; i<decodedObjectNames.size(); i++) {
		JavaHelpers sType = JavaClassImpl.reflect ((String)decodedObjectNames.get(i),o) ;
		if (sType != null &&  ((JavaClassImpl)sType).isExistingType()) {
		  decodedObjectReflectedClasses.add(sType) ;
		  // If we overided, the first one win
		  if (!fReflected2DecoderMap.containsKey(sType))
		     fReflected2DecoderMap.put(sType,decodedObjectDecoders.get(i)) ;
		}
		else {
			// This bean is not available in this RS, so move it to the tobeADDEDList
			removedList.put(decodedObjectNames.get(i),decodedObjectDecoders.get(i)) ;
			com.ibm.etools.jbcf.JBCFPlugin.log("ExpressionDecoderFactory.initialList() - removing "+decodedObjectNames.get(i),com.ibm.etools.jbcf.JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
			decodedObjectNames.remove(i) ;
			decodedObjectDecoders.remove(i) ;			
			// fReflected2DecoderMap, and decodedObjectReflectedClasses are clean by default
			i-- ;
			
		}
	}	
	fReflected2DecoderMap.put("noClue",defaultDecoder) ;	 //$NON-NLS-1$
	
	// Go throughthe tobeADDEDlist, and add elements in their correct order
	ArrayList cleanList = new ArrayList() ;	
	for (Iterator iter = tobeADDEDlist.keySet().iterator(); iter.hasNext();) {
		String objName = (String) iter.next();
		JavaHelpers objType = JavaClassImpl.reflect (objName,rs) ;
		if (objType == null || !((JavaClassImpl)objType).isExistingType()) continue ;
		// Need to figur out where to insert it
		int index = decodedObjectReflectedClasses.size()-1;
		for (int i=0; i<decodedObjectReflectedClasses.size(); i++) {
			JavaHelpers clazz = (JavaHelpers)decodedObjectReflectedClasses.get(i) ;
			if (clazz.isAssignableFrom((EClassifier)objType)) {
				index=i ;
				break ;
			}			
		}
		// Add as a true member, so that we do not have to go through it again
		decodedObjectReflectedClasses.add(index,objType) ;
		decodedObjectNames.add(index,objName) ;
		decodedObjectDecoders.add(index,tobeADDEDlist.get(objName)) ;
		fReflected2DecoderMap.put(objType,decodedObjectDecoders.get(index)) ;
		com.ibm.etools.jbcf.JBCFPlugin.log("ExpressionDecoderFactory.initialList() - adding "+decodedObjectNames.get(index),com.ibm.etools.jbcf.JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
		cleanList.add(objName) ;
	}
	// Remove those that became active
	for (Iterator iter = cleanList.iterator(); iter.hasNext();) 
	    tobeADDEDlist.remove(iter.next()) ;
	// Add those that became inactive, and are needed the next time around.
	for (Iterator iter = removedList.keySet().iterator(); iter.hasNext();) {
		String element = (String) iter.next();
		tobeADDEDlist.put(element,removedList.get(element)) ;
	}	
}



/**
 *  Resolve the Decoder
 */ 	
public static IExpressionDecoder getDecoder(IJavaInstance obj) {

	    initialList ((RefObject)obj) ;
	   
	    Class clazz = null ;
	    
	    EClassifier meta = (EClassifier) obj.getJavaType() ;
        String handle = ((JavaClassImpl)meta).getJavaName() ;
     
        clazz=(Class)fObj2DecoderMapCache.get(handle) ; 

        if (clazz == null) {  
    	    for (int i=0; i<decodedObjectReflectedClasses.size(); i++) 
    	    	if (((JavaHelpers)decodedObjectReflectedClasses.get(i)).isAssignableFrom(meta)) {	    		
    	            clazz = (Class) fReflected2DecoderMap.get(decodedObjectReflectedClasses.get(i)) ;                
    	            break ;
    	    	}
           if (clazz != null)
              fObj2DecoderMapCache.put(handle,clazz) ;
        }
	    if (clazz == null)	  // Use the vanilla decoder
	        clazz = (Class) fReflected2DecoderMap.get("noClue") ; //$NON-NLS-1$

	   
	    try {   		    	
	      Object newObject = clazz.newInstance() ;
	      return (IExpressionDecoder) newObject ;
	    }
	    catch (Exception e) {
	    	JBCFPlugin.log(e, JBCFMsgLogger.LOG_WARNING) ;
	    } ;
	  
	    return null ;
}	  
public static void clearCache() {
	currentRS = null ;	
	fReflected2DecoderMap = null ;
    fObj2DecoderMapCache = null ;
	decodedObjectReflectedClasses = null ;
}  
}