package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jdt.core.ISourceRange;

import com.ibm.etools.emf.notify.* ;
import com.ibm.etools.jbcf.codegen.util.CodeGenException;

public interface ICodeGenAdapter extends Adapter {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public final static Class VCE_CODE_GEN_TYPE = ICodeGenAdapter.class;  // Any Code Gen Adapter
	public final static Class JVE_CODEGEN_BEAN_PART_ADAPTER = BeanDecoderAdapter.class ;
	public final static Class JVE_CODEGEN_EXPRESSION_ADAPTER = ExpressionDecoderAdapter.class ;
	public final static Class JVE_CODEGEN_EXPRESSION_SOURCE_RANGE = ICodeGenSourceRange.class ; // Expression or Expresshio Shadow Adapter
	public final static Class JVE_CODEGEN_ANNOTATION_ADAPTER = AbstractAnnotationDecoder.class ;
	
	// Get code highlight offset/length. Useful for highlighting.
	public ICodeGenSourceRange getHighlightSourceRange() throws CodeGenException ;
	// Get the (java source) offset/length of the element the adapter is attached to.
	public ICodeGenSourceRange getJavaSourceRange() throws CodeGenException ;
    // Get BDM (Local) Source RAnge
	public ICodeGenSourceRange getBDMSourceRange() throws CodeGenException ;

}