package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jdt.internal.compiler.ast.MessageSend ;
import org.eclipse.jdt.internal.compiler.ast.Statement;

import com.ibm.etools.jbcf.codegen.model.* ;
import com.ibm.etools.jbcf.codegen.util.CodeGenException;
import com.ibm.etools.jbcf.codegen.* ;
import com.ibm.etools.emf.ref.RefStructuralFeature ;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance ;
import java.util.Vector ;


/**
 *   An expression decoder should be implemented to translate a java expression
 *   to a Composition model element/s and (in the future) vice versa.
 */
public interface IExpressionDecoder {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
   // A decode method will decode specific expressions.
   // If the expression was decoded, a true will be returned.
   // if a false is returned, the expression could not be decoded by
   // this decoder.
   public boolean decode () throws CodeGenException ;
   
   public Object determinePriority();
   
   // Generate the source
   public String generate(RefStructuralFeature sf, Object[] args) throws CodeGenException ;

   // At this time the Factory will construct decoders with a default constructor
   public void setExpression(CodeExpressionRef expr) ;
   public void setBeanModel(IBeanDeclModel model) ;
   public IBeanDeclModel getBeanModel() ;   
   public void setCompositionModel(IDiagramModelInstance cm) ;
   public IDiagramModelInstance getCompositionModel()  ;   
   public void setBeanPart(BeanPart part) ;
   public BeanPart getBeanPart() ;
   public boolean isDeleted()  ;
   public String getCurrentExpression() ;
   public String reflectExpression(String expSig) throws CodeGenException ;
   public void delete () ;
   public void dispose()  ;
   // Return a vector that contain a set of pair elements:
   // child component, the SF associated with the relationship of the child
   public Vector getChildren(IJavaObjectInstance component) ;
   public boolean isImplicit (Object[] args) ;
   public void reflectMOFchange ()  ;
   public RefStructuralFeature getSF() ;
   public void setSF (RefStructuralFeature sf) ;
   public void deleteFromComposition () ;
   public Object[] getArgsHandles(Statement expr) throws CodeGenException ;
   public CodeExpressionRef getExprRef() ;
   // is this decoder impacted by changes to this SF
   boolean isRelevantFeature (RefStructuralFeature sf) ;
   
   
   
   
   
   

}


