package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefStructuralFeature ;
import com.ibm.etools.java.instantiation.base.IJavaInstance ;
import org.eclipse.jdt.internal.compiler.ast.* ;
import com.ibm.etools.beaninfo.PropertyDecorator ;

/**
 *  An IFeatureMapper is a IExpressionDecoder helper which comes
 *  to provide java method to PropertyDecorator/SF mapping (and vice versa)
 */
public interface IJavaFeatureMapper {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static String  CONSTRAINT_BOUND = "setBounds" ;  //$NON-NLS-1$
public static String  CONSTRAINT_BOUND_FEATURE = "bounds" ;  //$NON-NLS-1$
public static String  CONSTRAINT_BOUND_CLASS = "java.awt.Rectangle" ; //$NON-NLS-1$

public static String  CONSTRAINT_SIZE =  "setSize" ; //$NON-NLS-1$
public static String  CONSTRAINT_SIZE_FEATURE =  "size" ; //$NON-NLS-1$
public static String  CONSTRAINT_SIZE_CLASS  = "java.awt.Dimension" ; //$NON-NLS-1$

public static String  CONSTRAINT_FEATURE_NAME = "constraints" ; //$NON-NLS-1$
public static String  COMPONENT_FEATURE_NAME = "components" ; //$NON-NLS-1$

public static String  JMENUBAR_FEATURE_NAME =	"menus" ; //$NON-NLS-1$
public static String  JMEN_FEATURE_NAME =		"items" ; //$NON-NLS-1$

public static String  LOCATION_FEATURE_NAME 	= "location" ; //$NON-NLS-1$
public static String  LOCATION_NAME 			= "setLocation" ; //$NON-NLS-1$

	
//  Given an expression, what is the SF.  The SF will be
//  calculated once, and cached from that point.	
public RefStructuralFeature	getFeature(Statement expr) ;
public void  setFeature(RefStructuralFeature sf) ;
public String getFeatureName() ;
public void setRefObject(IJavaInstance obj) ;
public IJavaInstance getRefObject() ;
public String getMethodName() ;
public String getIndexMethodName() ;
public String getReadMethodName() ;
public PropertyDecorator getDecorator() ;
public boolean isFieldFeature() ;
public int getPriorityIncrement(String methodName);

public static final int INTER_PRIORITY_GAP = 5;
public static final int INTER_LAYOUT_ADD_PRIORITIES_GAP = 5000; // Huge gap to allow children to prioritise themselves.

// Higher Values will come first in the code
public static final int PRIORITY_DEFAULT = 0;
public static final int PRIORITY_CONSTRAINT_CHANGE = PRIORITY_DEFAULT + INTER_PRIORITY_GAP;
public static final int PRIORITY_ADD_CHANGE = PRIORITY_CONSTRAINT_CHANGE + INTER_PRIORITY_GAP;
public static final int PRIORITY_LAYOUT_CHANGE = PRIORITY_ADD_CHANGE + INTER_LAYOUT_ADD_PRIORITIES_GAP;
public static final int PRIORITY_IMPLICIT = PRIORITY_LAYOUT_CHANGE + INTER_PRIORITY_GAP;

}