package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

/**
 *  To build a IBeanDeclModel, the JavaDecoder visits (parse) various
 *  parts of the code (Methods, Statements etc.)
 *  A ISourceVisitor may update the IBeanDeclModel and may call other Visitors.
 *  A ISourceVisitor may posponed its action to a second pass, if it can not resolve
 *  elements that have not been parsed yet.
 */
public interface ISourceVisitor {	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public void visit () ;
	// Do not allow the visitor to postpone its excecution.
	public void setNoRetry () ;
}