package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.jbcf.codegen.model.* ;
import com.ibm.etools.jbcf.codegen.util.* ;
import com.ibm.etools.jbcf.codegen.* ;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance ;
import com.ibm.etools.emf.ref.RefStructuralFeature ;
import java.util.* ;


public class JFrameDecoder extends AbstractCompositionalDecoder {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected final static  String CONTENT_PANE_METHOD = "setContentPane" ;	 //$NON-NLS-1$
protected final static  String GLASS_PANE_METHOD   = "setGlassPane" ; //$NON-NLS-1$
protected final static  String MENU_BAR_METHOD     = "setJMenuBar" ; //$NON-NLS-1$
protected final static  String LAYERED_PANE_METHOD = "setLayeredPane" ; //$NON-NLS-1$
protected final static  String ROOT_PANE_METHOD    = "setRootPane" ; //$NON-NLS-1$

// First element must be the SF/Method which has the true children.
protected final static String[] writeMethods = {
		CONTENT_PANE_METHOD, 
		GLASS_PANE_METHOD,
		MENU_BAR_METHOD,
		LAYERED_PANE_METHOD,
		ROOT_PANE_METHOD};
protected final static String[] structuralFeatures = {
		"contentPane", //$NON-NLS-1$
		"glassPane", //$NON-NLS-1$
		"JMenuBar", //$NON-NLS-1$
		"layeredPane", //$NON-NLS-1$
		"rootPane"}; //$NON-NLS-1$
/**
 *  A JPanel (maybe changing to Container ) Decoder will also add  ...
 *  May need to augment it with other features in the future
 */

public JFrameDecoder (CodeExpressionRef expr, IBeanDeclModel model, IDiagramModelInstance cm, BeanPart part) {
	super (expr, model, cm, part, structuralFeatures, writeMethods) ;
}

public JFrameDecoder() {	
	super (structuralFeatures, writeMethods) ;
}

protected IExpressionDecoderHelper getAppropriateDecoderHelper(String structuralFeature){
	return new DelegateRelationshipDecoderHelper(fbeanPart, fExpr,  fFeatureMapper, this);
}

/*
 * @see AbstractCompositionalDecoder#getAppropriateFeatureMapper(String)
 */
protected IJavaFeatureMapper getAppropriateFeatureMapper(String structuralFeature) {
	return null;
}

/**
 * @see com.ibm.etools.jbcf.codegen.java.AbstractCompositionalDecoder#isInternalPriorityCacheable()
 */
protected boolean isInternalPriorityCacheable() {
	return true;
}

}