package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.jbcf.codegen.IDiagramModelInstance;
import com.ibm.etools.jbcf.codegen.model.*;
import com.ibm.etools.jbcf.codegen.util.CodeGenUtil;

/**
 * @author gmendel
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class JMenuBarDecoder extends AbstractCompositionalDecoder {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected final static  String ITEM_METHOD = ADD_METHOD ;	 //$NON-NLS-1$

// First element must be the SF/Method which has the true children.
protected final static String[] writeMethods = {
		ITEM_METHOD
	};
public final static String[] structuralFeatures = {
		IJavaFeatureMapper.JMENUBAR_FEATURE_NAME 
	}; //$NON-NLS-1$
/**
 *  A JPanel (maybe changing to Container ) Decoder will also add  ...
 *  May need to augment it with other features in the future
 */

public JMenuBarDecoder (CodeExpressionRef expr, IBeanDeclModel model, IDiagramModelInstance cm, BeanPart part) {
	super (expr, model, cm, part, structuralFeatures, writeMethods) ;
}

public JMenuBarDecoder() {	
	super (structuralFeatures, writeMethods) ;
}

protected IExpressionDecoderHelper getAppropriateDecoderHelper(String structuralFeature){	
	RefStructuralFeature sf =  (RefStructuralFeature) fbeanPart.getRefObject().refMetaObject().metaObject(structuralFeature) ;  	 
	if (sf != null && isMethod(ITEM_METHOD,sf))
	    return new NoConstraintAddDecoderHelper(fbeanPart, fExpr,  fFeatureMapper,this) ;
	else
	    return null ;
}

/*
 * @see AbstractCompositionalDecoder#getAppropriateFeatureMapper(String)
 */
protected IJavaFeatureMapper getAppropriateFeatureMapper(String structuralFeature) {
	return new JMenuBarFeatureMapper() ;	
}

/**
 * @see com.ibm.etools.jbcf.codegen.java.AbstractCompositionalDecoder#isInternalPriorityCacheable()
 */
protected boolean isInternalPriorityCacheable() {
	return false;
}

}
