package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.jbcf.codegen.*;
import com.ibm.etools.jbcf.codegen.util.*;
import com.ibm.etools.jbcf.codegen.model.*;
import java.util.*;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.java.instantiation.base.*;

public class JScrollPaneDecoder 
	extends AbstractCompositionalDecoder{

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String SCROLLPANE_VIEWPORT_METHOD = "setViewportView"; //$NON-NLS-1$

// First element must be the SF/Method which has the true children.
protected static final String[] writeMethods = {SCROLLPANE_VIEWPORT_METHOD};
protected static final String[] structuralFeatures = {"viewportView"}; //$NON-NLS-1$

public JScrollPaneDecoder (CodeExpressionRef expr, IBeanDeclModel model, IDiagramModelInstance cm, BeanPart part) {
	super (expr, model, cm, part, structuralFeatures, writeMethods) ;
}

public JScrollPaneDecoder () {	
	super (structuralFeatures, writeMethods) ;
}

protected IExpressionDecoderHelper getAppropriateDecoderHelper(String structuralFeature){
	return new DelegateRelationshipDecoderHelper(fbeanPart, fExpr,  fFeatureMapper, this);
}
/*
 * @see AbstractCompositionalDecoder#getAppropriateFeatureMapper(String)
 */
protected IJavaFeatureMapper getAppropriateFeatureMapper(String structuralFeature) {
	return null;
}

/**
 * @see com.ibm.etools.jbcf.codegen.java.AbstractCompositionalDecoder#isInternalPriorityCacheable()
 */
protected boolean isInternalPriorityCacheable() {
	return true;
}

}