package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.jbcf.codegen.*;
import com.ibm.etools.jbcf.codegen.model.*;

/**
 * @version 	1.0
 * @author
 */
public class JSplitPaneDecoder 
	extends AbstractCompositionalDecoder {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String SPLITPANE_LEFT_METHOD = "setLeftComponent"; //$NON-NLS-1$
public static final String SPLITPANE_RIGHT_METHOD = "setRightComponent"; //$NON-NLS-1$
public static final String SPLITPANE_TOP_METHOD = "setTopComponent"; //$NON-NLS-1$
public static final String SPLITPANE_BOTTOM_METHOD = "setBottomComponent"; //$NON-NLS-1$

// First element must be the SF/Method which has the true children.
protected static final String[] writeMethods = {SPLITPANE_LEFT_METHOD, SPLITPANE_RIGHT_METHOD, SPLITPANE_TOP_METHOD, SPLITPANE_BOTTOM_METHOD};
protected static final String[] structuralFeatures = {"leftComponent", "rightComponent", "topComponent", "bottomComponent"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$

public JSplitPaneDecoder (CodeExpressionRef expr, IBeanDeclModel model, IDiagramModelInstance cm, BeanPart part) {
	super (expr, model, cm, part, structuralFeatures, writeMethods) ;
}

public JSplitPaneDecoder () {	
	super (structuralFeatures, writeMethods) ;
}

protected IExpressionDecoderHelper getAppropriateDecoderHelper(String structuralFeature){
	return new DelegateRelationshipDecoderHelper(fbeanPart, fExpr,  fFeatureMapper, this);
}
/*
 * @see AbstractCompositionalDecoder#getAppropriateFeatureMapper(String)
 */
protected IJavaFeatureMapper getAppropriateFeatureMapper(String structuralFeature) {
	return null;
}

/**
 * @see com.ibm.etools.jbcf.codegen.java.AbstractCompositionalDecoder#isInternalPriorityCacheable()
 */
protected boolean isInternalPriorityCacheable() {
	return true;
}

}
