package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import  org.eclipse.jdt.core.* ;

import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import  com.ibm.etools.jbcf.codegen.model.* ;
import  com.ibm.etools.jbcf.codegen.util.* ;
import  java.util.* ;
import  com.ibm.etools.emf.ref.* ;
import  com.ibm.etools.emf.notify.* ;

/**
 * This is used in the pull down save approach, and should be used for testing purpuses
 * @deprecated
 */
public class MethodAnalyzer {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected	IMethod           fMethod ;	
protected   IBeanDeclModel    fModel ;
protected   String            fSource  ;
protected   CodeMethodRef     fMethodRef ;
protected   String            flastFiller ;

	
public MethodAnalyzer (IMethod method, IBeanDeclModel model) {
	fModel = model ;
	fMethod = method ;
	if (fMethod != null)
	   try {
	     fSource = method.getSource() ;
	   } catch (Exception e) {
	   	 JBCFPlugin.log("MethodAnalyzer("+method.getElementName()+"): "+e, JBCFMsgLogger.LOG_WARNING) ; //$NON-NLS-1$ //$NON-NLS-2$
	   	 JBCFPlugin.log(e, JBCFMsgLogger.LOG_WARNING);
	   } 
	   
}


/**
 *   Find the next siebling of the method
 */
protected IMethod nextSiebling() throws JavaModelException {
	IMethod[] methods = fMethod.getDeclaringType().getMethods() ;
	for (int i=0; i<methods.length; i++) {
		if (methods[i].equals(fMethod))
		  if (i+1>=methods.length) return null ;
		  else return methods[i+1] ;
	}
	return null ;	
}
/**
 *  
 */
protected boolean hasContentChanged() {
	boolean result ;
	try {
       result = (!fMethodRef.getContent().equals(fMethod.getSource())) ;	
//       if (result) 
//		System.out.println("Content Changed:\n**Before\n"+fMethodRef.getContent()+"\n** After\n"+fMethod.getSource()) ;
	}
	catch (JavaModelException e) { return false; }
	
	return (result) ;
}

/**
 *
 */
protected void updateMethodContent(String newContent) throws CodeGenException {
	
	try {
	  ISourceRange sr = fMethod.getSourceRange() ;
	  // The compilation content will not be updated at this time, as to not shift
	  // offsets for follow on analyzors
        fMethodRef.setContent(newContent) ;
	}
	catch (JavaModelException e) {
		throw new CodeGenException(e) ;
	}

        
}
/**
 *  Delete the Expression from the Bean Decleration Model
 */
protected void removeDeletedExpressions(Vector list) {
	for (int i=0; i<list.size(); i++) {		
		fMethodRef.removeExpressionRef((CodeExpressionRef)list.elementAt(i)) ;		
		((CodeExpressionRef)list.elementAt(i)).getBean().removeRefExpression((CodeExpressionRef)list.elementAt(i)) ;
	}	
}

/**
 *  Reflect changes to existing source and record which beans have been worked on.
 *  @return offset last expression processed
 */
protected int reflectExistingSource(StringBuffer buf,Vector impactedBeans) throws CodeGenException {
	
	int left = 0, right = -1 ;  // Keep track where are we in the old source
	// Note the expressions are ordered by their offset		
	Iterator itr = fMethodRef.getExpressions() ;	
	Vector deleteCandidate = new Vector() ;
	
	if (itr.hasNext()) {      
		while (itr.hasNext()) {
		  CodeExpressionRef exp = (CodeExpressionRef) itr.next() ;
              // Copy source which has nothing to do with  bean expression
              if (!impactedBeans.contains(exp.getBean()))
                  impactedBeans.add(exp.getBean()) ;
              right = exp.getOffset() ;
              if (right < left)  throw new CodeGenException ("Bad expression offset") ; //$NON-NLS-1$
              if (right-left>0)
                buf.append(fSource.substring(left,right));
              left=right+exp.getLen() ; 
              // Get the latest expression 
String pc = exp.getContent() ;              
              exp.refreshFromComposition() ;
              exp.setOffset(buf.length()) ;
              if ((!exp.isAnyStateSet()) || exp.isStateSet(exp.STATE_NOT_EXISTANT)) { //(exp.getState() == exp.STATE_NOT_EXISTANT) {
            	// Skip the expression
            	com.ibm.etools.cde.CDEHack.fixMe("Need to deal with comments associated with statement") ; //$NON-NLS-1$
            	deleteCandidate.add(exp) ;
            	JBCFPlugin.log("\tDeleting: "+exp, JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
            	// Advance the left marker to the start of next expression
              }
              else 
                   if ((exp.isStateSet(exp.STATE_IN_SYNC)) && //((exp.getState() & exp.STATE_IN_SYNC)  >  0 && 
                       (!exp.isStateSet(exp.STATE_IMPLICIT))) { //(exp.getState() & exp.STATE_IMPLICIT) == 0) {
            	// Get the latest expression
            	buf.append(exp.getContent());            	
if (pc != null && !pc.equals(exp.getContent())) {
JBCFPlugin.log("\tUpdating: "+pc+" -> "+exp.getContent(), JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$ //$NON-NLS-2$
}
            	com.ibm.etools.cde.CDEHack.fixMe("clean this up") ; //$NON-NLS-1$
            	flastFiller = exp.getFillerContent() ;
              }            
		}
	}
	removeDeletedExpressions(deleteCandidate) ;
	
	if (flastFiller == null) flastFiller = "" ; //$NON-NLS-1$
	return left ;
}

/**
 *  Create a new Model element and a corresponding Java Source
 */
protected String GenerateAttribute(StringBuffer buf,RefStructuralFeature sf,BeanPart bean,int Offset, String filler) throws CodeGenException {
	CodeExpressionRef exp = new CodeExpressionRef(fMethodRef,bean) ;
	exp.setState(exp.STATE_EXIST, true); //exp.setState(exp.getState() | exp.STATE_EXIST) ;
	String src = exp.generateSource(sf) ;
	exp.setFillerContent(filler) ;
	exp.setOffset(Offset) ;
	return exp.getContent() ;
}

protected boolean isSourceExists(Notifier elm, RefObject bean, RefStructuralFeature sf) throws CodeGenException{
	boolean result = true ;
	if (elm != null) {
	   if (elm.getAdapter(ICodeGenAdapter.VCE_CODE_GEN_TYPE) == null)
	     result = false ;
	}
	else {
		BeanDecoderAdapter a = (BeanDecoderAdapter) bean.getAdapter(ICodeGenAdapter.JVE_CODEGEN_BEAN_PART_ADAPTER)  ;
		if (a == null) throw new CodeGenException("No Adapter"+bean) ; //$NON-NLS-1$
		if (a.getNullValuedAdapter(sf) == null)
		   result = false ;		
	}
    if (elm instanceof RefObject && 
		MethodTextGenerator.isNotToBeCodedAttribute(sf,bean))
		result = true ;

    return result ;
}

/**
 *  Look for added attributes
 *  
 */
protected void appendNewAttributes(StringBuffer buf,BeanPart bean,String filler) throws CodeGenException {
	RefObject obj = bean.getRefObject() ;
	Iterator itr = obj.refCurrentValues(true).iterator() ;
	while (itr.hasNext()) {
		Value val = (Value) itr.next() ;
		if (val.getValue() == null || val.getValue() instanceof Notifier)  {
		   Notifier elm = (Notifier) val.getValue() ;
		   if (!isSourceExists(elm,obj,val.getSF())) {
		    String src = GenerateAttribute(buf,val.getSF(),bean,buf.length(),filler) ;
		    if (src == null) throw new CodeGenException ("Could not Generate Source") ;	 //$NON-NLS-1$
		    JBCFPlugin.log ("\tAdding: "+src, JBCFMsgLogger.LOG_FINE) ;	       //$NON-NLS-1$
		    buf.append(src) ;		      	
		   }
		   
		}
	}	
}
/**
 *  Create a new Model element and a corresponding Java Source
 */
protected String GenerateAddComponent(StringBuffer buf,BeanPart bean,BeanPart child,int Offset,String filler) throws CodeGenException {
	CodeExpressionRef exp = new CodeExpressionRef(fMethodRef,bean) ;
	exp.setState(exp.STATE_EXIST, true); //exp.setState(exp.getState() | exp.STATE_EXIST) ;
	exp.setArguments(new Object[] {child} ) ;
	String src = exp.generateSource(CodeGenUtil.getComponentFeature(bean.getRefObject())) ;
	exp.setFillerContent(filler) ;
	exp.setOffset(Offset) ;
	return exp.getContent() ;
}


/**
 *  Look for new components added to bean
 *  
 */
protected void appendNewContainerSource(StringBuffer buf,BeanPart bean,String filler) throws CodeGenException, CodeGenInfoMissing {
	
	BeanDecoderAdapter bAdapter = (BeanDecoderAdapter) bean.getRefObject().getAdapter(ICodeGenAdapter.JVE_CODEGEN_BEAN_PART_ADAPTER) ;
	if (bAdapter == null) throw new CodeGenInfoMissing("MethodAnalyzer.appendNewContainerSource: "+bean+" - Adapter") ; //$NON-NLS-1$ //$NON-NLS-2$
		
	java.util.List children = CodeGenUtil.getChildrenComponents(bean.getRefObject()) ;
	if (children == null) return ;
	Iterator itr = children.iterator() ;
    while (itr.hasNext()) {
    	RefObject child = (RefObject)itr.next() ;
    	BeanPart bp = bean.getModel().getABean(child) ;
    	if (bp == null) throw new CodeGenInfoMissing("MethodAnalyzer.appendNewContainerSource: "+bean+" - BeanPart") ;    	 //$NON-NLS-1$ //$NON-NLS-2$
    	ICodeGenAdapter cAdapter = bAdapter.getChildAdapter(bp) ;
    	if (cAdapter == null) {
    		// A child that is not reflected in source code    	
		    String src = GenerateAddComponent(buf,bean,bp,buf.length(),filler) ;
		    if (src == null) throw new CodeGenException ("Could not Generate Source") ;	 //$NON-NLS-1$
		    JBCFPlugin.log ("\tAdding: "+src, JBCFMsgLogger.LOG_FINE) ;	       //$NON-NLS-1$
		    buf.append(src) ;	
    	}
    }
}

/**
 *  Look for information not already searilaized
 *  
 */
protected void appendNewSource(StringBuffer buf,BeanPart bean,String filler) throws CodeGenException, CodeGenInfoMissing {
	
	appendNewAttributes(buf,bean,filler) ;
	appendNewContainerSource(buf,bean,filler) ;

}


/**
 *   This function generate the latest Method source from the composition Model 
 *   It is assumed that the source has not
 *   changed since the last parsing.   If the source has changed, a null will be returned.
 */
public String getCompositionReflectedSource() throws CodeGenException {	
	
	if (fModel == null) throw new CodeGenException (fMethod.getElementName()+" is not in the model") ;	 //$NON-NLS-1$
	fMethodRef = fModel.getMethodInitializingABean(fMethod.getHandleIdentifier()) ;
	
	if (fMethodRef == null) return null ;
	JBCFPlugin.log("MethodAnalyzer: "+fMethod.getElementName()+"() - thinking ....", JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$ //$NON-NLS-2$
	// At this point we expect that the source has not changed yet.
//	if (hasContentChanged()) return null ;
	// re-construct in here 
	StringBuffer buf = new StringBuffer (2*fSource.length()) ;    
	// Keep track which beans are involved
	com.ibm.etools.cde.CDEHack.fixMe("this may not be the init method for a bean") ; //$NON-NLS-1$
	Vector beans = new Vector() ; 
	// Update existing source code  
	int srcOffset=reflectExistingSource(buf,beans) ;		
	
	com.ibm.etools.cde.CDEHack.fixMe() ;
	for (int i=0; i<beans.size(); i++) {
		appendNewSource(buf,(BeanPart)beans.elementAt(i),flastFiller) ;
	}
	// Copy the rest of the original source	
	buf.append(fSource.substring(srcOffset));	
      String proposedContent = buf.toString() ;
      if (!proposedContent.equals(fSource)) {
        JBCFPlugin.log ("                "+fMethod.getElementName()+"() - Updating Source", JBCFMsgLogger.LOG_FINE) ;         //$NON-NLS-1$ //$NON-NLS-2$
        updateMethodContent(proposedContent) ;        
      }
      else 
        JBCFPlugin.log ("                "+fMethod.getElementName()+"() - No Change", JBCFMsgLogger.LOG_FINE) ;           //$NON-NLS-1$ //$NON-NLS-2$
    return fMethodRef.getContent() ;	
}


public String toString() {
	return super.toString() + "\n" + fSource ; //$NON-NLS-1$
}


}