package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.jbcf.codegen.util.*;
import org.eclipse.jdt.internal.compiler.ast.*;
import org.eclipse.jdt.internal.compiler.ast.*;
import com.ibm.etools.jbcf.codegen.model.*;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFMsgLogger;
import com.ibm.etools.jbcf.codegen.java.rules.*;
import org.eclipse.jdt.internal.eval.CodeSnippetReturnStatement ;
import java.util.List ;



public class ReturnStmtVisitor extends SourceVisitor {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
CodeMethodRef             fMethod = null ;
ReturnStatement		  fReturnStmt = null ;
	

ReturnStmtVisitor(CodeMethodRef method,ReturnStatement stmt,IBeanDeclModel model,List reTryList) {
	super((AstNode)stmt,model,reTryList) ;	
	fMethod = method ;
	fReturnStmt = stmt ;
}
	
/**
 *  Process a Return Statement, 
 */
void processAReturnStatement() {
	
	Expression exp = fReturnStmt.expression ;
	
	if (exp instanceof SingleNameReference) {
		String value = new String (((SingleNameReference)exp).token) ;
		String localValue = BeanDeclModel.constructUniqueName(fMethod,value) ;		
		BeanPart bean  ;
		// It is possible that we have a local decleration with the same name of an 
		// instance variable.  If a local is defined, the return method is for it.
		bean = fModel.getABean(localValue) ;
		if (bean == null)
		   bean = fModel.getABean(value) ;
		if (bean != null) {
			bean.addReturnMethod(fMethod) ;
			try {
			  fModel.addMethodReturningABean(new String(fMethod.getDeclMethod().selector),bean.getUniqueName()) ;
			}
			catch (CodeGenException e) { // Should not be here
		      }
		}
	}
	
	
	
} 
 
	
/**
 *  Go for it
 */
public void visit(){
	
	IReturnStmtRule returnRule = (IReturnStmtRule) JavaPatternRuleFactory.getRule(IReturnStmtRule.RULE_ID) ;
	if (returnRule != null) {
		ISourceVisitor override = returnRule.overideReturnVisit(fMethod.getDeclMethod(),fReturnStmt,fModel) ;
		if (override != null) {
			override.visit() ;
			return ;
		}
	}
		
	if (!(fReturnStmt instanceof CodeSnippetReturnStatement) && 
		fReturnStmt instanceof ReturnStatement) 
	              processAReturnStatement () ;	
      else
        JBCFPlugin.log ("... did not process Expression:"+fReturnStmt, JBCFMsgLogger.LOG_FINE) ; //$NON-NLS-1$
	
	
}

}


