package com.ibm.etools.jbcf.codegen.java;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.notify.Notification;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFPlugin;
import com.ibm.etools.jbcf.codegen.model.BeanPart;
import com.ibm.etools.jbcf.codegen.model.CodeMethodRef;
import com.ibm.etools.jbcf.codegen.util.CodeGenException;

/**
 * @version 	1.0
 * @author
 */
public class ThisBeanDecoderAdapter extends BeanDecoderAdapter {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
    /**
     * Constructor for ThisBeanDecoderAdapter.
     * @param target
     * @param bean
     */
    public ThisBeanDecoderAdapter(Notifier target, BeanPart bean) {
        super(target, bean);
    }


protected boolean isAddingElement(Notification msg) {
    
    switch (msg.getEventType()) {
        case Notifier.SET:
        case Notifier.ADD:
        case Notifier.ADD_MANY:
        case Notifier.CREATE:
              return true ;
    }
    return false ;
}

protected void createInitMethodIfNedded() throws CodeGenException {
    
    CodeMethodRef m = fBean.getInitMethod() ;
    if (m == null) {
        BeanPartGenerator bg = new BeanPartGenerator(fBean.getModel(),fBean.getModel().getCompositionModel()) ;
        bg.generateThisInitMethod() ;
    }
    
}
    
/**
 * applied: A setting has been applied to the mof object,
 * notify the decoder
 */ 
public void notifyChanged(Notification msg){
    
    if (ignoreMsg(msg)) return ;
    if (isAddingElement(msg))
    try {
       createInitMethodIfNedded() ;
    }
    catch (CodeGenException e) {
        JBCFPlugin.log(e, JBCFMsgLogger.LOG_WARNING) ;
        return ;
    }
    super.notifyChanged(msg) ;
}

}
