package com.ibm.etools.jbcf.codegen.java.rules;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.jdt.internal.compiler.ast.*;
import com.ibm.etools.jbcf.codegen.java.ISourceVisitor;
import com.ibm.etools.jbcf.codegen.model.*;
/**
 *  Enable overides to the default visits to a method.  The implementor of
 *  this interface is responsible to provide an ISourceVisitor if a special
 *  visit is required for the given method.
 */
public interface IIfStatementRule {

	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
static String 	RULE_ID = "ruleIfStatement" ;	 //$NON-NLS-1$

static int		PROCESS_BOTH    = 0x3  ;
static int		PROCESS_IF      = 0x1  ;  // Do not look at the else part
static int		PROCESS_ELSE    = 0x2  ;  // Do not look at the if part
static int        PROCESS_NONE    = 0x0  ;  // Skip it all together.
static int        PROCESS_OVERIDE = -1 ;    // us overideMethodVisit()

          


/**
 * Unique method visits (like VAJ's "initialize()" method) can be used
 * @return ISourceVisitor - the object which will overide the method's visit
 */
public ISourceVisitor   overideIFVisit(AbstractMethodDeclaration method, IfStatement stmt, IBeanDeclModel model) ;
public int		      whichPartToProcess(AbstractMethodDeclaration method, IfStatement stmt) ;
	

}


