package com.ibm.etools.jbcf.codegen.java.rules;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jdt.internal.compiler.ast.AbstractMethodDeclaration ;
import com.ibm.etools.jbcf.codegen.java.ISourceVisitor ; 
import com.ibm.etools.jbcf.codegen.model.* ;

/**
 *  Enable overides to the default visits to a method.  The implementor of
 *  this interface is responsible to provide an ISourceVisitor if a special
 *  visit is required for the given method.
 */
public interface IOverideMethodVisitRule {

	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
static String RULE_ID = "ruleOverideMethod" ;	 //$NON-NLS-1$


/**
 * Unique method visits (like VAJ's "initialize()" method) can be used
 * @return ISourceVisitor - the object which will overide the method's visit
 *
 * May be used with connection type methods
 */
public ISourceVisitor overideMethodVisit(AbstractMethodDeclaration method, IBeanDeclModel model) ;
	



}