package com.ibm.etools.jbcf.codegen.java.rules;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.ITypeHierarchy;
import org.eclipse.jdt.internal.compiler.ast.*;

import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.resource.ResourceSet;
import com.ibm.etools.jbcf.codegen.java.ISourceVisitor;
import com.ibm.etools.jbcf.codegen.model.*;
/**
 *  this.setFoo() (or this.whoKnows()) is visited, - what toDo ?
 */
public interface IThisReferenceRule {

	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
static String 	RULE_ID = "ruleIThisReference" ;	 //$NON-NLS-1$

          


/**
 * Unique method visits (like VAJ's "initialize()" method) can be used
 * @return ISourceVisitor - the object which will overide the method's visit
 */
public ISourceVisitor   overideThisReferenceVisit(AbstractMethodDeclaration method, MessageSend stmt, IBeanDeclModel model) ;
//  Need to process these kind of statments only if the current type extends a bean we care about
public boolean      shouldProcess(AbstractMethodDeclaration method, MessageSend stmt) ;
//  Do we need to use inheritance
public boolean      useInheritance (String superClass, ResourceSet rs) ;
//  what is the name/modifier of the init metod for the this part
//  The return is an array of two string { name, modifier }
public String[] getThisInitMethodName(ITypeHierarchy h) ;
	

}


