package com.ibm.etools.jbcf.codegen.java.rules;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.* ;

import org.eclipse.core.runtime.*;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.Platform;



/**
 *  This is a hack, to be implemented later and allow a configurable mechanism
 *  to configure rule based pattern parsing 
 */
public class JavaPatternRuleFactory extends InstanceVariableRule {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
private static Hashtable  ruleClasses=null ;  
private static Hashtable  ruleCache=new Hashtable() ;
private static Hashtable  ruleType=new Hashtable() ;

public final static String RuleOverideID = "com.ibm.etools.jbcf.codegen.internal_rule_override" ; //$NON-NLS-1$


/**
 *  Hack for now,
 */ 	
private static void initialList() {
	if (ruleClasses != null) return ;
			
	ruleClasses = new Hashtable() ;
	ruleClasses.put(IInstanceVariableRule.RULE_ID,InstanceVariableRule.class) ; //$NON-NLS-1$
	ruleType.put(IInstanceVariableRule.RULE_ID,IInstanceVariableRule.class) ;
	
	ruleClasses.put(IMethodVariableRule.RULE_ID,InstanceVariableRule.class) ;	 //$NON-NLS-1$
	ruleType.put(IMethodVariableRule.RULE_ID,IMethodVariableRule.class) ;
	
	ruleClasses.put(IOverideMethodVisitRule.RULE_ID,OverideMethodVisitRule.class) ; //$NON-NLS-1$
	ruleType.put(IOverideMethodVisitRule.RULE_ID,IOverideMethodVisitRule.class) ;
	
    ruleClasses.put(IIfStatementRule.RULE_ID,IfStatementRule.class) ; //$NON-NLS-1$
    ruleType.put(IIfStatementRule.RULE_ID,IIfStatementRule.class) ;
        
    ruleClasses.put(IReturnStmtRule.RULE_ID,ReturnStmtRule.class) ; //$NON-NLS-1$
    ruleType.put(IReturnStmtRule.RULE_ID,IReturnStmtRule.class) ;
        
    ruleClasses.put(IThisReferenceRule.RULE_ID,ThisReferenceRule.class) ; //$NON-NLS-1$
    ruleType.put(IThisReferenceRule.RULE_ID,IThisReferenceRule.class) ;
        
    ruleClasses.put(IInstanceVariableCreationRule.RULE_ID,InstanceVariableCreationRule.class) ; //$NON-NLS-1$
    ruleType.put(IInstanceVariableCreationRule.RULE_ID,IInstanceVariableCreationRule.class) ;
    
    
    // Try to find the configuration element from the extension point 
	IExtensionPoint xp = Platform.getPluginRegistry().getExtensionPoint(RuleOverideID);
	
	if (xp != null) {						
		IExtension[] extensions = xp.getExtensions(); 
	  if (extensions.length>0) {
		for (int i=0;i < extensions.length; i++) {
			IConfigurationElement[] ces = extensions[i].getConfigurationElements();
			for (int j=0; j < ces.length; j++) {
				IConfigurationElement ce = ces[j];				
				if (ce.getName().equals("rule")) {   //$NON-NLS-1$
					try {
					  // <rule id="ruleInstanceVariable" class="my.rules.IntanceVairableRule"/>
					  String id = ce.getAttribute("id") ; //$NON-NLS-1$
					  Object rule = ce.createExecutableExtension("class") ; //$NON-NLS-1$
					  Class type = (Class) ruleType.get(id) ;
					  String pname = extensions[i].getDeclaringPluginDescriptor().getPlugin().getDescriptor().getUniqueIdentifier() ;
					  if (type != null &&  rule != null &&
					      (type.isAssignableFrom(rule.getClass()))) {
	                          com.ibm.etools.jbcf.JBCFPlugin.log("** Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " is overiding rule "+id, //$NON-NLS-1$
							                   com.ibm.etools.jbcf.JBCFMsgLogger.LOG_WARNING);
							ruleClasses.put(id,rule.getClass()) ;
					  }
					  else {
					  	  com.ibm.etools.jbcf.JBCFPlugin.log("** Plugin: "+pname+ //$NON-NLS-1$
	   		                                   " error overiding rule "+id, //$NON-NLS-1$
							                   com.ibm.etools.jbcf.JBCFMsgLogger.LOG_WARNING);
					  }
					}					      	        					      	
					catch (Throwable t) {
								com.ibm.etools.jbcf.JBCFPlugin.log(
									"Error overiding rule " + ce.getAttribute("id"), //$NON-NLS-1$ //$NON-NLS-2$ 
									com.ibm.etools.jbcf.JBCFMsgLogger.LOG_WARNING);
					}
				}
			}
		}
	  }
	}					
    	
}



/**
 *  Resolve the rule class
 */ 	
public static Object getRule(String ruleName) {
	
	   if (ruleClasses == null) initialList () ;
	
	    Object reUse = ruleCache.get(ruleName) ;
	    if (reUse != null) return reUse ;
	    try {   		    	
	      Class clazz = (Class) ruleClasses.get(ruleName) ;
	      Object newObject = clazz.newInstance() ;
	      if (newObject != null) ruleCache.put(ruleName,newObject) ;
	      return newObject ;
	    }
	    catch (Exception e) {} ;
	   return null ;
}

}