package com.ibm.etools.jbcf.codegen.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


public class AbstractBeanRelationship implements IBeanRelationship {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	BeanPart []		fRelatedBeans = null ;
	String		fName = null ;	
	IBeanDeclModel    fModel = null ;
	
public AbstractBeanRelationship(String name, BeanPart[] beans,IBeanDeclModel model) {
	fName = name ;
	fRelatedBeans = beans ;
	fModel = model ;
	fModel.addRelationship(this) ;
	for (int i=0; i<fRelatedBeans.length; i++) {
	    if (fRelatedBeans[i] != null)
         fRelatedBeans[i].addRelationship(this) ;
	}
	
}

public void deleteRelationship() {
	fModel.removeRelationship(this) ;
	for (int i=0; i<fRelatedBeans.length; i++) {
		if(fRelatedBeans[i]!=null)
			fRelatedBeans[i].removeRelationship(this) ;
	}
}

public String toString() {
	StringBuffer St = new StringBuffer() ;
	St.append(super.toString()+" : "+fName+" : ") ; //$NON-NLS-1$ //$NON-NLS-2$
	for (int i=0; i<fRelatedBeans.length; i++) {
		if (i>0) St.append(", ") ; //$NON-NLS-1$
		St.append(fRelatedBeans[i].toString()) ;
	}
	return St.toString() ;
}

}