package com.ibm.etools.jbcf.codegen.model;

import com.ibm.etools.jbcf.codegen.util.CodeGenException;

/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


public abstract class AbstractCodeRef {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
private     int            fsrcOffset,
                           fsrcLen ;
private     String         fContent ;										
										
public AbstractCodeRef(int Off,int Len, String Content) {
	fsrcOffset = Off ;
	fsrcLen = Len ;
	fContent = Content ;
}										

public AbstractCodeRef() {
  fsrcLen = fsrcOffset = -1 ;
  fContent = null ;	
}

/**
 *
 */
public int getOffset() {
	return fsrcOffset ;
}
public void setOffset (int off) {
	fsrcOffset = off ;
}
public int getLen() {
	return fsrcLen ;
} 

public String getContent() {
	return fContent ;
}

public void setContent(String content) {
	if (content == null) 
		fsrcLen = -1 ;
      else
            fsrcLen = content.length() ;                  
	fContent = content ;      
}

public String toString() {
	return super.toString() + ":" + fContent ; //$NON-NLS-1$
}

public abstract int isEquivalent(AbstractCodeRef codeRef) throws CodeGenException ;

}