package com.ibm.etools.jbcf.codegen.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.jdt.internal.compiler.ast.*;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import org.eclipse.jdt.core.*;
import java.util.* ;


public class CodeTypeRef {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
protected   CompilationUnitDeclaration  fdeclCU = null ;
protected   TypeDeclaration				fdeclType=null ;
protected   IType						fType = null ;
protected   ICompilationUnit			fCU = null ;
protected   String						fName ;
protected   IBeanDeclModel              fBeanModel ;
protected   Vector                      fMethods = new Vector () ;
	
public CodeTypeRef (String typeName, IBeanDeclModel model){
	fName = typeName;
	fBeanModel = model;
}

public CodeTypeRef (TypeDeclaration declType, IBeanDeclModel model) {
	fdeclType = declType ;
	fName = new String (declType.name) ;	
	fBeanModel = model ;
}	

public CodeTypeRef (CompilationUnitDeclaration declCU, IBeanDeclModel model) {
    this(declCU.types[0],model) ;	
	fdeclCU = declCU ;
}

public TypeDeclaration getTypeDecl() {
	return fdeclType ;
}

/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	return super.toString() + ":" + fName ; //$NON-NLS-1$
}

public IBeanDeclModel getBeanModel() {
	return fBeanModel ;
}

public void  addRefMethod(CodeMethodRef  method) {
	if (!fMethods.contains(method)) {
		fMethods.add(method) ;
	}
}

public void removeRefMethod (CodeMethodRef method) {
	fMethods.remove(method) ;
}

public Iterator getMethods() {
	return fMethods.iterator() ;
}

public String getName(){
	return fName;
}

public void dispose() {
	if (fMethods != null) {
		Object[] tmp = fMethods.toArray() ;
		for (int i=0; i<tmp.length; i++) {
			((CodeMethodRef)tmp[i]).dispose() ;
		}
	}
	fMethods.clear() ;
}


  


}


