package com.ibm.etools.jbcf.codegen.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

/**
 *  A Delegate Relationship is where a rootComponent composing a delegate component.
 *  e.g.,  a JPanel can be a delegate component of a JFrame's content pane.
 */
public class DelegatedComponentRelationship extends AbstractBeanRelationship {
	
   
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
   public DelegatedComponentRelationship (String attrName,BeanPart rootComponent, BeanPart delegComponent, IBeanDeclModel model) {
   	super(attrName, new BeanPart[] { rootComponent, delegComponent }, model) ;
   }
   
   public BeanPart getRootComponent() {
   	return fRelatedBeans[0] ;
   }   
   public BeanPart getDelegateComponent() {
   	return fRelatedBeans[1] ;
   }
   
   public void setDelegateComponent(BeanPart bean) {
   	getDelegateComponent().removeRelationship(this) ;
   	fRelatedBeans[1].addRelationship(this) ;
   }
   
   public void setRootComponent(BeanPart bean) {
   	getRootComponent().removeRelationship(this) ;
   	fRelatedBeans[0].addRelationship(this) ;
   }
   

}