package com.ibm.etools.jbcf.codegen.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.* ;
import com.ibm.etools.jbcf.codegen.util.* ;
import org.eclipse.jdt.internal.compiler.ast.TypeDeclaration ;
import org.eclipse.jdt.internal.compiler.ast.CompilationUnitDeclaration ;
import org.eclipse.jdt.core.ICompilationUnit ;
import org.eclipse.jdt.core.ITypeHierarchy;

import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;
import com.ibm.etools.jbcf.codegen.* ;
import com.ibm.etools.emf.ref.RefObject ;
import org.eclipse.jface.text.IDocument ;
import com.ibm.etools.jbcf.codegen.java.* ;

public interface IBeanDeclModel extends ITypeResolver{
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public final  int           BDM_STATE_DOWN            	= 0x1 ;	
	public final  int           BDM_STATE_UP_AND_RUNNING  	= 0x2 ;
	public final  int           BDM_STATE_UPDATING_JVE_MODEL	= 0x4 ;
	public final  int           BDM_STATE_SNIPPET     		= 0x8 ;
	
	public Vector getBeans() ;
	public void addBean (BeanPart bean) ;
	public void addMethodReturningABean(String method,String beanName) throws CodeGenException ;
	public BeanPart getABean(String name) ;
	public BeanPart getABean(RefObject obj) ;	
	public BeanPart getBeanReturned(String methodName) ;
	public TypeDeclaration getTypeDecleration()  ;
	public void setTypeDecleration(TypeDeclaration decl)  ;
	public void setJDOM(CompilationUnitDeclaration dom)  ;
	public CompilationUnitDeclaration getJDOM() ;
	public IDiagramModelInstance getCompositionModel() ;
	public void setCompositionModel(IDiagramModelInstance cm) ;	
	public ICompilationUnit getCompilationUnit() ;
	public IDocument getDocument() ;	
	public Object getDocumentLock() ;	
	public void addMethodInitializingABean (CodeMethodRef methodRef) ;
	public CodeMethodRef getMethodInitializingABean (String methodHandle) ;
	public CodeTypeRef getTypeRef() ;
	public void setTypeRef (CodeTypeRef tr) ;
    public BeanPart[] getBeansInializedByMethod(String methodHandle) ;
    public void removeBeanFromRoot (BeanPart bean) ;
    public void removeBean (BeanPart bean) ;
    public void removeMethodRef(CodeMethodRef mr) ;
    public void UpdateRefObjKey(BeanPart bean,RefObject prev) ;
    public void addRelationship(IBeanRelationship rel) ;
    public void removeRelationship(IBeanRelationship rel) ;
    public String resolveSingleNameReference(String selector, int location);
    public void setLineSeperator(String sep) ;
    public String getLineSeperator() ;
    public void setWorkingCopyProvider(IWorkingCopyProvider wcp) ;
	public IWorkingCopyProvider getWorkingCopyProvider() ;
	public void updateJavaSource (String elementHandle) ;
	public void setState(int flag, boolean state) throws CodeGenException ;
    public boolean isStateSet(int state) ;
    public void dispose() ;
    public void setSourceSynchronizer(JavaSourceSynchronizer sync) ;
    public void designateAsDelete(BeanPart bean) ;    
    public BeanPart getDeleteDesignated(IJavaObjectInstance obj, boolean remove) ;
    public void deleteDesignatedBeans() ;
    public Vector getRootBeans() ;
    public ITypeHierarchy getClassHierarchy()  ;
    public Collection getBeansInitilizedByMethod(CodeMethodRef mref) ;
    public void updateBeanNameChange(BeanPart bp) ;
	public ICodeGenStatus getFStatus() ;
	public void setFStatus(ICodeGenStatus fStatus) ;
	
}
      
	
