package com.ibm.etools.jbcf.codegen.model;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.* ;

/**
 * Contains change information for a reference method
 */
public interface ICodeDelta {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final int CODE_TYPE_EXPRESSION = 0x01;
public static final int CODE_TYPE_METHOD = 0x02;
public static final int CODE_TYPE_FIELD = 0x04;
public static final int CODE_TYPE_IMPORT = 0x08;
public static final int CODE_TYPE_TYPE = 0x10; 

public static final int ELEMENT_NO_CHANGE       =  0x01 ;
public static final int ELEMENT_DELETED         =  0x02; 
public static final int ELEMENT_ADDED           =  0x04; 
public static final int ELEMENT_CHANGED         =  0x08; 
public static final int ELEMENT_UPDATED_OFFSETS =  0x10;
public static final int ELEMENT_UNDETERMINED    =  0x20;

public CodeMethodRef getDeltaMethod () ;

public BeanPart  getDeltaField() ;

public int getElementStatus(AbstractCodeRef element) ;

public List getDeletedElements(AbstractCodeRef element) ;

public int getElementStatus(BeanPart element) ;



}