package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


public class BlockTemplate {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String LBRACE =    "{" ; //$NON-NLS-1$
public static final String RBRACE =    "}" ; //$NON-NLS-1$


	
	int                   fIndent=5 ;	
	int                   fexpIndet=5 ;
	ExpressionTemplate[]  fexpressions = null ;

public BlockTemplate(ExpressionTemplate[] exp, int indent) {
	fexpressions = exp;
	fIndent = indent ;
}

public void setExpressions (ExpressionTemplate[] exp) {
	fexpressions = exp ;
}	
public void setExpression(ExpressionTemplate exp) {
	fexpressions = new ExpressionTemplate[] { exp } ;
}
public void setIndent(int i) { fIndent = i; } ; 
	

protected void punchLine(StringBuffer sb,Object content) {
	for (int i=0; i<fIndent; i++)
	  sb.append(ExpressionTemplate.SPACE) ;
	sb.append(content.toString()) ;
	sb.append(System.getProperty("line.separator")) ; //$NON-NLS-1$
}	
	
/**
 *  This assumes that Statement was generated by this template.
 */
public String toString() {
	
	if (fexpressions == null) return null ;
	StringBuffer sb = new StringBuffer() ;
	punchLine(sb,LBRACE) ;
	for (int i=0; i<fexpressions.length; i++) {
		fexpressions[i].setIndent(fexpIndet) ;
		punchLine(sb,fexpressions[i]) ;
	}
	punchLine(sb,RBRACE) ;  
	return sb.toString() ;    
}		




}