package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

public class CodeTemplateHelper {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String DEFAULT_FILLER = "\t"; //$NON-NLS-1$

public static String getFillerForLevel(int level){
	if(level<=0)
		return ""; //$NON-NLS-1$
	String filler = new String();
	for(int i=0;i<level;i++)
		filler = filler.concat(DEFAULT_FILLER);
	return filler;
}

public static int NORMAL_METHOD_DEF_LEVEL = 1;
public static int NORMAL_METHOD_CONTENT_LEVEL = 2;
public static int NORMAL_IF_DEF_LEVEL = NORMAL_METHOD_CONTENT_LEVEL;
public static int NORMAL_IF_CONTENT_LEVEL = 3;
public static int NORMAL_TRY_DEF_LEVEL = NORMAL_IF_CONTENT_LEVEL;
public static int NORMAL_TRY_CONTENT_LEVEL = 4;

public static int getCharLength(String src){
	char[] chars = src.toCharArray();
	int length = 0;
	for(int i=0;i<chars.length;i++){
		if(chars[i]=='\t')
			length+=4;
		else
			length++;
	}
	return length;
}

}
