package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jdt.core.*;
import org.eclipse.jdt.core.ICompilationUnit ;
import org.eclipse.jdt.core.ISourceRange;
import org.eclipse.jdt.core.ITypeHierarchy;
import org.eclipse.ui.IFileEditorInput ;
import org.eclipse.core.resources.IFile ;
import org.eclipse.core.runtime.IProgressMonitor ;
import org.eclipse.jface.text.IDocument;
import java.util.* ;

import com.ibm.etools.jbcf.codegen.java.ITypeResolver;

import org.eclipse.jface.text.IDocumentListener ;



public interface IWorkingCopyProvider extends ITypeResolver{


 
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
 public ICompilationUnit getSharedWorkingCopy() ;
 public ICompilationUnit getSharedWorkingCopy(boolean forceReconcile) ;
 public ICompilationUnit getLocalWorkingCopy() ;
 
 public IFileEditorInput getEditor() ;
 public IFile getFile() ;
 
 public IDocument getSharedDocument() ;
 public IDocument getLocalDocument() ;
 public Object    getLocalDocLock() ;
 
 /**
  * Disconnect from the Shared/Local providers.
  */
 public void disconnect() ;
 /**
  * ReConnect to the Shared/Local providers.
  * @param new (or same) input file.
  */
 public void reconnect(IFile file) ;
 
 
 public void ReplaceWithLocalContent(IProgressMonitor pm, boolean commit) throws CodeGenException ; 
 public void UpdateDeltaToShared(ICancelMonitor pm, IDocumentListener docListener, List handles, boolean commit) throws CodeGenException ;
 
 public void aboutToChangeShared() ;
 public void changeCompleteShared() ;
 public ISourceRange getSharedSourceRange(String handle) ;
 public int getSharedLineNo(int Offset) ;
 public ITypeHierarchy getHierarchy() ;
 
 
 
 public void dispose() ;
 
 
}