package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


public class IfTemplate {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String IF =    "if" ; //$NON-NLS-1$

	
	int fIndent = 5;
	
	BlockTemplate ifPart  ;
	String        fExpression ;
	int           fBlockIndent = 5 ;

public void setIndent(int i) { fIndent = i; } ; 

public IfTemplate (BlockTemplate ifPart, String exp) {
	this.ifPart = ifPart ;
	fExpression = exp ;
}

protected void punchLine(StringBuffer sb,Object content) {
	for (int i=0; i<fIndent; i++)
	  sb.append(ExpressionTemplate.SPACE) ;
	sb.append(content.toString()) ;
	sb.append(System.getProperty("line.separator")) ; //$NON-NLS-1$
}	
	          

public String toString() {
	
	if (ifPart == null) return "" ; //$NON-NLS-1$
	
	StringBuffer sb = new StringBuffer () ;
	ifPart.setIndent(fIndent+fBlockIndent) ;
	punchLine(sb,IF+ExpressionTemplate.SPACE+ExpressionTemplate.LPAREN+fExpression+ExpressionTemplate.RPAREN+ExpressionTemplate.SPACE+BlockTemplate.LBRACE);
	sb.append(ifPart.toString()) ;	
	
	punchLine(sb,BlockTemplate.RBRACE) ;
	return sb.toString() ;
	
}



}