package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
/**
 * @version 	1.0
 * @author
 */
public class NullConstructorTemplate extends BeanMethodTemplate {


	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
    public static final String MODIFIER =        "public" ; //$NON-NLS-1$
    public static final String SUPER = 			"super();" ; //$NON-NLS-1$
    public static        String DEFAULT_INIT_EXP_FILLER = null ; ; //$NON-NLS-1$
    
    String  fsuperInitString = SUPER ;
    /**
     * Constructor for NullConstructorTemplate.
     * @param btype
     * @param bname
     * @param mname
     * @param comments
     */
    public NullConstructorTemplate(
        String btype,
        String bname,
        String mname,
        String[] comments) {
        super(btype, bname, mname, comments);
    }
    
    public void setSuperInitString(String sig) {
        fsuperInitString = sig ;
    }
    
public   String getPrefix() {
	StringBuffer sb = new StringBuffer(1000) ;
	  // Method Comment
      punchLine(sb,COMMENT_BEG,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
      punchLine(sb,COMMENT+VCE_COMMENT,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
      punchLine(sb,COMMENT,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
      if (fComments != null) {
         for (int i=0; i<fComments.length; i++)
            punchLine(sb,COMMENT+fComments[i],CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
         punchLine(sb,COMMENT,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
      }      
      punchLine(sb,COMMENT_END,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
      
      // Method Decleration

        punchLine(sb,MODIFIER+
                  ExpressionTemplate.SPACE+fMethodName+ExpressionTemplate.LPAREN+
                  ExpressionTemplate.RPAREN+ExpressionTemplate.SPACE+BlockTemplate.LBRACE,
                  CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;

      // Super
      
      punchLine(sb,fsuperInitString,CodeTemplateHelper.NORMAL_METHOD_CONTENT_LEVEL) ;
      return sb.toString() ;
      
}    

public static String getInitExprFiller() {
	if (DEFAULT_INIT_EXP_FILLER == null) {
        DEFAULT_INIT_EXP_FILLER = 	CodeTemplateHelper.DEFAULT_FILLER+
                                    CodeTemplateHelper.getFillerForLevel(CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
    }
    return DEFAULT_INIT_EXP_FILLER ;
        
}

public String getPostfix() {
   StringBuffer sb = new StringBuffer() ;		
	
   com.ibm.etools.cde.CDEHack.fixMe() ;
   // catch
   punchLine(sb,null,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;
   punchLine(sb,BlockTemplate.RBRACE,CodeTemplateHelper.NORMAL_METHOD_DEF_LEVEL) ;  
   return sb.toString() ; 	   	
}

}
