package com.ibm.etools.jbcf.codegen.util;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


public class TryTemplate  {
	

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public static final String TRY =    "try" ; //$NON-NLS-1$
public static final String CATCH =    "catch" ; //$NON-NLS-1$


	
	BlockTemplate tryPart=null,
	              catchPart=null ;
	int           fIndent = 5 ;
	int           fBlockIndent = 5 ;
	String        fException ;

public TryTemplate(BlockTemplate tryP, BlockTemplate catchP,String excep, int i) {
	tryPart = tryP ;
	catchPart = catchP ;
	fIndent = i ;
	fException = excep ;
}
	
public void setIndent(int i) { fIndent = i; } ; 

protected void punchLine(StringBuffer sb,Object content) {
	for (int i=0; i<fIndent; i++)
	  sb.append(ExpressionTemplate.SPACE) ;
	sb.append(content.toString()) ;
	sb.append(System.getProperty("line.separator")) ; //$NON-NLS-1$
}	
	          

public String toString() {
	
	if (tryPart == null) return "" ; //$NON-NLS-1$
	
	StringBuffer sb = new StringBuffer () ;
	tryPart.setIndent(fIndent+fBlockIndent) ;
	punchLine(sb,TRY+ExpressionTemplate.SPACE+BlockTemplate.LBRACE);
	sb.append(tryPart.toString()) ;
	
	catchPart.setIndent(fIndent+fBlockIndent) ;
	punchLine(sb,CATCH+ExpressionTemplate.LPAREN+fException+ExpressionTemplate.RPAREN+ExpressionTemplate.SPACE+BlockTemplate.LBRACE) ;
	sb.append(catchPart.toString()) ;
	
	punchLine(sb,BlockTemplate.RBRACE) ;
	return sb.toString() ;
	
}


}