package com.ibm.etools.jbcf.editorpart;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.SWT;
import org.eclipse.ui.part.*;
import org.eclipse.ui.*;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.jbcf.*;
import org.eclipse.ui.views.contentoutline.*;
import java.util.*;

public class BeansList extends ContentOutline {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$

protected PageRec doCreatePage(IWorkbenchPart part) {
	// Try to get a beans list
	Object obj = part.getAdapter(this.getClass());
	if (obj instanceof IContentOutlinePage) {
		IContentOutlinePage page = (IContentOutlinePage)obj;
		if (page instanceof IPageBookViewPage) 
			initPage((IPageBookViewPage)page);
		page.createControl(getPageBook());
		return new PageRec(part, page);
	}
	// There is no beans list
	return null;
}
protected IPage createDefaultPage(PageBook book) {
	MessagePage msgPage = (MessagePage) super.createDefaultPage(book);
	msgPage.setMessage(CodegenEditorPartMessages.getString("BeansList.DefaultPageMessage")); //$NON-NLS-1$
	return msgPage;
}
}