package com.ibm.etools.jbcf.editorpart;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import java.io.NotSerializableException;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.jface.action.ContributionItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.texteditor.StatusLineContributionItem;

import com.ibm.etools.cde.CDEPlugin;

/**
 * @author gmendel
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class JVEActionStatusLineContributionItem extends ContributionItem implements IJVEActionField {
	
	
		
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private Label fUpLabel ;	
	private boolean fUpFlag = false ;
	private static String MSG_SYNC_MODEL		= CodegenEditorPartMessages.getString("JVE_STATUS_BAR_MSG_SYNC_CANVAS") ; //$NON-NLS-1$
	private Label fDownLabel ;
	private static String MSG_SYNC_SRC		= CodegenEditorPartMessages.getString("JVE_STATUS_BAR_MSG_SYNC_SOURCE") ; //$NON-NLS-1$
	private boolean fDownFlag = false ;
	
	private String fPauseHoverText=null ;
	public  static String MSG_PUSH_TO_PAUSE 	= CodegenEditorPartMessages.getString("JVE_STATUS_BAR_MSG_STOP_RT") ; //$NON-NLS-1$
	public  static String MSG_PUSH_TO_PLAY 	= CodegenEditorPartMessages.getString("JVE_STATUS_BAR_MSG_RESUME_RT") ; //$NON-NLS-1$
	public  static String MSG_PARSING_ERROR   =  CodegenEditorPartMessages.getString("JVE_STATUS_BAR_MSG_PARSE_ERROR") ; //$NON-NLS-1$
	private Button fPauseButton ;
	private boolean fPauseFlag = false ;
	private boolean fErrorFlag = false ;
	
	
	private MouseListener fPauseListener=null ;
	private Composite     fParent ;
	
	protected Timer guiSrcTimer = new Timer(true);
	
	// Set up the varous images	
	static Image fsrc2guiImage[] = new Image[4];
	static String[] fsrc2guiImageURL = { 
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/src2gui.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/src2gui1.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/src2gui2.gif", //$NON-NLS-1$		
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/src2gui3.gif" //$NON-NLS-1$		
	};
	protected TimerTask fsrc2guiTick;

	static Image fgui2srcImage[] = new Image[4];
	static String[] fgui2srcImageURL = { 
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/gui2src.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/gui2src1.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/gui2src2.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/gui2src3.gif" //$NON-NLS-1$				
	};
	protected TimerTask fgui2srcTick;
	
	static Image fPauseImage[] = new Image[3];
	static String fPauseImageURL[] = { 
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/pause.gif", //$NON-NLS-1$
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/play.gif", //$NON-NLS-1$			
		"platform:/plugin/com.ibm.etools.jbcf/icons/full/cview16/error_obj.gif" //$NON-NLS-1$			
	};
	static {
		for (int i = 0; i < fsrc2guiImage.length; i++)
			fsrc2guiImage[i] = CDEPlugin.getImageFromURLString(fsrc2guiImageURL[i]);
		for (int i = 0; i < fgui2srcImage.length; i++)
			fgui2srcImage[i] = CDEPlugin.getImageFromURLString(fgui2srcImageURL[i]);
		for (int i = 0; i < fPauseImage.length; i++)
			fPauseImage[i] = CDEPlugin.getImageFromURLString(fPauseImageURL[i]);
			
	}
		
		
    class  debugMouseListener implements MouseListener  {
    	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
    	/**
		 * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(MouseEvent)
		 */
		public void mouseDoubleClick(MouseEvent e) {
			System.out.println("No Listener on this button !!!!") ;			 //$NON-NLS-1$
		}

		/**
		 * @see org.eclipse.swt.events.MouseListener#mouseDown(MouseEvent)
		 */
		public void mouseDown(MouseEvent e) {
			System.out.println("No Listener on this button !!!!") ; //$NON-NLS-1$
		}

		/**
		 * @see org.eclipse.swt.events.MouseListener#mouseUp(MouseEvent)
		 */
		public void mouseUp(MouseEvent e) {
			System.out.println("No Listener on this button !!!!") ; //$NON-NLS-1$
		}

}

	/**
	 * Constructor for JVEStatusLineContributionItem.
	 * @param id
	 */
	public JVEActionStatusLineContributionItem(String id) {
		super(id);		
		fPauseListener =  new debugMouseListener() ;
	}
		
	/**
	 * dispose - called when contributor is no longer needed.
	 */
	public synchronized void dispose() {
		guiSrcTimer.cancel();	// Force a quick stop of the timer		
		guiSrcTimer = null;		
	}	
	
	/*
	 * @see IContributionItem#fill(Composite)
	 */
	public void fill(Composite parent) {

//      Group's frame takes space for the title :(
//		
//		Group group = new Group(parent,SWT.SHADOW_IN);
//		GridLayout gridLayout = new GridLayout();
//		gridLayout.numColumns = 3 ;
//		gridLayout.marginHeight = 0 ;	
//		gridLayout.verticalSpacing=1 ;
//		group.setLayout(gridLayout);
//	
//		
//	    GridData data = new GridData();
//	    data.verticalAlignment = GridData.FILL;
//	    data.horizontalAlignment = GridData.FILL;
//	    data.grabExcessVerticalSpace = true ;
//	    group.setLayoutData(data);		
		
		fParent = parent ;
		Composite Root = new Composite(parent, SWT.SHADOW_IN);
		GridData data = new GridData(GridData.FILL_BOTH) ;
		Root.setLayoutData(data) ;
		

		GridLayout gridLayout = new GridLayout();		
		gridLayout.numColumns = 3;
		gridLayout.marginHeight = 0 ;		
		Root.setLayout(gridLayout);

		fUpLabel = new Label(Root, SWT.CENTER|SWT.SHADOW_IN);
		data = new GridData(GridData.VERTICAL_ALIGN_CENTER|GridData.HORIZONTAL_ALIGN_CENTER);
		fUpLabel.setLayoutData(data);

		fPauseButton = new Button(Root, SWT.CENTER|SWT.TOGGLE);	     
		data = new GridData(GridData.VERTICAL_ALIGN_CENTER|GridData.HORIZONTAL_ALIGN_CENTER);
		fPauseButton.setLayoutData(data);
		if (fPauseListener != null)
		   fPauseButton.addMouseListener(fPauseListener) ;

		fDownLabel = new Label(Root, SWT.CENTER|SWT.SHADOW_IN);
		data = new GridData(GridData.VERTICAL_ALIGN_CENTER|GridData.HORIZONTAL_ALIGN_CENTER);
		fDownLabel.setLayoutData(data);

		fDownLabel.setToolTipText(MSG_SYNC_SRC) ;
		fUpLabel.setToolTipText(MSG_SYNC_MODEL) ;

        setModel2Src(fDownFlag)  ;
        setSrc2Model(fUpFlag) ;
        if (fErrorFlag)
           setError(fErrorFlag) ;
        else
           setPause(fPauseFlag) ;
        setPauseListener(fPauseListener) ;
	}

	public void setPauseListener(MouseListener listener) {
		if (listener == fPauseListener) return ;
		if (fPauseButton != null && !fPauseButton.isDisposed()) {
			if (fPauseListener != null)
			   fPauseButton.removeMouseListener(fPauseListener) ;
			fPauseListener = listener;
			if (fPauseListener!=null)
			   fPauseButton.addMouseListener(fPauseListener) ;			
		}		
	}
	
	
	/**
	 * @see com.ibm.etools.jbcf.editorpart.IJVEActionField#setModel2Src(boolean)
	 */
	public synchronized void setModel2Src(boolean flag) {
		fDownFlag = flag ;
		if (guiSrcTimer == null || fDownLabel == null || fDownLabel.isDisposed()) return ;
		if (flag) {
			if (fgui2srcTick == null) {
				// For showing that the update is in place we animate a series of icons to give the 
				// appearance of movement along the arrow.  Because SWT doesn't automatically animate an
				// animated GIF for you we must do this by hand with a  tick thread that repeats every 300ms				
				final Display display = fDownLabel.getDisplay();
				fgui2srcTick = new TimerTask(){
					protected int imageNumber = 1;
					public void run(){
						display.syncExec(new Runnable(){
							public void run(){
								if (!fDownLabel.isDisposed())
									fDownLabel.setImage(fgui2srcImage[imageNumber]);
								else
									cancelgui2src();	// Label is disposed, so cancel the task.
							}
						});
						imageNumber++;
						if(imageNumber > 3)imageNumber = 1;
					}
				};
				guiSrcTimer.schedule(fgui2srcTick,0,250);			
			}
		} else { 
			cancelgui2src();		
		}						
	}

	private void cancelgui2src() {
		// We need to revert to the default image and also stop the timer task
		if ( fgui2srcTick != null){
			fgui2srcTick.cancel();
			fgui2srcTick = null;
		}
		// Set the image if it isn't already the default image
		if (!fDownLabel.isDisposed() && fgui2srcImage[0] != fDownLabel.getImage()){
		   fDownLabel.setImage(fgui2srcImage[0]) ;	
		}	
	}

	/**
	 * @see com.ibm.etools.jbcf.editorpart.IJVEActionField#setPause(boolean)
	 */
	public void setPause(boolean flag) {
		fPauseFlag = flag ;
		if (fPauseButton == null || fPauseButton.isDisposed()) return ;
		if (flag) {
			if (!fPauseButton.getSelection())
			   fPauseButton.setSelection(true) ;
			if (fPauseImage[1] != fPauseButton.getImage())
			    fPauseButton.setImage(fPauseImage[1]) ;
			fPauseButton.setToolTipText(MSG_PUSH_TO_PLAY) ;
		}
		else {
			if (fPauseButton.getSelection())
			   fPauseButton.setSelection(false) ;
			if (fPauseImage[0] != fPauseButton.getImage())
			   fPauseButton.setImage(fPauseImage[0]) ;			
			fPauseButton.setToolTipText(MSG_PUSH_TO_PAUSE) ;
		}
	}
	/**
	 * @see com.ibm.etools.jbcf.editorpart.IJVEActionField#setSrc2Model(boolean)
	 */
	public synchronized void setSrc2Model(boolean flag) {
		fUpFlag = flag ;
		if (guiSrcTimer == null || fUpLabel == null || fUpLabel.isDisposed()) return ;
		if (flag) {
			if (fsrc2guiTick == null) {
				// For showing that the update is in place we animate a series of icons to give the 
				// appearance of movement along the arrow.  Because SWT doesn't automatically animate an
				// animated GIF for you we must do this by hand with a  tick thread that repeats every 300ms
				final Display display = Display.getCurrent();
				fsrc2guiTick = new TimerTask(){
					protected int imageNumber = 1;
					public void run(){
						display.syncExec(new Runnable(){
							public void run(){
								// check to see if it has been canceled (tell by the variable going null)
								// If it has been canceled we don't want to go ahead and set the image.
								// It would leave it in the wrong state.
								// It is ok to just check the variable because it is only changed within
								// the UI thread, either via setSrc2Model or through the cancel call below.
								if (fsrc2guiTick != null)
									if (!fUpLabel.isDisposed())
										fUpLabel.setImage(fsrc2guiImage[imageNumber]);							
									else
										cancelsrc2gui();	// Label is disposed, so cancel the task.
							}
						});
						imageNumber++;
						if(imageNumber > 3)imageNumber = 1;
					}
				};
				guiSrcTimer.schedule(fsrc2guiTick,0,250);
			}
		} else {
			cancelsrc2gui();
		}
	}

	private void cancelsrc2gui() {
		// We need to revert to the default image and also stop the timer
		if ( fsrc2guiTick != null){
			fsrc2guiTick.cancel();
			fsrc2guiTick = null;
		}
		// Set the image if it isn't already the default image
		if (!fUpLabel.isDisposed() && fsrc2guiImage[0] != fUpLabel.getImage()){
		   fUpLabel.setImage(fsrc2guiImage[0]) ;	
		}
	}
	/**
	 * @see com.ibm.etools.jbcf.editorpart.IJVEActionField#setError(boolean)
	 */
	public void setError(boolean flag) {
		fErrorFlag = flag ;
		if (fPauseButton == null || fPauseButton.isDisposed()) return ;
		if (flag) {
			if (!fPauseButton.getSelection())
			   fPauseButton.setSelection(true) ;
			if (fPauseImage[2] != fPauseButton.getImage())
			    fPauseButton.setImage(fPauseImage[2]) ;
			fPauseButton.setToolTipText(MSG_PARSING_ERROR) ;
		}
		else {
			if (fPauseButton.getSelection())
			   fPauseButton.setSelection(false) ;
			if (fPauseImage[0] != fPauseButton.getImage())
			   fPauseButton.setImage(fPauseImage[0]) ;			
			fPauseButton.setToolTipText(MSG_PUSH_TO_PAUSE) ;
		}
	
	}

}

