package com.ibm.etools.jbcf.editorpart;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.viewers.*;
import java.util.*;

public class JavaVisualEditorSelectionProvider implements ISelectionProvider {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected List fListeners = new Vector();
	protected JavaVisualEditorPart fEditor;
	
public JavaVisualEditorSelectionProvider(JavaVisualEditorPart anEditor){
	fEditor = anEditor;
}
public void addSelectionChangedListener(ISelectionChangedListener aListener){
	fListeners.add(aListener);	
}
public ISelection getSelection(){

	if ( fEditor.isVCEEditorActive() ) {
		return fEditor.getVCEEditor().getPrimaryViewer().getSelection();
	} else {
		return fEditor.getJavaEditor().getSelectionProvider() == null ? null : fEditor.getJavaEditor().getSelectionProvider().getSelection();
	}
}
public void removeSelectionChangedListener(ISelectionChangedListener aListener){
	fListeners.remove(aListener);
}
public void setSelection(ISelection aSelection){
	if ( fEditor.isVCEEditorActive() ){
		fEditor.getVCEEditor().getPrimaryViewer().getSelection();
	} else {
		fEditor.getJavaEditor().getSelectionProvider().setSelection(aSelection);
	}
}
public void fireSelectionChanged(SelectionChangedEvent event){
	Iterator iter = fListeners.iterator();
	while(iter.hasNext()){
		ISelectionChangedListener listener = (ISelectionChangedListener)iter.next();
		listener.selectionChanged(event);
	}
}
}
