package com.ibm.etools.jbcf.vce;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.viewers.*;
import com.ibm.etools.beaninfo.*;
import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFPlugin;
import com.ibm.etools.jbcf.emf.vce.*;

public class MethodLabelProvider extends LabelProvider {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public String getText(Object element) {
	if ( element == null ) return ""; //$NON-NLS-1$
	if ( element instanceof Method ) {
		MethodProxy methodProxy = (MethodProxy) ((Method)element).getMethod();
		return methodProxy.getMethod().getMethodElementSignature();
	} else {
		JBCFPlugin.log("Method label provider got an element " + element, JBCFMsgLogger.LOG_FINEST); //$NON-NLS-1$
	}
	return ""; //$NON-NLS-1$
}
}