package com.ibm.etools.jbcf.vce;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

//import com.ibm.etools.ocb.propertysheet.*;
import org.eclipse.ui.views.properties.*;
import com.ibm.etools.beaninfo.adapters.Utilities;
import com.ibm.etools.jbcf.emf.vce.ParameterConnection;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;
import com.ibm.etools.jbcf.BeanProxyAdapter;
import com.ibm.etools.emf.ref.*;
import com.ibm.etools.java.*;
import com.ibm.etools.beaninfo.*;
import com.ibm.etools.jbcf.emf.vce.Method;
import com.ibm.etools.jbcf.emf.vce.BeanJavaConstant;
import com.ibm.etools.emf.resource.*;
//import com.ibm.etools.emf.notify.*;
//import com.ibm.etools.emf.uuid.*;
import java.util.*;

//public class MethodPropertySourceAdapter implements IPropertySource  {
public class MethodPropertySourceAdapter {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Method fMethodNode;
	protected MethodProxy fMethodProxy;
	
private void keepAndReviewInTheFuture() {
	com.ibm.etools.cde.CDEHack.fixMe("Class has been commented out for now. Keep for the future"); //$NON-NLS-1$
}
public MethodPropertySourceAdapter(Method aMethodNode){
	fMethodNode = aMethodNode;
	fMethodProxy = (MethodProxy)aMethodNode.getMethod();
}
/**
 * The MethodProxy's methods parms are those created by reflection
 * We want the beanInfo ones so we get these from a decorator
 */
public IPropertyDescriptor[] getPropertyDescriptors() {
	
	MethodDecorator methodDecor = Utilities.getMethodDecorator(fMethodProxy);
	List parms = methodDecor.getParameterDescriptors();
	// There is a bug where the parmaeterDescriptors do not point to the JavaMethod instances
	// therefore we must get this list separately and associate them in the descriptors
	com.ibm.etools.cde.CDEHack.fixMe("Needs fixing once the ParameterDescriptor points to the JavaParameter"); //$NON-NLS-1$
	List javaParms = fMethodProxy.getMethod().getParametersWithoutReturn();
	IPropertyDescriptor[] result = new IPropertyDescriptor[javaParms.size()];
	for(int i=0;i<javaParms.size();i++){
		result[i] = new MethodParameterPropertyDescriptor(
			(JavaParameter)javaParms.get(i),
			fMethodNode,
			(ParameterDecorator)parms.get(i)
		);
	}
	return result;
	
}
public Object getEditableValue(){
	return fMethodNode;
}
public boolean isPropertySet(Object feature) {
	com.ibm.etools.cde.CDEHack.fixMe("Nees more thought - here to stop a class cast"); //$NON-NLS-1$
	return true;
}
/**
 * The value for a method parm is provided as follows
 * -- for a constant:
 * <nodes xmi:type="vce:Method" method="setTitle" xmi:id="m1"/>
 * <nodes xmi:type="vce:BeanConstant" xmi:id="c1">
 *   <bean xmi:type="java.lang:String" initializationString=""Hello World""/>
 * </nodes>
 * <connections xmi:type="ParameterConnection" source="c1" target="m1" parameterName="arg0"/>
 * OR -- for a parameter from method
 * <nodes xmi:type="vce:Method" xmi:id="setTitle" xmi:id="m1"/>
 * <nodes xmi:type="vce:Method" method="getHelloWorld" xmi:id="m2"/>
 * <connections xmi:type="ParameterConnection source="m1" target="m2" parameterName="arg0"/>
 */
//public Object getPropertyValue(Object feature) {
//
//	String parmName = getParmName((JavaParameter)feature);
//	// Iterate over all connections to the method ( the target ) to find one for the same parameter name
//	ParameterConnection connectionToJavaParm = getParameterConnectionNamed(parmName);
//	if ( connectionToJavaParm == null ) return null;
//	// Case 1 - the connection's source is a constant
//	if ( connectionToJavaParm.getSourceNode() instanceof BeanJavaConstant ) {
//		BeanJavaConstant beanConstant = (BeanJavaConstant)connectionToJavaParm.getSourceNode();
//		IJavaObjectInstance javaObjectInstance = beanConstant.getBean();
//		// Adapt values on the way out so that they show appear as property sources 
//		// in the property sheet with children for their properties - like the property sheet
//		// for properties on beans themselves
//		// Put a propertySource adapter onto it because one will be needed but this guy isn't in a resource set to get it.
//		// Set it an IPropertySource so that we don't loop it up again below.
//		fMethodNode.getResourceSet().getContext().getAdapterFactory(BeanProxyAdapter.BEAN_PROXY_TYPE).adapt(javaObjectInstance, BeanProxyAdapter.BEAN_PROXY_TYPE);		
//		IPropertySource ps = (IPropertySource) fMethodNode.getResourceSet().getContext().getAdapterFactory(IPropertySource.class).adapt(javaObjectInstance, IPropertySource.class);
//		if (ps != null) {
//			return ps;
//		} else {
//			return javaObjectInstance;
//		}
//	}
//	return "???";
//	
//}
//protected ParameterConnection getParameterConnectionNamed(String parmName){
//	Iterator connectionsToMethod = fMethodNode.getInbound().iterator();
//	while(connectionsToMethod.hasNext()){
//		Object connectionToMethod = connectionsToMethod.next();
//		if ( connectionToMethod instanceof ParameterConnection ) {
//			ParameterConnection parmConnection = (ParameterConnection)connectionToMethod;
//			if ( parmConnection.getParameterName().equals(parmName)){
//				return parmConnection;
//			}		
//		}
//	}	
//	return null;
//}
//protected String getParmName(JavaParameter javaParm){
//	// The feature id is the java parameter itself.  For the name we use its id, e.g. arg0, arg1
//	String parmID = javaParm.refID();
//	// The parmID is a string like "Dialog.setTitle(java.lang.String-arg0"
//	// We just care about the arg0 so we must strip this off
//	int indexOfLastDash = parmID.lastIndexOf('-');
//	return parmID.substring(indexOfLastDash + 1);
//}
//public void resetPropertyValue(Object feature){
//}
//public void setPropertyValue(Object feature, Object val){
//	System.out.println("Method PS set.  Feature=" + feature + " val=" + val);
//	com.ibm.etools.cde.CDEHack.fixMe("All this stuff needs moving to being done in a command");
//	// The feature is a JavaParameter 
//	// The val is a java object instance
//	// We want the following structure in the VCE model
//	// <nodes vce:Method xmi:id="m1" method="Dialog.setTitle"/>
//	// <nodes vce:BeanConstant xmi:id="c1">
//	//   <bean xmi:type="java.lang:String" initializationString=""Hello World""/>
//	// </nodes>
//	// <connections xmi:type="ParameterConnection" source="c1" target="m1" parameterName="arg0"/>
//	// The bean in the bean constant is the val in c1
//	
//	// There may or may not be a ParameterConnection object existing - create one if required
//	String parmName = getParmName((JavaParameter)feature);
//	ParameterConnection parmConnection = getParameterConnectionNamed(parmName);
//	// If the connection is there then get its source
//	Object parmSource = parmConnection.getSourceNode();
//	// The source node might be a BeanConstant.  If this is the case just change its bean
//	// or the source node might be a Method in which case delete it ( THINK about the scope of deletion here )
//	// of the source node might be absent in which case create one
//	BeanJavaConstant beanConstant = null;
//	if ( parmSource instanceof BeanJavaConstant ) {
//		beanConstant = (BeanJavaConstant)parmSource;
//	} else if ( parmSource == null ) {
//		beanConstant = ((com.ibm.etools.jbcf.emf.vce.VceFactory)JBCFVCEContext.VCE_PACKAGE.getFactory()).createBeanJavaConstant();
//	}
//	beanConstant.setBean((IJavaObjectInstance)val);
//	
//}
/*
// We have to implement RefBaseObject because when we become the source for the JavaBean editors
// they will cast us to this to get the resource set that the VCE document is in
// This is a hack but it will do for now
public RefObject metaObject(String name){return null;}
public EList refAttributes(){return null;}
public RefBaseObject refContainer(){return null;}
public Extent refContainerExtent(){return null;}
public RefStructuralFeature refContainerSF(){return null;}
public EList refContainsExtent(EList results){return null;}
public EList refContainsNested(EList results){return null;}
public void refDelete(){}
public Extent refExtent(){return null;}
public String refID(){return null;}
public RefPackage refImmediatePackage(){return null;}
public boolean refIsContainer(RefBaseObject newContainer){return false;}
public boolean refItself(RefBaseObject otherObject){return false;}
public RefObject refMetaObject(){return null;}
public UUID refMofId(){return null;}
public String refName(){return null;}
public RefPackage refOutermostPackage(){return null;}
public RefPackage refPackage(){return null;}
public EList refReferences(){return null;}
public Notification refRemoveContent(RefObject feature, RefBaseObject oldContent){return null;}
// Defer to the reosurce set of the ref object
public Resource refResource(){
	return fRefObject.refResource();
}
public void refSetExtent(Extent newExtent){}
public void refSetID(String id){}
public void refSetID(){}
public void refSetIDContains(){}
public void refSetMetaObject(RefObject metaObject){}
public void refSetUUID(){}
public void refSetUUID(UUID uuid){}
public void refSetUUID(String uuid){}
public EList refContainments(){return null;}
public EList refContains(){return null;}
public void addAdapter(Adapter o){}
public Collection getAdapters(){return null;}
public Adapter getExistingAdapter(Object type){return null;}
public Adapter getAdapter(Object type){return null;}
public boolean isDelivery(){return false;}
public boolean isDeliveryAll(){return false;}
public void notify(int eventType, RefObject sf, Object oldValue, Object newValue, int pos){}
public void notify(Notification msg){}
public void removeAdapter(Adapter o){}
public void setDelivery(boolean deliver){}
public void setDeliveryAll(boolean deliver){}
public ResourceSet getResourceSet(){return null;}
*/
}