package com.ibm.etools.jbcf.vce;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.text.Collator;
import java.util.*;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;

import com.ibm.etools.beaninfo.MethodProxy;
import com.ibm.etools.java.JavaClass;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;
import com.ibm.etools.jbcf.emf.vce.EventToMethodConnection;
import com.ibm.etools.jbcf.emf.vce.Method;
import com.ibm.etools.propertysheet.ISourced;
import com.ibm.etools.propertysheet.StandardComboBoxCellEditor;

public class MethodsComboBoxCellEditor extends StandardComboBoxCellEditor implements ISourced {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Object[] fSources;
	protected IJavaObjectInstance fJavaObject;

public MethodsComboBoxCellEditor(Composite parent) {
	super(parent);
}

public void setSources(Object[] sources, IPropertySource[] pos, IPropertyDescriptor[] des){
	fSources = sources;
	EventToMethodConnection conn = (EventToMethodConnection) fSources[0];
	com.ibm.etools.cde.CDEHack.fixMe("the following statement needs to be refactored"); //$NON-NLS-1$
//	fJavaObject = (IJavaObjectInstance) ((Method)conn.getTargetNode()).getPerformedBy();
	JavaClass javaClass = (JavaClass)fJavaObject.refMetaObject();
	List behaviorsList = javaClass.getEAllBehaviors();
	// Find the MethodProxy classes in the behaviors list and get their Method classes
	List methodsList = new ArrayList(behaviorsList.size());	
	List methodNamesList = new ArrayList(behaviorsList.size());
	Iterator iter = behaviorsList.iterator();
	while(iter.hasNext()){
		Object behavior = iter.next();
		if ( behavior instanceof MethodProxy ) {
			methodsList.add(behavior);
			// add the method signature to the list for the combo box
			String signature = ((MethodProxy)behavior).getMethod().getMethodElementSignature();
			methodNamesList.add(signature);
		}
	}
	// Sort the methods in order by the method name
	Collections.sort(methodsList, new Comparator() {
		Collator coll = Collator.getInstance(Locale.getDefault());
		public int compare(Object a, Object b) {
			MethodProxy c1, c2;
			String dname1, dname2;
			c1 = (MethodProxy) a;
			dname1 = c1.getMethod().getMethodElementSignature();
			c2 = (MethodProxy) b;
			dname2 = c2.getMethod().getMethodElementSignature();
			return coll.compare(dname1, dname2);
		}
	});
	
	
	// We need the two lists as arrays for the combo box
	Object[] methods = methodsList.toArray();
	String[] methodNames = new String[methods.length];
	for(int i=0;i<methods.length;i++){
		methodNames[i] = ((MethodProxy)methods[i]).getMethod().getMethodElementSignature();
	}
	setItems(methodNames,methods);
}
protected boolean isCorrect(Object value) {
	return true;
}

/**
 * The value is a Method when the combo box is filled with MethodProxy classes
 */
protected int doGetIndex(Object value){
	if ( value == null ) return sNoSelection;
	Object methodProxy = ((Method)value).getMethod();
	if (fItems != null) {
		for (int i=0; i<fItems.length; i++) {
			if (fItems[i] == null)
				if (value == null)
					return i;
				else
					;
			else if (fItems[i].equals(methodProxy))
				return i;
		}
	}
			
	return sNoSelection;
}
}