package com.ibm.etools.jbcf.vce;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.core.runtime.Plugin;
import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.jface.preference.*;
import com.ibm.etools.jbcf.JBCFPlugin;
import java.io.IOException;
import org.eclipse.core.runtime.Platform;
import java.net.URL;

public class VCEPlugin extends Plugin {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static String SWING_LOOKANDFEEL = "SWING_LOOKANDFEEL"; //$NON-NLS-1$
	public static String SHOW_LIVE_WINDOW = "SHOW_LIVE_WINDOW"; //$NON-NLS-1$
	public static String NOTEBOOK_PAGE = "NOTEBOOK_PAGE"; //$NON-NLS-1$
	public static String SELECT_SOURCE = "SELECT_SOURCE"; //$NON-NLS-1$
	public static String SPLITPANE_SHOW_GEF_PALETTE = "SPLITPANE_SHOW_GEF_PALETTE"; //$NON-NLS-1$
	public static String NOTEBOOK_SHOW_GEF_PALETTE = "NOTEBOOK_SHOW_GEF_PALETTE";	 //$NON-NLS-1$
	public static String SOURCE_SYNC_DELAY = "SOURCE_SYNC_DELAY" ; //$NON-NLS-1$
	public static int	   DEFAULT_SYNC_DELAY = 500 ;
	public static String SOURCE_DELAY_FACTOR = "SOURCE_DELAY_FACTOR" ; //$NON-NLS-1$
	public static int	   DEFAULT_L2R_FACTOR = 2 ;
    public static String GENERATE_COMMENT = "GENERATE_EXPRESSION_COMMENT" ; //$NON-NLS-1$
    public static String GENERATE_TRY_CATCH_BLOCK = "GENERATE_TRY_CATCH_BLOCK"; //$NON-NLS-1$
//    public static String REQUIRE_IVJ_COMPONENTS = "REQUIRE_IVJ_COMPONENTS"; //$NON-NLS-1$
    // Store the sash widths for the palette so that as the user resizes the palette sash
    // it is saved and retrieved for new editors
    public static String PALETTE_SASH_LEFT_RATIO = "PALETTE_SASH_LEFT_RATIO"; //$NON-NLS-1$
    public static String PALETTE_SASH_RIGHT_RATIO = "PALETE_SASH_RIGHT_RATIO"; //$NON-NLS-1$
    public static int	   DEFAULT_PALETTE_SASH_LEFT_RATIO = 1;
    public static int	   DEFAULT_PALETTE_SASH_RIGHT_RATIO = 4;    
    
    public static String  ALIGNMENTWINDOW_X = "ALIGNMENTWINDOW_X"; //$NON-NLS-1$
    public static String  ALIGNMENTWINDOW_Y = "ALIGNMENTWINDOW_Y"; //$NON-NLS-1$
    
    // The following are run time options
    public static final String DEBUG_CONSOLE_ECHO   = "/debug/consolelog" ; // Dump all logs to console //$NON-NLS-1$
    public static final String DEBUG_XMITEXT_OPTION = "/debug/xmltext" ;    // Provide the XMI text option  //$NON-NLS-1$
    public static final String DEBUG_LIVEWINDOW_OPTION = "/debug/livewindow" ; // Provide the Live Window option  //$NON-NLS-1$

    
    
	private static VCEPlugin PLUGIN;
	
public VCEPlugin(IPluginDescriptor descriptor) {
	super(descriptor);
	PLUGIN = this;
}	
	
public static VCEPlugin getPlugin() {
	return PLUGIN;
}

protected void initializeDefaultPluginPreferences() {
	// The user gets a dialog when they open the JavaVisualEditor
	// telling them about it and
	VCEPreferencePage.initDefaults(getPluginPreferences());
}	
}