package com.ibm.etools.jbcf.vce.javabeanviewer;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.*;
import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.geometry.*;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.*;

public class BorderFigure extends RectangleFigure {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	Color BACKGROUND = new Color(Display.getDefault(),255,178,29);
	public String fConstraint;
	
public BorderFigure(String aConstraint){
	fConstraint = aConstraint;
	setBorder(new BevelBorder());
}	
protected void fillShape(Graphics graphics){
	graphics.setBackgroundColor(BACKGROUND);
	graphics.fillRectangle(getBounds());
	
	graphics.setForegroundColor(ColorConstants.white);
	Rectangle bounds = getBounds();
	graphics.drawString(fConstraint,bounds.x,bounds.y,Graphics.TRANSPARENT);

}
public Dimension getPreferredSize(){
	
	// We should have one child figure if we have a component in our region
	IFigure childFigure = null;
	if (getChildren().size() > 0 ){
		childFigure = (IFigure)getChildren().get(0);
	}
	int preferredWidth = 15;
	int preferredHeight = 15;
	if(childFigure != null){
		preferredWidth = 2 + childFigure.getSize().width;
		preferredHeight = 13 + childFigure.getSize().height;
	}
	// Make sure the preferred size is not too small
	if ( fConstraint.equals("North") || fConstraint.equals("South")){ //$NON-NLS-1$ //$NON-NLS-2$
		preferredWidth = Math.max(preferredWidth,130);
		preferredHeight = Math.max(preferredHeight,25);
	} else if ( fConstraint.equals("East") || fConstraint.equals("West") ) { //$NON-NLS-1$ //$NON-NLS-2$
		preferredWidth = Math.max(preferredWidth,25);
		preferredHeight = Math.max(preferredHeight,60);
	} else if ( fConstraint.equals("Center") ) { //$NON-NLS-1$
		preferredWidth = Math.max(preferredWidth,80);
		preferredHeight = Math.max(preferredHeight,60);
	}
	return new Dimension(preferredWidth,preferredHeight);
}
}