package com.ibm.etools.jbcf.vce.javabeanviewer;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.graphics.*;
import com.ibm.etools.draw2d.geometry.Rectangle;
import com.ibm.etools.draw2d.*;
import org.eclipse.swt.widgets.*;

/**
 * Draws a rectangle whose size is determined
 * by the bounds set to it.
 */
public class CardLayoutFigure extends Clickable {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	static Color TITLE_INACTIVE_BACKGROUND = new Color(Display.getDefault(),255,178,29);
	static Color TITLE_INACTIVE_FOREGROUND = new Color(Display.getDefault(),212,208,200);	
	static Color TITLE_ACTIVE_BACKGROUND = ColorConstants.blue;
	static Color TITLE_ACTIVE_FOREGROUND = ColorConstants.white;
	String fCardName;
	boolean isActiveCard;

public CardLayoutFigure(final String cardName){
	fCardName = cardName;
	setLayoutManager(new XYLayout());
}
protected Color getFillColor(){
	if (isActiveCard){
		return TITLE_ACTIVE_BACKGROUND;
	} else {
		return TITLE_INACTIVE_BACKGROUND;
	}
}
protected Color getTextColor(){
	if (isActiveCard){
		return TITLE_ACTIVE_FOREGROUND;
	} else {
		return TITLE_INACTIVE_FOREGROUND;
	}
}
public void setActiveCard(boolean aBool){
//	isActiveCard = aBool;
}
public void paintFigure(Graphics graphics){

	// Draw a rectangle around the card
	graphics.setBackgroundColor(getFillColor());
	Rectangle titleBox = getBounds();
	titleBox.height = 14;
	graphics.fillRectangle(titleBox);
	
	// Draw the card name at the top
	graphics.setForegroundColor(getTextColor());
	int x = getBounds().x;
	int y = getBounds().y;
	graphics.drawString(fCardName,x,y,Graphics.TRANSPARENT);	

	// Draw a rectangle around the card in a slightly darker color
	graphics.setForegroundColor(TITLE_INACTIVE_FOREGROUND);
	Rectangle r = getBounds();
	graphics.drawRectangle(titleBox.x, titleBox.y, titleBox.width-1, 11);
		
}
}
