package com.ibm.etools.jbcf.vce.javabeanviewer;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

//import com.ibm.etools.jbcf.visual.*;
import com.ibm.etools.jbcf.*;
import org.eclipse.swt.widgets.*;
import org.eclipse.ui.part.*;
import org.eclipse.ui.*;
import org.eclipse.jface.viewers.*;
import com.ibm.etools.gef.ui.parts.*;
import com.ibm.etools.java.instantiation.base.*;
import com.ibm.etools.jbcf.vce.javabeanviewer.*;
import org.eclipse.swt.SWT;
import com.ibm.etools.gef.*;
import java.util.*;

public class JavaBeanView extends ViewPart implements IPartListener {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Label fLabel;
	protected EditPartViewer fViewer;
	private IWorkbenchPart focusPart;
	private ISelectionProvider focusSelectionProvider;	
	private ISelectionChangedListener focusSelectionChangedListener = new ISelectionChangedListener() {
		public void selectionChanged(SelectionChangedEvent event) {
			JavaBeanView.this.focusSelectionChanged(event);
		}
	};
	      
public JavaBeanView() {
	super();
}
protected void focusSelectionChanged(SelectionChangedEvent event){
	updateFocusResource(event.getSelection());
}
protected void updateFocusResource(ISelection aSelection){
	com.ibm.etools.cde.CDEHack.fixMe("Needs to be refactored... can't depend on the JBCF Visual plugin"); //$NON-NLS-1$
//	if (aSelection instanceof StructuredSelection){
//		Iterator iter = ((StructuredSelection)aSelection).iterator();
//		if ( iter.hasNext() ) {
//			Object firstSelectedObject = iter.next();
//			if ( firstSelectedObject instanceof ContainerGraphicalEditPart ){
//				JavaBeanViewerContainerGraphicalEditPart rootPart = new JavaBeanViewerContainerGraphicalEditPart();
//				fViewer.setContents(rootPart);				
//				rootPart.setJavaBean((IJavaObjectInstance)((EditPart)firstSelectedObject).getModel());
//			}		
//		}
//	}
}
public void setFocus() {
}
public void createPartControl(Composite parent) {
	JBCFPlugin.log("JavaBeanView called with createPartControl", JBCFMsgLogger.LOG_FINEST); //$NON-NLS-1$
	Canvas canvas = new Canvas(parent, 0);
	createPrimaryViewer().setControl(canvas);
}
protected EditPartViewer createPrimaryViewer(){
	fViewer = new GraphicalViewerImpl();
	return fViewer;
}
public void init(IViewSite site) throws PartInitException {
	super.init(site);
	getSite().getPage().addPartListener(this);
}
public void partBroughtToTop(IWorkbenchPart part){
}
public void partClosed(IWorkbenchPart part){
	if ( part == focusPart ){
		fViewer.setContents(null);
		focusPart = null;
	}	
}
public void partOpened(IWorkbenchPart part){
}
public void partDeactivated(IWorkbenchPart part){
}
public void partActivated(IWorkbenchPart part) {
	if (part == focusPart)
		return;
		
	if (part instanceof JBCFGraphicalEditorPart){
		if (focusSelectionProvider != null) {
			focusSelectionProvider.removeSelectionChangedListener(focusSelectionChangedListener);
			focusSelectionProvider = null;
		}		
		focusPart = part;		
		JBCFGraphicalEditorPart jbcfPart = (JBCFGraphicalEditorPart)part;
		fViewer.setEditDomain(jbcfPart.getDomain());
		focusSelectionProvider = focusPart.getSite().getSelectionProvider();
		if (focusSelectionProvider != null) {
			focusSelectionProvider.addSelectionChangedListener(focusSelectionChangedListener);
			updateFocusResource(focusSelectionProvider.getSelection());
		}
		else {
			updateFocusResource(null);
		}
	}
	
}
}

