package com.ibm.etools.jbcf.vce.launcher;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

/*
 * (c) Copyright IBM Corp. 2000, 2001.
 * All Rights Reserved.
 */
 
import java.lang.reflect.InvocationTargetException;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.search.IJavaSearchScope;
import org.eclipse.jdt.internal.ui.IJavaHelpContextIds;
import org.eclipse.jdt.internal.ui.JavaUIMessages;
import org.eclipse.jdt.internal.ui.util.ExceptionHandler;
import org.eclipse.jdt.internal.ui.util.MainMethodSearchEngine;
import org.eclipse.jdt.ui.JavaElementLabelProvider;
import org.eclipse.jface.operation.IRunnableContext;
import org.eclipse.jface.util.Assert;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.help.WorkbenchHelp;

import org.eclipse.ui.dialogs.TwoPaneElementSelector;

/**
 * A dialog to select a bean type from a list of types. The dialog allows
 * multiple selections.
 */
public class JavaBeanTypeFinderDialog extends TwoPaneElementSelector {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private IRunnableContext fRunnableContext;
	private IJavaElement fElem;
	private int fStyle;
	
	private static class PackageRenderer extends JavaElementLabelProvider {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
		public PackageRenderer() {
			super(JavaElementLabelProvider.SHOW_PARAMETERS | JavaElementLabelProvider.SHOW_POST_QUALIFIED | JavaElementLabelProvider.SHOW_ROOT);	
		}

		public Image getImage(Object element) {
			return super.getImage(((IType)element).getPackageFragment());
		}
		
		public String getText(Object element) {
			return super.getText(((IType)element).getPackageFragment());
		}
	}
	
	/**
	 * Constructor.
	 */
	public JavaBeanTypeFinderDialog(Shell shell, IRunnableContext context,
		IJavaElement elem, int style)
	{
		super(shell, new JavaElementLabelProvider(JavaElementLabelProvider.SHOW_BASICS | JavaElementLabelProvider.SHOW_OVERLAY_ICONS), 
			new PackageRenderer());

		Assert.isNotNull(context);

		fRunnableContext= context;
		fElem= elem;
		fStyle= style;
	}

	/*
	 * @see Window#open()
	 */
	public int open() {
		JavaBeanSearchEngine engine= new JavaBeanSearchEngine();
		IType[] types;
		try {
			types= engine.searchJavaBeans(fRunnableContext, fElem, fStyle);
		} catch (InterruptedException e) {
			return CANCEL;
		} catch (InvocationTargetException e) {
			ExceptionHandler.handle(e, VCELauncherMessages.getString("ErrorDialog.Title"), e.getMessage()); //$NON-NLS-1$
			return CANCEL;
		}
		
		setElements(types);
		return super.open();
	}
	
}