package com.ibm.etools.jbcf.vce.launcher.remotevm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.net.URL;
import java.util.Enumeration;
import java.applet.*;
import java.util.*;

/**
 * Frame to host an applet that allows control over starting, stopping, etc...
 */
public class AppletFrame extends Frame implements AppletContext {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Applet fApplet;
	protected Label fLabel;
	protected Map fAppletParms;
	protected AppletStub fAppletStub;

	public AppletFrame(String title,Applet anApplet,Map appletParms) {
		super(title);
		fApplet = anApplet;
		fAppletParms = appletParms;
		fAppletStub = new JavaLauncherAppletStub(appletParms,fApplet, this);
		fApplet.setStub(fAppletStub);
		add(anApplet);
		fLabel = new Label();
		add(fLabel,BorderLayout.SOUTH);
		createMenu();
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				fApplet.destroy();
			}
		});
	}
	
	protected void createMenu(){

		MenuBar menuBar = new MenuBar();
		setMenuBar(menuBar);
		Menu appletMenu = new Menu((VCELauncherMessages.getString("BeansLauncher.Menu.Applet")),true); //$NON-NLS-1$
		appletMenu.setShortcut(new MenuShortcut(VCELauncherMessages.getChar("BeansLauncher.Menu.Applet.Shortcut"))); //$NON-NLS-1$
		menuBar.add(appletMenu);
		
		MenuItem startApplet = new MenuItem(VCELauncherMessages.getString("BeansLauncher.Menu.Start"),new MenuShortcut(VCELauncherMessages.getChar("BeansLauncher.Menu.Start.Shortcut"))); //$NON-NLS-1$ //$NON-NLS-2$
		startApplet.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fApplet.start();
			}
		});
		appletMenu.add(startApplet);
		
		MenuItem stopApplet = new MenuItem(VCELauncherMessages.getString("BeansLauncher.Menu.Stop"),new MenuShortcut(VCELauncherMessages.getChar("BeansLauncher.Menu.Stop.Shortcut"))); //$NON-NLS-1$ //$NON-NLS-2$
		stopApplet.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				fApplet.stop();
			}
		});			
		appletMenu.add(stopApplet);
		
	}
	public Applet getApplet(String name) {
		return null;
	}
	public Enumeration getApplets() {
		return null;
	}
	public AudioClip getAudioClip(URL url) {
		return null;
	}
	public Image getImage(URL url) {
		return null;
	}
	public void showDocument(URL url, String target) {
	}
	public void showDocument(URL url) {
	}
	public void showStatus(String status) {
		fLabel.setText(status);
	}

}
