package com.ibm.etools.jbcf.vce.launcher.remotevm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.applet.*;
import java.awt.Image;
import java.util.*;
import java.net.*;

public class JavaLauncherAppletStub implements AppletStub {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private Map fProperties;
	private Applet fApplet;
	protected AppletContext fAppletContext;
	protected URL codeBase, docBase;

public JavaLauncherAppletStub(Map properties, Applet a, AppletContext context) {
	fApplet = a;
	fProperties = properties;
	Iterator keys = fProperties.keySet().iterator();
	while(keys.hasNext()){
		String key = (String)keys.next();
		String value = (String)fProperties.get(key);
	}
	fAppletContext = context;
	String classfilename = (a.getClass().getName().replace('.', '/').concat(".class")); //$NON-NLS-1$
	URL classURL = a.getClass().getResource('/'+classfilename);
	if (classURL != null) {
		try {
			String eForm = classURL.toExternalForm();
			docBase = new URL(eForm.substring(0, eForm.length()-classfilename.length()));	// Up to but package fragment root of the class.
			int lastSlash = eForm.lastIndexOf('/');	// Find where the class file itself is at.
			if (lastSlash >= 0)
				codeBase = new URL(eForm.substring(0, lastSlash+1));	// Up to the class file itself
		} catch(MalformedURLException e) {
		}
	}		
}

public void appletResize (int width, int height) {
	fApplet.resize (width, height);
}
 
public AppletContext getAppletContext () {
	return fAppletContext;
}

public URL getCodeBase() {
	return codeBase;
}
public URL getDocumentBase() {
	return docBase;
}

public String getParameter (String p) {
	return (String)fProperties.get(p);
}
public boolean isActive () {
	return true;
}
}
