package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbenchPage;

import com.ibm.etools.jbcf.vce.SubclassCompositionComponentsGraphicalEditPart;
import com.ibm.etools.gef.*;
import com.ibm.etools.jbcf.IBeanProxyHost;
import com.ibm.etools.jbcf.JBCFEditDomainHelper;
import com.ibm.etools.proxy.*;
import com.ibm.etools.jbcf.BeanProxyUtilities;
import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.jbcf.CompositionProxyAdapter;
import com.ibm.etools.jbcf.emf.vce.BeanSubclassComposition;

/**
 * Composition Graphical Edit Part for a Bean subclass in a visual environment.
 * Creation date: (06/22/00 4:56:28 PM)
 * @author: Joe Winchester
 */
public class CompositionFreeFormComponentsGraphicalEditPart extends SubclassCompositionComponentsGraphicalEditPart {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected FreeFormComponentsHostAdapter fFreeFormHost;
	protected IWorkbenchPage fWorkbenchPage;

public CompositionFreeFormComponentsGraphicalEditPart(Object model,IWorkbenchPage workbenchPage) {
	super(model);
	fWorkbenchPage = workbenchPage;
}

public void activate() {
	// Make sure that the proxy host for the frame that hosts free form components is instantiated
	activateFreeFormEnvironment();	
	super.activate();
}

protected void activateFreeFormEnvironment(){
	CompositionProxyAdapter compositionAdapter = (CompositionProxyAdapter) ((Notifier)getModel()).getAdapter(CompositionProxyAdapter.BEAN_COMPOSITION_PROXY);
	fFreeFormHost = (FreeFormComponentsHostAdapter) compositionAdapter.getAdapter(FreeFormComponentsHostAdapter.FREE_FORM_COMPONENTS_HOST);
	// There is no factory to create this object we create it by hand if required
	if ( fFreeFormHost == null ) {
		fFreeFormHost = new FreeFormComponentsHostAdapter(JBCFEditDomainHelper.getBeanProxyDomain(EditDomain.getEditDomain(this)), (BeanSubclassComposition) getModel(), fWorkbenchPage);
		compositionAdapter.addAdapter(fFreeFormHost);
		fFreeFormHost.setTarget(compositionAdapter);
	}
	fFreeFormHost.instantiateDialogs();	
}

/**
 * deactivate: Clean up and dispose the dialog bean proxy for free form host.
 */
public void deactivate() {
	super.deactivate();
	if ( fFreeFormHost != null ) {
		fFreeFormHost.disposeDialogs();
	}
}
}
