package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.draw2d.FlowLayout;
import com.ibm.etools.common.command.Command;
import com.ibm.etools.gef.EditPart;
import com.ibm.etools.gef.GraphicalEditPart;
import com.ibm.etools.draw2d.geometry.Rectangle;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.ref.RefStructuralFeature;
import com.ibm.etools.gef.Request;
import com.ibm.etools.gef.requests.*;
import com.ibm.etools.draw2d.IFigure;
import com.ibm.etools.gef.EditPolicy;
import java.util.*;

/**
 * Layout input policiy for hanlding the Flow layout of a Container.
 */
public class FlowLayoutEditPolicy extends com.ibm.etools.cde.FlowLayoutEditPolicy {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected FlowLayoutPolicyHelper helper = new FlowLayoutPolicyHelper();
	protected FlowLayout fFlowLayout = new FlowLayout(); // Required for the superclass to work correctly
	
/**
 * Create with the container policy for handling DiagramFigures.
 */
public FlowLayoutEditPolicy(ContainerPolicy containerPolicy) {
	super(containerPolicy);
	helper.setContainerPolicy(containerPolicy);
	fFlowLayout.setHorizontal(true); // AWT is only horizontal
}
/**
 * The child editpart is about to be added to the parent.
 */
public Command createAddCommand(EditPart childEditPart, EditPart before) {

	// We need to create a constraint and send this and the child over to the container policy.
	Object child = childEditPart.getModel();
	return helper.getAddChildrenCommand(Collections.nCopies(1, child), Collections.nCopies(1, null), before != null ? before.getModel() : null);
}
protected Command getCreateCommand(CreateRequest aRequest) {
	Object child = aRequest.getNewObject();
	EditPart before = getInsertionReference(aRequest);
	return helper.getCreateChildCommand(child, null, before != null ? before.getModel() : null);
}
/**
 * The inherited GEF behavior requires us to use a FlowLayout.
 * Our figure is really an XY layout so we hold onto our own draw2d layout
 */
protected FlowLayout getLayoutManager() {
	return fFlowLayout;
}
}
