package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.util.*;
import com.ibm.etools.common.command.Command;
/**
 * This helper class is used when a container's layout is changed
 * to an Flow type.
 * There is no constraint that we can handle, so we add back in 
 * the same order with no constraint.
 *
 * Creation date: (10/10/00 3:50:16 PM)
 * @author: Peter Walker
 */
public class FlowLayoutSwitcher extends LayoutSwitcher {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected FlowLayoutPolicyHelper helper;

	public FlowLayoutSwitcher(ContainerPolicy cp) {
		super(cp);
		helper = new FlowLayoutPolicyHelper(cp);
	}

	/**
	 * Returns a compound command containing the child constraint commands to position the
	 * children within a flow Layout container.
	 */
	protected Command getChangeConstraintsCommand(List children) {		
		return helper.getAddChildrenCommand(children, Collections.nCopies(children.size(), null), null);	// Now let the helper add them back correctly.
	}

}


