package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.common.command.Command;
import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;
import com.ibm.etools.jbcf.*;
import java.util.List;
import java.util.*;
/**
 * This helper class is used when a container's layout is changed
 * to a GridBagLayout. Each of the constraints for the container's children 
 * constraints need to be assigned a GridBagConstaints.
 *
 */
public class GridBagLayoutSwitcher extends LayoutSwitcher {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	GridBagLayoutPolicyHelper helper;

public GridBagLayoutSwitcher(ContainerPolicy cp) {
	super(cp);
	helper = new GridBagLayoutPolicyHelper(cp);
}
/**
 * Returns a compound command containing the child constraint commands to position the
 * children within a GridBagLayout container.
 * Since this is a GridBagLayout, it doesn't matter what the previous constraints
 * were for the children since we're going to create GridBagConstraints constraints.
 * In order to do this we must get the position coordinates from the live bean
 * and create setting commands with a Bean rectangle constraint.
 */
protected Command getChangeConstraintsCommand(List children) {
	List constraints = helper.getGridBagConstraints(children);
	if (!children.isEmpty() && !constraints.isEmpty()) {
		return helper.getAddChildrenCommand(children, constraints, null);	// Now let the helper add them back correctly.
	}
	return null;
}

}