package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;
import com.ibm.etools.common.command.Command;

/**
 * This helper interface is used when a container's layout is changed
 * and the constraints for it's children need to be adjusted or added 
 * to work correctly in the new layout manager.
 *
 * Creation date: (10/9/00 5:33:16 PM)
 * @author: Peter Walker
 */
public interface IConstraintConverter {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
/**
 * Return a compound command containing the constraint commands
 * for each of the container's children that were adjusted.
 * Creation date: (10/9/00 5:52:50 PM)
 */
Command getComponentConstraintsCommand();
/**
 * Set the container whose children's constraints need to be adjusted.
 * Creation date: (10/9/00 5:52:50 PM)
 */
void setContainer(IJavaObjectInstance aContainer);
}


