package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.io.File;
import java.util.StringTokenizer;

import org.eclipse.jface.viewers.LabelProvider;

import com.ibm.etools.java.instantiation.base.IJavaObjectInstance;

public class ImageIconLabelProvider extends LabelProvider {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public String getText(Object element) {

		if (element instanceof IJavaObjectInstance) {
			IJavaObjectInstance imageIcon = (IJavaObjectInstance) element;
			return getPathFromInitializationString(imageIcon.getInitializationString());
		}
		return ""; //$NON-NLS-1$
	}

	public static String fixBackSlash(String pathname) {
		if (pathname != null && !pathname.equals("")) { //$NON-NLS-1$
			pathname = pathname.replace('\\', '/');
		}
		return pathname;

	}
	
	/**
	 * Parse through the initialization string and strip out the path information.
	 */
	protected String getPathFromInitializationString(String initStr) {
		if (initStr == null || initStr.equals("") || initStr.indexOf('"') == -1) //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		StringTokenizer stk = new StringTokenizer(initStr, "\""); //$NON-NLS-1$
		String first = stk.nextToken();
		String pathname = fixBackSlash(stk.nextToken().trim());
		return pathname;
	}
}