package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.emf.ecore.*;
import com.ibm.etools.emf.ecore.EClass;
import com.ibm.etools.emf.ecore.EFactory;
import com.ibm.etools.emf.resource.*;
import com.ibm.etools.emf.resource.URI;
import com.ibm.etools.emf.resource.URIFactory;

/**
 * URI's for important features in EMF within a class.
 * @version 	1.0
 * @author
 */
public class JBCFConstants {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public static final URI
		SF_COMPONENT_VISIBLE,	// java.awt.Component, visible
		SF_COMPONENT_LOCATION,	// java.awt.Component, location
		SF_COMPONENT_SIZE,		// java.awt.Component, size
		SF_COMPONENT_BOUNDS,	// java.awt.Component, bounds
		SF_COMPONENT_NAME,		// java.awt.Component, name
		
		SF_CONSTRAINT_COMPONENT,	// containerVisuals/ConstraintComponent, component
		SF_CONSTRAINT_CONSTRAINT,	// containerVisuals/ConstraintComponent, constraint
		
		SF_CONTAINER_COMPONENTS,	// java.awt.Container, components
		SF_CONTAINER_LAYOUT,	// java.awt.Container, layout
		
		SF_DIALOG_MODAL,		// java.awt.Dialog, modal		
		
		SF_GRIDBAGCONSTRAINTS_GRIDX,	// java.awt.GridBagConstraints, gridx
		SF_GRIDBAGCONSTRAINTS_GRIDY,
		SF_GRIDBAGCONSTRAINTS_GRIDWIDTH,
		SF_GRIDBAGCONSTRAINTS_GRIDHEIGHT,
		SF_GRIDBAGCONSTRAINTS_WEIGHTX,
		SF_GRIDBAGCONSTRAINTS_WEIGHTY,
		SF_GRIDBAGCONSTRAINTS_FILL,
		SF_GRIDBAGCONSTRAINTS_INSETS,
		SF_GRIDBAGCONSTRAINTS_IPADX,
		SF_GRIDBAGCONSTRAINTS_IPADY,
		
		SF_LABEL_TEXT,
		
		SF_JSCROLLPANE_VIEWPORTVIEW,
		
		SF_JSPLITPANE_LEFTCOMPONENT,
		SF_JSPLITPANE_RIGHTCOMPONENT,
		SF_JSPLITPANE_TOPCOMPONENT,
		SF_JSPLITPANE_BOTTOMCOMPONENT,
		SF_JSPLITPANE_ORIENTATION,
		SF_JSPLITPANE_DIVIDERLOCATION,	
		
		SF_JSLIDER_MAJORTICKS,
		SF_JSLIDER_LABELTABLE,	
		
		SF_JTABBEDPANE_TABS,
		SF_JTABCOMPONENT_COMPONENT,	//jtabbedPaneVisuals/JTabComponent, component
		SF_JTABCOMPONENT_ICON,	//jtabbedPaneVisuals/JTabComponent, tabIcon
		SF_JTABCOMPONENT_TITLE,	//jtabbedPaneVisuals/JTabComponent, tabTitle
		SF_JTABCOMPONENT_TOOLTIP,	//jtabbedPaneVisuals/JTabComponent, tabTooltipText
		
		SF_JTABLE_COLUMNS,
		SF_JTABLE_AUTOCREATECOLUMNSFROMMODEL,
		SF_TABLECOLUMN_MODELINDEX,
		SF_TABLECOLUMN_HEADERVALUE,		
		
		SF_JMENUBAR_MENUS,
		SF_JMENU_ITEMS,
		
		CLASS_CONTAINER_CONSTRAINTCOMPONENT,	// containerVisuals/ConstraintComponent
		CLASS_JTABBEDPANE_JTABCOMPONENT;	// jtabbedPaneVisuals/JTabComponent	
		
	static {
		URIFactory fact = URIFactoryRegister.getFactory();

		SF_COMPONENT_VISIBLE = fact.makeURI("java:/java.awt#Component/visible");		 //$NON-NLS-1$
		SF_COMPONENT_LOCATION = fact.makeURI("java:/java.awt#Component/location");		 //$NON-NLS-1$
		SF_COMPONENT_SIZE = fact.makeURI("java:/java.awt#Component/size");				 //$NON-NLS-1$
		SF_COMPONENT_BOUNDS = fact.makeURI("java:/java.awt#Component/bounds");						 //$NON-NLS-1$
		SF_COMPONENT_NAME = fact.makeURI("java:/java.awt#Component/name");						 //$NON-NLS-1$
		SF_CONTAINER_LAYOUT = fact.makeURI("java:/java.awt#Container/layout"); //$NON-NLS-1$
		SF_CONTAINER_COMPONENTS = fact.makeURI("java:/java.awt#Container/components");		 //$NON-NLS-1$
		SF_CONSTRAINT_COMPONENT = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/java/awt/containerVisuals.xmi#ConstraintComponent.component"); //$NON-NLS-1$
		SF_CONSTRAINT_CONSTRAINT = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/java/awt/containerVisuals.xmi#ConstraintComponent.constraint"); //$NON-NLS-1$
		
		SF_DIALOG_MODAL = fact.makeURI("java:/java.awt#Dialog/modal");		 //$NON-NLS-1$		
				
		SF_GRIDBAGCONSTRAINTS_GRIDX = fact.makeURI("java:/java.awt#GridBagConstraints/gridx"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_GRIDY = fact.makeURI("java:/java.awt#GridBagConstraints/gridy"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_GRIDWIDTH = fact.makeURI("java:/java.awt#GridBagConstraints/gridwidth"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_GRIDHEIGHT = fact.makeURI("java:/java.awt#GridBagConstraints/gridheight"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_WEIGHTX = fact.makeURI("java:/java.awt#GridBagConstraints/weightx"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_WEIGHTY = fact.makeURI("java:/java.awt#GridBagConstraints/weighty"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_FILL = fact.makeURI("java:/java.awt#GridBagConstraints/fill"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_INSETS = fact.makeURI("java:/java.awt#GridBagConstraints/insets"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_IPADX = fact.makeURI("java:/java.awt#GridBagConstraints/ipadx"); //$NON-NLS-1$
		SF_GRIDBAGCONSTRAINTS_IPADY = fact.makeURI("java:/java.awt#GridBagConstraints/ipady");																				 //$NON-NLS-1$
		
		SF_LABEL_TEXT = fact.makeURI("java:/java.awt#Label/text");																				 //$NON-NLS-1$		

		SF_JSCROLLPANE_VIEWPORTVIEW = fact.makeURI("java:/javax.swing#JScrollPane/viewportView"); //$NON-NLS-1$
		
		SF_JSPLITPANE_LEFTCOMPONENT = fact.makeURI("java:/javax.swing#JSplitPane/leftComponent");		 //$NON-NLS-1$
		SF_JSPLITPANE_RIGHTCOMPONENT = fact.makeURI("java:/javax.swing#JSplitPane/rightComponent"); //$NON-NLS-1$
		SF_JSPLITPANE_TOPCOMPONENT = fact.makeURI("java:/javax.swing#JSplitPane/topComponent"); //$NON-NLS-1$
		SF_JSPLITPANE_BOTTOMCOMPONENT = fact.makeURI("java:/javax.swing#JSplitPane/bottomComponent"); //$NON-NLS-1$
		SF_JSPLITPANE_ORIENTATION = fact.makeURI("java:/javax.swing#JSplitPane/orientation");		 //$NON-NLS-1$
		SF_JSPLITPANE_DIVIDERLOCATION = fact.makeURI("java:/javax.swing#JSplitPane/dividerLocation");		 //$NON-NLS-1$
		
		SF_JSLIDER_MAJORTICKS = fact.makeURI("java:/javax.swing#JSlider/majorTickSpacing");		 //$NON-NLS-1$
		SF_JSLIDER_LABELTABLE= fact.makeURI("java:/javax.swing#JSlider/labelTable");		 //$NON-NLS-1$
				
		SF_JTABBEDPANE_TABS = fact.makeURI("java:/javax.swing#JTabbedPane/tabs"); //$NON-NLS-1$
		
		SF_JTABCOMPONENT_COMPONENT = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/javax/swing/jtabbedPaneVisuals.xmi#JTabComponent.component");		 //$NON-NLS-1$
		SF_JTABCOMPONENT_ICON = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/javax/swing/jtabbedPaneVisuals.xmi#JTabComponent.tabIcon"); //$NON-NLS-1$
		SF_JTABCOMPONENT_TITLE = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/javax/swing/jtabbedPaneVisuals.xmi#JTabComponent.tabTitle");		 //$NON-NLS-1$
		SF_JTABCOMPONENT_TOOLTIP = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/javax/swing/jtabbedPaneVisuals.xmi#JTabComponent.tabTooltipText");		 //$NON-NLS-1$

		SF_JTABLE_COLUMNS = fact.makeURI("java:/javax.swing#JTable/columns"); //$NON-NLS-1$
		SF_JTABLE_AUTOCREATECOLUMNSFROMMODEL = fact.makeURI("java:/javax.swing#JTable/autoCreateColumnsFromModel");	//$NON-NLS-1$
		
		SF_TABLECOLUMN_MODELINDEX = fact.makeURI("java:/javax.swing.table#TableColumn/modelIndex");	//$NON-NLS-1$		
		SF_TABLECOLUMN_HEADERVALUE = fact.makeURI("java:/javax.swing.table#TableColumn/headerValue");	//$NON-NLS-1$				


		SF_JMENUBAR_MENUS = URIFactoryRegister.getFactory().makeURI("java:/javax.swing#JMenuBar/menus"); //$NON-NLS-1$
		SF_JMENU_ITEMS = URIFactoryRegister.getFactory().makeURI("java:/javax.swing#JMenu/items"); //$NON-NLS-1$
		
		CLASS_CONTAINER_CONSTRAINTCOMPONENT = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/java/awt/containerVisuals.xmi#ConstraintComponent");				 //$NON-NLS-1$
		CLASS_JTABBEDPANE_JTABCOMPONENT = fact.makeURI("plugin.com.ibm.etools.jbcf.visual/overrides/javax/swing/jtabbedPaneVisuals.xmi#JTabComponent");						 //$NON-NLS-1$
	}
	
	public static EFactory getFactory(EClass aClass) {
		return (EFactory) ((EPackage) aClass.getEObjectContainer()).getFactory();
	}
}
