package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.List;

import org.eclipse.jdt.launching.VMRunnerConfiguration;

import com.ibm.etools.jbcf.*;
import com.ibm.etools.jbcf.JBCFPlugin;
import com.ibm.etools.jbcf.vce.VCEPlugin;
import com.ibm.etools.proxy.*;

public class JBCFVisualContributor implements IConfigurationContributor {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	public void contributeClasspaths(List classPaths, IClasspathContributionController controller) {
		// Add the visualvm.jar and nls jars to the end of the classpath. This jar contains the vm stuff
		// needed for doing JVE editing.
		controller.contributeClasspath(
			ProxyPlugin.getPlugin().urlLocalizeFromPluginDescriptorAndFragments(JBCFVisualPlugin.getPlugin().getDescriptor(), "jbcfvisualvm.jar"), //$NON-NLS-1$
			classPaths,
			-1);
	}
	/*
	 * @see IConfigurationContributor#contributeToConfiguration(VMRunnerConfiguration)
	 */
	public void contributeToConfiguration(VMRunnerConfiguration config) {
	}

	/*
	 * @see IConfigurationContributor#contributeToRegistry(ProxyFactoryRegistry)
	 */
	public void contributeToRegistry(ProxyFactoryRegistry registry) {
		String lookAndFeelClass =
			VCEPlugin.getPlugin().getPluginPreferences().getString(VCEPlugin.SWING_LOOKANDFEEL);
		if (lookAndFeelClass != null & lookAndFeelClass.length() > 0) {
			try {
				IBeanTypeProxy aUIManagerBeanTypeProxy =
					registry.getBeanTypeProxyFactory().getBeanTypeProxy("javax.swing.UIManager"); //$NON-NLS-1$
				IMethodProxy setLookAndFeelMethodProxy =
					aUIManagerBeanTypeProxy.getMethodProxy("setLookAndFeel", "javax.swing.LookAndFeel"); //$NON-NLS-1$ //$NON-NLS-2$
				IBeanProxy windowsLookAndFeelProxy =
					registry.getBeanTypeProxyFactory().getBeanTypeProxy(lookAndFeelClass).newInstance();
				setLookAndFeelMethodProxy.invoke(aUIManagerBeanTypeProxy, windowsLookAndFeelProxy);
			} catch (ThrowableProxy exc) {
				JBCFPlugin.log("Unable to set target VM to L&F" + lookAndFeelClass, JBCFMsgLogger.LOG_WARNING); //$NON-NLS-1$
				JBCFPlugin.log(exc, JBCFMsgLogger.LOG_WARNING);
			}
		}
	}

}