package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */
 
import java.util.List;

import com.ibm.etools.cde.ImageFigure;
import com.ibm.etools.gef.EditPart;
 
/**
 * GraphicalEditPart for JLayeredPane.
 * 
 * @author richkulp
 */
public class JLayeredPaneGraphicalEditPart extends ContainerGraphicalEditPart {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$

	/**
	 * Constructor for JLayeredPaneGraphicalEditPart.
	 * @param model
	 */
	public JLayeredPaneGraphicalEditPart(Object model) {
		super(model);
	}

	/**
	 * @see com.ibm.etools.gef.editparts.AbstractEditPart#createChild(Object)
	 */
	protected EditPart createChild(Object model) {
		// All of the children of a JLayeredGraphicalEditPart need 
		// to have this component's ImageFigure made the parent image figure so
		// that they will draw in the correct order and any overlaying bounds will be clipped
		// correctly.
		EditPart ep = super.createChild(model);
		((ImageFigure) ((ComponentGraphicalEditPart) ep).getFigure()).setUseParentImageFigure(true);
		return ep;
	}

	/**
	 * @see com.ibm.etools.gef.editparts.AbstractEditPart#getModelChildren()
	 */
	protected List getModelChildren() {
		// Bit of a kludge, but we need to get the order that the JLayeredPane has them. They may
		// be a different order because it all depends on the layer/order they were added, or in
		// the case of JDesktopPane, which one was selected. Thus, the hit test order could be
		// different than the order in the MOF model.
		return ((JLayeredPaneProxyAdapter) getComponentProxy()).getCurrentOrder();
	}

}
