package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.cde.FlowLayoutEditPolicy;
import com.ibm.etools.draw2d.FlowLayout;

/**
 * @author pwalker
 *
 * Layout edit policy for JmenuBarGraphicalEditPart
 * We need a FlowLayout so we can insert & add menus with the flow layout feedback
 */
public class JMenuBarLayoutEditPolicy extends FlowLayoutEditPolicy {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected FlowLayout fFlowLayout = new FlowLayout(); // Required for the superclass to work correctly

	/**
	 * Constructor for JMenuBarLayoutEditPolicy.
	 * Use JMenuBarContainerPolicy which allows only JMenu's to be added.
	 * @param containerPolicy
	 */
	public JMenuBarLayoutEditPolicy(JMenuBarGraphicalEditPart editpart) {
		super(new JMenuBarContainerPolicy(EditDomain.getEditDomain(editpart)));
		fFlowLayout.setHorizontal(true); // AWT is only horizontal
	}

	/**
	 * The inherited GEF behavior requires us to use a FlowLayout.
	 * Our figure is really an XY layout so we hold onto our own draw2d layout
	 */
	protected FlowLayout getLayoutManager() {
		return fFlowLayout;
	}
}
