package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.List;

import com.ibm.etools.cde.CDEUtilities;
import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.emf.ecore.EStructuralFeature;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.gef.EditPart;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.java.JavaClass;

/**
 * @author pwalker
 *
 * GraphicalEditPart for javax.swing.JPopupMenu's.
 * This is not currently used because we don't know how to create
 * the children for Actions and Strings.
 */
public class JPopupMenuGraphicalEditPart extends ContainerGraphicalEditPart {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected EStructuralFeature sfItems;

	/**
	 * Constructor for JPopupMenuTreeEditPart.
	 * @param model
	 */
	public JPopupMenuGraphicalEditPart(Object model) {
		super(model);
	}

	/**
	 * Use a JPopupMenuLayoutPolicy which is a FlowLayout
	 */
	protected void createLayoutEditPolicy() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new JPopupMenuLayoutEditPolicy(this));
	}

	public List getModelChildren() {
		return (List) ((RefObject) getModel()).refValue(sfItems);
	}
	public void notifyChanged(
		Notifier notifier,
		int eventType,
		RefObject sf,
		Object oldValue,
		Object newValue,
		int pos) {
		if (sf == sfItems)
			refreshChildren();
	}
	protected EditPart createChild(Object model) {
		EditDomain dom = EditDomain.getEditDomain(this);
		EditPart ep = CDEUtilities.getEditPartFactory(this).createEditPart(model);
		// Commented out the next 2 lines of code because Actions and strings
		// can be added to menus and are not ComponentGraphicalEditParts. This
		// causes ClassCastExceptions and needs to be designed more carefully.
//		((ComponentGraphicalEditPart) ep).setPropertySourceModel((Notifier) ((RefObject) model));
//		((ComponentGraphicalEditPart) ep).setTransparent(true);
		return ep;
	}
	/*
	 * @see EditPart#setModel(Object)
	 */
	public void setModel(Object model) {
		super.setModel(model);
		JavaClass modelType = (JavaClass) ((RefObject) model).refMetaObject();
		sfItems = (EStructuralFeature) modelType.metaObject("items"); //$NON-NLS-1$
	}
}
