package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.*;

import com.ibm.etools.cde.*;
import com.ibm.etools.cde.DefaultContainerEditPolicy;
import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.cde.emf.*;
import com.ibm.etools.draw2d.IFigure;
import com.ibm.etools.emf.ecore.EStructuralFeature;
import com.ibm.etools.emf.notify.Adapter;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.emf.resource.ResourceSet;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.EditPart;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.java.instantiation.base.*;
import com.ibm.etools.jbcf.BeanProxyUtilities;
import com.ibm.etools.proxy.*;
import com.ibm.etools.proxy.IBeanProxy;
import com.ibm.etools.proxy.IIntegerBeanProxy;

public class JTableGraphicalEditPart extends ComponentGraphicalEditPart implements IEMFListener {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private EStructuralFeature sf_tableColumns;
	protected EMFListenerAdapter containerAdapter;

public JTableGraphicalEditPart(Object aModel){
	super(aModel);
}
protected void createEditPolicies(){
	installEditPolicy(EditPolicy.CONTAINER_ROLE, new DefaultContainerEditPolicy());	
	super.createEditPolicies();
}

protected List getModelChildren() {
	// columns children is the feature for the children
	return (List) ((RefObject) getModel()).refValue(sf_tableColumns);
}

protected EditPart createChild(Object model) {
	EditDomain dom = EditDomain.getEditDomain(this);
	EditPart ep = new TableColumnGraphicalEditPart(model);
	return ep;
}

public void setModel(Object aModel){
	super.setModel(aModel);
	// Get and cache the structural feature that traverses from the JTable to its
	// table columns
	ResourceSet rset = ((IJavaObjectInstance) aModel).getResourceSet();	
	sf_tableColumns = JavaInstantiation.getSFeature(rset, JBCFConstants.SF_JTABLE_COLUMNS);
}
public void activate() {
	super.activate();
	((RefObject) getModel()).addAdapter(getModelAdapter());
}
protected Adapter getModelAdapter() {
	if (containerAdapter == null) {
		containerAdapter = new EMFListenerAdapter(this, false);
	}
	return containerAdapter;
}
public void deactivate() {
	super.deactivate();
	((RefObject) getModel()).removeAdapter(getModelAdapter());
}
public void notifyChanged(Notifier notifier, int eventType, RefObject sf, Object oldValue, Object newValue, int pos) {
	refreshChildren();
}
}