package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.cde.IPaletteContributionItem;
import com.ibm.etools.gef.*;
import org.eclipse.jface.action.ControlContribution;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.SWT;

public class PaletteCategoryContribution extends ControlContribution implements IPaletteContributionItem {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Button fButton;
	protected EditDomain fEditDomain;
	protected String fLabel;
	protected Image fImage;
	
public PaletteCategoryContribution(String id,Image image, String label) {
	super(id);
	fImage = image;
	fLabel = label;
}	

public Control createControl(Composite aComposite){
	
	fButton = new Button(aComposite,SWT.PUSH);
	if ( fImage != null){
		fButton.setImage(fImage);
	}
	if ( fLabel != null){
		fButton.setText(fLabel);
	}
	fButton.setEnabled(fEditDomain != null);	
	return fButton;
	
}
public void setEditDomain(EditDomain anEditDomain){
	if (fButton != null){
		fButton.setEnabled(anEditDomain != null);
	}
	fEditDomain = anEditDomain;
}
}
