package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.List;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.cde.emf.EMFContainerPolicy;
import com.ibm.etools.common.command.Command;
import com.ibm.etools.common.command.UnexecutableCommand;

/**
 * Container policy for rootpanes whose only child is a contentpane...
 * so this is here to prevent adding, deleting anything from the container.
 * 
 */
public class RootPaneContainerPolicy extends EMFContainerPolicy {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Constructor for RootPaneContainerPolicy.
	 * @param domain
	 */
	public RootPaneContainerPolicy(EditDomain domain) {
		super(null, domain);
	}

	/**
	 * @see com.ibm.etools.cde.ContainerPolicy#getDeleteDependentCommand(Object)
	 */
	public Command getDeleteDependentCommand(Object child) {
		return null;
	}

	/**
	 * @see com.ibm.etools.cde.ContainerPolicy#getMoveChildrenCommand(List, Object)
	 */
	public Command getMoveChildrenCommand(List children, Object positionBeforeChild) {
		return UnexecutableCommand.INSTANCE;
	}

	/**
	 * @see com.ibm.etools.cde.ContainerPolicy#getOrphanChildrenCommand(List)
	 */
	public Command getOrphanChildrenCommand(List children) {
		return UnexecutableCommand.INSTANCE;
	}

	/**
	 * @see com.ibm.etools.cde.emf.AbstractEMFContainerPolicy#isValidChild(Object)
	 */
	protected boolean isValidChild(Object child) {
		return false;
	}

}