package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.List;

import com.ibm.etools.cde.EditDomain;
import com.ibm.etools.emf.ecore.EStructuralFeature;
import com.ibm.etools.emf.notify.Notifier;
import com.ibm.etools.emf.ref.RefObject;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.java.JavaClass;

/**
 * @author pwalker
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class RootPaneJMenuBarContainerTreeEditPart extends RootPaneContainerTreeEditPart {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private EStructuralFeature sf_jmenubar;

	/**
	 * Constructor for RootPaneJMenuBarContainerTreeEditPart.
	 * @param model
	 */
	public RootPaneJMenuBarContainerTreeEditPart(Object model) {
		super(model);
	}

	/**
	 * Our children is the root pane.  We must create one for now if it is not there
	 */
	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.TREE_CONTAINER_ROLE, new com.ibm.etools.cde.TreeContainerEditPolicy(createContainerEditPolicy()));
	}

	protected com.ibm.etools.cde.ContainerPolicy createContainerEditPolicy() {
		return new RootPaneJMenuBarContainerPolicy(EditDomain.getEditDomain(this));
	}

	/**
	 * Our logical child is the JMenuBar.
	 */
	public List getModelChildren() {
		RefObject model = (RefObject) getModel();
		List result = super.getModelChildren();

		// If there is a JMenuBar, include this in the list
		if (sf_jmenubar != null) {
			Object jmenuBar = model.refValue(sf_jmenubar);
			if (jmenuBar != null)
				result.add(jmenuBar);
		}

		return result;
	}

	public void notifyChanged(Notifier notifier, int eventType, RefObject sf, Object oldValue, Object newValue, int pos) {
		super.notifyChanged(notifier, eventType, sf, oldValue, newValue, pos);
		if (sf == sf_jmenubar)
			refreshChildren();
	}

	public void setModel(Object model) {
		super.setModel(model);
		JavaClass modelType = (JavaClass) ((RefObject) model).refMetaObject();
		sf_jmenubar = (EStructuralFeature) modelType.metaObject("JMenuBar"); //$NON-NLS-1$
	}
}
