package com.ibm.etools.jbcf.visual;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.cde.*;
import com.ibm.etools.draw2d.Figure;
import com.ibm.etools.draw2d.IFigure;
import com.ibm.etools.gef.EditPolicy;
import com.ibm.etools.gef.editparts.AbstractGraphicalEditPart;

/**
 * This is here only so that we have a child of JTable that can be selected.
 * It can't be selected graphically because it won't even be visible. It will
 * be selected via the JavaBeanViewer and the SelectionSynchronizer. It is
 * here so that when selected in the tree, a selection will be notified here,
 * and anyone listening (such as CardLayout) will know it was selected.
 */
public class TableColumnGraphicalEditPart extends AbstractGraphicalEditPart {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public TableColumnGraphicalEditPart(Object aModel){
	setModel(aModel);
}
public void createEditPolicies(){
	// It has none. It is not even selectable. 
}
protected IFigure createFigure() {
	Figure fig = new Figure();
	fig.setVisible(false);
	return fig;
}	
}
