package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import javax.swing.border.*;


public class BorderEditor extends java.beans.PropertyEditorSupport {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Object fBorder = null;
	protected BorderPropertyEditor fCustomEditor = null;
	
public String getAsText(){
	if (fBorder == null) return ""; //$NON-NLS-1$
	// Force creation of the custom editor because this knows how to 
	// create a nice display name for the border
	getCustomEditor();
	return fCustomEditor.getBorderName();
}

public java.awt.Component getCustomEditor(){
	if(fCustomEditor == null){
		Border aBorder = (Border)getValue();
		if (aBorder == null){
			fCustomEditor = new BorderPropertyEditor();
		}
		else{
			fCustomEditor = new BorderPropertyEditor(aBorder);
		}
	}
	return fCustomEditor;
}

public String getJavaInitializationString(){
	Border Border = (Border) fBorder;
	if (fCustomEditor != null){
		return fCustomEditor.getBorderInitializationString();
	}
	else{
		return fBorder.toString();
	}
}

public Object getValue(){
	if (fCustomEditor != null){
		return (Object)fCustomEditor.getBorderValue();
	}else{
		return super.getValue();
	}
}

public void setValue(Object newValue){
	fBorder = newValue;
	if(fCustomEditor != null){
		fCustomEditor.setBorderValue((Border)newValue);
	}
	super.setValue(newValue);
}

public boolean supportsCustomEditor(){
	return true;
}

}