package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.awt.FlowLayout;
import java.beans.*;

public class FlowLayoutBeanInfo extends IvjBeanInfo {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
private static java.util.ResourceBundle FlowLayoutMessages = java.util.ResourceBundle.getBundle("com/ibm/etools/jbcf/visual/beaninfo/flowlayout");  //$NON-NLS-1$

public Class getBeanClass() {
	return FlowLayout.class;
}
public java.beans.BeanDescriptor getBeanDescriptor() {
	return new java.beans.BeanDescriptor(FlowLayout.class);
}
/**
 * Return the event set descriptors for this bean.
 * @return java.beans.EventSetDescriptor[]
 */
public java.beans.EventSetDescriptor[] getEventSetDescriptors() {
	return( new java.beans.EventSetDescriptor[0]);
}
/**
 * Return the property descriptors for this bean.
 * @return java.beans.PropertyDescriptor[]
 */
public java.beans.PropertyDescriptor[] getPropertyDescriptors() {

	try {
		java.beans.PropertyDescriptor aDescriptorList[] = {
			// hgap
	   	super.createPropertyDescriptor(getBeanClass(),"Hgap", new Object[] {//$NON-NLS-1$
		   	DISPLAYNAME, "horizontal gap", //$NON-NLS-1$
	      	SHORTDESCRIPTION, "Horizontal gap between components", //$NON-NLS-1$
	    		}
	    	),				
			// vgap
	   	super.createPropertyDescriptor(getBeanClass(),"Vgap", new Object[] {//$NON-NLS-1$
		   	DISPLAYNAME, "vertical gap", //$NON-NLS-1$
	      	SHORTDESCRIPTION, "Veritcal gap between components", //$NON-NLS-1$
	    		}
			),
		super.createPropertyDescriptor(getBeanClass(),"alignment" ,new Object[] { //$NON-NLS-1$
			DISPLAYNAME , FlowLayoutMessages.getString("alignment.Name"), //$NON-NLS-1$
			SHORTDESCRIPTION, FlowLayoutMessages.getString("alignment.Desc"), //$NON-NLS-1$
			ENUMERATIONVALUES, new Object[] {
	      		FlowLayoutMessages.getString("LEFT"), new Integer(FlowLayout.LEFT), "java.awt.FlowLayout.LEFT", //$NON-NLS-1$ //$NON-NLS-2$
	           	FlowLayoutMessages.getString("CENTER"), new Integer(FlowLayout.CENTER), "java.awt.FlowLayout.CENTER", //$NON-NLS-1$ //$NON-NLS-2$
	          	FlowLayoutMessages.getString("RIGHT"),new Integer(FlowLayout.RIGHT), "java.awt.FlowLayout.RIGHT", //$NON-NLS-1$ //$NON-NLS-2$
	    		}
			}
		),
		};			
		return aDescriptorList;
	} catch (Throwable exception) {
		handleException(exception);
	};
	return null;
}
}
