package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.awt.*;
import java.beans.*;

public class FontEditor extends PropertyEditorSupport {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static java.util.ResourceBundle resabtedit = java.util.ResourceBundle.getBundle("com/ibm/etools/jbcf/visual/beaninfo/vceedit");  //$NON-NLS-1$
	FontPropertyEditor customEditor = null;
	private Object fFont = null;
public String getAsText() {
	String strStyle;
	Font font = (Font) getValue();
	if (!(font instanceof Font))
		return null;	
	if (font.isBold()) {
		strStyle = font.isItalic() ? resabtedit.getString("bolditalic") : resabtedit.getString("bold"); //$NON-NLS-2$ //$NON-NLS-1$
	} else {
		strStyle = font.isItalic() ? resabtedit.getString("italic") : resabtedit.getString("plain"); //$NON-NLS-2$ //$NON-NLS-1$
	}
	return font.getName() + ", " + strStyle + ", " + font.getSize(); //$NON-NLS-2$//$NON-NLS-1$
}
public Component getCustomEditor() {
	if (customEditor == null) {
		Font aFont = (Font)getValue();
		if (aFont == null) {
			customEditor = new FontPropertyEditor();
		} else {
			customEditor = new FontPropertyEditor(aFont);
		}
	}	
	return customEditor;
}
public String getJavaInitializationString() {
	
	Font font = (Font)getValue();
	if (font != null)	
		return "new java.awt.Font(\"" + font.getFamily() + "\", " +//$NON-NLS-2$//$NON-NLS-1$
			font.getStyle() + ", " + font.getSize() + ")";//$NON-NLS-2$//$NON-NLS-1$
	return "new java.awt.Font(\"dialog\", 0, 12)"; //$NON-NLS-1$
}
public Object getValue() {

	if (customEditor != null) {
		return customEditor.getFontValue();
	} else {
		return super.getValue();
	}	
}
public void setAsText(String text) throws IllegalArgumentException {
	throw new IllegalArgumentException(text);
}
public void setValue(Object newValue) {
	
	if (customEditor != null) {
		customEditor.setFontValue((Font)newValue);
	}
	fFont = newValue;
	super.setValue(newValue);	
}
public boolean supportsCustomEditor() {
	return true;
}
}
