/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



package com.ibm.etools.jbcf.visual.beaninfo;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
/**
 * This type was generated by a SmartGuide.
 */
public class FontPropertyEditor extends Panel implements java.beans.PropertyChangeListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static java.util.ResourceBundle resabtedit = java.util.ResourceBundle.getBundle("com/ibm/etools/jbcf/visual/beaninfo/vceedit");  //$NON-NLS-1$
	private Font fontValue;
	private java.lang.String[] fonts;
	private BorderLayout ivjBorderLayout = null;
	private Panel ivjHeaderPanel = null;
	private GridLayout ivjHeaderGridLayout = null;
	private Label ivjFamilyLabel = null;
	private Label ivjStyleLabel = null;
	private Label ivjSizeLabel = null;
	private List ivjFamilyChooser = null;
	private List ivjSizeChooser = null;
	private List ivjStyleChooser = null;
	private TextArea ivjTextArea = null;
	private final static int[] pointSizes = { 3, 5, 8, 10, 12, 14, 18, 24, 36, 48 };
	private Label sample;
	private String sampleText = resabtedit.getString("Abcde..."); //$NON-NLS-1$
	private final static java.lang.String[] styleNames = { resabtedit.getString("plain"), resabtedit.getString("bold"), resabtedit.getString("italic"), resabtedit.getString("bold_italic") }; //$NON-NLS-3$ //$NON-NLS-2$ //$NON-NLS-1$ //$NON-NLS-4$
	private final static int[] styles = { Font.PLAIN, Font.BOLD, Font.ITALIC, Font.BOLD | Font.ITALIC };
	private PropertyChangeSupport support = new PropertyChangeSupport(this);
	private Toolkit toolkit;
/**
 * IBMFontEditor constructor comment.
 */
public FontPropertyEditor() {
	super();
	this.initialize();	
	// If we are created with a null constructor make sure we have some font to show
	setFontValue(new java.awt.Font("SansSerif" , java.awt.Font.PLAIN , 12)); //$NON-NLS-1$

}
/**
 * IBMFontEditor constructor comment.
 */
public FontPropertyEditor(Font aFont) {
	super();
	this.initialize();
	setFontValue(aFont);
}

/**
 * addPropertyChangeListener method comment.
 */
public synchronized void addPropertyChangeListener(PropertyChangeListener listener) {
	support.addPropertyChangeListener(listener);
}
public void updateFont(){

	String family = getFamilyChooser().getSelectedItem();
	int style = styles[getStyleChooser().getSelectedIndex()];
	int size = pointSizes[getSizeChooser().getSelectedIndex()];
	try {
	    Font f = new Font(family, style, size);
	    changeFont(f);
	} catch (Exception ex) {
	    System.err.println(resabtedit.getString("Couldn't_create_font") + family + "-" +//$NON-NLS-2$ //$NON-NLS-1$
			styleNames[style] + "-" + size);//$NON-NLS-1$
	}
}
/**
 * This method was created by a SmartGuide.
 * @param f java.awt.Font
 */
private void changeFont(Font f) {

	fontValue = f;
	Component p = getParent();
	if (p != null) {
	    p.invalidate();
	    p.doLayout();
	  //``````````
	}
	invalidate();
	doLayout();
	repaint();
	support.firePropertyChange("", null, null);//$NON-NLS-1$
}
/**
 * Return the AlexFontDialogBorderLayout property value.
 * @return java.awt.BorderLayout
 */
private BorderLayout getBorderLayout() {
	try {
		/* Create part */
		ivjBorderLayout = new java.awt.BorderLayout(5,5);
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	};
	return ivjBorderLayout;
}
/**
 * Return the FamilyChooser property value.
 * @return java.awt.Choice
 */
private List getFamilyChooser() {
	if (ivjFamilyChooser == null) {
		ivjFamilyChooser = new java.awt.List();
		ivjFamilyChooser.setName("FamilyChooser");//$NON-NLS-1$
		ivjFamilyChooser.addItemListener(getItemListener());
	};
	return ivjFamilyChooser;
}
protected ItemListener fItemListener;
protected ItemListener getItemListener(){
	if ( fItemListener == null ) {
		fItemListener = new ItemListener(){
			public void itemStateChanged(ItemEvent event){
				updateFont();
			}
		};
	}
	return fItemListener;
}
/**
 * Return the FamilyLabel property value.
 * @return java.awt.Label
 */
private Label getFamilyLabel() {
	if (ivjFamilyLabel == null) {
		try {
			ivjFamilyLabel = new java.awt.Label();
			ivjFamilyLabel.setName("FamilyLabel");//$NON-NLS-1$
			ivjFamilyLabel.setText(resabtedit.getString("Name")); //$NON-NLS-1$
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjFamilyLabel;
}
/**
 * getValue method comment.
 */
public Font getFontValue() {
	return fontValue;
}
/**
 * Return the HeaderPanel property value.
 * @return java.awt.Panel
 */
private Panel getHeaderPanel() {
	if (ivjHeaderPanel == null) {
		ivjHeaderPanel = new java.awt.Panel();
		ivjHeaderPanel.setName("HeaderPanel");//$NON-NLS-1$
		ivjHeaderPanel.setLayout(new GridBagLayout());
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.anchor = GridBagConstraints.WEST;
		ivjHeaderPanel.add(getFamilyLabel(), constraints);
		constraints.gridx = constraints.gridx + 1;
		ivjHeaderPanel.add(getStyleLabel(), constraints);
		constraints.gridx = constraints.gridx + 1;			
		ivjHeaderPanel.add(getSizeLabel(), constraints);
		constraints.fill = GridBagConstraints.BOTH;
		constraints.gridx = 0;
		constraints.gridy = 1;
		constraints.weightx = 1.0;
		constraints.weighty = 1.0;						
		ivjHeaderPanel.add(getFamilyChooser(), constraints);
		constraints.weightx = 0;		
		constraints.gridx = constraints.gridx + 1;			
		ivjHeaderPanel.add(getStyleChooser(), constraints);
		constraints.gridx = constraints.gridx + 1;			
		ivjHeaderPanel.add(getSizeChooser(), constraints);
		// Add the text box to the bottom of the panel
		constraints.gridx = 0;
		constraints.gridy = 2;
		constraints.gridwidth = 3;		
		constraints.weighty = 0;		
		ivjHeaderPanel.add(getTextArea(), constraints);
	};
	return ivjHeaderPanel;
}
/**
 * Return the SizeChooser property value.
 * @return java.awt.Choice
 */
private List getSizeChooser() {
	if (ivjSizeChooser == null) {
		ivjSizeChooser = new java.awt.List();
		ivjSizeChooser.setName("SizeChooser");//$NON-NLS-1$
		ivjSizeChooser.addItemListener(getItemListener());
	};
	return ivjSizeChooser;
}
/**
 * Return the SizeLabel property value.
 * @return java.awt.Label
 */
private Label getSizeLabel() {
	if (ivjSizeLabel == null) {
		ivjSizeLabel = new java.awt.Label();
		ivjSizeLabel.setName("SizeLabel");//$NON-NLS-1$
		ivjSizeLabel.setText(resabtedit.getString("Size")); //$NON-NLS-1$
	};
	return ivjSizeLabel;
}
/**
 * Return the StyleChooser property value.
 * @return java.awt.Choice
 */
private List getStyleChooser() {
	if (ivjStyleChooser == null) {
		ivjStyleChooser = new java.awt.List();
		ivjStyleChooser.setName("StyleChooser");//$NON-NLS-1$
		ivjStyleChooser.addItemListener(getItemListener());
	};
	return ivjStyleChooser;
}
/**
 * Return the StyleLabel property value.
 * @return java.awt.Label
 */
private Label getStyleLabel() {
	if (ivjStyleLabel == null) {
		try {
			ivjStyleLabel = new java.awt.Label();
			ivjStyleLabel.setName("StyleLabel");//$NON-NLS-1$
			ivjStyleLabel.setText(resabtedit.getString("Style")); //$NON-NLS-1$
		} catch (java.lang.Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return ivjStyleLabel;
}
/**
 * This method was created by a SmartGuide.
 * @return java.awt.TextArea
 */
private TextArea getTextArea() {
	if (ivjTextArea == null) {
		ivjTextArea = new java.awt.TextArea();
		ivjTextArea.setRows(3);
		ivjTextArea.setColumns(20);
		ivjTextArea.setName("TextArea");//$NON-NLS-1$
		ivjTextArea.setText(resabtedit.getString("The_quick_brown_fox")); //$NON-NLS-1$
		// Add a listener to the tab key so the text field can be made to lose focus
		ivjTextArea.addKeyListener(new KeyAdapter(){
			public void keyPressed(KeyEvent event){
				if ( event.getKeyCode() == KeyEvent.VK_TAB ) {
					if ( event.isShiftDown() ) {
						// Tab backwards to the control before us
						getSizeChooser().requestFocus();
					} else { 
						// Forward tab is harder to process, because the text box is the last control
						// What we do is find the panel that contains us and also the OK and Cancel buttons put there by the JVE
						// and then traverse to the OK button
						try {
							Container parent = (Container)getParent().getParent();
							// The second component in the parent will be the container
							Container buttonBarPanel = (Container) ((Container)parent.getComponent(1)).getComponent(0);
							buttonBarPanel.getComponent(0).requestFocus();
						} catch (Exception exc) {
							// In case all the wierd traversal to find the OK button goes wrong
							// just go to the parent
							getParent().requestFocus();
						}
					}
				} 
			}
		});
	};
	return ivjTextArea;
}
/**
 * This method was created by a SmartGuide.
 * @param exception java.lang.Throwable
 */
private void handleException (Throwable exception ) {
	return;
}
/**
 * This method was created by a SmartGuide.
 */
private void initChoiceContents() {
    fonts = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();	

	for (int i = 0; i < fonts.length; i++) {
	    getFamilyChooser().add(fonts[i]);
	}
	for (int i = 0; i < styleNames.length; i++) {
	    getStyleChooser().add(styleNames[i]);
	}
	for (int i = 0; i < pointSizes.length; i++) {
	    getSizeChooser().add("" + pointSizes[i]);//$NON-NLS-1$
	}
	return;
}
/**
 * This method was created by a SmartGuide.
 */
private void initialize() {
	addPropertyChangeListener(this);
	setName("Font Selection");//$NON-NLS-1$
	setName("Font Selection");//$NON-NLS-1$
	setLayout(getBorderLayout());
	setSize(405, 200);
	this.add("Center", getHeaderPanel());//$NON-NLS-1$
	initChoiceContents();
}
/**
 * propertyChange method comment.
 */
public void propertyChange(PropertyChangeEvent evt) {
	if ((evt.getSource() == this) ) {	
		getTextArea().setFont((java.awt.Font)this.getFontValue());
	}
}
/**
 * removePropertyChangeListener method comment.
 */
public synchronized void removePropertyChangeListener(PropertyChangeListener listener) {
	support.removePropertyChangeListener(listener);
}
/**
 * setValue method comment.
 */
public void setFontValue(Font newFont) {
	// if (toolkit == null) { initialize(); }
	changeFont(newFont);
	
	if(fontValue!=null){
		// Update the current GUI choices.
		for (int i = 0; i < fonts.length; i++) {
			if (fonts[i].equalsIgnoreCase(fontValue.getName())) {
				getFamilyChooser().select(i);
				break;
			}
		}
		for (int i = 0; i < styleNames.length; i++) {
			if (fontValue.getStyle() == styles[i]) {
				getStyleChooser().select(i);
		      break;
			}
		}
		for (int i = 0; i < pointSizes.length; i++) {
			if (fontValue.getSize() <= pointSizes[i]) {
				getSizeChooser().select(i);
				break;
			}
		}
	}
}

public Dimension getPreferredSize(){
	return new Dimension(450,250);	
}

}
