package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.*;

public class LocaleCountry {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private String id = null;
	private String name = null;
	private LocaleVariant[] variants = null;
	private Vector fVariants = new Vector();
public String getID(){
	return id;
}

public String getName(){
	return name;
}

public LocaleVariant[] getVariants(){
	int fSize = fVariants.size();
	variants = new LocaleVariant[fSize];
	
	Enumeration enum = fVariants.elements();
	for (int i = 0; i < fSize && enum.hasMoreElements(); i++){
		variants[i] = (LocaleVariant)enum.nextElement();
	}
	
	//sort variants into ascending order
	sortVariants();
	return variants;
}


public void sortVariants(){
	for (int i = 0; i < variants.length; i++){
		String s = variants[i].getID();
		int min = i;		
		if ( s != null && !s.equals(" ")){ //$NON-NLS-1$
			for (int j = i; j < variants.length; j++){
				String newString = variants[j].getName();
				if (newString.compareTo(s) < 0){
					min = j;
					s = variants[min].getName();
				}
			}
		}

		LocaleVariant swap = variants[i];
		variants[i] = variants[min];
		variants[min] = swap;
	}

}


public void setID(String anID){
	id = anID;
}

public void setName(String aName){
	name = aName;
}

//we need to insert the variant in a right position to keep the ascending 
//order of array
public void addVariant(LocaleVariant aVariant){
	boolean shouldNotAddVariant = false;
	for (int i = 0; i < fVariants.size(); i++){
		if((LocaleVariant)(fVariants.elementAt(i)) == aVariant 
		|| aVariant.getName() == null || aVariant.getName().equals(" ")){ //$NON-NLS-1$
				shouldNotAddVariant = true;
			}
	}
		
	if (shouldNotAddVariant == false){	
		fVariants.addElement(aVariant);
	}
	
}

}