package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.Locale;

public class LocaleEditor extends java.beans.PropertyEditorSupport {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected java.lang.Object fLocale = null;
	protected LocalePropertyEditor fCustomEditor = null;
	
public String getAsText(){
	if (fLocale != null)
		return ((java.util.Locale)fLocale).getDisplayName();
	return null;
}

public java.awt.Component getCustomEditor(){
	if(fCustomEditor == null){
		Locale aLocale = (Locale)getValue();
		if (aLocale == null){
			fCustomEditor = new LocalePropertyEditor();
		}
		else{
			fCustomEditor = new LocalePropertyEditor(aLocale);
		}
	}
	return fCustomEditor;
}

public String getJavaInitializationString(){
	Locale locale = (Locale) fLocale;
	if (fCustomEditor != null){
		return fCustomEditor.getLocaleInitializationString();
	}
	else{
		return"new java.util.Locale(\" " + locale.getLanguage() + "\", \"" + locale.getCountry() + "\", \"" + locale.getVariant() + "\")"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	}
}

public Object getValue(){
	if (fCustomEditor != null){
		return (Object)fCustomEditor.getLocaleValue();
	}else{
		return super.getValue();
	}
}

public void setValue(Object newValue){
	fLocale = newValue;
	if(fCustomEditor != null){
		fCustomEditor.setLocaleValue((Locale)newValue);
	}
	super.setValue(newValue);
}

public boolean supportsCustomEditor(){
	return true;
}

}