package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.awt.*;
/**
 * This property editor is paintable and paints a preview of the chosen font
 */
public class PaintableFontEditor extends FontEditor {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
public boolean isPaintable() {
	return true;
}
/**
 * Paint a character in the rectangle in the chosen font
 */
public void paintValue(Graphics gfx, Rectangle box) {
	gfx.setColor( Color.white );
	gfx.fillRect(box.x+1, box.y+1, box.height-2, box.height-2);
	gfx.setColor( Color.black );
	Font font = (Font) getValue();
	gfx.setFont(font);
	FontMetrics fm = gfx.getFontMetrics();
	int xStart = box.x + (box.height/2)-(fm.charWidth('A')/2);
	int yStart = box.y + box.height - 1;
	gfx.drawString(new String(VisualBeanInfoMessages.getString("PaitableFontEditor.SampleString")), xStart, yStart); //$NON-NLS-1$
	gfx.drawRect(box.x+1, box.y+1, box.height-2, box.height-2);
}
}
