package com.ibm.etools.jbcf.visual.beaninfo;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
public class RGBColorPropertyPage extends JPanel implements ChangeListener, KeyListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static java.util.ResourceBundle resabtedit = java.util.ResourceBundle.getBundle("com/ibm/etools/jbcf/visual/beaninfo/vceedit");  //$NON-NLS-1$
	private JLabel blueLabel = null;
	private JSlider blueSlider = null;
	private JTextField blueText = null;
	private JLabel greenLabel = null;
	private JSlider greenSlider = null;
	private JTextField greenText = null;
	private JLabel redLabel = null;
	private JSlider redSlider = null;
	private JTextField redText = null;
	protected transient PropertyChangeSupport propertyChange = new PropertyChangeSupport(this);
public RGBColorPropertyPage() {
	super();
	initialize();
}
/**
 * The addPropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void addPropertyChangeListener(PropertyChangeListener listener) {
	propertyChange.addPropertyChangeListener(listener);
}
private void blueSliderChanged ( ) {
	// only update the textfield if this method was called
	// as a result of the user moving the slider
	if ( getBlueSlider().getValueIsAdjusting() ) {
		String oldText = getBlueText().getText();
		String newText = Integer.toString(getBlueSlider().getValue());
		if (!(oldText.equals(newText))) {
			getBlueText().setText(newText);
		}
	}
	firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	return;
}

private void blueTextChanged ( ) {
	int value;
	try {
		value = (new Integer(getBlueText().getText())).intValue();

		getBlueSlider().setValue(value);
		firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	} catch (Throwable ex) {
		// If a non-integer value is in the text field ignore it
	}
	return;
}

/**
 * The firePropertyChange method was generated to support the propertyChange field.
 */
public void firePropertyChange(String propertyName, Object oldValue, Object newValue) {
	if ( propertyChange == null ) {
		propertyChange = new PropertyChangeSupport(this);
	}
	propertyChange.firePropertyChange(propertyName, oldValue, newValue);
}
private JLabel getBlueLabel() {
	if (blueLabel == null) {
		try {
			blueLabel = new JLabel();
			blueLabel.setName("BlueLabel");//$NON-NLS-1$
			blueLabel.setText(resabtedit.getString("Blue")); //$NON-NLS-1$
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return blueLabel;
}
private JSlider getBlueSlider() {
	if (blueSlider == null) {
		try {
			blueSlider = new JSlider();
			blueSlider.setName("BlueSlider");//$NON-NLS-1$
			blueSlider.setValue(0);
			blueSlider.setMaximum(255);
			blueSlider.setMinorTickSpacing(17);
			blueSlider.setMajorTickSpacing(85);
			blueSlider.setPaintLabels(true);
			blueSlider.setPaintTicks(true);
			blueSlider.setBackground(SystemColor.control);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return blueSlider;
}
private JTextField getBlueText() {
	if (blueText == null) {
		try {
			blueText = new JTextField();
			blueText.setName("BlueText");//$NON-NLS-1$
			blueText.setText("0");//$NON-NLS-1$
			blueText.setBackground(SystemColor.window);
			blueText.setColumns(4);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return blueText;
}
/**
 * Gets the colorValueproperty (java.awt.Color) value.
 * @return The colorValue property value.
 * @see #setColorValue
 */
public Color getColorValue() {
	return (Color)getValue();
}
private JLabel getGreenLabel() {
	if (greenLabel == null) {
		try {
			greenLabel = new JLabel();
			greenLabel.setName("GreenLabel");//$NON-NLS-1$
			greenLabel.setText(resabtedit.getString("Green")); //$NON-NLS-1$
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return greenLabel;
}
private JSlider getGreenSlider() {
	if (greenSlider == null) {
		try {
			greenSlider = new JSlider();
			greenSlider.setName("GreenSlider");//$NON-NLS-1$
			greenSlider.setValue(0);
			greenSlider.setMaximum(255);
			greenSlider.setMinorTickSpacing(17);
			greenSlider.setMajorTickSpacing(85);
			greenSlider.setPaintLabels(true);
			greenSlider.setPaintTicks(true);
			greenSlider.setBackground(SystemColor.control);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return greenSlider;
}
private JTextField getGreenText() {
	if (greenText == null) {
		try {
			greenText = new JTextField();
			greenText.setName("GreenText");//$NON-NLS-1$
			greenText.setText("0");//$NON-NLS-1$
			greenText.setBackground(SystemColor.window);
			greenText.setColumns(4);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return greenText;
}
String getJavaInitializationString ( ) {
	// new Color(r,g,b)
	int r = getRedSlider().getValue();
	int g = getGreenSlider().getValue();
	int b = getBlueSlider().getValue();
	return "new java.awt.Color(" + r + "," + g + "," + b + ")";//$NON-NLS-4$//$NON-NLS-3$//$NON-NLS-2$//$NON-NLS-1$
}
private JLabel getRedLabel() {
	if (redLabel == null) {
		try {
			redLabel = new JLabel();
			redLabel.setName("RedLabel");//$NON-NLS-1$
			redLabel.setText(resabtedit.getString("Red")); //$NON-NLS-1$
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return redLabel;
}
private JSlider getRedSlider() {
	if (redSlider == null) {
		try {
			redSlider = new JSlider();
			redSlider.setName("RedSlider");//$NON-NLS-1$
			redSlider.setValue(0);
			redSlider.setMaximum(255);
			redSlider.setMinorTickSpacing(17);
			redSlider.setMajorTickSpacing(85);
			redSlider.setPaintLabels(true);
			redSlider.setPaintTicks(true);
			redSlider.setBackground(SystemColor.control);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return redSlider;
}
private JTextField getRedText() {
	if (redText == null) {
		try {
			redText = new JTextField();
			redText.setName("RedText");//$NON-NLS-1$
			redText.setText("0");//$NON-NLS-1$
			redText.setBackground(SystemColor.window);
			redText.setColumns(4);
		} catch (Throwable ivjExc) {
			handleException(ivjExc);
		}
	};
	return redText;
}
Object getValue() {
	// new Color(r,g,b)
	int r = getRedSlider().getValue();
	int g = getGreenSlider().getValue();
	int b = getBlueSlider().getValue();
	return new Color(r,g,b);
}
private void greenSliderChanged ( ) {
	// only update the textfield if this method was called
	// as a result of the user moving the slider
	if ( getGreenSlider().getValueIsAdjusting() ) {
		String oldText = getGreenText().getText();
		String newText = Integer.toString(getGreenSlider().getValue());
		if (!(oldText.equals(newText))) {
			getGreenText().setText(newText);
		}
	}
	firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	return;
}

private void greenTextChanged ( ) {
	int value;
	try {
		value = (new Integer(getGreenText().getText())).intValue();
		
		getGreenSlider().setValue(value);
		firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	} catch (Throwable ex) {
		// If a non-integer value is in the text field ignore it
	}
	return;
}

/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	// System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	// exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 */
private void initConnections() {
	getRedText().addKeyListener(this);
	getGreenText().addKeyListener(this);
	getBlueText().addKeyListener(this);
	getRedSlider().addChangeListener(this);
	getGreenSlider().addChangeListener(this);
	getBlueSlider().addChangeListener(this);
}
/**
 * Initialize the class.
 */
private void initialize() {
	setName("RGBColorPropertyPage");//$NON-NLS-1$
	setLayout(new GridBagLayout());
	setBackground(SystemColor.control);
	setSize(258, 193);

	GridBagConstraints constraintsRedLabel = new GridBagConstraints();
	constraintsRedLabel.gridx = 0; constraintsRedLabel.gridy = 0;
	constraintsRedLabel.gridwidth = 1; constraintsRedLabel.gridheight = 1;
	constraintsRedLabel.anchor = GridBagConstraints.SOUTHWEST;
	constraintsRedLabel.weightx = 0.0;
	constraintsRedLabel.weighty = 0.0;
	this.add(getRedLabel(), constraintsRedLabel);

	GridBagConstraints constraintsGreenLabel = new GridBagConstraints();
	constraintsGreenLabel.gridx = 0; constraintsGreenLabel.gridy = 2;
	constraintsGreenLabel.gridwidth = 1; constraintsGreenLabel.gridheight = 1;
	constraintsGreenLabel.anchor = GridBagConstraints.SOUTHWEST;
	constraintsGreenLabel.weightx = 0.0;
	constraintsGreenLabel.weighty = 0.0;
	this.add(getGreenLabel(), constraintsGreenLabel);

	GridBagConstraints constraintsBlueLabel = new GridBagConstraints();
	constraintsBlueLabel.gridx = 0; constraintsBlueLabel.gridy = 4;
	constraintsBlueLabel.gridwidth = 1; constraintsBlueLabel.gridheight = 1;
	constraintsBlueLabel.anchor = GridBagConstraints.SOUTHWEST;
	constraintsBlueLabel.weightx = 0.0;
	constraintsBlueLabel.weighty = 0.0;
	this.add(getBlueLabel(), constraintsBlueLabel);

	GridBagConstraints constraintsRedText = new GridBagConstraints();
	constraintsRedText.gridx = 0; constraintsRedText.gridy = 1;
	constraintsRedText.gridwidth = 1; constraintsRedText.gridheight = 1;
	constraintsRedText.anchor = GridBagConstraints.NORTHWEST;
	constraintsRedText.weightx = 0.0;
	constraintsRedText.weighty = 0.0;
	constraintsRedText.insets = new Insets(0, 0, 0, 10);
	this.add(getRedText(), constraintsRedText);

	GridBagConstraints constraintsGreenText = new GridBagConstraints();
	constraintsGreenText.gridx = 0; constraintsGreenText.gridy = 3;
	constraintsGreenText.gridwidth = 1; constraintsGreenText.gridheight = 1;
	constraintsGreenText.anchor = GridBagConstraints.NORTHWEST;
	constraintsGreenText.weightx = 0.0;
	constraintsGreenText.weighty = 0.0;
	this.add(getGreenText(), constraintsGreenText);

	GridBagConstraints constraintsBlueText = new GridBagConstraints();
	constraintsBlueText.gridx = 0; constraintsBlueText.gridy = 5;
	constraintsBlueText.gridwidth = 1; constraintsBlueText.gridheight = 1;
	constraintsBlueText.anchor = GridBagConstraints.NORTHWEST;
	constraintsBlueText.weightx = 0.0;
	constraintsBlueText.weighty = 0.0;
	this.add(getBlueText(), constraintsBlueText);

	GridBagConstraints constraintsRedSlider = new GridBagConstraints();
	constraintsRedSlider.gridx = 1; constraintsRedSlider.gridy = 0;
	constraintsRedSlider.gridwidth = 3; constraintsRedSlider.gridheight = 2;
	constraintsRedSlider.fill = GridBagConstraints.HORIZONTAL;
	constraintsRedSlider.anchor = GridBagConstraints.CENTER;
	constraintsRedSlider.weightx = 0.0;
	constraintsRedSlider.weighty = 0.0;
	constraintsRedSlider.insets = new Insets(0, 0, 20, 0);
	this.add(getRedSlider(), constraintsRedSlider);

	GridBagConstraints constraintsGreenSlider = new GridBagConstraints();
	constraintsGreenSlider.gridx = 1; constraintsGreenSlider.gridy = 2;
	constraintsGreenSlider.gridwidth = 3; constraintsGreenSlider.gridheight = 2;
	constraintsGreenSlider.fill = GridBagConstraints.HORIZONTAL;
	constraintsGreenSlider.anchor = GridBagConstraints.CENTER;
	constraintsGreenSlider.weightx = 0.0;
	constraintsGreenSlider.weighty = 0.0;
	constraintsGreenSlider.insets = new Insets(0, 0, 20, 0);
	this.add(getGreenSlider(), constraintsGreenSlider);

	GridBagConstraints constraintsBlueSlider = new GridBagConstraints();
	constraintsBlueSlider.gridx = 1; constraintsBlueSlider.gridy = 4;
	constraintsBlueSlider.gridwidth = 3; constraintsBlueSlider.gridheight = 2;
	constraintsBlueSlider.fill = GridBagConstraints.HORIZONTAL;
	constraintsBlueSlider.anchor = GridBagConstraints.CENTER;
	constraintsBlueSlider.weightx = 0.0;
	constraintsBlueSlider.weighty = 0.0;
	this.add(getBlueSlider(), constraintsBlueSlider);

	initConnections();
}
public void preselectColor(Color aColor) {
	getRedText().setText(Integer.toString(aColor.getRed()));
	getGreenText().setText(Integer.toString(aColor.getGreen()));
	getBlueText().setText(Integer.toString(aColor.getBlue()));
	
	getRedSlider().setValue( aColor.getRed() );
	getGreenSlider().setValue( aColor.getGreen() );
	getBlueSlider().setValue( aColor.getBlue() );	
	
	return;
}
private void redSliderChanged ( ) {
	// only update the textfield if this method was called
	// as a result of the user moving the slider
	if ( getRedSlider().getValueIsAdjusting() ) {
		String oldText = getRedText().getText();
		String newText = Integer.toString(getRedSlider().getValue());
		if (!(oldText.equals(newText))) {
			getRedText().setText(newText);
		}
	}
	firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	return;
}

private void redTextChanged ( ) {
	int value;
	try {
		value = (new Integer(getRedText().getText())).intValue();

		getRedSlider().setValue(value);
		firePropertyChange("colorValue", null, getColorValue());//$NON-NLS-1$
	} catch (Throwable ex) {
		// If a non-integer value is in the text field ignore it
	}
	return;
}
	
/**
 * The removePropertyChangeListener method was generated to support the propertyChange field.
 */
public synchronized void removePropertyChangeListener(PropertyChangeListener listener) {
	propertyChange.removePropertyChangeListener(listener);
}
/**
 * Sets the colorValue property (java.awt.Color) value.
 * @param colorValue The new value for the property.
 * @see #getColorValue
 */
public void setColorValue(Color colorValue) {
	// I may use this in the future in order to convert
	// the color value from another page into an RGB
	// color, but for now, do nothing.
	return;
}
public void stateChanged(ChangeEvent e) {
	if ((e.getSource() == getRedSlider()) ) {
		redSliderChanged();
	}
	if ((e.getSource() == getGreenSlider()) ) {
		greenSliderChanged();
	}
	if ((e.getSource() == getBlueSlider()) ) {
		blueSliderChanged();
	}
}

/**
 * @see java.awt.event.KeyListener#keyPressed(KeyEvent)
 */
public void keyPressed(KeyEvent e) {
}

/**
 * @see java.awt.event.KeyListener#keyReleased(KeyEvent)
 */
public void keyReleased(KeyEvent e) {
	if ((e.getSource() == getRedText()) ) {
		redTextChanged();
	}
	if ((e.getSource() == getGreenText()) ) {
		greenTextChanged();
	}
	if ((e.getSource() == getBlueText()) ) {
		blueTextChanged();
	}
}

/**
 * @see java.awt.event.KeyListener#keyTyped(KeyEvent)
 */
public void keyTyped(KeyEvent e) {
}

}
