package com.ibm.etools.jbcf.visual.beaninfo;

/**
 * @author jmyers
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/*
 * Usage note: reusing the same SubEditorJDialog can cause modal problems.
 * For best usability, construct a new SubEditorJDialog whenever it is shown
 */
public class SubEditorJDialog extends JDialog implements ActionListener {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private static java.util.ResourceBundle resabtedit = java.util.ResourceBundle.getBundle("com/ibm/etools/jbcf/visual/beaninfo/vceedit");  //$NON-NLS-1$

	public static final int OK = 0;
	public static final int CANCELLED = 1;

	private int closedState = CANCELLED;

	Component propertyEditor = null;
	JButton okButton = null;
	JButton cancelButton = null;
		 
	public SubEditorJDialog(Frame owner) {
		super(owner, VisualBeanInfoMessages.getString("SubEditorJDialog.title"), true); //$NON-NLS-1$
		initialize();
	}

	public SubEditorJDialog(Dialog owner) {	
		super(owner, VisualBeanInfoMessages.getString("SubEditorJDialog.title"), true); //$NON-NLS-1$
		initialize();
	}

	public JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setBackground(SystemColor.control);
			okButton.setText(resabtedit.getString("OK")); //$NON-NLS-1$
			okButton.addActionListener(this);
		}
		return okButton;
	}

	public JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setBackground(SystemColor.control);
			cancelButton.setText(resabtedit.getString("Cancel")); //$NON-NLS-1$
			cancelButton.addActionListener(this);
		}
		return cancelButton;
	}

	public void initialize() {
		getContentPane().setBackground(SystemColor.control);
		getContentPane().setLayout(new BorderLayout());
		JPanel content = new JPanel();
		content.setBackground(SystemColor.control);
		getContentPane().add(content, BorderLayout.CENTER);

		JPanel buttonRow = new JPanel();
		buttonRow.setBackground(SystemColor.control);
		buttonRow.setLayout(new FlowLayout(FlowLayout.RIGHT));

		JPanel buttonGrid = new JPanel();
		buttonGrid.setBackground(SystemColor.control);
		buttonRow.add(buttonGrid);
		buttonGrid.setLayout(new GridLayout(1, 0, 5, 0));

		buttonGrid.add(getOkButton());
		buttonGrid.add(getCancelButton());

		getContentPane().add(buttonRow, BorderLayout.SOUTH);

		getRootPane().setDefaultButton(getOkButton());
	}

	public void setPropertyEditor(Component propertyEditor) {
		this.propertyEditor = propertyEditor;
		getContentPane().add(propertyEditor, BorderLayout.CENTER);
		pack();
	}

	public int showEditor() {
		setVisible(true);
		return closedState;
	}

	public int getState() {
		return closedState;
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == getOkButton()) {
			closedState = OK;
		} else {
			closedState = CANCELLED;
		}
		setVisible(false);
	}
}

