package com.ibm.etools.jbcf.visual.tab;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.jface.action.Action;
import com.ibm.etools.jbcf.visual.*;

/**
 * @author JoeWin
 */
public class ShowTabOrderAction extends Action {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
		public static String ACTION_ID = "TAB_ORDER_SHOW";
		ITabRootEditPart fEditPart;
	
	public ShowTabOrderAction(ITabRootEditPart anEditPart){
		
		fEditPart = anEditPart;
		setChecked(anEditPart.isShowingTabOrder());
		setText(VisualMessages.getString("ShowTabOrder.label"));
		
	}
	
	public void run(){
		
		if ( fEditPart.isShowingTabOrder() ) {
			fEditPart.setShowTabOrder(false);
			setChecked(false);
		} else { 
			fEditPart.setShowTabOrder(true);
			setChecked(true);
		}
		
	}
	
	public String getId(){
		return ACTION_ID;
	}
	
}
