package com.ibm.etools.jbcf.visual.tab;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.geometry.*;
/**
 * @author JoeWin
 */
public class TabConnectionAnchor extends AbstractConnectionAnchor {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Point fAdjustment;
/**
 * TabLineConnector constructor comment.
 * @param owner com.ibm.swt.draw.framework.Figure
 */
public TabConnectionAnchor(IFigure owner) {
	super(owner);
}
/**
 * Construct us setting our adjustment that we will be moved from the center by
 */
public TabConnectionAnchor(Figure owner , Point adjustment) {
	super(owner);
	fAdjustment = adjustment;
}
public Point getLocation(Point aPoint) {
	return new Point(aPoint.x, aPoint.y);
}
/**
 * Attach us to the center of our owner ( the figre the tab connects to ) but adjust for the offset
 */
public Point getReferencePoint(){
	if (getOwner() == null)
		return null;
	else{
		Point ref = getOwner().getBounds().getCenter();
		getOwner().translateToAbsolute(ref);
		if ( fAdjustment != null ) {
			return new Point(ref.x + fAdjustment.x, ref.y + fAdjustment.y);
		} else {
			return new Point(ref.x, ref.y);
		}
	}
}
}