package com.ibm.etools.jbcf.visual.tab;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontMetrics;
import com.ibm.etools.draw2d.*;
import com.ibm.etools.draw2d.geometry.*;

/**
 * @author JoeWin
 */
public class TabOrderEllipseDecoration extends Shape implements RotatableDecoration {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected Integer fTabIndex;
	protected static Font fTabIndexFont = new Font(null, "ms sans serif", 8, SWT.NORMAL);//$NON-NLS-1$	
	protected int fNumChars = 1;
	protected FontMetrics fFontMetrics;

public TabOrderEllipseDecoration(int tabIndex){
	fTabIndex = new Integer(tabIndex);
	setSize(18,22);
}

protected void fillShape(Graphics graphics){

	// To help with debugging show the bouding rectangle
//	graphics.drawRectangle(getBounds().resize(-1,-1));
	
	int x1 = getBounds().x + getBounds().width/2;
	int y1 = getLocation().y + getBounds().height/2;
	graphics.setFont(fTabIndexFont);
	fFontMetrics = graphics.getFontMetrics();
	int fCharWidth = fFontMetrics.getAverageCharWidth() * fNumChars;
	int fCharHeight = fFontMetrics.getHeight();
	// The char height and charWidth are used to calculate the dimensions of an oval to be drawn
	// fR1 and fR2 are the two radix of the oval ( fR1 being horizontal and fR2 being vertical )
	int fR1 = fCharWidth + 8;
	int fR2 = fCharHeight + 6;
	Point fOvalCorner = new Point( x1 - fCharWidth/2 - 4 , y1 - fCharHeight/2 - 3);
	graphics.setBackgroundColor( ColorConstants.yellow );
	graphics.setForegroundColor( ColorConstants.black );
	graphics.fillOval(new Rectangle(fOvalCorner.x , fOvalCorner.y  , fR1 , fR2));
	graphics.drawOval(new Rectangle(fOvalCorner.x , fOvalCorner.y , fR1 , fR2));
	graphics.drawText(fTabIndex.toString() , x1 - fCharWidth/2 , y1 - 7);

}
public Rectangle getBounds(){
	int width = super.getBounds().width;
	int height = super.getBounds().height;
	return super.getBounds().getTranslated(-width/2,-height/2);
}

protected void outlineShape(Graphics graphics){
}

public void setReferencePoint(Point p) {
}

}
