package com.ibm.etools.jbcf.visual.tab;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.io.StringWriter;
import com.ibm.etools.java.instantiation.base.IJavaInstance;
/**
 * Object to refrepsent a tab order line between two beans
 * @author: Joe Winchester
 */
public class TabOrderLine {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	protected IJavaInstance fSource;
	protected IJavaInstance fTarget;
	protected IOrderManager fTabOrderManager;
	public int fTabIndex;
	protected boolean fFirst = false;
/**
 * Construct an instance of us with the source and target set
 */
public TabOrderLine(IJavaInstance source, IJavaInstance target , IOrderManager aTabOrderManager , int aTabIndex){

	fSource = source;
	fTarget = target;
	fTabOrderManager = aTabOrderManager;
	fTabIndex = aTabIndex;

}

/**
 * Get the source of the tab line
 */
public IJavaInstance getSource() {
	return fSource;
}
/**
 * Get the tab order manager
 */
public IOrderManager getTabOrderManager() {
	return fTabOrderManager;
}
/**
 * Get the target of the tab line
 */
public IJavaInstance getTarget() {
	return fTarget;
}
/**
 * Answer whether we are the first line or not
 */
public boolean isFirst(){

	return fFirst;

}
/**
 * Set that we are the first line
 */
public void setFirst(){

	fFirst = true;

}
/**
 * Set the source of the tab line
 */
public void setSource(IJavaInstance aSource) {
	fSource = aSource;
}
/**
 * Not externalized as this is just to help debugging
 */
public String toString(){

	StringWriter writer = new StringWriter();
	writer.write("TabOrderLine(");	//NON-NLS{1}
	if ( fSource != null ) {
		writer.write(fSource.toString());
	}
	writer.write(")to("); //NON-NLS{1}
	if ( fTarget != null ) {
		writer.write(fTarget.toString());
	}
	writer.write(")"); //NON-NLS{1}
	return writer.toString();
		
}
public int getTabIndex() {
	return fTabIndex;
}

}