package com.ibm.etools.jbcf.visual.tab;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.draw2d.*;
import com.ibm.etools.gef.*;
import com.ibm.etools.gef.editparts.*;
import com.ibm.etools.jbcf.visual.*;

/**
 * @author JoeWin
 */
public class TabOrderLineConnectionEditPart extends AbstractConnectionEditPart {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private TabOrderLineConnectionEditPart fPreviousConnectionEditPart;
	private TabOrderLine fLine;
	
public TabOrderLineConnectionEditPart(TabOrderLine aLine,ComponentGraphicalEditPart source, ComponentGraphicalEditPart target){
	fLine = aLine;
	setModel(aLine);
	setSource(source);
	setTarget(target);
}
/**
 * Anchor our start.  
 */
protected ConnectionAnchor getSourceConnectionAnchor() {
	
	if ( getSource() != null ) {
		return new TabConnectionAnchor(((GraphicalEditPart)getSource()).getFigure());
	} else {
		return null;
	}
	
}
protected ConnectionAnchor getTargetConnectionAnchor() {

	if ( getTarget() != null ) {	
		return new TabConnectionAnchor(((GraphicalEditPart)getTarget()).getFigure());
	} else {
		return null;
	}
	
}
protected IFigure createFigure(){
	TabOrderLineConnectionFigure result = new TabOrderLineConnectionFigure();
	result.setForegroundColor(ColorConstants.red);
	result.setSourceDecoration(new TabOrderEllipseDecoration(fLine.getTabIndex() + 1));
	if ( fLine.getTabIndex() == 1 ) {
		result.setTargetDecoration(new TabOrderEllipseDecoration(1));		
	}
	return result;
}
	
public void setPreviousEditPart(TabOrderLineConnectionEditPart anEditPart){

	fPreviousConnectionEditPart = anEditPart;
	// When the previous view object is set we need to make sure that our figure knows about the
	// decoration at the end of it
	// We can do this by just re-creating our figure although GEF needs to be changed so that we don't need to do this
	// and that createFigure() is not called so early in the construction cycle
	TabOrderLineConnectionFigure tabFigure = ((TabOrderLineConnectionFigure)getFigure());
	if ( fPreviousConnectionEditPart == null ) {
		tabFigure.setPreviousLineEndDecoration(null);
	} else {
//		tabFigure.setPreviousLineEndDecoration(
//			((TabOrderLineConnectionFigure)fPreviousConnectionEditPart.getFigure()).getEndDecoration());
	}
}	

}
