package com.ibm.etools.jbcf.visual.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.applet.*;
import java.awt.Image;
import java.awt.image.ImageProducer;
import java.net.URL;
import java.util.*;
import java.util.Collections;
import java.util.Enumeration;

/**
 * Dummy Applet Context used when applet not instantiated with one.
 * This is created by DummyAppletStub.applyApplet(...). That is why it is
 * private.
 */
class DummyAppletContext implements AppletContext {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	private Applet targetApplet;

	DummyAppletContext(Applet targetApplet) {
		this.targetApplet = targetApplet;
	}

	/**
	 * @see AppletContext#getAudioClip(URL)
	 */
	public AudioClip getAudioClip(URL url) {
		return null;	// Don't support audio on devtime. 
	}

	private Hashtable images;
	/**
	 * @see AppletContext#getImage(URL)
	 */
	public Image getImage(URL url) {
		// In case applet being tested ever needs an image, see if we can get one.
		if (images == null)
			images = new Hashtable();

		Object image = images.get(url);
		if (image != null) {
			return (Image) image;
		}

		try {
			image = url.getContent();
			if (image == null) {
				return null;
			}
			if (image instanceof Image) {
				images.put(url, image);
				return (Image) image;
			}

			Image img = targetApplet.createImage((ImageProducer) image);
			images.put(url, img);
			return img;

		} catch (Exception ex) {
			return null;
		}
	}

	/**
	 * @see AppletContext#getApplet(String)
	 */
	public Applet getApplet(String name) {
		return null;
	}

	/**
	 * @see AppletContext#getApplets()
	 */
	public Enumeration getApplets() {
		return Collections.enumeration(Collections.nCopies(1, targetApplet));
	}

	/**
	 * @see AppletContext#showDocument(URL)
	 */
	public void showDocument(URL url) {
	}

	/**
	 * @see AppletContext#showDocument(URL, String)
	 */
	public void showDocument(URL url, String target) {
	}

	/**
	 * @see AppletContext#showStatus(String)
	 */
	public void showStatus(String status) {
	}

}