package com.ibm.etools.jbcf.visual.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.awt.Component;
import java.awt.Container;

import javax.swing.*;
import javax.swing.Action;
import javax.swing.JMenuItem;

/**
 * This is the manager for a javax.swing.JMenu and JPopupMenu.
 * It handles removing actions and strings.
 * 
 * Note: It is static. No need to have one for each menu... it will always be passed in.
 */
public class JMenuManager extends Object {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$

	public static int componentIndexForString(Container menu, String s) {
		Component[] components = null;
		if (menu instanceof JMenu)
			components = ((JMenu)menu).getMenuComponents();
		else
			components = menu.getComponents();
		for (int i = 0; i < components.length; i++) {
			if (components[i] instanceof JMenuItem) {
				JMenuItem menuitem = (JMenuItem)components[i];
				if (menuitem.getText().equals(s))
					return i;
			}
		}
		return -1;
	}

	public static void removeMenuItemWithString(Container menu, String s) {
		int index = componentIndexForString(menu, s);
		if (index != -1)
			menu.remove(index);
	}

	public static int componentIndexForAction(Container menu, Action a) {
		Component[] components = null;
		if (menu instanceof JMenu)
			components = ((JMenu)menu).getMenuComponents();
		else
			components = menu.getComponents();
		for (int i = 0; i < components.length; i++) {
			if (components[i] instanceof JMenuItem) {
				JMenuItem menuitem = (JMenuItem)components[i];
				if (menuitem.getAction() == a)
					return i;
			}
		}
		return -1;
	}

	public static void removeMenuItemWithAction(Container menu, Action a) {
		int index = componentIndexForAction(menu, a);
		if (index != -1)
			menu.remove(index);
	}
}
