package com.ibm.etools.jbcf.visual.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import javax.swing.JPopupMenu;

/**
 * This is the manager for a javax.swing.JPopupMenu. 
 * It handles removing actions and strings; and hides/shows JPopupMenu's again
 * in order to force the popup to pack and resize when new components
 * are added or removed.
 * 
 * Note: It is static. No need to have one for each popup menu... it will always be passed in.
 */
public class JPopupMenuManager {

	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Hide and show the popup menu in order to resize it based on it's children.
	 */
	public static void revalidate(JPopupMenu popup) {
		if (popup != null) {
			popup.setVisible(false);
			popup.setVisible(true);
		}
	}

}
