package com.ibm.etools.jbcf.visual.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import javax.swing.JTable;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import java.util.ArrayList;
import java.util.Enumeration;

/**
 * Used to manage the JTable. It is static, references
 * will have the JTable passed in.
 */
public class JTableManager {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
	/**
	 * Remove all columns. It's easier to do this then to try
	 * to individually remove them. There are times where the
	 * old ones aren't known.
	 */
	public static void removeAllColumns(JTable jtable) {
        TableColumnModel cm = jtable.getColumnModel();
        while (cm.getColumnCount() > 0) {
            cm.removeColumn(cm.getColumn(0));
        }
	}
	
	/**
	 * Reset the header value of a table column so that it matches the default.
	 * A helper so that we don't need to remove and add all of the columns.
	 */
	public static void resetHeaderValue(JTable jtable, TableColumn column) {
		int modelColumn = column.getModelIndex();
		String columnName = jtable.getModel().getColumnName(modelColumn);
		column.setHeaderValue(columnName);
	}
}
