package com.ibm.etools.jbcf.visual.vm;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.awt.Component;

import javax.swing.*;

/**
 * @author pwalker
 *
 * This is the manager for a javax.swing.JToolBar
 * It handles adding and removing actions.
 */
public abstract class JToolBarManager {
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$

	public static int componentIndexForAction(JToolBar toolbar, Action a) {
		Component[] components = null;
		components = toolbar.getComponents();
		for (int i = 0; i < components.length; i++) {
			if (components[i] instanceof JButton) {
				JButton item = (JButton) components[i];
				if (item.getAction() == a)
					return i;
			}
		}
		return -1;
	}

	public static void removeItemWithAction(JToolBar toolbar, Action a) {
		int index = componentIndexForAction(toolbar, a);
		if (index != -1)
			toolbar.remove(index);
	}
}
