package com.ibm.etools.jbcf.wizards;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.net.MalformedURLException;
import java.net.URL;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.internal.ui.JavaPlugin;
import org.eclipse.jdt.internal.ui.*;
import org.eclipse.jdt.internal.ui.wizards.*;
import org.eclipse.jdt.ui.wizards.NewClassWizardPage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PartInitException;

import com.ibm.etools.jbcf.JBCFPlugin;
import com.ibm.etools.jbcf.codegen.CodegenMessages;
import com.ibm.etools.jbcf.editorpart.CodegenEditorPartMessages;
import com.ibm.etools.jbcf.editorpart.JavaVisualEditorPart;

/**
 * @author JoeWin
 */
public class NewVisualClassCreationWizard extends NewElementWizard {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2002."; //$NON-NLS-1$
		private String fSuperclassName;
	private NewClassWizardPage fPage;

	public NewVisualClassCreationWizard() {
		super();
		setDefaultPageImageDescriptor(JBCFPlugin.getWizardTitleImageDescriptor());
		setDialogSettings(JavaPlugin.getDefault().getDialogSettings());		
		setWindowTitle(CodegenMessages.getString("NewVisualClassCreationWizard.title")); //$NON-NLS-1$
	}
	/*
	 * @see Wizard#performFinish
	 */		
	public boolean performFinish() {
		if (finishPage(fPage.getRunnable())) {
			ICompilationUnit cu= fPage.getCreatedType().getCompilationUnit();
			if (cu.isWorkingCopy()) {
				cu= (ICompilationUnit)cu.getOriginalElement();
			}	
			try {
				IResource resource= cu.getUnderlyingResource();
				selectAndReveal(resource);
				openResource(resource);
			} catch (JavaModelException e) {
				JavaPlugin.log(e);
				// let pass, only reveal and open will fail
			}
			return true;
		}
		return false;		
	}		
	
	public void addPages() {
		fPage = new NewVisualClassWizardPage();
		addPage(fPage);
		fPage.init(getSelection());			
	}	
	// Make sure we are opened with the JavaVisualEditor	
	protected void openResource(final IResource resource) {
		JavaVisualEditorPart.openResource(resource,getShell().getDisplay());
	}
}
