package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import org.eclipse.jface.viewers.ICellEditorValidator;
/**
 * This is a default implementation for WrapperedValidators
 * that can be used.
 */

public class DefaultWrapperedValidator implements IWrapperedValidator {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected ICellEditorValidator[] fValidators;

	public DefaultWrapperedValidator() {
	}
	
	public DefaultWrapperedValidator(ICellEditorValidator[] validators) {
		fValidators = validators;
	}
	
	public ICellEditorValidator[] getValidators(){
		return fValidators;
	}
	
	public void setValidators(ICellEditorValidator[] validators){
		fValidators = validators;
	}
	
	public String isValid(Object value){
		if (fValidators != null) {
			for (int i=0; i<fValidators.length; i++) {
				if (fValidators[i] != null) {
					String result = fValidators[i].isValid(value);
					if (result != null && result.length() > 0)
						return result;	// One of them has stopped it
				}
			}
		}
		return null;
	}
	
}