package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.jface.viewers.ICellEditorValidator;
/**
 * This is a default implementation of IEToolsPropertyDescriptor.
 */

public abstract class EToolsPropertyDescriptor extends PropertyDescriptor implements IEToolsPropertyDescriptor {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected boolean fNullsInvalid = true;
	protected boolean fExpandable = true;
	protected boolean fReadOnly = false;
	
	public EToolsPropertyDescriptor(Object id, String displayName) {
		super(id, displayName);
	}
	
	public void setNullInvalid(boolean nullsInvalid) {
		fNullsInvalid = nullsInvalid;
	}
	
	public boolean areNullsInvalid() {
		return fNullsInvalid;
	}
	
	public void setExpandable(boolean expandable) {
		fExpandable = expandable;
	}
	
	public boolean isExpandable() {
		return fExpandable;
	}
	
	public boolean isReadOnly(){
		return fReadOnly;
	}
	public void setReadOnly(boolean readOnly){
		fReadOnly = readOnly;
	}
}