package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */



import org.eclipse.jface.action.Action;
import org.eclipse.swt.custom.*;
import org.eclipse.ui.views.properties.IPropertySheetEntry;
import org.eclipse.jface.viewers.*;
import java.util.*;
/**
 * This knows the TableTree that is used by the PropertySheetViewer.
 * This is extremelly kludgy but the PropertySheetViewer is packaged
 * protected and we can't get access to it. The TableTree gives
 * us what we need, basically the root entry and the selected entries.
 */
public abstract class EToolsPropertySheetAction extends Action {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	
	protected EToolsPropertySheetPage propertySheet;
	
	public EToolsPropertySheetAction(EToolsPropertySheetPage page) {
		super();
		propertySheet = page;
	}
	
	protected IPropertySheetEntry getRootEntry() {
		return propertySheet.getRootEntry();
	}
	
	/**
	 * The <code>PropertySheetAction</code> implementation of this 
	 * <code>ISelectionProvider</code> method
	 * returns the result as a <code>StructuredSelection</code>.
	 * <p>
	 * Note that this method only includes <code>IPropertySheetEntry</code>
	 * in the selection (no categories).
	 * </p>
	 */
	public ISelection getSelection() {
		return propertySheet.getSelection();
	}		
}