package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.common.command.Command;
import org.eclipse.ui.views.properties.*;

/**
 * When it is time to set the value of something from 
 * this descriptor, the property sheet can ask this 
 * interface to actually return a command that sets the value. 
 * That way depending upon the type of property ,
 * a different command can be returned, instead of 
 * always using the same command.
 */
public interface ICommandPropertyDescriptor extends IPropertyDescriptor {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Return a command which will set the value
	 * on the source.
	 *
	 * Creation date: (6/9/00 1:52:56 PM)
	 * @return com.ibm.vcf.commands.ICommand
	 * @param setValue java.lang.Object
	 */
	public Command setValue(IPropertySource source, Object setValue);
	
	/**
	 * Return a command which will reset the value
	 * on the source. 
	 *
	 * Creation date: (6/9/00 1:52:56 PM)
	 * @return com.ibm.vcf.commands.ICommand
	 * @param setValue java.lang.Object
	 */
	public Command resetValue(IPropertySource source);
}
