package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource;


/**
 * Objects that implement this interface want to
 * know their sources. These are sometimes needed to
 * perform validations or determining valid selections
 * in a combobox depending on the sources.
 * 
 * It will pass in the array of sources, array of propertySources (associated w/sources), array of descriptors (associated with each property source) 
 *
 * Currently this is checked for on CellEditors and CellEditorValidators.
 */
public interface ISourced {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Set the sources. The sources will be the editable value.
	 * In other words, IPropertySources will be converted to
	 * editable value before being set.
	 */
	public void setSources(Object[] sources, IPropertySource[] propertySources, IPropertyDescriptor[] descriptors);
}