package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.ui.views.properties.*;

/**
 * This property descriptor is used when the
 * source is not just a straight IPropertySource and
 * the value when querying must be handled specially.
 */
public interface ISourcedPropertyDescriptor extends IPropertyDescriptor {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Query the value from this descriptor for the
	 * given source.
	 * Creation date: (6/9/00 2:42:36 PM)
	 * @return java.lang.Object
	 * @param source java.lang.Object
	 */
	public Object getValue(IPropertySource source);
	
	/**
	 * Return whether this value is set or not for the
	 * given source using this descriptor.
	 */
	public boolean isSet(IPropertySource source);
}
