package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ICellEditorValidator;
import org.eclipse.swt.widgets.Composite;
/**
 * A Generic property descriptor for numbers.
 * It will use the NumberCellEditor and Label provider.
 * These editors and providers display and format the numbers in locale format.
 */
public class NumberPropertyDescriptor extends EToolsPropertyDescriptor {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	protected static final NumberLabelProvider sLabelProvider = new NumberLabelProvider();	// Need only one, they are not descriptor specific.
	
	public NumberPropertyDescriptor(Object propertyID, String propertyDisplayname) {
		super(propertyID, propertyDisplayname);
		
		setLabelProvider(sLabelProvider);	// The default provider, this can be overridden by just setting in a different value after creating descriptor.
	}
	
	public CellEditor createPropertyEditor(Composite parent) {
		CellEditor editor = new NumberCellEditor(parent);
		ICellEditorValidator v = getValidator();
		if (v != null)
			editor.setValidator(v);				
		return editor;
	}
}