package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.util.Hashtable;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.core.runtime.Plugin;

import com.ibm.etools.logging.util.*;
import com.ibm.etools.logging.util.MsgLogger;
import com.ibm.etools.logging.util.PluginHelperImpl;
/**
 * Plugin class for the property sheet.
 */
public class PSheetPlugin extends AbstractUIPlugin implements IPluginHelper {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	private static PSheetPlugin sPlugin;
	
	private MsgLogger internalMsgLogger = null;	
	
	public PSheetPlugin(IPluginDescriptor pd) {
		super(pd);
		sPlugin = this;
	}
	
	public static PSheetPlugin getPlugin() {
		return sPlugin;
	}
	
	/*
	 * The levels of logging for the MsgLogger are defined in
	 * the class com.ibm.etools.logging.util.Level
	 */
	public MsgLogger getMsgLogger(){
		if(internalMsgLogger==null)
			internalMsgLogger = (MsgLogger) MsgLogger.getFactory().getLogger(
												PluginHelperImpl.getMsgLoggerName(this), this);
		return internalMsgLogger;
	}

	/**
	 * @see IPluginHelper#getMsgLoggerConfig(Plugin)
	 */
	public Hashtable getMsgLoggerConfig(Plugin plugin) {
		return new PluginHelperImpl().getMsgLoggerConfig(this);
	}

	/**
	 * @see IPluginHelper#setMsgLoggerConfig(Hashtable)
	 */
	public void setMsgLoggerConfig(Hashtable msgLoggerConfig) {
		getMsgLogger().setMsgLoggerConfig(msgLoggerConfig);
	}	

}