package com.ibm.etools.propertysheet;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.common.command.AbstractCommand;
import org.eclipse.ui.views.properties.IPropertySource;

public class RestoreDefaultPropertyValueCommand extends AbstractCommand {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
protected Object propertyId;
protected Object undoValue;
protected boolean setOnUndo;
protected IPropertySource target;

public RestoreDefaultPropertyValueCommand(){
}

public RestoreDefaultPropertyValueCommand(String label){
	super(label);
}

public boolean canExecute() {
	return true;
}

public void execute() {
	setOnUndo = getTarget().isPropertySet(propertyId);
	if (setOnUndo) {
		undoValue = getTarget().getPropertyValue(propertyId);
		// Since getPropertyValue turns things into IPropertySources, we
		// need to unwrapper it so that the actual value can be applied back.		
		if (undoValue instanceof IPropertySource)
			undoValue = ((IPropertySource) undoValue).getEditableValue();		
		getTarget().resetPropertyValue(propertyId);	
	} else
		undoValue = null;
		
}

public IPropertySource getTarget() { return target;}

public void setTarget(IPropertySource aTarget) {target = aTarget;}

public void redo() {
	execute();
}
public void setPropertyId(Object pId) {
	propertyId = pId;
}

public void undo() {
	if (setOnUndo)
		getTarget().setPropertyValue(propertyId, undoValue);
	else
		getTarget().resetPropertyValue(propertyId);
}

}


