package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


/**
 * A Proxy for an array type.
 */

public interface IArrayBeanTypeProxy extends IBeanTypeProxy {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * getComponentType: Get the component type of this array.
	 * e.g. (new Object[3]).getClass().getComponentType() will
	 * return "java.lang.Object".
	 * and (new Object[3][2][1]).getClass().getComponentType() will
	 * return "Object[][]";
	 */
	public IBeanTypeProxy getComponentType();
	/**
	 * Return the final type, i.e. the final non-array type.
	 * i.e. int[][] will return int.
	 */
	public IBeanTypeProxy getFinalComponentType();	
	/**
	 * Return the number of dimensions for this type.
	 * i.e. int [][] will return 2.
	 */
	public int getDimensions();
}