package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.launching.VMRunnerConfiguration;
/**
 * This interface is used to contribute to the classpath that will be
 * used to start a remote vm. In addition it allows contributions
 * to the VMRunnerConfiguration and to the registry. 
 */
public interface IConfigurationContributor {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	/**
	 * Contribute classpaths to the list of classpaths that is passed in.
	 * Must use the controller to add to the classpaths.
	 */
	public void contributeClasspaths(List classpaths, IClasspathContributionController controller) throws CoreException;
	
	/**
	 * Contribute to the VMRunnerConfiguration. This allows
	 * the addition/modification of the arguments for example.
	 * It will be called after system updates are made to the configuration.
	 */
	public void contributeToConfiguration(VMRunnerConfiguration config);
	
	/**
	 * Contribute to the registry once it has been initialized.
	 */
	public void contributeToRegistry(ProxyFactoryRegistry registry);
}