package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


/**
 * Interface for Method Proxies
 * Creation date: (12/3/99 11:36:29 AM)
 * @author: Joe Winchester
 */
public interface IMethodProxy extends IBeanProxy {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
/**
 * Answer the class the method is defined in.
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanTypeProxy getClassType();
/**
 * Answer the name of the method
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
String getName();
/**
 * Answer the parameter types of the method
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanTypeProxy[] getParameterTypes();
/**
 * Answer the return type of the method
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanTypeProxy getReturnType();
/**
 * Invoke us on the subject
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invoke(IBeanProxy subject) throws ThrowableProxy;
/**
 * Invoke us on the subject with the specified arguments
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invoke(IBeanProxy subject, IBeanProxy[] arguments) throws ThrowableProxy;
/**
 * Invoke us on the subject with the specified argument
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invoke(IBeanProxy subject, IBeanProxy argument) throws ThrowableProxy;

/**
 * Invoke us on the subject, however catch all exceptions
 * Only to be used when you don't want ThrowableExceptions. This should
 * not be the normal way to invoke.
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invokeCatchThrowableExceptions(IBeanProxy subject);
/**
 * Invoke us on the subject with the specified arguments, however catch all exceptions
 * Only to be used when you don't want ThrowableExceptions. This should
 * not be the normal way to invoke.
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invokeCatchThrowableExceptions(IBeanProxy subject, IBeanProxy[] arguments);
/**
 * Invoke us on the subject with the specified argument, however catch all exceptions
 * Only to be used when you don't want ThrowableExceptions. This should
 * not be the normal way to invoke.
 * Creation date: (12/3/99 11:37:12 AM)
 * @author Joe Winchester
 */
IBeanProxy invokeCatchThrowableExceptions(IBeanProxy subject, IBeanProxy argument);

}
