package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


/**
 * Factory for creating method proxies.
 *
 * The factory exists for use, but generally it is better
 * to go through the bean type proxy to get a method proxy.
 * This is useful for setting up a bunch of method proxies
 * in initialization routines so you don't need to have
 * a bean type proxy for each.
 *
 * Creation date: (12/3/99 6:21:52 PM)
 * @author: Joe Winchester
 */
public interface IMethodProxyFactory extends IBeanProxyFactory {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
/**
 * Return a method proxy for the specified name, arguments from the class.
 * null for parameterTypes means no parameters.
 * Creation date: (12/3/99 6:22:05 PM)
 */
IMethodProxy getMethodProxy(String className, String methodName, String[] parameterTypes);
}
