package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class ProxyMessages {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	private static final String BUNDLE_NAME = "com.ibm.etools.proxy.messages";	//$NON-NLS-1$

	// Keys for messages/strings within the resource bundle.
	static public final String
		CLASSCAST_INCORRECTTYPE = "ClassCast_EXC_.IncorrectType", //$NON-NLS-1$
		UNEXPECTED_EXCEPTION = "UnexpectedException_EXC_", //$NON-NLS-1$
		PROXYFACTORY_NOBEANPROXY = "ProxyFactory_EXC_.NoBeanProxyFactory", //$NON-NLS-1$
		PROXYFACTORY_NOBEANTYPEPROXY = "ProxyFactory_EXC_.NoBeanTypeProxyFactory", //$NON-NLS-1$
		NOT_JAVA_PROJECT = "Not_Java_Project_WARN_", //$NON-NLS-1$
		NO_VM = "No_VM_WARN_", //$NON-NLS-1$
		NO_IMPLEMENTATION = "No_Implementation_WARN_"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE =
		ResourceBundle.getBundle(BUNDLE_NAME);

	private ProxyMessages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}