package com.ibm.etools.proxy;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


/**
 * This is a proxy wrapper for an exception being thrown on the
 * remove VM. The standard exception methods refer to this proxy.
 * To refer to the proxied exception itself, the methods defined
 * in here would be used.
 */
public abstract class ThrowableProxy extends java.lang.Exception implements IBeanProxy {
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
   /**
    * Constructs an <code>Exception</code> with no specified detail message. 
    */
   public ThrowableProxy() {
		super();
   }

   /**
    * Constructs an <code>Exception</code> with the specified detail message. 
    *
    * @param   s   the detail message.
    */
   public ThrowableProxy(String s) {
		super(s);
   }
	
	
	public abstract String getProxyLocalizedMessage();
	public abstract String getProxyMessage();
	public abstract void printProxyStackTrace(java.io.PrintWriter writer);
	public abstract void printProxyStackTrace(java.io.PrintStream stream);
	public abstract void printProxyStackTrace();

	public String toString() {
		return super.toString() + "Proxy: " + toBeanString();	//$NON-NLS1$ - toString's aren't nls'ed. //$NON-NLS-1$
	}
}