package com.ibm.etools.proxy.remote;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class ProxyRemoteMessages {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	private static final String BUNDLE_NAME =
		"com.ibm.etools.proxy.remote.messages";	//$NON-NLS-1$
	public final static String 
		ERROR_NO_OUTPUT_FOLDER = "NO_OUTPUT_FOLDER_EXC_", //$NON-NLS-1$
		
		VM_TERMINATED = "VM_TERMINATED_INFO_", //$NON-NLS-1$
		VM_TERMINATED_LINE1 = "VM_TERMINATED_LINE1", //$NON-NLS-1$
		VM_TERMINATED_LINE2 = "VM_TERMINATED_LINE2",		 //$NON-NLS-1$
		VM_TERMINATED_LINE3 = "VM_TERMINATED_LINE3", //$NON-NLS-1$
		
		REMOTE_VM_TRACE_HEADER = "REMOTE_VM_TRACE_INFO_", //$NON-NLS-1$
		REMOVE_VM_LOCAL_TRACE_HEADER = "REMOTE_VM_LOCAL_TRACE_INFO_"; //$NON-NLS-1$

	private static final ResourceBundle RESOURCE_BUNDLE =
		ResourceBundle.getBundle(BUNDLE_NAME);

	private ProxyRemoteMessages() {
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}