package com.ibm.etools.proxy.remote;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import com.ibm.etools.proxy.*;
import com.ibm.etools.proxy.common.remote.Commands;

/**
 * Character.TYPE BeanType Proxy.
 * Creation date: (2/23/00 1:59:02 PM)
 * @author: Richard Lee Kulp
 */
final class REMCharacterTypeBeanTypeProxy extends REMPrimitiveBeanTypeProxy {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	final REMCharacterTypeBeanProxy nilProxy;	// Value of '\0'
/**
 * REMCharacterBeanTypeProxy constructor comment.
 * @param aClass java.lang.Class
 */
REMCharacterTypeBeanTypeProxy(REMProxyFactoryRegistry aRegistry) {
	super(aRegistry, new Integer(Commands.CHARACTER_TYPE), Character.TYPE.getName());
	
	nilProxy = new REMCharacterTypeBeanProxy(aRegistry, '\0');
}

/**
 * Static helper to create a bean proxy
 * Package protected because everyone should go through the factory API
 * that is defined as part of IBeanProxyFactory
 * Use the cache.
 */
ICharacterBeanProxy createCharacterBeanProxy(char aCharacter) {
	return new REMCharacterTypeBeanProxy(fRegistry, aCharacter);
}

/**
 * newInstance method. Character doesn't have a default ctor, so the standard way won't work.
 * Return the nilProxy for this case because that is the default value.
 */
public IBeanProxy newInstance() {
	return nilProxy;
}

/**
 * Create a new bean proxy the ValueObject passed in.
 * We will assume the object is correct type.
 */
public IBeanProxy newBeanProxy(Commands.ValueObject value) {
	return createCharacterBeanProxy(value.aChar);
}
}


