package com.ibm.etools.proxy.remote.test;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.proxy.vm.remote.*;
import com.ibm.etools.proxy.common.CommandException;
import com.ibm.etools.proxy.common.*;
import java.io.OutputStream;
import java.io.IOException;
/**
 * This is a test for testing callback streams.
 *
 * This class needs to be defined in any implementation
 * of proxy on a remote side. The test case in 
 * proxy expects it to be there with this name, including package.
 */
public class TestCallbackStream implements ICallback {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	IVMServer vmServer;
	int callbackID;
	boolean stop = false;

	/**
	 * When told to start, it will send a stream of 30000 bytes of incrementing
	 * value (i.e. 0, 1, 2, ..., 127, -127, ...)
	 */
	public void start() {
		new Thread(new Runnable() {
			public void run() {
				OutputStream os = null;
				try {
					os = vmServer.requestStream(callbackID, 0);
					if (os != null)
						for (int i=0; i<30000; i++)
							os.write(i);
				} catch (Exception e) {
					e.printStackTrace();
				}
				try {
					if (os != null)
						os.close();
				} catch (IOException e) {
				}
		}}).start();
	}
	
	/**
	 * It is being initialized.
	 */
	public void initializeCallback(IVMServer server, int id) {
		vmServer = server;
		callbackID = id;
	}

}