package com.ibm.etools.proxy.test;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import com.ibm.etools.proxy.*;
import java.io.InputStream;
/**
 * This is the callback for the test case.
 */
public class TestCallback implements ICallback {
	
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	Object tester;
	int counter = 0;
	
	// Normally the callback doesn't determine when to stop 
	// the callback proxy. But for this test it does.
	public TestCallback(Object t) {
		tester = t;
	}
	
	public Object calledBack(int msgID, IBeanProxy parm){
		if (parm instanceof IIntegerBeanProxy) {
			System.out.println("  Callback parm="+((IIntegerBeanProxy) parm).intValue()); //$NON-NLS-1$
			if (++counter == 2) {
				System.out.println("So far test has succeeded.");				 //$NON-NLS-1$
				stopTest();
			}
		}
		return null;
	}
	public Object calledBack(int msgID, Object[] parms){
		System.out.println("Failed Callback Test. Shouldn't have gotton to multi-parms"); //$NON-NLS-1$
		stopTest();
		return null;
	}
	public void calledBackStream(int msgID, InputStream in){
		System.out.println("Failed Callback Test. Shouldn't have gotton to input stream"); //$NON-NLS-1$
		stopTest();
	}	
	
	void stopTest() {
		synchronized(tester) {
			tester.notify();
		}
	}

}