package com.ibm.etools.proxy.vm.remote;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * This class is a helper for Class accessing functions.
 * Its main function is to bypass security. This is because
 * we don't care about security for remote vm. Security is
 * handled by the IDE and compilor over there. We do what
 * we're told.
 * 
 * @author richkulp
 */
public class ClassHelper {

	/**
	 * Constructor for ClassHelper.
	 */
	private ClassHelper() {
		super();
	}
	
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	private static final Class[] EMPTY_CLASS_ARRAY = new Class[0];
	private static final Object[] EMPTY_OBJECT_ARRAY = new Object[0];	
	public static Object newInstance(Class targetClass) throws NoSuchMethodException, InvocationTargetException, IllegalAccessException, InstantiationException {
		// We want to get the default ctor, which is in the declared list. No need
		// to worry about inheritance because ctors are never virtual.
		Constructor ctor = targetClass.getDeclaredConstructor(EMPTY_CLASS_ARRAY);
		ctor.setAccessible(true);
		return ctor.newInstance(EMPTY_OBJECT_ARRAY);
	}

}
