package com.ibm.etools.proxy.vm.remote;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


import java.net.*;
import java.io.*;
import java.util.*;
import com.ibm.etools.proxy.common.remote.*;
import com.ibm.etools.proxy.common.*;
/**
 * This is a thread to handle one connection.
 */

public class ConnectionThread extends Thread {	
		
	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
	final protected ConnectionHandler connectionHandler;
	
	public ConnectionThread(Socket sc, RemoteVMServerThread svr, String name) {
		super(name);

		connectionHandler = new ConnectionHandler(sc, svr, this);
	}
	
	/**
	 * Request the thread to close down.
	 */
	public void close() {
		try {
			connectionHandler.close();
		} catch (Exception e) {
		}
	}
	
	public void run() {
		try {
			connectionHandler.run();
		} catch (CommandException e) {
			e.printStackTrace();
		}
	}
	
}