package com.ibm.etools.proxy.vm.remote;
/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved. 
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */


/**
 * The application to run to kick off the remote VM server side.
 *
 *
 * All this does is start the Server Thread and waits for it to finish.
 * This allows other mains to have a server thread, and some other
 * threads if they wished. They could start the server thread too
 * and some other thread, and then wait for both to finish.
 */

public class RemoteVMApplication {

	public static final String copyright = "(c) Copyright IBM Corporation 2001, 2002."; //$NON-NLS-1$
public static void main(java.lang.String[] args) {
	String serverName = "Server Thread"; //$NON-NLS-1$
	if (System.getProperty("proxyvm.servername") != null) //$NON-NLS-1$
		serverName = serverName + "-" + System.getProperty("proxyvm.servername"); //$NON-NLS-1$ //$NON-NLS-2$
	Thread t = new RemoteVMServerThread(serverName);
	t.start();
	try {
		t.join();
	} catch (Exception e) {
	}
	System.exit(0);
}



}